*******************************************
	subroutine mnmx( n, x, xmn, xmx )
* find min and max values
* Input:
*	n	i4 number of data values
*	x(n)	r4 data values
* Output:
*	xmn	r4 minimum value
*	xmx	r4 maximum value
	real*4 x(*)
	xmn = x(1)
	xmx = xmn
      do i=1,n
	xmn = min( xmn, x(i) )
	xmx = max( xmx, x(i) )
      end do
	return
	end
*******************************************
	subroutine mnmx_index( n, x, imn, imx )
* find index of min and max values
* Input:
*	n	i4 number of data values
*	x(n)	r4 data values
* Output:
*	imn	r4 index of first min value
*	imx	r4 index of last max value
* 2018 Oct Keith Horne @St.Andrews
	real*4 x(*)
	imn = 1
	imx = 1
      do i=1,n
	if( x(i) .lt. x(imn) ) imn = i
	if( x(i) .ge. x(imx) ) imx = i
      end do
	return
	end
*******************************************
	function minpos( n, x )
* find index of min value
* Input:
*	n	i4 number of data values
*	x(n)	r4 data values
* Output:
*	minpos	r4 index of first min value
* 2018 Oct Keith Horne @St.Andrews
	real*4 x(*)
	m = 1
      do i=1,n
	if( x(i) .lt. x(m) ) m = i
      end do
	minpos = m
	return
	end
*******************************************
	function maxpos( n, x )
* find index of max value
* Input:
*	n	i4 number of data values
*	x(n)	r4 data values
* Output:
*	maxpos	r4 index of last max value
* 2018 Oct Keith Horne @St.Andrews
	real*4 x(*)
	m = 1
      do i=1,n
	if( x(i) .gt. x(m) ) m = i
      end do
	maxpos = m
	return
	end
*******************************************
	subroutine mnmxpos( n, x, xmn, xmx )
* find min and max of positive values
* Input:
*	n	i4 number of data values
*	x(n)	r4 data values
* Output:
*	xmn	r4 minimum value
*	xmx	r4 maximum value
* 2004 Apr Keith Horne @ St.And
* 2012 Sep KDH @ StA fix bug when x(1) < 0
	real*4 x(*), xmn, xmx
	npos = 0
      do i=1,n
      if( x(i) .gt. 0. ) then
	npos = npos + 1
      if( npos .eq. 1 ) then
	xmn = x(i)
	xmx = xmn
      else
	xmn = min( xmn, x(i) )
	xmx = max( xmx, x(i) )
      end if
      end if
      end do
      if( npos .lt. 1 ) then
	xmn = 0.
	xmx = 0.
      end if
	return
	end
*******************************************
	subroutine mnmxi( n, i, imn, imx )
* find min and max values for integer array 
* Input:
*	n	i4 number of data values
*	i(n)	i4 data values
* Output:
*	imn	r4 minimum value
*	imx	r4 maximum value
* 2004 Feb Keith Horne @ St-Andrews
	integer*4 i( * )
	imn = i( 1 )
	imx = imn
      do k=1,n
	imn = min( imn, i( k ) )
	imx = max( imx, i( k ) )
      end do
	return
	end

*******************************************
	subroutine dmnmx( n, x, xmn, xmx )
* find min and max of real*8 values
* Input:
*	n	i4 number of data values
*	x(n)	r8 data values
* Output:
*	xmn	r8 minimum value
*	xmx	r8 maximum value
	real*8 x(*), xmn, xmx
	xmn = x(1)
	xmx = xmn
      do i=1,n
	xmn = min( xmn, x(i) )
	xmx = max( xmx, x(i) )
      end do
	return
	end

*******************************************
	subroutine imnmx( n, x, imn, imx )
* find indices of min and max values
* Input:
*	n	i4 number of data values
*	x(n)	r4 data values
* Output:
*	imn	r4 index of minimum value
*	imx	r4 index of maximum value
* 2012 Apr Keith Horne @ StA
	real*4 x( * )
	imn = 1
	imx = 1
      do i=1,n
	if( x( i ) .lt. x( imn ) ) imn = i
	if( x( i ) .gt. x( imx ) ) imx = i
      end do
	return
	end
*******************************************
	subroutine imnmxpos( n, x, imn, imx )
* find indices of min and max of positive values
* Input:
*	n	i4 number of data values
*	x(n)	r4 data values
* Output:
*	imn	r4 index of minimum positive value
*	imx	r4 index of maximum positive value
* 2012 Apr Keith Horne @ StA
	real*4 x( * )
	imn = 0
	imx = 0
	np = 0
      do i=1,n
      if( x( i ) .gt. 0. ) then
	np = np + 1
      if( np .eq. 1 ) then
	imn = i
	imx = i
      else
	if( x( i ) .lt. x( imn ) ) imn = i
	if( x( i ) .gt. x( imx ) ) imx = i
      end if
      end if
      end do
	return
	end
*******************************************
	subroutine imnmxi( n, i, imn, imx )
* find indeces of min and max values for integer array 
* Input:
*	n	i4 number of data values
*	i(n)	i4 data values
* Output:
*	imn	r4 index of minimum value
*	imx	r4 index of maximum value
* 2012 Apr Keith Horne @ StA
	integer*4 i( * )
	imn = 1
	imx = 1
      do k=1,n
	if( i( k ) .lt. i( imn ) ) imn = k
	if( i( k ) .gt. i( imx ) ) imx = k
      end do
	return
	end

*******************************************
	subroutine imnmx8( n, x, imn, imx )
* find indices of min and max of real*8 values
* Input:
*	n	i4 number of data values
*	x(n)	r8 data values
* Output:
*	imn	i4 index of minimum value
*	imx	i4 index of maximum value
* 2012 Apr Keith Horne @ StA
	real*8 x( * )
	imn = 1
	imx = 1
      do i=1,n
	if( x( i ) .lt. x( imn ) ) imn = i
	if( x( i ) .gt. x( imx ) ) imx = i
      end do
	return
	end
******************************************
	subroutine medmad_old( n, x, xmed, xmad )
* median and mean absolute deviation of n data points
* Input:
*	n	i4 number of data
*	x(n)	r4 data
* output:
*	xmed	r4 median value
*	xmad	r4 mean absolute deviation
* 2009 May Keith Horne @ St.Andrews
	real*4 x(*)
	real*8 sum
	xmed = xmedian( n, x )
	sum = 0.d0
      do i=1,n
	sum = sum + abs( x(i) - xmed )
      end do
	xmad = sum / max( 1, n )

* median absolute deviation = 1.4862 sigma
*   mean absolute deviation = 1.2533 sigma

	return
	end

******************************************
	subroutine medmad( n, d, dmed, dmad )
* median and MAD = median absolute deviation of d( n )
* or of a uniform sample from d( n ) if n > maxn
* In:	n	i4 number of data
*	d(n)	r4 data
* Out:	dmed	r4 median value
*	dmad	r4 median absolute deviation
* 2018 Feb Keith Horne @ St.Andrews
* 2019 Sep KDH @ St.A  maxn 1e5->1e6
	real*4 d( n )

	parameter( maxn = 1e6 )
	integer*4 ir( maxn )
	real*4 work( maxn )

	dmed = 0.
	dmad = 0.
	if( n .le. 0 ) return
	dmed = d( 1 )
	if( n .eq. 1 ) return

* short dataset
      if( n .le. maxn ) then 
	call medmad0( n, d, dmed, dmad, work, ir )
* sample long dataset
      else
	m = min( n, maxn )
      do i = 1, m
	p = ( i - 0.5 ) / m
	k = nint( 0.5 + p * n )
	work( i ) = d( k )
      end do
* medmad
	call medmad0( m, work, dmed, dmad, work, ir )
      end if

* median absolute deviation = 1.4862 sigma
*   mean absolute deviation = 1.2533 sigma

	return
	end

******************************************
	subroutine medmad0( n, d, dmed, dmad, a, ir )
* median and MAD = median absolute deviation of d( n )
* In:	n	i4 number of data
*	d( n )	r4 data
* Out:	dmed	r4 median value
*	dmad	r4 median absolute deviation
*	a( n )	r4 sorted absolute deviations
*	ir( n )	r4 dat(ir(i)) ascends
* 2018 Feb Keith Horne @ St.Andrews
	real*4 d( n ), a( n )
	integer*4 ir( n )
* median
	call median0( n, d, dmed, ir )
* mad
      do i = 1, n
	a( i ) = abs( d( i ) - dmed )
      end do
	call median0( n, a, dmad, ir )
	return
	end

******************************************
	subroutine median0( n, d, dmed, ir )
* median of d( n )
* In:	n	i4 number of data
*	d( n )	r4 data
* Out:	dmed	r4 median value
*	ir( n )	r4 d( ir( i ) ) ascends
* 2018 Feb Keith Horne @ St.Andrews
	real*4 d( n )
	integer*4 ir( n )

	dmed = 0.
	if( n .le. 0 ) return
	ir( 1 ) = 1
	if( n .eq. 1 ) return
* median
	call quicksort( n, d, ir )
	k = n / 2
	kp = k + 1
	dmed = d( ir( k ) )
	if( mod( n, 2 ) .eq. 0 ) dmed = ( d( ir( kp ) ) + dmed ) / 2.

	return
	end
* =============================================
        subroutine mad2rms( amad, rms )
* in    r4 amad	median (or mean) absolute deviation
* out   r4 rms	de-bias assuming <rms> = 1.4826 <mad>
* 2018 Jul Keith Horne @ St-Andrews
        rms = amad * 1.4826
        return
        end
******************************************
	subroutine avgrms( n, x, bar, rms )
* unweighted mean and rms of n data points x(i)
* Input:
*	n	i4 number of data
*	x(n)	r4 data
* output:
*	bar	r4 mean value
*	rms	r4 root-mean-square
* Running update method (B.P.Welford 1962)
* Seems to be more robust to round-off errors.
* 2011 Feb Keith Horne @ St.Andrews
	real*4 x(*)
	real*8 sum, sum2, add
      if( n .le. 1 ) then
	bar = x(1)
	rms = 0.
	return
      end if
	sum1 = x(1)
	sum2 = 0.d0
      do i=2,n
	add = dble( x(i) ) - sum1
	sum1 = sum1 + add / i
	sum2 = sum2 + add * ( dble( x(i) ) - sum1 )
      end do
	bar = sum1
	var = sum2 / max( 1, n - 1 )	
	rms = sqrt( var )
	return
	end

******************************************
	subroutine avgrms1( n, x, bar, rms )
* unweighted mean and rms of n data points x(i)
* Input:
*	n	i4 number of data
*	x(n)	r4 data
* output:
*	bar	r4 mean value
*	rms	r4 root-mean-square
* 1999 Sep Keith Horne @ St.Andrews
* 2011 Feb KDH @ StA - x(i)**2 -> x(i)*x(i)
	real*4 x(*)
	real*8 sum, sum2
	bar = x(1)
	rms = 0.
	if( n.le.1 ) return
	sum = 0.d0
	sum2 = 0.d0
      do i=1,n
	sum = sum + x(i)
	sum2 = sum2 + x(i) * x(i)
      end do
	bar = sum / n
	var = ( sum2 - sum * sum / n ) / max( 1, n-1 )
	rms = sqrt( max( 0., var ) )
	return
	end
*================================================
        subroutine wgtavg( n, x, w, a )
* weighted average
* In    n       i4 number of data
*       x(n)    r4 data
*       w(n)    r4 weights
* Out   a       r4 weighted average
* 2015 Mar Keith Horne @ St-Andrews
	real*4 x(*), w(*)
	real*8 sum, wsum
	a = 0.
	if( n .le. 0 ) return
	sum = 0.d0
	sumw = 0.d0
      do i = 1, n
	sum = sum + w(i) * x(i)
	sumw = sumw + w(i)
      end do
	if( sumw .gt. 0. ) a = sum / sumw
	return
	end
********************************************
	subroutine optavg( n, dat, sig, avg, sigavg )
* optimal average
* Input:
*	n	i4 number of data values
*	dat(n)	r4 data values
*	sig(n)	r4 error bars (negative to ignore point)
* Output:
*	avg	r4 optimal average
*	sigavg	r4 error bar of optimal average
* 2000 Sep Keith Horne @ St.Andrews
* 2016 Aug KDH @ St.A - prescaling
	real*4 dat(*), sig(*)
	real*8 sum, sumw, div
	avg = 0.
	sigavg = -1.
	if( n .le. 0 ) return
* prescale divisor
	div = safedivisor( n, dat, sig )
	sum = 0.d0
	sumw = 0.d0
      do i = 1, n
	s = sig( i ) / div
      if( s .gt. 0. ) then
	w = 1. / ( s * s )
	sumw = sumw + w
	sum  = sum  + w * dat( i )
      end if
      end do
	if( sumw .le. 0.d0 ) return
	avg = sum / sumw
	sigavg = div / dsqrt( sumw )
	return
	end
********************************************
	subroutine optavg1( n, dat, sig, avg, sigavg )
* optimal average (old version with no prescaling)
* Input:
*	n	i4 number of data values
*	dat(n)	r4 data values
*	sig(n)	r4 error bars (negative to ignore point)
* Output:
*	avg	r4 optimal average
*	sigavg	r4 error bar of optimal average
* 2000 Sep Keith Horne @ St.Andrews
	real*4 dat(*), sig(*)
	real*8 sum, sumw
	avg = 0.
	sigavg = -1.
	if( n .le. 0 ) return
	sum = 0.d0
	sumw = 0.d0
      do i = 1, n
	s = sig( i )
      if( s .gt. 0. ) then
	w = 1. / ( s * s )
	sumw = sumw + w
	sum = sum + w * dat(i)
      end if
      end do
	if( sumw .le. 0.d0 ) return
	avg = sum / sumw
	sigavg = 1.d0 / dsqrt( sumw )
	return
	end

* ==================================
	function safedivisor( n, dat, sig )
* find a "safe" prescale factor
* Input:
*	n	i4 number of data values
*	dat(n)	r4 data values
*	sig(n)	r4 error bars (negative to ignore point)
* Output:
*	safedivisor	r4 "safe" divisor for prescaling
* 2016 Aug Keith Horne @ St.Andrews
	real*4 dat( * )
	real*4 sig( * )
* range of dat and sig where sig > 0
	np = 0
      do i = 1, n
	s = sig( i )
      if( s .gt. 0. ) then
	d = dat( i )
      if( np .eq. 0 ) then
	dmn = d
	dmx = d
	smn = s
	smx = s
      else
	dmn = min( dmn, d )
	dmx = max( dmx, d )
	smn = min( smn, s )
	smx = max( smx, s )
      end if
	np = np + 1	
      end if
      end do
* half-range of good data
	s = ( dmx - dmn ) / 2.
* smallest error bar
	if( np .gt. 0 ) s = smn
* or no safe divisor
	if( s .le. 0. ) s = 1.
	safedivisor = s
	return
	end
********************************************
	subroutine optscl( n, dat, sig, pfl, scl, sigscl )
* scale profile to fit data
* Input:
*	n	i4 number of data points
*	dat(n)	r4 data values
*	sig(n)	r4 1-sigma error bars (<0 to omit data point)
*	pfl(n)	r4 profile to be scaled to fit
* Output:
*	scl	r4 scale factor
*	sigscl	r4 1-sigma error bar on scale factor
* 2000 Oct Keith Horne @ St.Andrews
	real*4 dat(*), sig(*), pfl(*)
	real*8 sum, sum1
	scl = 0.
	sigscl = -1.
	if( n.le.0 ) return
	sum = 0.d0
	sum1 = 0.d0
      do i=1,n
      if( sig(i) .gt. 0. ) then
	wgt = pfl(i) / sig(i)**2
	sum = sum + dat(i) * wgt
	sum1 = sum1 + pfl(i) * wgt
      end if
      end do
	if( sum1 .le. 0.d0 ) return
	scl = sum / sum1
	var = 1. / sum1
	sigscl = sqrt( var )
	return
	end
********************************************
	subroutine optavgrms( n, dat, sig, bar, rms )
* optimal average
	real*4 dat(*), sig(*)
	real*8 top, bot, sum
	bar = 0.
	rms = -1.
	if( n.le.0 ) return
	call optavg( n, dat, sig, bar, sigbar )
	nsum = 0
	sum = 0.d0
!	top = 0.d0
!	bot = 0.d0
      do i=1,n
	s = sig(i)
      if( s .gt. 0. ) then
	nsum = nsum + 1
!	w = 1. / s / s
	e = dat(i) - bar
	ee = e * e
!	top = top + w * ee
!	bot = bot + w
	sum = sum + ee
      end if
      end do
	var = sum / max( 1, nsum - 1 )
!	var = top / bot
	rms = sqrt( var )
	return
	end
* =================================================
	subroutine avgrmsx( n, dat, sig, good, avg, rms, sigavg, sigrms )
* Maximum likelihood estimator of the mean and intrinsic rms
* given independent samples with error bars
* In:	n	i4 number of data
*	dat(n)	r4 data
*	sig(n)	r4 1-sigma error bars (<0 to skip)
* Out:	good	r4 number of "good" data
*	avg	r4 mean value
*	sigavg	r4 1-sigma error bar
*	rms	r4 excess rms
*	sigrms	r4 1-sigma of excess rms
* 2014 Aug Keith Horne @ St Andrews
* 2014 Nov KDH @ StA - improve estimate of sigrms
* 2016 Mar KDH @ StA - catch crash if no variance
* 2016 Mar KDH @ StA - scale to <1/sig^2>=1, to avoid vmin=0.
* 2018 Mar KDH @ StA - verbose

	real*4 dat( n ), sig( n )
	real*8 sum, sumg, sum1, sum2, sum3
	logical verbose/.false./
* trap no data
	good = 0.
	avg = 0.
	rms = 0.
	sigavg = -1.
	sigrms = -1.
	if( n .le. 0 ) return

* mean of positive error bars
	ng = 0
	sum = 0.d0
      do k = 1, n
	e = sig( k )
      if( e .gt. 0. ) then
	sum = sum + e
	ng = ng + 1
      end if
      end do
	e1 = sum / max( 1, ng ) 

* abort no valid data
      if( ng .le. 0 ) then
	if( verbose ) write(*,*) '** ERROR in AVGRMSX: NO >0 ERROR BARS n', n, ' ng', ng
	return	
      end if

* abort e1 = 0
      if( e1 .le. 0. ) then
	write(*,*) '** ERROR in AVGRMSX. MEAN ERROR BAR e1', e1
	write(*,*) '** sum', sum, ' n', n, ' ng', ng
	return
      end if

* initial estimate
	sum1 = 0.d0
	sum2 = 0.d0
      do k = 1, n
	e = sig( k )
      if( e .gt. 0. ) then
	d = dat( k )
	w = ( e1 / e ) ** 2
	sum1 = sum1 + w * d
	sum2 = sum2 + w	
      end if
      end do

* abort no valid data
      if( sum2 .le. 0. .or. ng .le. 0 ) then
	write(*,*) '** ERROR in AVGRMSX. n', n, ' ng', ng, ' sum2=', sum2
	return	
      end if

* optimal average and its variance
	avg = sum1 / sum2
	sigavg = e1 / dsqrt( sum2 )
* scale factor ( makes <1/sig^2>=1 )
	w = ng / sum2
	e1 = e1 * sqrt( w )
* estimate for rms
	rms = e1

* convergence threshold
	tiny = 2.e-5
* lower limit for extra rms
	rmin = tiny * e1

* KDH : NO LONGER NEEDED ?
      if( rmin .le. 0. ) then
	write(*,*) '** WARNING in AVGRMSX : rmin not positive :('
	write(*,*) ' sum1', sum1, ' sum2', sum2, ' ng', ng
	write(*,*) ' avg', avg, ' sigavg', sigavg
	write(*,*) '  e1', e1, ' rmin', rmin
      end if

* iterate to converge avg and rms
	nloop = 1000
      do loop = 1, nloop
* stow for convergence test
	oldavg = avg
	oldrms = rms
* zero sums
	sum1 = 0.d0
	sum2 = 0.d0
	sumg = 0.d0
	sum  = 0.d0
	sum3 = 0.d0
* scaled avg and rms
	a = avg / e1
	r = rms / e1
	rr = r * r
* data loop
      do k = 1, n
* reject data with negative error bar
	e = sig( k )
      if( e .gt. 0. ) then
* scale data and error bar
	d = dat( k ) / e1
	e = e / e1
* "goodness" of this data point
	g = rr / ( rr + e * e )
	x = g * ( d - a )
	xx = x * x
* increment sums
	sum1 = sum1 + g * d
	sumg = sumg + g
	sum  = sum  + g * g
	sum2 = sum2 + xx
	sum3 = sum3 + g * xx
      end if
* next datum
      end do

* "good" data points ( e.g. with sig < rms )
	good = sumg

* KDH: CATCH SUMG=0
      if( sumg .le. 0.d0 ) then
	write(*,*) '** ERROR in AVGRMSX. NON-POSITIVE SUM(G)=', sumg
	write(*,*) '** loop', loop, ' ndat', n, ' ngood', ng
	write(*,*) '** sumg', sumg, ' sum1', sum1, ' sum', sum
	write(*,*) '**  r', r, ' rr', rr
	write(*,*) '** dat(:)', (dat(i),i=1,n)
	write(*,*) '** sig(:)', (sig(i),i=1,n)
	write(*,*) 'Should we abort here ?'
	stop
      end if

* revise avg and rms
	a = sum1 / sumg
	r = dsqrt( sum2 ) / dsqrt( sumg )
	r = max( rmin, r )
* error bars on scaled avg and rms
	siga = r / sqrt( sumg )
	g = 2.d0 * ( 2.d0 * sum3 / sum2 * sumg - sum )
	sigr = r
	if( g .gt. 0. ) sigr = r / sqrt( g )

* restore scaling
	avg = a * e1
	rms = r * e1
	sigavg = siga * e1
	sigrms = sigr * e1


* KDH: CATCH SUM2=0 (NO VARIANCE)
      if( sum2 .le. 0.d0 ) then
	rms = 0.
	sigrms = -1.
	return
      end if

* converge when test < 1
      if( loop .gt. 1 ) then
* step
	safe = 0.9
	avg = oldavg * ( 1. - safe ) + safe * avg
	rms = oldrms * ( 1. - safe ) + safe * rms
* chi
	chiavg = ( avg - oldavg ) / sigavg
	chirms = ( rms - oldrms ) / sigrms
	test = max( abs( chiavg ), abs( chirms ) ) / tiny

* report on last 5 iterations
      if( loop .gt. nloop - 3 ) then
	write(*,*) 'Loop', loop, ' of', nloop, ' in AVGRMSX'
	write(*,*) 'Ndat', n, ' Ngood', good, ' Neff', g
	write(*,*) ' avg', avg, ' rms', rms
	write(*,*) ' +/-', sigavg, ' +/-', sigrms
	write(*,*) ' chiavg', chiavg, ' chirms', chirms, ' test', test
	if( test .lt. 1. ) write(*,*) '** CONVERGED ** :))'
      end if
* converged
	if( test .lt. 1. ) return
      end if

* quit if rms vanishes
	if( rms .le. 0. ) return

* next loop
      end do

* failed to converge
	write(*,*) '** AVGRMSX FAILED TO CONVERGE :((((('
	return
	end
	subroutine fitline( n, t, dat, sig, t0, a, b, siga, sigb )
*  fit y(t)=a+b(t-t0) to data points dat(i)+/-sig(i) at times t(i)
*  input:
*	n	i4 number of data points
*	t(n)	r4 independent variable
*	dat(n)	r4 data values
*	sig(n)	r4 error bars
*  output:
*	t0,a,b	r4 best fit y(t) = a + b * ( t - t0 )
*	siga,sigb r4 fit variance is siga^2 + ((t-t0)*sigb)^2
*
* 2002 May Keith Horne @ St.Andrews
	real*4 t(*), dat(*), sig(*)
	real*8 w, wx, wy, wxx, wxy, det
* sanity check
	t0 = 0.
	a = 0.
	b = 0.
	siga = -1.
	sigb = -1.
	if( n .le. 0 ) return
* centroids and scales
	call optavg( n, t, sig, t0, tscale )
	call optavg( n, dat, sig, y0, yscale )
	call mnmx( n, t, tmn, tmx )
	call mnmx( n, dat, ymn, ymx )
	tscale = abs( tmx - tmn )
	yscale = abs( ymx - ymn )
	if( tscale. le. 0. ) tscale = 1.
	if( yscale .le. 0. ) yscale = 1.
* matrix elements
	w = 0.d0
	wx = 0.d0
	wy = 0.d0
	wxx = 0.d0
	wxy = 0.d0
      do i=1,n
      if( sig(i) .gt. 0. ) then
	wgt = ( yscale / sig(i) )**2
	x = ( t(i) - t0 ) / tscale
	y = ( dat(i) - y0 ) / yscale
	w  = w  + wgt
	wx  = wx  + wgt * x
	wy  = wy  + wgt * y
	wxx = wxx + wgt * x * x
	wxy = wxy + wgt * y * x
      end if
      end do
	if( w .le. 0.d0 ) return
* invert matrix
	det = w * wxx - wx * wx
      if( det .gt. 0.d0 ) then
	a = ( wy * wxx - wx * wxy ) / det
	b = (  w * wxy - wx * wy ) / det
	siga = 1.d0 / dsqrt( w )
c	sigb = 1.d0 / dsqrt( det )
	sigb = 1.d0 / dsqrt( wxx )
      else
	a = wy / w
	siga = 1.d0 / dsqrt( w )
	b = 0.
	sigb = 0.
      end if
* de-scale results
	a = a * yscale + y0
	siga = siga * yscale
	bscale = yscale / tscale
	b = b * bscale
	sigb = sigb * bscale
	return
	end
*=================================================
	subroutine fitcp( n, dat, sig, p, a0, a1, chi2, ndof )
* fit a0 + a1 * p(i) to dat(i) +/- sig(i)
* 2000 Apr Keith Horne @ St.Andrews
* 2002 Oct KDH @ St-And - dof -> ndof
	real*4 dat(*), sig(*), p(*)
	real*8 c0, c1, h00, h01, h11, det, sum
	c0 = 0.d0
	c1 = 0.d0
	h00 = 0.d0
	h01 = 0.d0
	h11 = 0.d0
	ng = 0
      do i = 1, n
      if( sig( i ) .gt. 0. ) then
	ng = ng + 1
	w = 1. / sig( i )**2
	c0 = c0 + dat( i ) * w
	h00 = h00 + w
      if( p( i ) .ne. 0. ) then
	wp = w * p( i )
	c1 = c1 + dat( i ) * wp
	h01 = h01 + wp
	h11 = h11 + wp * p( i )
      end if
      end if
      end do
* 0 parameters
	a0 = 0.
	a1 = 0.
	chi2 = 0.
	ndof = ng
	if( ng .le. 0 ) return
* 1 parameter
	if( h00 .gt. 0.d0 ) a0 = c0 / h00
	ndof = ng - 1
* 2 parameters
	det = h00 * h11 - h01 * h01
      if( det .ne. 0.d0 ) then
	a0 = ( h11 * c0 - h01 * c1 ) / det
	a1 = ( h00 * c1 - h01 * c0 ) / det
	ndof = ng - 2
      end if
* evaluate chi^2
	sum = 0.d0
      do i = 1, n
      if( sig( i ) .gt. 0. ) then
	fit = a0 + a1 * p(i)
	eta = ( dat( i ) - fit ) / sig( i )
	sum = sum + eta**2
      end if
      end do
	chi2 = sum
	return
	end

*=================================================
	subroutine fitcp2( n, dat, sig, p1, p2, a0, a1, a2, chi2, ndof )
* fit a0 + a1 * p1(i) + a2 * p2(i) to dat(i) +/- sig(i)
* 2003 Jan Keith Horne @ St-Andrews
	real*4 dat(*), sig(*), p1(*), p2(*)
	real*8 c0, c1, c2
	real*8 h00, h01, h02, h11, h12, h22
	real*8 cof00, cof01, cof02, cof11, cof12, cof22
	real*8 det0, det1, det2, det, sum
* c_j = sum_k dat(k) * p_j(k) / sig(k)^2
	c0 = 0.d0
	c1 = 0.d0
	c2 = 0.d0
* h_ij = sum_k p_i(k) * p_j(k) / sig(k)^2
	h00 = 0.d0
	h01 = 0.d0
	h02 = 0.d0
	h11 = 0.d0
	h12 = 0.d0
	h22 = 0.d0
	ng = 0
      do i = 1, n
      if( sig( i ) .gt. 0. ) then
	ng = ng + 1
	w = 1. / sig( i )**2
	c0 = c0 + dat( i ) * w
	h00 = h00 + w
      if( p1( i ) .ne. 0. ) then
	w1 = w * p1( i )
	c1 = c1 + w1 * dat( i )
	h01 = h01 + w1
	h11 = h11 + w1 * p1( i )
      if( p2( i ) .ne. 0. ) then
	w2 = w * p2( i )
	c2 = c2 + w2 * dat( i )
	h02 = h02 + w2
	h12 = h12 + w1 * p2( i )
	h22 = h22 + w2 * p2( i )
      end if
      end if
      end if
      end do
* 0 parameters
	a0 = 0.
	a1 = 0.
	a2 = 0.
	chi2 = 0.
	ndof = ng
	if( ng .le. 0 ) return
* 1 parameter
	if( h00 .gt. 0.d0 ) a0 = c0 / h00
	ndof = ng - 1
* hessian cofactors
	cof00 = h11 * h22 - h12 * h12
	cof11 = h00 * h22 - h02 * h02
	cof22 = h00 * h11 - h01 * h01
	cof01 = h02 * h12 - h01 * h22
	cof02 = h01 * h12 - h02 * h11
	cof12 = h02 * h01 - h00 * h12
* hessian determinant
	det0 = h00 * cof00
	det1 = h01 * cof01
	det2 = h02 * cof02
	det = det0 + det1 + det2
* 2 parameters
      if( det .eq. 0.d0 ) then
	write(*,*) '** fitcp2 singular matrix', det0, det1, det2, det
* 3 parameters
      else
	a0 = ( cof00 * c0 + cof01 * c1 + cof02 * c2 ) / det
	a1 = ( cof01 * c0 + cof11 * c1 + cof12 * c2 ) / det
	a2 = ( cof02 * c0 + cof12 * c1 + cof22 * c2 ) / det
	ndof = ng - 3
      end if
* evaluate chi^2
	sum = 0.d0
      do i = 1, n
      if( sig(i) .gt. 0. ) then
	fit = a0 + a1 * p1(i) + a2 * p2(i)
	eta = ( dat(i) - fit ) / sig(i)
	sum = sum + eta * eta
      end if
      end do
	chi2 = sum
	return
	end
	SUBROUTINE BOXFILT( NPIX, DATA, NFILT )
*
*  Boxcar filter
*
*  Inputs:
*	NPIX	= NUMBER OF DATA VALUES
*	DATA	= DATA ARRAY
*	NFILT	= FILTER WIDTH ( should be odd)
*  Outputs:
*	DATA	= Filtered data array
*
*  Feb 1985 by Keith Horne at IOA
*
	REAL*4 DATA(*)
	PARAMETER (MAXBOX = 1001)
	REAL*4 BOX(MAXBOX)
	REAL*8 SUM
*
	IF( NPIX.LE.1 ) RETURN
*
*  Determine boxcar width
*	
	NBOX = MIN( NPIX, NFILT, MAXBOX )
	NHBOX= NBOX/2
	NBOX = NHBOX*2+1	! Ensure box width is an odd integer
	IF( NBOX.LT.3 ) RETURN
*
*  Determine slopes for end corrections
*
	SUM = 0.D0
      DO I=1,NHBOX
	SUM = SUM - DATA(I)
      END DO
      DO I=NHBOX+2,NBOX
	SUM = SUM + DATA(I)
      END DO
	SLOPE1 = SUM / (NHBOX*(NHBOX+1))
	ICEN1 = NHBOX+1
*
	SUM = 0.D0
      DO I=NPIX-2*NHBOX,NPIX-NHBOX-1
	SUM = SUM - DATA(I)
      END DO
      DO I=NPIX-NHBOX+1,NPIX
	SUM = SUM + DATA(I)
      END DO
	SLOPE2 = SUM / (NHBOX*(NHBOX+1))
	ICEN2 = NPIX-NHBOX
*
*  Load and sum first box of data
*
	SUM = 0.D0
      DO I=1,NBOX
	BOX(I) = DATA(I)
	SUM = SUM + BOX(I)
      END DO
*
*  Loop thru the array, computing box averages
*  (NHBOX+1 pixels on each end of the array get identical values)
*
	NEXTPUT = NBOX-1
	NEXTGET = NEXTPUT
      DO I = ICEN1, ICEN2
	NEXTGET = NEXTGET + 1
	NEXTPUT = NEXTPUT + 1
	IF( NEXTPUT.GT.NBOX ) NEXTPUT = 1
	SUM = SUM - BOX(NEXTPUT) + DATA(NEXTGET)	! Update box sum
	BOX(NEXTPUT) = DATA(NEXTGET)	! Move latest value into the box
	DATA(I) = SUM / NBOX		! Store the box average
      END DO
*
*  Make end corrections by linear extrapolation
*
      DO I=1,ICEN1-1
	DATA(I) = DATA(ICEN1) + SLOPE1 * (I-ICEN1)
      END DO
      DO I=NPIX-ICEN1+1,NPIX
	DATA(I) = DATA(ICEN2) + SLOPE2 * (I-ICEN2)
      END DO
*
	RETURN
	END
	SUBROUTINE MEDFILT(DATA,DOUT,NPOINT,MEDP,IFAIL)
C
C THIS ROUTINE MEDIAN FILTERS ARRAY DATA(NPOINT)
C IT FITS AS MANY OF THE SPECIFIED SIZE OF FILTER
C AS IT CAN GIVEN THE END CONSTRAINTS, AND USES THE MEDIAN
C AS THE FILTERED VALUE. 
C 
C PASSED: REAL*4 DATA(NPOINT) -- DATA ARRAY TO BE FILTERED
C	  INTEGER*4 NPOINT -- NUMBER OF POINTS IN ARRAY
C	  INTEGER*4 MEDP -- WIDTH OF FILTER IN BINS
C
C RETURNED:
C	  REAL*4 DOUT(NPOINT) -- FILTERED ARRAY
C	  INTEGER*4 IFAIL -- ERROR RETURN = 1 IN CASE OF ERROR
C
*  1985 BY TOM MARSH AT IOA
* 
	PARAMETER ( MFMAX = 5001 )
	INTEGER*4 MEDP, IWORK(MFMAX) ! INDEX ARRAY
	REAL*4 DATA(NPOINT),DOUT(NPOINT)
	REAL*4 WORK(MFMAX+2)
C
	IF(MEDP.EQ.1) THEN
	  DO I=1,NPOINT
	    DOUT(I) = DATA(I)
	  END DO
	  RETURN
	END IF

	IF(2*(MEDP/2)-MEDP.EQ.0) MEDP = MEDP - 1
	IFAIL = 0
	IF(MEDP.GT.MFMAX) THEN
	  IFAIL = 1
	  RETURN
	END IF

	JSTART=1
	JSTOP = MIN(MEDP/2+1,NPOINT) 
	NACT = JSTOP
	DO J=1,NACT
	  WORK(JSTOP+J)=DATA(J)
	END DO
C
C SORT FIRST FILTER BLOCK
C
	CALL QUICKSORT( NACT, WORK(JSTOP+1), IWORK)
	DO I=1,NACT
	  WORK(I) = WORK(JSTOP+IWORK(I))
	END DO
	DOUT(1) = WORK(NACT/2+1)
	DO I=2,NPOINT
C
C FIND START AND STOP POINTS FOR FILTER
C
	  JNEW1 = MAX(I - MEDP/2,1)
	  JNEW2 = MIN(I + MEDP/2,NPOINT)
C
C UPDATE KEY INDEX ARRAY, IF START HAS CHANGED
C DELETE FIRST POINT
C
	  IF(JNEW1 - JSTART .EQ. 1) THEN
	    IAD = 0
	    DO J=1,NACT
	      IF(IWORK(J).EQ.1) IAD = 1
	      IN = J + IAD
	      IWORK(J) = IWORK(IN) - 1
	      WORK(J) = WORK(IN)
	    END DO
	    NACT = NACT -1
	  END IF
C
C IF STOP HAS CHANGED
C ADD EXTRA POINT TO THE END
C
	  IF(JNEW2 - JSTOP .EQ.1) THEN
	    TEST = DATA(JSTOP)
	    NACT = NACT + 1
	    DO J=1,NACT-1
	      IF(TEST.LT.WORK(J)) THEN
	        ITEST = J
	        GOTO 10
	      END IF
	    END DO
	    IWORK(NACT) = NACT
	    WORK(NACT) = TEST
	    GOTO 20
   10	CONTINUE
	    DO J=NACT,ITEST+1,-1
	      IWORK(J) = IWORK(J-1)
	      WORK(J)  = WORK(J-1)
	    END DO
	    WORK(ITEST) = TEST
	    IWORK(ITEST) = NACT
	  END IF
   20	CONTINUE
	  DOUT(I) = WORK(NACT/2+1)
	  JSTART = JNEW1
	  JSTOP  = JNEW2
	END DO
	RETURN
	END
      SUBROUTINE MEDIAN(WDATA,NPIX,IPEAK,ESIG,RBIN,SIGBIN,IFLIP)
C
C   THIS SUBROUTINE CALCULATES ACCURATE LINE POSITIONS GIVEN A
C   LINE POSITION 'IPEAK' AND A LINE FULL-WIDTH-HALF-MAXIMUM 'ESIG'.
C   A MEAN POSITION IS CALCULATED BY CHOOSING A POINT WHICH EQUATES THE
C   NUMBER OF COUNTS IN THE LINE ABOVE AND BELOW THE GIVEN POSITION. THIS
C   IS DONE WITH A GAUSSIAN DERIVATIVE KERNAL FUNCTION RATHER THAN A
C   STEP FUNCTION. THIS GIVES HIGH STABILITY FOR CONFUSED LINES OR LOW
C   SIGNAL-TO-NOISE RATIO DATA.
C
C   WDATA  =  REAL*4 ARRAY CONTAINING THE ARC FRAME.
C   NPIX   =  INTEGER*4. NUMBER OF PIXELS IN DATA ARRAY.
C   IPEAK  =  BIN NUMBER OF PEAK OF LINE. NEED ONLY BE WITHIN ABOUT 'ESIG'
C             OF TRUE POSITION.
C   ESIG   =  FULL-WIDTH HALF MAXIMUM OF LINE TO BE FED IN. NEED ONLY BE
C             ACCURATE TO ABOUT 40 PERCENT.
C             IF ESIG.LT.2. THEN A VALUE OF 2. IS USED.
C   RBIN   =  REAL*4 RETURNS LINE POSITION.
C   SIGBIN =  REAL*4 RETURNS THE RATIO OF THE ERROR OF THE LINE
C             POSITION IN BINS TO THE ERROR IN THE DATA NUMBER
C             FOR A PIXEL IN THE CONTINUUM.
C   IFLIP  =  INTEGER*4 1 FOR EMISSION LINES, -1 FOR ABSORPTION.
C
C   POSITION CALCULATION ACCURATE TO ABOUT ESIG/SQRT(NUMBER OF PHOTONS IN LINE).
C
* 2001 Aug Keith Horne @ St.And - linux JMIN0,JMAX0,JMOD,JNINT
      REAL*4 WDATA(*)
      REAL*4 CNT(11)
C
C   SIGFAC =  RATIO OF SMOOTHING FUNCTION SIGMA TO LINE SIGMA.
      DATA SIGFAC/.8/
C
C     EPS = TOLERANCE IN BINS FOR NEWTON ITERATION 
      DATA EPS/1.E-5/
      CARE=1.
      FSIG=ESIG
      IF (FSIG.LT.2.) FSIG=2.
      RSIG=(FSIG/2.35)*SIGFAC
      IWID = NINT( ( FSIG /2.35 )*3. )
C
C   HUNT FOR LOCAL MAXIMUM.
C
      ICHAMP=IPEAK
 13   JPEAK=ICHAMP
      ISEARCH = MAX( 2, MIN ( 5, IWID ) )
      DO 100 IP=JPEAK-ISEARCH,JPEAK+ISEARCH
      II=IP-JPEAK+ISEARCH+1
      CNT(II)=0.
      DO 111 IQ = MAX( 1, IP-IWID ), MIN( NPIX, IP+IWID )
      FACT=((IQ-IP)**2)/(2.*(ESIG/2.35)**2)
      FACT=EXP(-FACT)
 111  CNT(II)=CNT(II)+WDATA(IQ)*FACT
 100  CONTINUE
      CHAMP=CNT(1)
      ICHAMP=JPEAK-ISEARCH
      DO 12 II=1,2*ISEARCH+1
      IF (CNT(II)*IFLIP.LT.CHAMP*IFLIP) GO TO 12
      CHAMP=CNT(II)
      ICHAMP=JPEAK+II-ISEARCH-1
 12   CONTINUE
      IF (IABS(ICHAMP-JPEAK).EQ.ISEARCH) GO TO 13
      JPEAK=ICHAMP
      RMU=JPEAK
C
C   SOLVE LINE-POSITION EQUATION BY NEWTON'S METHOD.
C
      DO 1 IT=1,100
      IF( MOD(IT,10) .EQ. 0 ) CARE=0.95*CARE
      RX1=0.
      RX2=0.
      JPEAK = NINT( RMU )
      IB1 = MAX( 1, JPEAK - IWID )
      IB2 = MIN( NPIX, JPEAK + IWID )
      DO 2 I=IB1,IB2
      RAT=(I-RMU)*(I-RMU)/(RSIG*RSIG)
      EXPF=EXP(-RAT*0.5)
      RX1=RX1+WDATA(I)*(I-RMU)*EXPF
 2    RX2=RX2+WDATA(I)*(RAT-1.)*EXPF
      IF (RX2.NE.0.) RMUN=RMU-CARE*AMAX1(-3.,AMIN1(RX1/RX2,3.))
      IF (RX2.EQ.0.) RMUN=RMU-1.
      IF (ABS(RMUN-RMU).LE.EPS) GO TO 3
      RMU=RMUN
 1    CONTINUE
 3    RBIN=RMUN
C
C  CALCULATE ERROR IN BIN POSITION
C
      RX1=0.
      RX2=0.
      DO 5 I=IB1,IB2
      RAT=(I-RBIN)*(I-RBIN)/(RSIG*RSIG)
      EXPF=EXP(-RAT*0.5)
      RX1=RX1+ABS(WDATA(I))*(I-RBIN)*(I-RBIN)*EXPF*EXPF
    5 RX2=RX2+WDATA(I)*(RAT-1.)*EXPF
      SIGBIN=0.
      IF(RX2*RX2.NE.0.) SIGBIN=SQRT(RX1/(RX2*RX2))
      RETURN
      END
***************************************************
	FUNCTION XMEDIAN( NDATA, DATA )
* find median of an array of real numbers
*  Input:
*	NDATA	= I4 number of data values
*	DATA	= R4 array of data values
*  Output:
*	MEDVAL	= R4 median value of data
*
* Mar 1988 Keith Horne @ STScI - add special cases N=1,2, trap invalid inputs
* Jan 1995 KDH @ St.And - fix bug when NPTS = 2, eliminate type.
* Mar 2000 KDH @ St.And - MAXDATA 10000->20000
* Mar 2000 KDH @ St.And - medval(x,n) -> xmedian(n,x)
* Sep 2000 KDH @ St.And - shellsort -> quicksort
* Sep 2003 KDH @ St.And - MAXDATA 20,000->100,000
* Jun 2012 KDH @ St.And - MAXDATA 100,000->200,000

	REAL*4 DATA(*)
	PARAMETER ( MAXDATA = 200000 )
	INTEGER*4 IRANK( MAXDATA )

* trap invalid dimensions

      IF( NDATA.LT.1 ) THEN
	WRITE(*,*) '** INVALID DIMENSION', NDATA 
	GOTO 999
      ELSE IF( NDATA.GT.MAXDATA ) THEN
	WRITE(*,*) '** WARNING: buffer overflow in XMEDIAN', NDATA, MAXDATA
      END IF
	NPTS = MIN( NDATA, MAXDATA )

      IF( NPTS.EQ.1 ) THEN
	XMEDIAN = DATA(1)
	GOTO 1000
      ELSE IF( NPTS.EQ.2 ) THEN
	XMEDIAN = 0.5 * ( DATA(1) + DATA(2) )
	GOTO 1000
      END IF

* compute rank of each data value using a sort

	CALL QUICKSORT( NPTS, DATA, IRANK )
	MEDRANK = ( NPTS + 1 ) / 2 
	XMEDIAN = DATA( IRANK( MEDRANK ) )

* average two values if the number of points is even 

      IF( MEDRANK + MEDRANK .EQ.NPTS ) THEN
	XMEDIAN = 0.5 * ( XMEDIAN + DATA( IRANK( MEDRANK+1 ) ) )
      END IF

* normal return

 1000	RETURN

* error return

  999	XMEDIAN = 0.
	WRITE(*,*) '** XMEDIAN aborted.'
	RETURN
	END
********************************************
	SUBROUTINE QUICKSORT( N, X, KEY )
*
* QUICKSORT subroutine (Hoare)
* Produces index such that X(KEY(I)) ascends with I
*
* Input:
*	N	= number of items to be sorted
*	X(N)	= REAL*4 values to be sorted
* Output:
*	KEY(N)	= sort key such that X(KEY(I)) ascends with I
*
* Adapted by T.R.Marsh from a Mike Irwin routine.
* X is left unchanged.  Compatible arguments with
* SHELLSORT and BUBSORT.  About 3 times faster than
* SHELLSORT for more than 5000 points, roughly the
* same below 2000.
*
* July 1985 KDH @ STScI -- typed in and tested.
* 1999 Oct KDH @ St.Andrews - eliminate TYPE
* 2001 Jul KDH @ St.And -- use .eqv. when comparing logicals
* 2018 Feb KDH @ St.And X(*),KEY(*)=>X(N),KEY(N)
	REAL*4 X( N )
	INTEGER*4 KEY( N )
	PARAMETER ( MAXSTACK=300 )
	INTEGER*4 ISTACK(2,MAXSTACK)
	LOGICAL*1 L1, L2, L3, CARRYON
      DO I = 1, N
	KEY(I) = I
      END DO
	CARRYON = .TRUE.
	M = 9
	IF( N.LE.M ) GOTO 500
	IL = 1
	IR = N
	ISP = 0			! Initialize stack pointer
      DO WHILE( CARRYON )
	I = IL
	J = IR + 1
	IM = ( IL + IR ) / 2	! Find median for partition
	L1 = X( KEY(IM) ) .LT. X( KEY(IR) )
	L2 = X( KEY(IR) ) .LT. X( KEY(IL) )
	L3 = X( KEY(IL) ) .LT. X( KEY(IM) )
      IF( L2 .EQV. L3 ) THEN
	IQ = IL
      ELSE IF( L1 .EQV. L3 ) THEN
	IQ = IM
      ELSE
	IQ = IR
      END IF
	XTEST = X( KEY(IQ) )
	ITEST = KEY(IQ)
	KEY(IQ) = KEY(IL)
	KEY(IL) = ITEST
  100	I = I + 1
      DO WHILE( X( KEY(I) ) .LT. XTEST )
	I = I + 1
      END DO
	J = J - 1
      DO WHILE( XTEST .LT. X( KEY(J) ) )
	J = J - 1
      END DO
      IF( J.LE.I ) THEN
	ITEST = KEY(J)
	KEY(J) = KEY(IL)
	KEY(IL) = ITEST
      ELSE
	ITEST = KEY(J)
	KEY(J) = KEY(I)
	KEY(I) = ITEST
	GOTO 100
      END IF

* Update stack

      IF( IR-J.GE.J-IL .AND. J-IL.GT.M ) THEN
	ISP = ISP + 1
	IF( ISP.GT.MAXSTACK ) write(*,*)
     &		CHAR(7),'*** STACK OVERFLOW IN QUICKSORT.'
	ISTACK(1,ISP) = J + 1
	ISTACK(2,ISP) = IR
	IR = J - 1
      ELSE IF( J-IL.GT.IR-J .AND. IR-J.GT.M ) THEN
	ISP = ISP + 1
	IF( ISP.GT.MAXSTACK ) write(*,*)
     &		CHAR(7),'*** STACK OVERFLOW IN QUICKSORT.'
	ISTACK(1,ISP) = IL
	ISTACK(2,ISP) = J - 1
	IL = J+1
      ELSE IF( IR-J.GT.M .AND. M.GE.J-IL ) THEN
	IL = J + 1
      ELSE IF( J-IL.GT.M .AND. M.GE.IR-J ) THEN
	IR = J-1
      ELSE IF( ISP.GT.0 ) THEN
	IL = ISTACK(1,ISP)
	IR = ISTACK(2,ISP)
	ISP = ISP - 1
      ELSE
	CARRYON = .FALSE.
      END IF
      END DO

* Straight insertion sort

  500	IF( M .EQ. 1 ) RETURN
	INT = 1
	IFIN = N - INT
      DO II = 1, IFIN
	I = II
	J = I + INT
      IF( X( KEY(I) ) .GT. X( KEY(J) ) ) THEN
	XTEST = X( KEY(J) )
	ITEST = KEY(J) 
	KEY(J) = KEY(I)
	J = I
	I = I - INT
      DO WHILE( I .GT. 0 .AND. X( KEY(MAX(1,I)) ) .GT. XTEST )
	KEY(J) = KEY(I)
	J = I
	I = I - INT
      END DO
	KEY(J) = ITEST
      END IF
      END DO
	RETURN
	END
********************************************
	SUBROUTINE QUICKSORTI( N, IX, KEY )
*
* QUICKSORT subroutine (Hoare)
* Produces index such that IX(KEY(I)) ascends with I
*
* Input:
*	N	= number of items to be sorted
*	IX(N)	= INTEGER*4 values to be sorted
* Output:
*	KEY(N)	= sort key such that IX(KEY(I)) ascends with I
*
* Adapted by T.R.Marsh from a Mike Irwin routine.
* X is left unchanged.  Compatible arguments with
* SHELLSORT and BUBSORT.  About 3 times faster than
* SHELLSORT for more than 5000 points, roughly the
* same below 2000.
*
* July 1985 KDH @ STScI -- typed in and tested.
* 1999 Oct KDH @ St.Andrews - eliminate TYPE
* 2001 Jul KDH @ St.And -- use .eqv. when comparing logicals
* 2003 Dec KDH @ St.And -- QUICKSORTI adapted from QUICKSORT
	INTEGER*4 IX( * )
	INTEGER*4 KEY( * )
	PARAMETER ( MAXSTACK=300 )
	INTEGER*4 ISTACK( 2, MAXSTACK )
	LOGICAL*1 L1, L2, L3, CARRYON
      DO I = 1, N
	KEY(I) = I
      END DO
	CARRYON = .TRUE.
	M = 9
	IF( N.LE.M ) GOTO 500
	IL = 1
	IR = N
	ISP = 0			! Initialize stack pointer
      DO WHILE( CARRYON )
	I = IL
	J = IR + 1
	IM = ( IL + IR ) / 2	! Find median for partition
	L1 = IX( KEY(IM) ) .LT. IX( KEY(IR) )
	L2 = IX( KEY(IR) ) .LT. IX( KEY(IL) )
	L3 = IX( KEY(IL) ) .LT. IX( KEY(IM) )
      IF( L2 .EQV. L3 ) THEN
	IQ = IL
      ELSE IF( L1 .EQV. L3 ) THEN
	IQ = IM
      ELSE
	IQ = IR
      END IF
	IXTEST = IX( KEY(IQ) )
	ITEST = KEY(IQ)
	KEY(IQ) = KEY(IL)
	KEY(IL) = ITEST
  100	I = I + 1
      DO WHILE( IX( KEY(I) ) .LT. IXTEST )
	I = I + 1
      END DO
	J = J - 1
      DO WHILE( IXTEST .LT. IX( KEY(J) ) )
	J = J - 1
      END DO
      IF( J.LE.I ) THEN
	ITEST = KEY(J)
	KEY(J) = KEY(IL)
	KEY(IL) = ITEST
      ELSE
	ITEST = KEY(J)
	KEY(J) = KEY(I)
	KEY(I) = ITEST
	GOTO 100
      END IF

* Update stack

      IF( IR-J .GE. J-IL .AND. J-IL .GT. M ) THEN
	ISP = ISP + 1
	IF( ISP .GT. MAXSTACK ) write(*,*)
     &		CHAR(7),'*** STACK OVERFLOW IN QUICKSORT.'
	ISTACK( 1, ISP ) = J + 1
	ISTACK( 2, ISP ) = IR
	IR = J - 1
      ELSE IF( J-IL .GT. IR-J .AND. IR-J .GT. M ) THEN
	ISP = ISP + 1
	IF( ISP .GT. MAXSTACK ) write(*,*)
     &		CHAR(7),'*** STACK OVERFLOW IN QUICKSORT.'
	ISTACK( 1, ISP ) = IL
	ISTACK( 2, ISP ) = J - 1
	IL = J+1
      ELSE IF( IR-J .GT. M .AND. M .GE. J-IL ) THEN
	IL = J + 1
      ELSE IF( J-IL .GT. M .AND. M .GE. IR-J ) THEN
	IR = J-1
      ELSE IF( ISP .GT. 0 ) THEN
	IL = ISTACK( 1, ISP )
	IR = ISTACK( 2, ISP )
	ISP = ISP - 1
      ELSE
	CARRYON = .FALSE.
      END IF
      END DO

* Straight insertion sort

  500	IF( M .EQ. 1 ) RETURN
	INT = 1
	IFIN = N - INT
      DO II = 1, IFIN
	I = II
	J = I + INT
      IF( IX( KEY(I) ) .GT. IX( KEY(J) ) ) THEN
	IXTEST = IX( KEY(J) )
	ITEST = KEY(J) 
	KEY(J) = KEY(I)
	J = I
	I = I - INT
      DO WHILE( I.GT.0 .AND. IX( KEY(I) ) .GT. IXTEST )
	KEY(J) = KEY(I)
	J = I
	I = I - INT
      END DO
	KEY(J) = ITEST
      END IF
      END DO
	RETURN
	END
********************************************
	SUBROUTINE QUICKSORT8( N, X, KEY )
*
* REAL*8 VERSION OF QUICKSORT
* QUICKSORT subroutine (Hoare)
* Produces index such that X(KEY(I)) ascends with I
*
* Input:
*	N	= number of items to be sorted
*	X(N)	= REAL*8 values to be sorted
* Output:
*	KEY(N)	= sort key such that X(KEY(I)) ascends with I
*
* Adapted by T.R.Marsh from a Mike Irwin routine.
* X is left unchanged.  Compatible arguments with
* SHELLSORT and BUBSORT.  About 3 times faster than
* SHELLSORT for more than 5000 points, roughly the
* same below 2000.
*
* July 1985 KDH @ STScI -- typed in and tested.
* 1999 Oct KDH @ St.Andrews - eliminate TYPE
* 2001 Jul KDH @ St.And -- use .eqv. when comparing logicals
* 2009 Jul KDH @ St.And -- real*8 version
* 2018 Feb KDH @ St.And -- X(*),KEY(*) -> X(N),KEY(N)
	REAL*8 X( N ), XTEST
	INTEGER*4 KEY( N )
	PARAMETER ( MAXSTACK=300 )
	INTEGER*4 ISTACK(2,MAXSTACK)
	LOGICAL*1 L1, L2, L3, CARRYON
      DO I = 1, N
	KEY(I) = I
      END DO
	CARRYON = .TRUE.
	M = 9
	IF( N.LE.M ) GOTO 500
	IL = 1
	IR = N
	ISP = 0			! Initialize stack pointer
      DO WHILE( CARRYON )
	I = IL
	J = IR + 1
	IM = ( IL + IR ) / 2	! Find median for partition
	L1 = X( KEY(IM) ) .LT. X( KEY(IR) )
	L2 = X( KEY(IR) ) .LT. X( KEY(IL) )
	L3 = X( KEY(IL) ) .LT. X( KEY(IM) )
      IF( L2 .EQV. L3 ) THEN
	IQ = IL
      ELSE IF( L1 .EQV. L3 ) THEN
	IQ = IM
      ELSE
	IQ = IR
      END IF
	XTEST = X( KEY(IQ) )
	ITEST = KEY(IQ)
	KEY(IQ) = KEY(IL)
	KEY(IL) = ITEST
  100	I = I + 1
      DO WHILE( X( KEY(I) ) .LT. XTEST )
	I = I + 1
      END DO
	J = J - 1
      DO WHILE( XTEST .LT. X( KEY(J) ) )
	J = J - 1
      END DO
      IF( J.LE.I ) THEN
	ITEST = KEY(J)
	KEY(J) = KEY(IL)
	KEY(IL) = ITEST
      ELSE
	ITEST = KEY(J)
	KEY(J) = KEY(I)
	KEY(I) = ITEST
	GOTO 100
      END IF

* Update stack

      IF( IR-J.GE.J-IL .AND. J-IL.GT.M ) THEN
	ISP = ISP + 1
	IF( ISP.GT.MAXSTACK ) write(*,*)
     &		CHAR(7),'*** STACK OVERFLOW IN QUICKSORT.'
	ISTACK(1,ISP) = J + 1
	ISTACK(2,ISP) = IR
	IR = J - 1
      ELSE IF( J-IL.GT.IR-J .AND. IR-J.GT.M ) THEN
	ISP = ISP + 1
	IF( ISP.GT.MAXSTACK ) write(*,*)
     &		CHAR(7),'*** STACK OVERFLOW IN QUICKSORT.'
	ISTACK(1,ISP) = IL
	ISTACK(2,ISP) = J - 1
	IL = J+1
      ELSE IF( IR-J.GT.M .AND. M.GE.J-IL ) THEN
	IL = J + 1
      ELSE IF( J-IL.GT.M .AND. M.GE.IR-J ) THEN
	IR = J-1
      ELSE IF( ISP.GT.0 ) THEN
	IL = ISTACK(1,ISP)
	IR = ISTACK(2,ISP)
	ISP = ISP - 1
      ELSE
	CARRYON = .FALSE.
      END IF
      END DO

* Straight insertion sort

  500	IF( M .EQ. 1 ) RETURN
	INT = 1
	IFIN = N - INT
      DO II = 1, IFIN
	I = II
	J = I + INT
      IF( X( KEY(I) ) .GT. X( KEY(J) ) ) THEN
	XTEST = X( KEY(J) )
	ITEST = KEY(J) 
	KEY(J) = KEY(I)
	J = I
	I = I - INT
      DO WHILE( I.GT.0 .AND. X( KEY(MAX(1,I)) ) .GT. XTEST )
	KEY(J) = KEY(I)
	J = I
	I = I - INT
      END DO
	KEY(J) = ITEST
      END IF
      END DO
	RETURN
	END
      SUBROUTINE LSQUAR(DATA,NUMBER,N,A,CHISQ,XM,NORM)
C
C   LQSUAR PROVIDES A POLYNOMIAL FIT OF SPECIFIED DEGREE TO A SET OF
C   DATA POINTS. THE FIT IS DONE IN DOUBLE PRECISION.
C   USES THE DOUBLE PRECISION MATRIX INVERSION SUBROUTINE 'MLSRAR'.
C
C   DATA    =  ARRAY CONTAINING THE DATA. THIS SHOULD BE ARRANGED:
C              DATA(1,K): X-VALUE OF DATA POINT.
C              DATA(2,K): Y-VALUE OF DATA POINT.
C              DATA(3,K): SIGMA IN Y-VALUE OF DATA POINT.
C              (REAL*8).
C   NUMBER  =  NUMBER OF DATA POINTS TO BE FITTED.
C   N       =  NUMBER OF COEFFICIENTS IN POLYNOMIAL TO BE FITTED. THE
C              ORDER OF THE POLYNOMIAL IS (N-1).
C   A       =  ARRAY HOLDING COEFFICIENTS OF FIT (REAL*8). THIS IS ARRANGED:
C              POLY = A(1) + A(2)*X + ... A(N)*X**(N-1)
C   CHISQ   =  CONTAINS THE CHI-SQUARE VALUE OF THE FIT ON OUTPUT. IF
C              CHISQ = -1. ON OUTPUT THEN THE MATRIX WAS SINGULAR, IF
C              CHISQ = -2. ON OUTPUT THEN OVERFLOW OR DIVIDE CHECK OCCURED.
C              CHISQ = -3. ON OUTPUT THEN INVALID PARAMETERS INPUT.
C              IF YOU SET CHISQ = 0. ON INPUT ERROR MESSAGES WILL BE PRINTED.
C              (REAL*8)
C   XM      =  WORKING STORAGE ARRAY (REAL*8). DIMENSION IN THE MAIN
C              PROGRAM AS XM(NMAX,2*NMAX+3) WHERE 'NMAX' IS THE MAXIMUM
C              VALUE OF 'N' YOU WISH TO CALL.
C   NORM    =  SCALING PARAMETER. SINCE LARGE POWERS OF THE INPUT DATA ARE
C              TO BE TAKEN OVERFLOWS OR UNDERFLOWS CAN EASILY OCCUR. IF
C              YOU SET NORM = 1 ON INPUT DATA ARE SCALED TO REDUCE LIKELIHOOD
C              OF THIS EVENT. NORM = 0 INSTRUCTS FOR NO SCALING. INPUT DATA
C              ARE NOT DESTROYED BY THE SCALING, AND COEFFICIENTS ARE
C              AUTOMATICALLY SCALED BACK BEFORE OUTPUT.
C
* Jan 1995 KDH @ St.And - PRINTR => IPRINT
* Aug 2019 KDH @ St.And - Don't use XM(2,*) when N=1
      REAL*8 XM(N,2*N+3),XX,RR,EPS,AVE,SIGMA
      REAL*8 DATA(3,NUMBER),A(N),CHISQ,S,R
C
C   EPS    =  MAXIMUM ALLOWED ERROR IN ITERATIONS ON THE POLYNOMIAL
C             COEFFICIENTS. CONVERGENCE TERMINATES WHEN ERROR.LT.EPS
C   NMAX   =  MAXIMUM ALLOWED NUMBER OF COEFFICIENTS (DUE TO DIMENSION
C             STATEMENTS).
C IPRINT   =  FORTRAN UNIT NUMBER FOR PRINTOUT
	LOGICAL RITE
	IPRINT = 2
	RITE = .FALSE.      
	EPS = 1.D-6
	NMAX = 50
C
C   TEST INPUT DATA.
C
      IF ((NUMBER.LE.0.OR.N.GT.NUMBER).OR.N.LE.0) THEN
      WRITE (IPRINT,801) NUMBER,N
 801  FORMAT ('0LSQUAR: NO OF POINTS: ',I5,' NO OF COEFFICIENTS: ',I5/
     $' INVALID VALUES (MUST BE POSITIVE AND POINTS.GE.COEFFICIENTS)')
      CHISQ=-3.
      RETURN
      ELSE IF (N.GT.NMAX) THEN
      WRITE (IPRINT,802) N,NMAX
 802  FORMAT ('0LSQUAR: NO OF COEFFICIENTS: ',I4,' MUST NOT EXCEED:',I4)
      CHISQ=-3.
      RETURN
      END IF

C
C   IF THE INPUT VALUE OF CHISQ IS 0. ALLOW PRINTING OF ERROR MESSAGES.  
C
      IF (CHISQ.EQ.0.) RITE=.TRUE.
      ITER=5
      IF (RITE) ITER=-ITER
      N21=2*N+1
      N22=N21+1
      N23=N21+2
C
C   RESCALE THE INPUT DATA (FOR NORM.NE.0).
C
      IF (NORM.EQ.0.OR.N.EQ.1) GO TO 1
      AVE=0.0
      SIGMA=0.0     
      DO 210 I=1,NUMBER      
      AVE=AVE+DATA(1,I)    
      SIGMA=SIGMA+DATA(1,I)**2    
 210  CONTINUE 
      AVE=AVE/NUMBER
      SIGMA=DSQRT(SIGMA/NUMBER-AVE*AVE)   
C
C   ZERO THE WORKING ARRAY.
C
 1    DO 12 I=1,N     
      DO 12 J=N21,N23 
 12   XM(I,J)=0.D0    
C
C   COMPUTE THE MOMENTS OF THE DATA.
C
      M2=2*N   
      DO 26 I=1,NUMBER
      RR=(1.D0/DATA(3,I))**2
* 2019 AUG KDH : THIS FAILS IF N=1
      IF( N .GT. 1 ) XM(2,N21)=XM(2,N21)+RR 
      XX=DATA(2,I)*RR 
      XM(1,N23)=XM(1,N23)+XX 
      IF (N.EQ.1) GO TO 26   
      DO 21 J=3,M2    
      IF (NORM.EQ.0) THEN
      RR=RR*DATA(1,I) 
      ELSE
      RR=RR*(DATA(1,I)-AVE)/SIGMA
      END IF
      IF (J.GT.N) GO TO 22   
      XM(J,N21)=XM(J,N21)+RR 
      GO TO 21 
 22   XM(J-N,N22)=XM(J-N,N22)+RR    
 21   CONTINUE 
      DO 25 J=2,N    
      IF (NORM.EQ.0) THEN
      XX=XX*DATA(1,I) 
      ELSE
      XX=XX*(DATA(1,I)-AVE)/SIGMA
      END IF
 25   XM(J,N23)=XM(J,N23)+XX 
 26   CONTINUE    
C
C   COMPUTE MATRIX FOR INVERSION.
C
      DO 31 I=1,N     
      DO 31 J=1,N  
      K=I+J    
      IF (K.GT.N) GO TO 32   
      XM(I,J)=XM(K,N21)      
      GO TO 31 
 32   XM(I,J)=XM(K-N,N22)    
 31   CONTINUE  
C
C   CALL DOUBLE PRECISION MATRIX INVERSION ROUTINE.
C
      IF (N.NE.1) GO TO 35     
      XM(1,1)=(1.0D0)/XM(1,1)
      A(1)=XM(1,1)*XM(1,N23) 
      GO TO 37      
 35   CALL MLSRAR(N,XM,XM(1,N23),ITER,EPS,A,ITEST,0,XM(1,N+1))  
      IF (ITEST.GE.5) GO TO 80
C
C   COMPUTE CHI-SQUARE FOR RESULTING FIT.
C
 37   CHISQ=0.0  
      DO 70 I=1,NUMBER     
      S=A(1)
      IF (N.EQ.1) GO TO 69     
      R=1.    
      DO 68 J=2,N  
      IF (NORM.EQ.0) THEN
      R=R*DATA(1,I)
      ELSE
      R=R*(DATA(1,I)-AVE)/SIGMA
      END IF
 68   S=S+A(J)*R  
 69   CHISQ=CHISQ+((S-DATA(2,I))/DATA(3,I))**2     
 70   CONTINUE     
      GO TO 79
C
C   ERROR MESSAGES AFTER INVERSION OF THE MATRIX XM (H IN THE WRITE-UP).
C
 80   CONTINUE
      SING=5. 
C     IF (RITE) WRITE (IPRINT,800) ITEST
C800  FORMAT ('0LSQUAR ERROR: NO CONVERGENCE',I5,'  ITERATIONS')
      CHISQ=-2.0   
 79   IF (NORM.EQ.0.OR.N.EQ.1) RETURN
C
C   RESCALE COEFFICIENTS IF DATA SCALING WAS REQUESTED.
C
      SIGMA=1.0D0/SIGMA
      AVE=-AVE*SIGMA
      L=N-1   
      DO 6 I=1,L 
      XM(I,1)=AVE**I
 6    XM(I,2)=0.D0
      XM(1,2)=1.D0
      XM(N,2)=0.D0
      DO 7 I=1,L
      K=N-I+1
      DO 8 J=2,K     
 8    XM(J,2)=XM(J,2)+XM(J-1,2)
      K=I+1
      DO 9 J=K,N
 9    A(I)=A(I)+A(J)*XM(J-I+1,2)*XM(J-I,1)
      A(I)=A(I)*SIGMA**(I-1)
 7    CONTINUE
      A(N)=A(N)*SIGMA**(N-1)
      RETURN 
      END
C-----------------------------------------------------
      SUBROUTINE MLSRAR(N,BDMTX,V,ITER,EPS,F,IT,INEW,A)
C
C   DOUBLE PRECISION MATRIX INVERSION.
C
C   N       =  ORDER OF MATRIX.
C   BDMTX   =  TWO-DIMENSIONAL ARRAY OF COEFFICIENTS.
C   V       =  RIGHT-HAND VECTOR.
C   ITER    =  MAXIMUM NUMBER OF ITERATIONS DESIRED.
C   EPS     =  TOLERANCE FOR CONVERGENCE.
C   F       =  RESULTING VECTOR.
C   IT      =  OUTPUT FROM ROUTINE SPECIFYING NUMBER OF ITERATIONS ACTUALLY
C              DONE.
C   INEW    =  VARIABLE SET TO VALUE .NE.1 ON FIRST CALL. ON SUBSEQUENT CALLS
C              IT IS SET TO 1 IF THE MATRIX IS UNCHANGED BUT THE COLUMN
C              VECTOR 'B' IS CHANGED.
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION BDMTX(N,N),V(N),F(N),A(N,N),X(50),IDX(50),XT(50)
      LOGICAL RITE
      RITE=.FALSE.
	IPRINT = 2
      IF (ITER.LT.0) RITE=.TRUE.
      ITER=IABS(ITER)
      IT = 0
      DO 9 I=1,N
      X(I)=V(I)
      F(I)=0.0 
 9    CONTINUE 
      N1=N-1
      IF (INEW .EQ. 1) GO TO 181
      DO 10 I=1,N
      DO 10 J=1,N
      A(I,J)=BDMTX(I,J)
 10   CONTINUE
      DO 12 I=1,N
 12   IDX(I)=I 
      SG1=0.
      DO 60 I=2,N
C
C   PARTIAL PIVOTING, CHECK FOR MAX ELEMENT IN (I-1)ST COLUMN.
C
      IM1=I-1
      AMX=DABS(A(IM1,IM1))
      JMX=IM1
      DO 16 J=I,N
      ABSA=DABS(A(J,IM1))
      IF(AMX.GE.ABSA) GO TO 16
      AMX=ABSA 
      JMX=J
 16   CONTINUE
      IF(JMX.EQ.IM1) GO TO 20
C
C   MOVE THE ROW WITH MAX A(J,IM1) TO (IM1)ST ROW.
C
      DO 18 K=1,N
      T=A(IM1,K)
      A(IM1,K)=A(JMX,K)
 18   A(JMX,K)=T
      II=IDX(IM1)
      IDX(IM1)=IDX(JMX)
      IDX(JMX)=II
      XI=X(IM1)
      X(IM1)=X(JMX)
      X(JMX)=XI
      SG1=1.0
 20   CONTINUE
      IF(A(IM1,IM1).EQ.0.) GO TO 200
      DO 55 J=I,N
      CX=A(J,IM1)/A(IM1,IM1)
      DO 50 K=I,N
      A(J,K)=A(J,K)-CX*A(IM1,K)
 50   CONTINUE
      A(J,IM1)=CX
 55   CONTINUE
 60   CONTINUE
C
C   FORWARD PASS - OPERATE ON RIGHT HAND SIDE AS ON MATRIX.
C
 62   CONTINUE
      DO 70 I=2,N
      DO 65 J=I,N
      X(J)=X(J)-X(I-1)*A(J,I-1) 
 65   CONTINUE
 70   CONTINUE
C  
C   BACKWARD PASS - SOLVE FOR AX = B.
C
      X(N)=X(N)/A(N,N)
      DO 80 I=1,N1
      SUM=0.0
      I2=N-I+1
      IM1=I2-1
      DO 75 J=I2,N
      SUM=SUM+A(IM1,J)*X(J)
 75   CONTINUE
      X(IM1)=(X(IM1)-SUM)/A(IM1,IM1)
 80   CONTINUE
      DO 90 I=1,N
      F(I)=F(I)+X(I)
 90   CONTINUE
      SING=0.
      IF (IT.EQ.ITER) RETURN 
      IT=IT+1
      DO 95 I=1,N
      IF (F(I).EQ.0.) SING=1.00D38
      IF (F(I).EQ.0.) GO TO 150 
      SING=DMAX1(SING,DABS(X(I)/F(I)))
 95   CONTINUE
      IF (SING.GT.EPS) GO TO 150
C
C   FINISHED.
C
      RETURN
C
C   DOUBLE PRECISION MATRIX MULTIPLICATION.
C
 150  CONTINUE
      DO 170 I=1,N
      R=0.0D0
      DO 160 J=1,N
      R=R+BDMTX(I,J)*F(J)
 160  CONTINUE
      X(I)=V(I)-R
 170  CONTINUE
 181  IF(SG1.EQ.0.0) GO TO 62
C
C   IF SG1.NE.0, PERMUTE X BEFORE PERFORMING FORWARD PASS.
C
      DO 182 I=1,N
 182  XT(I)=X(I)
      DO 184 I=1,N
      K=IDX(I)
 184  X(I)=XT(K)
      GO TO 62
 200  IF (RITE) WRITE (IPRINT,510) IM1
 510  FORMAT ('0MLSRAR: DIAGONAL TERM:',I3,' REDUCED TO ZERO')
      RETURN
      END
C SUBROUTINE MATINV.F 
C
C SOURCE								       
C   BEVINGTON, PAGES 302-303.
C
C Modified 6/26/89 by G. Kriss for use in specfit.
C	Changed array sizes to MAXPAR=500.
C Modified 5/31/95 by G. Kriss for use in specfit
C	Changed array sizes to MAXFREE=200
C
C PURPOSE
C   INVERT A SYMMETRIC MATRIX AND CALCULATE ITS DETERMINANT
C
C USAGE 
C   CALL MATINV (ARRAY, NORDER, DET)
C
C DESCRIPTION OF PARAMETERS
C   ARRAY  - INPUT MATRIX WHICH IS REPLACED BY ITS INVERSE
C   NORDER - DEGREE OF MATRIX (ORDER OF DETERMINANT)
C   DET    - DETERMINANT OF INPUT MATRIX
C
C SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED 
C   NONE
C
C COMMENT
C   DIMENSION STATEMENT VALID FOR NORDER UP TO 200
C
	SUBROUTINE MATINV (ARRAY,NORDER,DET)
	DOUBLE PRECISION ARRAY,AMAX,SAVE
	parameter ( maxfree = 500 )
	DIMENSION ARRAY(norder,norder)
	integer*4 IK(maxfree), JK(maxfree)
	DET = 0.
	IF( NORDER .LE. 0 ) RETURN
	IF( NORDER .GT. MAXFREE ) RETURN
C
10	DET=1.
11	DO 100 K=1,NORDER
C
C FIND LARGEST ELEMENT ARRAY(I,J) IN REST OF MATRIX
C
	AMAX=0. 
21	DO 30 I=K,NORDER
	DO 30 J=K,NORDER
23	IF (DABS(AMAX)-DABS(ARRAY(I,J))) 24,24,30
24	AMAX=ARRAY(I,J) 
	IK(K)=I 
	JK(K)=J 
30	CONTINUE
C
C INTERCHANGE ROWS AND COLUMNS TO PUT AMAX IN ARRAY(K,K)
C
31	IF (AMAX) 41,32,41
32	DET=0.
	GOTO 140
41	I=IK(K) 
	IF (I-K) 21,51,43
43	DO 50 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=ARRAY(I,J)
50	ARRAY(I,J)=-SAVE
51	J=JK(K) 
	IF (J-K) 21,61,53
53	DO 60 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=ARRAY(I,J)
60	ARRAY(I,J)=-SAVE
C
C ACCUMULATE ELEMENTS OF INVERSE MATRIX 
C
61	DO 70 I=1,NORDER
	IF (I-K) 63,70,63
63	ARRAY(I,K)=-ARRAY(I,K)/AMAX
70	CONTINUE
71	DO 80 I=1,NORDER
	DO 80 J=1,NORDER
	IF (I-K) 74,80,74
74	IF (J-K) 75,80,75
75	ARRAY(I,J)=ARRAY(I,J)+ARRAY(I,K)*ARRAY(K,J)
80	CONTINUE
81	DO 90 J=1,NORDER
	IF (J-K) 83,90,83
83	ARRAY(K,J)=ARRAY(K,J)/AMAX
90	CONTINUE
	ARRAY(K,K)=1./AMAX
100	DET=DET*AMAX
C
C RESTORE ORDERING OF MATRIX
C
101	DO 130 L=1,NORDER
	K=NORDER-L+1
	J=IK(K) 
	IF (J-K) 111,111,105
105	DO 110 I=1,NORDER
	SAVE=ARRAY(I,K) 
	ARRAY(I,K)=-ARRAY(I,J)
110	ARRAY(I,J)=SAVE 
111	I=JK(K) 
	IF (I-K) 130,130,113
113	DO 120 J=1,NORDER
	SAVE=ARRAY(K,J) 
	ARRAY(K,J)=-ARRAY(I,J)
120	ARRAY(I,J)=SAVE 
130	CONTINUE
140	RETURN
	END

C*WORD1 -- isolate first word of a text string
C+
	SUBROUTINE WORD1( STRING, L1, L2 )
*
* Isolates the first word of a character string 
*
* Input:
*	STRING	= character string
* Output:
*	L1,L2	= Inclusive index limits of first word
C--
* Jan 1986 Keith Horne @ STScI
* Jan 1989 KDH @ STScI - revise to allow BLANK or TAB separators
* Oct 2014 KDH @ StAnd - revise to allow comma separators
	CHARACTER*(*) STRING
	CHARACTER*1 TAB, BLANK, TEST, comma
	comma = ','
	TAB = CHAR( 9 )
	BLANK = ' '
	LMAX = LEN1( STRING )
      DO I1 = 1, LMAX
	TEST = STRING(I1:I1)
      IF(     TEST .NE. BLANK
     &	.AND. TEST .NE. TAB
     &	.and. test .ne. comma ) THEN
	L1 = I1
      DO I2 = L1 + 1, LMAX
	TEST = STRING(I2:I2)
      IF(    TEST .EQ. BLANK
     &	.OR. TEST .EQ. TAB
     &	.or. test .eq. comma ) THEN
	L2 = I2 - 1
	RETURN
      END IF
      END DO
	L2 = LMAX
	RETURN
      END IF
      END DO
	L1 = 0
	L2 = 0
	RETURN
	END
************************************
	integer function len1( string )
* length up to last non-blank character
	character*(*) string
      do i = len( string ), 1, -1
      if( string( i:i ) .ne. ' ' ) then
	len1 = i
	return
      end if
      end do
	len1 = 0
	return
	end
***********************************************
	SUBROUTINE UPCASE( TEXTIN, TEXTOUT )
* replacement for VMS library routine STR$UPCASE( TEXTOUT, TEXTIN )
	CHARACTER*(*) TEXTIN
	CHARACTER*(*) TEXTOUT
	TEXTOUT = TEXTIN
	JADD = ICHAR('A') - ICHAR('a')
      DO I=1,LEN1(TEXTOUT)
	JTEST = ICHAR(TEXTOUT(I:I) )
      IF( JTEST .GE. ICHAR('a') .AND. JTEST .LE. ICHAR('z') ) THEN
	TEXTOUT(I:I) = CHAR( JTEST + JADD )
      END IF
      END DO
	RETURN
	END
*************************
	subroutine append( str1, str2 )
* append two strings with a space in between
* 2003 Jun Keith Horne @ St.Andrews
	character*(*) str1, str2
	l1 = len1( str1 )
	l2 = len1( str2 )
      if( l1 .le. 0 ) then
	str1 = str2( : l2 )
      else
	str1 = str1( : l1 ) // ' ' // str2( : l2 )
      end if
	return
	end
****************************************
	subroutine append_i( str, i )
* append integer to string
* 2003 Jun Keith Horne @ St.Andrews
	character*(*) str
	character*40 number
	write( number, * ) i
	call word1( number, l1, l2 )
	call append( str, number( l1 : l2 ) )
	return
	end
****************************************
	subroutine append_f( str, x, fmt )
* append formatted real to string
* 2003 Jun Keith Horne @ St.Andrews
* 2008 Aug KDH @ St.A - add '*' format
	character*(*) str, fmt
	character*40 number
      if( fmt(1:1) .eq. '*' ) then
	write( number, * ) x
      else
	write( number, fmt ) x
      end if
	call word1( number, l1, l2 )
	call append( str, number( l1 : l2 ) )
	return
	end
****************************************
	subroutine append_d( str, x, fmt )
* append formatted real*8 to string
* 2004 Feb Keith Horne @ St.Andrews
	real*8 x
	character*(*) str, fmt
	character*40 number
	write( number, fmt ) x
	call word1( number, l1, l2 )
	call append( str, number( l1 : l2 ) )
	return
	end

****************************************
	subroutine append_n( title, val, idig )
* append val to title with idig significant digits
* 2008 Jun Keith Horne @ St.Andrews
* 2008 Jul KDH @ SAAO - idig
	character*(*) title
	character*20 fmt
	i = max( 2, idig )
	a= abs( val ) / 10**(i)
      if( a .eq. 0.0 ) then
	call append_f( title, val, '(f10.1)' )
      else if( a .lt. 9.9e-8) then
	fmt = '(1pe'
	call append_i( fmt, i + 7 )
	call append( fmt, '.' )
	call append_i( fmt, i - 1 )
	call append( fmt, ')' )
	call nospace( fmt )
	call append_f( title, val, fmt )
      else if( a .lt. 9.9e-7) then
	call append_f( title, val, '(f15.6)' )
      else if( a .lt. 9.9e-6) then
	call append_f( title, val, '(f15.5)' )
      else if( a .lt. 9.9e-5 ) then
	call append_f( title, val, '(f15.4)' )
      else if( a .lt. 9.9e-4 ) then
	call append_f( title, val, '(f15.3)' )
      else if( a .lt. 9.9e-3 ) then
	call append_f( title, val, '(f15.2)' )
      else if( a .lt. 0.099 ) then
	call append_f( title, val, '(f15.1)' )
      else
	call append_i( title, nint( val ) )
      end if
	return
	end

********************************************
        subroutine append_datsig( title, dat, sig, kfig )
* Input
*       title   c* string
*       dat     r4 data
*       sig     r4 sigma
*       kfig    i4 number of significant figures on sigma
* Output
*       title   c* string // data(sigma)
* 2004 Feb Keith Horne @ St-Andrews
* 2013 May KDH @ StA trap sig not positive
* 2017 Sep KDH @ StA revise for very small/large numbers
        character*(*) title
        real*8 hjd, big
	dmx = 1000
	dmn = 0.0001

      if( sig .le. 0. ) then
	call append_n( title, dat, max( 2, kfig ) )

      else if( abs(dat) .ge. dmn .and. abs( dat ) .le. dmx ) then
        hjd = dat
        call append_hjdsig( title, hjd, sig, kfig )

      else

* divide by a power of 10
        mpow = nint( log10( abs( dat * 2. ) ) )
        ipow = nint( alog10( sig * 2. ) )
        kpow = ipow - kfig

	kpow = int( alog10( max( abs(dat), sig ) ) ) - 1
        div = 10. ** kpow
	hjd = dat / div

	call append_hjdsig( title, hjd, sig/div, kfig )
* exponent
      if( kpow .ne. 0 ) then
	l = len1( title ) + 1
	title(l:l) = 'E'
	call append_i( title, kpow )
	call nospace( title( l : len1(title) ) )
      end if
      end if
        return
        end

********************************************
        subroutine append_hjdsig( title, hjd, sig, kfig )
* Input
*       title   c* string
*       hjd     r8 data
*       sig     r4 sigma
*       kfig    i4 number of significant figures on sigma
* Output
*       title   c* string // data(sigma)
* 2004 Feb Keith Horne @ St-Andrews
* 2012 Dec KDH @ StA omit E0, skip if sig not positive
* 2013 May KDH @ StA trap sig not positive
        character*(*) title
        real*8 hjd
        character*50 fmt

      if( sig .le. 0. ) then
	call append_n( title, real(hjd), max( 2, kfig ) )
	return
      end if

        l1 = len1( title )
        mpow = nint( log10( abs( hjd * 2. ) ) )
        ipow = nint( alog10( sig * 2. ) )
        kpow = ipow - kfig
        div = 10. ** kpow

      if( kpow .lt. 0 ) then
        fmt = '(f20.'
        call append_i( fmt, -kpow )
        call append( fmt, ')' )
        call nospace( fmt )
        call append_d( title, hjd, fmt )

      if( sig .gt. 0. ) then
        sigdiv = sig / div
        call append( title, '(' )
      if( sig .lt. 1. ) then
        call append_i( title, nint( sigdiv ) )
      else
        call append_f( title, sig, fmt )
      end if
        call append( title, ')' )
      end if

      else if( kpow .gt. 3 ) then
        lpow = mpow
        if( iabs( ipow ) .gt. iabs( mpow ) ) lpow = ipow
        div = 10. ** lpow
        fmt = '(f20.'
        call append_i( fmt, kfig )
        call append( fmt, ')' )
        call nospace( fmt )
        call append_d( title, hjd / div, fmt )

      if( sig .gt. 0. ) then
        call append( title, '(' )
        call append_f( title, sig / div, fmt )
        call append( title, ')' )
      if( lpow .ne. 0 ) then
        call append( title, 'E' )
        call append_i( title, lpow )
      end if
      end if

      else
        idiv = 10 ** kpow
        call append_i( title, nint( hjd / idiv ) * idiv )
      if( sig .gt. 0. ) then
        call append( title, '(' )
        call append_i( title, nint( sig / idiv ) * idiv )
        call append( title, ')' )
      end if

      end if
        call nospace( title(l1+2:) )
        return
        end

****************************************
	subroutine nospace( str )
* remove spaces from string
* 2003 Aug Keith Horne @ St.Andrews
	character*(*) str
	n = len1( str )
	if( n .lt. 1 ) return
	j = 0
      do i=1,n
      if( str( i : i ) .ne. ' ' ) then
	j = j + 1
	str( j : j ) = str( i : i )
      end if
      end do
	str = str( : j )
	return
	end
****************************************
	subroutine notail( str, chr )
* remove specified character from end of string
* 2003 Dec Keith Horne @ St.Andrews
	character*(*) str, chr
	n = len1( str )
	if( n .lt. 1 ) return
      do while( n .gt. 0 .and. str(n:n) .eq. chr(1:1) )
	n = n - 1
      end do
	str = str(:n)
	return
	end
*------------------------------
	subroutine noeqbl( title )
* change '= ' to '='
* 2006 Feb Keith Horne @ St.Andrews
	character*(*) title
    1	l = index( title, '= ' )
	if( l .le. 0 ) return
	title = title(:l) // title(l+2:)
	goto 1
	end
*------------------------------
	subroutine nogreek( title )
* change pgplot greeks to text
* 2007 Aug Keith Horne @ LaSilla
	character*(*) title
	parameter ( nfix = 15 )
	character*3 old( nfix )
	character*5 new( nfix )
	data old/
     &		'\ga',	'\gb',	'\gg',	'\gg',	'\ge'
     &	,	'\gh',	'\gy',	'\gm',	'\gn',	'\gp'
     &	,	'\gr',	'\gs',	'\gx',	'\gD',	'\gW'
     &	/
	data new/
     &		'alp',	'bet',	'gam',	'del',	'eps'
     &	,	'theta', 'eta',	'mu',	'nu',	'pi'
     &	,	'rho',	'sig',	'chi',	'Del',	'Omega'
     &	/

      do k=1,nfix
	i = 1
      do while( i .gt. 0 )
	i = index( title, old(k) )
      if( i .gt. 0 ) then
	n = len1( new(k) )
	title = title(:i-1) // new(k)(:n) // title(i+3:)
      end if
      end do
      end do

	return
	end
*------------------------------
	subroutine noupdn( title )
* change pgplot sub and superscripts to text
* 2007 Aug Keith Horne @ LaSilla
	character*(*) title
	m = 1
      do while( m .gt. 0 )
	i = index( title, '\u' )
	j = index( title, '\d' )
      if( i .gt. 0 .and. j .gt. i ) then
	title = title(:i-1) // '^' // title(i+2:j-1) // title(j+2:)
      else if( j .gt. 0 .and. i .gt. j ) then
	title = title(:j-1) // '_' // title(j+2:i-1) // title(i+2:)
      else
	m = 0
      end if
      end do
	return
	end

*=============================================
        subroutine append_kmb( string, big, n )
* append big with units K=1e3, M=1e6, B=1e9
* In:   string  c* character string
*       big     r4 large number
*       n       i4 number of digits of precision
* Out:  label   c* appended string
* 2020 Apr Keith Horne @ St.Andrews
        character*(*) string
        x = big
        a = abs( x )
      if( a .lt. 1.e4 ) then
        call append_i( string, nint( x ) )
      else if( a .lt. 1.e6 ) then
        call append_n( string, x / 1.e3, n )
        call append( string, 'K' )
      else if( a .lt. 1.e9 ) then
        call append_n( string, x / 1.e6, n )
        call append( string, 'M' )
      else
        call append_n( string, x / 1.e9, n )
        call append( string, 'B' )
      end if
        return
  	end
	SUBROUTINE INQ( MESSAGE, DEFAULT, REPLY )
*
* get character string from user
*
* input:
*	MESSAGE	C* message to be sent to user
*	DEFAULT C* default reply
* output:
*	REPLY	C* user reply to the message
*
* 1988 Mar KDH @ STScI
* 2001 Jul KDH @ St.And - avoid char*(*) concatenation
	CHARACTER*(*) MESSAGE
	CHARACTER*(*) DEFAULT
	CHARACTER*(*) REPLY
	CHARACTER*256 LOCAL

      IF( DEFAULT.EQ.' ' ) THEN
	WRITE( *, '(1X,A,A,$)' ) MESSAGE( :LEN1(MESSAGE) ), ' '
      ELSE
	WRITE( *, '(1X,A,A,A,A,$)' ) MESSAGE( :LEN1(MESSAGE) ),
     #		' [' , DEFAULT( :LEN1(DEFAULT) ) , '] '
      END IF
	READ( *, '(A)' ) LOCAL
      IF( LOCAL.EQ.' ' ) THEN
	REPLY = DEFAULT
      ELSE
	REPLY = LOCAL
      END IF
	RETURN
	END
*===========================================================
	SUBROUTINE INQI( MESSAGE, IDEF, IVAL )
*
* get integer from the user
*
* input:
*	MESSAGE	C* message
*	IDEF 	I4 default value
* output:
*	IVAL	I4 returned value
*
* 1988 Mar KDH @ STScI
* 2002 Jul KDH @ St.And - add end=10
*
	CHARACTER*(*) MESSAGE
	CHARACTER*20 NUMBER
   10	WRITE( NUMBER, * ) IDEF
	CALL WORD1( NUMBER, L1, L2 )
	CALL INQ( MESSAGE, NUMBER(L1:L2), NUMBER )
	READ( NUMBER, *, ERR=10, END=10 ) NEW
	IVAL = NEW
	RETURN
	END
*===========================================================
	SUBROUTINE INQR( MESSAGE, DEF, VAL )
*
* get real value from the user
*
* input:
*	MESSAGE	C* message
*	DEF 	R4 default value
* output:
*	VAL	R4 returned value
*
* 1988 Mar KDH @ STScI
* 2002 Jul KDH @ St.And - add end=10
*
	CHARACTER*(*) MESSAGE
	CHARACTER*20 NUMBER
   10	WRITE( NUMBER, * ) DEF
	CALL INQ( MESSAGE, NUMBER, NUMBER )
	READ( NUMBER, *, ERR=10, END=10 ) WANT
	VAL = WANT
	RETURN
	END
*===========================================================
	SUBROUTINE INQD( MESSAGE, DEF, VAL )
*
* get real*8 value from the user
*
* input:
*	MESSAGE	C* message
*	DEF 	R8 default value
* output:
*	VAL	R8 returned value
*
* 1988 Mar KDH @ STScI
* 2002 Jul KDH @ St.And - add end=10
* 2004 Feb KDH @ St.And - adapt from INQR
* 2012 Nov KDH @ St.And - char*20->char*30 number
	REAL*8 DEF, VAL, WANT
	CHARACTER*(*) MESSAGE
	CHARACTER*30 NUMBER
   10	WRITE( NUMBER, * ) DEF
	CALL INQ( MESSAGE, NUMBER, NUMBER )
	READ( NUMBER, *, ERR=10, END=10 ) WANT
	VAL = WANT
	RETURN
	END
*===========================================================
	SUBROUTINE INQ2R( NAME, R1, R2 )
* get 2 reals from the user
* input:
*	NAME	C* name
*	R1 	R4 default value
*	R2 	R4 default value
* output:
*	R1	R4 returned value
*	R2	R4 returned value
* 2002 Jul KDH @ St.And
* 2008 Jul KDH @ SAAO - read v1, then v1,v2
	CHARACTER*(*) NAME
	CHARACTER*256 REPLY
   10	WRITE(*,*) 'Old ', NAME( :LEN1(NAME) ), ' : ', R1, R2
	WRITE(*,'(A,A,A,$)') ' New ', NAME( :LEN1(NAME) ), ' : '
	READ( *, '(A)' ) REPLY
      IF( REPLY .NE. ' ' ) THEN
	READ( REPLY ,*, ERR=10, END=20 ) V1
	R1 = V1
	READ( REPLY ,*, ERR=10, END=20 ) V1, V2
	R2 = V2
      END IF
   20	RETURN
	END
*===========================================================
	SUBROUTINE INQ2D( NAME, R1, R2 )
* get 2 real*8 values from the user
* In:	NAME	C* name
*	R1 	R8 default value
*	R2 	R8 default value
* Out:	R1	R8 returned value
*	R2	R8 returned value
* 2002 Jul KDH @ St.And
* 2008 Jul KDH @ SAAO - read v1, then v1,v2
* 2020 Jul KDH @ ST.And - adapt from INQ2R
	REAL*8 R1, R2, V1, V2
	CHARACTER*(*) NAME
	CHARACTER*256 REPLY
   10	WRITE(*,*) 'Old ', NAME( :LEN1(NAME) ), ' : ', R1, R2
	WRITE(*,'(A,A,A,$)') ' New ', NAME( :LEN1(NAME) ), ' : '
	READ( *, '(A)' ) REPLY
      IF( REPLY .NE. ' ' ) THEN
	READ( REPLY ,*, ERR=10, END=20 ) V1
	R1 = V1
	READ( REPLY ,*, ERR=10, END=20 ) V1, V2
	R2 = V2
      END IF
   20	RETURN
	END
*===========================================================
	SUBROUTINE INQ3R( NAME, R1, R2, R3 )
* get 3 reals from the user
* input:
*	NAME	C* name
*	R1 	R4 default value
*	R2 	R4 default value
*	R3 	R4 default value
* output:
*	R1	R4 returned value
*	R2	R4 returned value
*	R3	R4 returned value
* 2002 Jul KDH @ St.And
* 2008 Jul KDH @ SAAO - read v1, then v1,v2
* 2008 Jul KDH @ StA - adapt from INQ2R
	CHARACTER*(*) NAME
	CHARACTER*256 REPLY
   10	WRITE(*,*) 'Old ', NAME( :LEN1(NAME) ), ' : ', R1, R2, R3
	WRITE(*,'(A,A,A,$)') ' New ', NAME( :LEN1(NAME) ), ' : '
	READ( *, '(A)' ) REPLY
      IF( REPLY .NE. ' ' ) THEN
	READ( REPLY ,*, ERR=10, END=20 ) V1
	R1 = V1
	READ( REPLY ,*, ERR=10, END=20 ) V1, V2
	R2 = V2
	READ( REPLY ,*, ERR=10, END=20 ) V1, V2, V3
	R3 = V3
      END IF
   20	RETURN
	END
*===========================================================
	SUBROUTINE INQ2I( NAME, I1, I2 )
* get 2 integers from the user
* input:
*	NAME	C* name
*	I1 	I4 default value
*	I2 	I4 default value
* output:
*	I1	I4 returned value
*	I2	I4 returned value
* 2002 Jul KDH @ St.And
* 2008 Jul KDH @ SAAO - read j1, then j1,j2
	CHARACTER*(*) NAME
	CHARACTER*256 REPLY
   10	WRITE(*,*) 'Old ', NAME( :LEN1(NAME) ), ' : ', I1, I2
	WRITE(*,'(A,A,A,$)') ' New ', NAME( :LEN1(NAME) ), ' : '
	READ( *, '(A)' ) REPLY
      IF( REPLY .NE. ' ' ) THEN
	read( reply, *, err=10, end=20 ) j1
	i1 = j1
	READ( REPLY ,*, ERR=10, END=20 ) J1, J2
	I2 = J2
      END IF
   20	RETURN
	END

************************
	subroutine spawn( task )
*
* spawn a task to the operating system
*
* 1994 Jan KDH @ Utrecht - dummy version
* 1994 Mar KDH @ Utrecht - call system( task )
* 1994 Mar KDH @ Utrecht - call system( spawn task )
* 2000 Nov KDH @ Austin - call system( task )
* 2001 Jul KDH @ St-And - linux g77 rejects char*(*) concatenations
* 2015 Aug KDH @ St-And - comment out external system
	character*(*) task

* external seems not to be needed and causes problems on some compilers
c	external system

* at Utrecht, this works:
c	write(*,*) ' call system( spawn ' // TASK(:LEN1(TASK)) // ' )'
c	write(*,*) ' '
c	CALL SYSTEM( 'spawn ' // TASK(:LEN1(TASK)) )
* Note: $HOME/bin/spawn is an executable script as follows :
*  #!/bin/csh
*  source $HOME/.login ; $*
* at Austin, this works:
c	write(*,*) ' call system( ' // task(:len1(task)) // ' )'
c	call system( task(:len1(task)) )

* on linux, this works
* Note: linux g77 rejects character*(*) concatenation
	l1 = len1( task )
	write(*,*) 'call system( ', task(:l1), ' ) '
	call system( task( :l1 ) )
	return
	end
***********************************
	subroutine peqc( n, x, c )
* x(i) = c for i=1...n
	real*4 x(n)
      do i=1,n
	x(i) = c
      end do
	return
	end
***********************************
	subroutine peqp( n, x, y )
* x(i) = y(i) for i=1...n
	real*4 x(n), y(n)
      do i=1,n
	x(i) = y(i)
      end do
	return
	end
***********************************
	subroutine peqpap( n, x, y, z )
* x(i) = y(i) + z(i) for i=1..n
	real*4 x(n), y(n), z(n)
      do i=1,n
	x(i) = y(i) + z(i)
      end do
	return
	end
	subroutine peqpac( n, x, y, c )
* x(i) = y(i) + c for i=1...n
	real*4 x(n), y(n)
	if( c .eq. 0. ) return
      do i=1,n
	x(i) = y(i) + c
      end do
	return
	end
***********************************
	subroutine peqpmc( n, x, y, c )
* x(i) = y(i) for i=1...n
	real*4 x(n), y(n)
	if( c .eq. 1.0 ) return
      do i=1,n
	x(i) = y(i) * c
      end do
	return
	end
***********************************
	subroutine peqpmcap( n, x, y, c, z )
* x(i) = y(i) * c + z(i) for i=1..n
	real*4 x(n), y(n), z(n)
      do i=1,n
	x(i) = y(i) * c + z(i)
      end do
	return
	end
C*CGS ... physical constants in cgs units
C+
      REAL FUNCTION CGS( REQUEST )
*
* supplies value in cgs units of requested constant
C--
* 1988 Jul Keith Horne @ STScI
* 1989 Jul Keith Horne @ STScI - added MH, ME, E
* 1990 Jan KDH @ STScI - call double-precision version
	CHARACTER*(*) REQUEST
	REAL*8 DCGS
	CGS = DCGS( REQUEST )
	RETURN
	END

C*DCGS ... physical constants in double precision cgs units
C+
      REAL*8 FUNCTION DCGS( REQUEST )
*
* supplies value in cgs units of requested constant
C--
* Jul 1988 Keith Horne @ STScI
* Jul 1989 Keith Horne @ STScI - added MH, ME, E
* Jan 1990 KDH @ STScI - additional constants, double precision version
* 2001 Apr KDH @ Austin - MJY and ANGSTROM
* 2001 Jul KDH @ StAnd - g77 can't concatenate request
* 2013 Jul KDH @ StAnd - Thompson scattering cross-section
* 2014 Mar KDH @ StA - DAY
* 2014 Dec KDH @ StA - WIEN, ALPHA
* 2014 Dec KDH @ StA - STEFAN and THOMPSON aliases
	CHARACTER*(*)	REQUEST

* WARNING: long names must preceed otherwise identical short ones
* since otherwise wrong identification may occur

* pi
      IF( REQUEST .EQ. 'PI' ) THEN
        DCGS = 4.D0 * DATAN(1.D0)
* light speed c [cm/s]
      ELSE IF( REQUEST .EQ. 'C' ) THEN
        DCGS = 2.997925D10
* km/s ( KMS must precede K )
      ELSE IF( REQUEST .EQ. 'KMS' ) THEN
	DCGS = 1.E5

* Newton G [cm3/g/s2]
      ELSE IF( REQUEST .EQ. 'G' ) THEN
        DCGS = 6.673D-8
* Planck h [erg s]
      ELSE IF( REQUEST .EQ. 'H' ) THEN
        DCGS = 6.6262D-27
* Boltzman k [erg/K]
      ELSE IF( REQUEST .EQ. 'K' ) THEN
        DCGS = 1.3806D-16

* fine structure alpha = ( 2 pi e^2 ) / ( h c )
      ELSE IF( REQUEST .EQ. 'ALPHA' ) THEN
	DCGS = 1.d0 / 137.035965D0

* Thompson cross-section (8pi/3)(e4/m2c4) [cm2]
      ELSE IF( REQUEST .EQ. 'SIGMAT' .OR. REQUEST .EQ. 'THOMPSON' ) THEN
        DCGS = 0.66524E-24

* Stefan-Boltzman sigma = 2 pi^4 k^4 / ( 15 c^2 h^3 ) [erg/cm2/s/K4]
      ELSE IF( REQUEST .EQ. 'SIGMA' .or. REQUEST .EQ. 'STEFAN' ) THEN
        DCGS = 5.66956D-5

* Wien (lam_max of B_lambda) [cm Kelvin]
      ELSE IF( REQUEST .EQ. 'WIEN' ) THEN
	DCGS = 0.28979D0

* mJy [erg/cm2/s/Hz]
      ELSE IF( REQUEST .EQ. 'MJY' ) THEN
	DCGS = 1.D-26
* Angstroms [cm]
      ELSE IF( REQUEST .EQ. 'ANGSTROM' ) THEN
	DCGS = 1.D-8

* energies [erg = g cm2/s2]
      ELSE IF( REQUEST .EQ. 'RYD') THEN
        DCGS = 2.17992D-11
      ELSE IF( REQUEST .EQ. 'EV') THEN
        DCGS = 1.602192D-12

* Earth
      ELSE IF( REQUEST .EQ. 'MEARTH' ) THEN
        DCGS = 5.976D27
      ELSE IF( REQUEST .EQ. 'REARTH' ) THEN
        DCGS = 6.378164D8
* Sun
      ELSE IF( REQUEST .EQ. 'MSUN' ) THEN
        DCGS = 1.989D33
      ELSE IF( REQUEST .EQ. 'RSUN' ) THEN
        DCGS = 6.9599D10
      ELSE IF( REQUEST .EQ. 'LSUN' ) THEN
        DCGS = 3.826D33

* Jupiter
      ELSE IF( REQUEST .EQ. 'MJUP' ) THEN
	DCGS = 3.1783D2 * 5.976D27
      ELSE IF( REQUEST .EQ. 'RJUP' ) THEN
	DCGS = 7.13D9

* Eddington luminosity [erg/s/Msun]
*  Ledd = ( 4 pi G c m_p / sigma_T ) (M/Msun)
      ELSE IF( REQUEST .EQ. 'LEDSUN' ) THEN
        DCGS = 1.257D38

* Eddington accretion rate [g/s/Msun]
* ( Ledd / eta c^2 ) = ( 4 pi G m_p / eta c sigma_t ) [g/s/Msun]
* KDH: WHAT ETA IS ASSUMED ?
      ELSE IF( REQUEST .EQ. 'MDOTEDSUN' ) THEN
        DCGS = 1.399D17

* particle masses [g]
      ELSE IF( REQUEST .EQ. 'ME' ) THEN
        DCGS = 9.10956D-28
      ELSE IF( REQUEST .EQ. 'MP' ) THEN
        DCGS = 1.672661D-24
      ELSE IF( REQUEST .EQ. 'MH' ) THEN
        DCGS = 1.67352D-24
      ELSE IF( REQUEST .EQ. 'AMU' ) THEN
        DCGS = 1.660531D-24
* electron charge [ESU]
      ELSE IF( REQUEST .EQ. 'E') THEN
        DCGS = 4.80325D-10

* time
      ELSE IF( REQUEST .EQ. 'YR' .or. REQUEST .EQ. 'YEAR' ) THEN
        DCGS = 3.1556925D7
      ELSE IF( REQUEST .EQ. 'DY' .or. REQUEST .EQ. 'DAY' ) THEN
	DCGS = 24.D0 * 3600.D0
* distance
      ELSE IF( REQUEST .EQ. 'PC' ) THEN
        DCGS = 3.085678D18
      ELSE IF( REQUEST .EQ. 'AU' ) THEN
        DCGS = 1.49597D13

* help from the user
      ELSE
10      WRITE(*,'(A,A,A,$)')
     &	' Enter CGS value for "', REQUEST, '" : '
        READ(*,*,ERR=10 ) DCGS
      END IF

C	WRITE(*,*) 'CGS value for ", REQUEST, " is ', DCGS
      RETURN
      END		
      function jdate( iy, im, id )
C  Julian Date at 12 hrs UT
* pre-1983 code from Peter Young.
* 1999 Oct Keith Horne @ St.Andrews - eliminate type
* 2002 Mar KDH @ St.And - mdy -> ymd
      if(iy.lt.1801.or.iy.gt.2099) then
	write(*,*) '** JDATE: Year out of range 1801 - 2099', iy
	stop
      end if
      if(im.lt.1.or.im.gt.12) then
	write(*,*) '** JDATE: Month out of range', im
	stop
      end if
      if(id.lt.1.or.id.gt.31) then
	write(*,*) '** JDATE: Day out of range', id
	stop
      end if
	jj = 367*iy - (7*(iy+(im+9)/12))/4 + (275*im)/9 + id + 1721014
	if( 100*iy + im .lt. 190002.5 ) jj = jj + 1
	jdate = jj
	return
	end
*==================================
	real*4 function rankdh( iseed )
* random number uniform on (0-1)
* hi-level routines call this one, which can
* be used to select different lo-level generators.
* Input:
*	iseed	i4  repeat sequence if iseed < 0, otherwise ignore
*
* 2001 Jul Keith Horne @ St.Andrews
* 2006 Aug KDH @ St.A - use numerical recipes routine ran1
* 2008 Oct KDH @ St.A - try ran3
* 2016 Jan KDH @ Iceland - irand
	logical firstcall/.true./
	save firstcall
	data irand/0/
	is = iseed
      if( irand .ne. 0 ) then
* system-supplied
	ran = rand( is )
      else
* numerical recipes routine 
      if( firstcall ) then
	is = - iabs( is )
	firstcall = .false.
      end if
	ran = ran3( is )
      end if
	iseed = is
	rankdh = ran
	return
	end
*==================================
	FUNCTION RAN3(IDUM)
C			IMPLICIT REAL*4(M)
C			PARAMETER (MBIG=4000000.,MSEED=1618033.,MZ=0.,FAC=1./MBIG)
	PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1./MBIG)
	DIMENSION MA(55)
	DATA IFF /0/
	IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
		IFF=1
		MJ=MSEED-IABS(IDUM)
		MJ=MOD(MJ,MBIG)
		MA(55)=MJ
		MK=1
		DO I=1,54
			II=MOD(21*I,55)
			MA(II)=MK
			MK=MJ-MK
			IF(MK.LT.MZ)MK=MK+MBIG
			MJ=MA(II)
		ENDDO
		DO K=1,4
			DO I=1,55
				MA(I)=MA(I)-MA(1+MOD(I+30,55))
				IF(MA(I).LT.MZ)MA(I)=MA(I)+MBIG
			ENDDO
		ENDDO
		INEXT=0
		INEXTP=31
		IDUM=1
	ENDIF
	INEXT=INEXT+1
	IF(INEXT.EQ.56)INEXT=1
	INEXTP=INEXTP+1
	IF(INEXTP.EQ.56)INEXTP=1
	MJ=MA(INEXT)-MA(INEXTP)
	IF(MJ.LT.MZ)MJ=MJ+MBIG
	MA(INEXT)=MJ
	RAN3=MJ*FAC
	RETURN
	END
************************************************
	function rang( avg, rms, iseed )
* Gaussian random number generator.
* Input:
*	avg	r4	mean value
*	rms	r4	standard deviation
*	iseed	i4	seed integer for ran( iseed ) 
* Output:
*	rang	r4	gaussian random number
*	iseed	i4	seed integer from ran( iseed )
*
* Box-muller transform of 2 independent random variables
* 1978 Peter Young @ Caltech -- original version GAUSS
* 1995 Keith Horne @ St-Andrews -- adapted from GAUSS.
* 2001 Sep KDH @ St-And - tidy up
* 2016 Jul KDH @ Iceland - ran -> rankdh (ran fails w gfortran)
	logical	newpair /.true./
	save y, u, newpair
	rang = avg
	if( rms .le. 0. ) return
      if ( newpair ) then
	r2 = 10.
      do while ( r2 .ge. 1. )
	x = 2. * rankdh( iseed ) - 1.
	y = 2. * rankdh( iseed ) - 1.
	r2 = x * x + y * y
      end do
	u = sqrt( -2. * alog( r2 ) / r2 )
	rang = x * u
      else
	rang = y * u
      end if
	newpair = .not. newpair
	rang = avg + rms * rang
	return
	end
*========================================
        subroutine rangtest( iseed )
* check avg and rms of gaussian random numbers
* 2016 Jul Keith Horne @ Iceland
        real*8 sum, sum2
        logical fail
* sample
        n = 10000
	sum = 0.d0
	sum2 = 0.d0
      do i = 1, n
        add = rang( 0., 1., iseed )
        sum = sum + add
        sum2 = sum2 + add * add
      end do
* mean
        avg = sum / n
	siga = 1. / sqrt( float( n ) )
	chia = avg / siga
* rms
	sum2 = ( sum2 - ( sum / n ) * sum ) / ( n - 1 )
        rms = dsqrt( sum2 )
	sigr = sqrt( 2. / ( n - 1 ) )
	chir = ( rms - 1. ) / sigr
* report
	write(*,*) 'avg', avg, ' =', chia, ' sigma'
	write(*,*) 'rms', rms, ' =', chir, ' sigma'
* test
        fail = max( abs( chia ), abs( chir ) ) .gt. 10.
      if( fail ) then
        write(*,*) '** RANG TEST FAILED  :('
	stop
      end if
        return
        end
	subroutine pause( message )
* substitute for pause statement (withdrawn from gfortran)
* 2010 Jun Keith Horne @ St.Andrews
	character*(*) message
	character*50 reply
	l = len1( message )
	if( l .gt. 0 ) write(*,*) '** pause ', message(:l)
   10	call inq( '** pause C(ontinue) or D(ie) ?', 'C', reply )
	call upcase( reply, reply )
	if( reply .eq. 'D' ) stop 'bye for now.'
	if( reply .ne. 'C' ) goto 10
	return
	end
	subroutine openfile( iunit, name, form, status, ier )
* Input:
*	iunit	i4 unit number
*	name	c* file name
*	form	c* 'formatted' or 'unformatted'
*	status	c* 'old', 'new', ...
* Output:
*	ier	i4 0 if successful
* 2001 Jul Keith Horne @ St.Andrews -- use FULLPATH
* 2001 Aug KDH @ St-And -- silence
* 2001 Aug KDH @ St-And -- default extension .dat

	character*(*)	name, form, status
	character*256	path
	logical silence
	common/silence/ silence

* get full path
	call fullpath( name, path )
      if( .not. silence ) then
      if( path .ne. name ) then
	write(*,*) 'Path( ', name(:len1(name)), ' ) = ', 
     &		path(:len1(path)) 
      end if
      end if

* open file
	open( unit=iunit, file=path, form=form, status=status, err=2 )
	goto 10

* try again with default extension
    2	path = path( :len1( path ) ) // '.dat'
	open( unit=iunit, file=path, form=form, status=status, err=3 )
	goto 10

* normal return

   10	ier = 0
      if( .not. silence ) then
	write(*,*) 'Open(', iunit, ', ', path(:len1(path)),
     &	', ', form(:len1(form)), ', ', status(:len1(status)), ' )' 
      end if
	return

* error return

    3	ier = 1
	write(*,*) '** OPENFILE FAILED :( '
	write(*,*) '** Path( ', name(:len1(name)), ' ) = ', 
     &		path(:len1(path)) 
	return
	end
	subroutine fullpath( s1, s2 )
* evaluate unix path by translating environment variables
* 2001 Jul Keith Horne @ St.Andrews
	character*(*) s1, s2
	parameter ( maxchar = 256 )
	character*( maxchar ) t1, t2
* null string
	call word1( s1, l1, l2 )
      if( l1.lt.1 ) then
	s2 = s1
	return
      end if
* copy to a local string
	t1 = s1( l1:l2 )
      if( l2-l1+1 .gt. maxchar ) then
	write(*,*) '** fullpath truncation:', l1, l2, l2-l1+1, maxchar
	write(*,*) '"', s1( :len1(s1) ), '"'
	write(*,*) '"', t1( :len1(t1) ), '"'
      end if
* isolate the environment variable to be translated
	ldollar = index( t1, '$' )
      do while( ldollar .gt. 0 )
	l1 = ldollar + 1
	lslash = ldollar + index( t1( l1:len1(t1) ) // '/', '/' )
	l2 = lslash - 1
* translate the environment variable
	call getenv( t1( l1:l2 ), t2 )
      if( len1( t2 ) .ge. maxchar ) then
	write(*,*) '** fullpath possible truncation:'
	write(*,*) '"', t1( :len1(t1) ), '"'
	write(*,*) '"', t2( :len1(t2) ), '"'
      end if

	if( ldollar .gt. 1 ) t2 = t1(:ldollar-1) // t2(:len1(t2) )

	t1 = t2(:len1(t2) ) // t1(l2+1:)

	ldollar = index( t1, '$' )
      end do
* copy to output string
	s2 = t1
	l1 = len1( t1 )
	l2 = len1( s2 )
      if( l1 .gt. l2 ) then
	write(*,*) '** fullpath truncation:', l1, l2
	write(*,*) '"', t1(:l1), '"'
	write(*,*) '"', s2(:l2), '"'
      end if
	return
	end
C*LOADLIST ... load a list of strings from a disk file
C+
	SUBROUTINE LOADLIST( SOURCE, NLIST, LIST )
*
* load a list of strings from a file
*
* Input:
*	SOURCE	C* "@filename" loads one or more strings from a file
*	NLIST	I4  >0 .. maximum allowed number of strings
*		    <0 .. requests the |NLIST|th string only
* Output:
*	NLIST	I4 total number of strings, or the sequence number
*		closest to the requested sequence number
*		(0 if failed)
*	LIST()	C* the list of strings
C--
* Jul 1988 KDH @ STScI - rename to LOADLIST
* Mar 1989 KDH @ STScI - use SOURCE and 'NONE'.
* Mar 1989 KDH @ STScI - default extension is .lis, then .dat
* May 1989 KDH @ STScI - NLIST<0 option to select specific sequence number
* 			- use ! to start comment
* Jul 1990 KDH @ STScI - use ! or # to start comment
* Aug 1991 KDH @ STScI - fix bug so !,# work when NLIST<0
* Sep 1999 KDH @ StAndrews - eliminate TYPE *
* 2001 Jul KDH @ St.Andrews - no READONLY :(, no char*(*) concatenation
* 2001 Aug KDH @ St.A - openfile
* 2010 Mar KDH @ LCO - avoid ERR=n on statement n
	CHARACTER*(*)	SOURCE
	CHARACTER*(*)	LIST(*)
	PARAMETER ( MAXCHR = 256 )
	CHARACTER*( MAXCHR ) FILE
	CHARACTER*10	REPLY

* check list dimension

	MLIST = NLIST
	NLIST = 0

      IF( MLIST.EQ.0 ) THEN
	write(*,*) '** dimension error ', MLIST
	GOTO 999
      END IF

* an empty list

	IF( LEN1( SOURCE ) .LE. 0 ) GOTO 1000
	CALL WORD1( SOURCE, L1, L2 )
	REPLY = SOURCE( L1:L2 )
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ. 'NONE' ) GOTO 1000

* a single entry list rather than input from a disk file

	L0 = INDEX( SOURCE, '@' )
      IF( L0.LE.0 ) THEN
	NLIST = 1
	LIST(1) = SOURCE
	GOTO 1000
      END IF

* isolate name of the disk file from which the list is read

	CALL WORD1( SOURCE(L0+1:), L1, L2 )
	IF( L1.LT.0 .OR. L2.LT.L1 ) GOTO 999
	L1 = L0 + L1
	L2 = L0 + L2

* open disk file (default is .lis, then .dat )

	L3 = MIN( L2, MAX( L1, INDEX( SOURCE, ']' ) ) )
      IF( INDEX( SOURCE(L3:L2), '.' ) .GT.0 ) THEN
   25	CALL OPENFILE( 47, SOURCE(L1:L2), 'FORMATTED', 'OLD', IER )
	IF( IER .NE. 0 ) GOTO 90
      ELSE
	FILE = SOURCE( L1:L2 ) // '.lis'
	CALL OPENFILE( 47, FILE, 'FORMATTED', 'OLD', IER )
c	IF( IER .NE. 0 ) GOTO 25
      if( ier .ne. 0 ) then
	CALL OPENFILE( 47, SOURCE(L1:L2), 'FORMATTED', 'OLD', IER )
	IF( IER .NE. 0 ) GOTO 90
      end if
      END IF

* load entire list elements

      IF( MLIST.GT.0 ) THEN
	NLIST = 0
      DO I=1,MLIST
   30	continue
	READ( 47, '(A)', ERR=30, END=100 ) LIST(I)
	L1 = MAX( INDEX( LIST(I), '!' ), INDEX( LIST(I), '#' ) )
	IF( L1 .GT. 0 ) LIST(I) = LIST(I)(:L1-1)
	IF( LIST(I) .EQ. ' ' ) GOTO 30
	NLIST = NLIST + 1
      END DO

* find element closest to the requested sequence number

      ELSE
	MLIST = IABS( MLIST )
	NLIST = 0
   60	continue
	READ( 47, '(A)', ERR=60, END=100 ) LIST(1)
	L1 = MAX( INDEX( LIST(1), '!' ), INDEX( LIST(1), '#' ) )
	IF( L1 .GT. 0 ) LIST(1) = LIST(1)(:L1-1)
	IF( LIST(1) .EQ. ' ' ) GOTO 60
	NLIST = NLIST + 1
	IF( NLIST.LT.MLIST ) GOTO 60
      END IF

* close input file for normal return

  100	CLOSE( UNIT=47 )
	IF( NLIST.LT.1 ) GOTO 999

* normal return

 1000	RETURN

* error return

  999	write(*,*) '** LOADLIST aborted.', NLIST
	RETURN

* handle file open error

   90	write(*,*) '** error opening file ', SOURCE(:LEN1(SOURCE))
	GOTO 999
	END
C*LOAD1D .. load up to 140 columns of data from multi-column ascii file
C+
      SUBROUTINE LOAD1D( NAME, NCOL, NROW,
     #	C1, C2, C3, C4, C5, C6, C7, C8, C9,
     #	C10, C11, C12, C13, C14, C15, C16, C17, C18, C19,
     #	C20, C21, C22, C23, C24, C25, C26, C27, C28, C29,
     #	C30, C31, C32, C33, C34, C35, C36, C37, C38, C39,
     #	C40, C41, C42, C43, C44, C45, C46, C47, C48, C49,
     #	C50, C51, C52, C53, C54, C55, C56, C57, C58, C59,
     #	C60, C61, C62, C63, C64, C65, C66, C67, C68, C69,
     #	C70, C71, C72, C73, C74, C75, C76, C77, C78, C79,
     #	C80, C81, C82, C83, C84, C85, C86, C87, C88, C89,
     #	C90, C91, C92, C93, C94, C95, C96, C97, C98, C99,
     #	C100, C101, C102, C103, C104, C105, C106, C107, C108, C109,
     #	C110, C111, C112, C113, C114, C115, C116, C117, C118, C119,
     #	C120, C121, C122, C123, C124, C125, C126, C127, C128, C129,
     #	C130, C131, C132, C133, C134, C135, C136, C137, C138, C139,
     #	C140 )
*
* Loads up to 140 columns of data from a free-format ASCII data file
* Use as follows:
*       parameter ( maxdat = 10000 )
*       real*4 c1(maxdat), c2(maxdat), c3(maxdat)
*       character*256 file
*       file = 'file.dat'
*       ndat = maxdat
*       call load1d( file, 3, ndat, c1, c2, c3 )
*
*  Input:
*	NAME	= C* Name of disk file, ' ' for interactive selection.
*	NCOL	= I4 Number of columns to be read (if NCOL > 0)
*		     (if NCOL < 0, then only column -NCOL is read)
*	NROW	= I4 Maximum allowed number of rows
*  Output:
*	NAME	= C* Name of disk file (only if selected interactively)
*	NROW	= I4 Number of data points (0 if none loaded)
*	C1(NROW)= R4 first column
*	C2(NROW)= R4 second column
*	  ...
*	C140(NROW)= R4 140th column
C--
* May 1987 Keith Horne @ STScI
* Sep 1987 KDH - add NCOL<0 option to read specified column.
* May 1988 KDH - add final read to pick up eof after reading all rows.
* Jul 1988 KDH @ STScI - change name from LOAD_ASCII to LOAD_DAT
* Sep 1991 KDH @ STScI - skip words when COL < 0.
* Jan 1994 KDH @ Utrecht - split LOAD_DAT to LOAD1D,LOAD1D10,...
* Mar 1994 KDH @ Utrecht - entry points LOAD1DX, X=1...20
* Mar 1998 KDH @ St.Andrews - MAXCOL=20->140
* 1999 Oct KDH @ St.And - change OPEN for unix compatibility
* 2001 Jul KDH @ St.And -- no // of character*(*)
* 2001 Aug KDH @ St.And -- use OPENFILE
* 2010 Mar KDH @ St.And -- continue to avoid err=n branch to same line
* 2018 Jul KDH @ St.And -- entry points LOAD1DX, X=21...35
	REAL*4 C1(*), C2(*), C3(*), C4(*), C5(*)
	REAL*4 C6(*), C7(*), C8(*), C9(*), C10(*)
	REAL*4 C11(*), C12(*), C13(*), C14(*), C15(*)
	REAL*4 C16(*), C17(*), C18(*), C19(*), C20(*)
	REAL*4 C21(*), C22(*), C23(*), C24(*), C25(*)
	REAL*4 C26(*), C27(*), C28(*), C29(*), C30(*)
	REAL*4 C31(*), C32(*), C33(*), C34(*), C35(*)
	REAL*4 C36(*), C37(*), C38(*), C39(*), C40(*)
	REAL*4 C41(*), C42(*), C43(*), C44(*), C45(*)
	REAL*4 C46(*), C47(*), C48(*), C49(*)
	REAL*4 C50(*), C51(*), C52(*), C53(*), C54(*)
	REAL*4 C55(*), C56(*), C57(*), C58(*), C59(*)
	REAL*4 C60(*), C61(*), C62(*), C63(*), C64(*)
	REAL*4 C65(*), C66(*), C67(*), C68(*), C69(*)
	REAL*4 C70(*), C71(*), C72(*), C73(*), C74(*)
	REAL*4 C75(*), C76(*), C77(*), C78(*), C79(*)
	REAL*4 C80(*), C81(*), C82(*), C83(*), C84(*)
	REAL*4 C85(*), C86(*), C87(*), C88(*), C89(*)
	REAL*4 C90(*), C91(*), C92(*), C93(*), C94(*)
	REAL*4 C95(*), C96(*), C97(*), C98(*), C99(*)
	REAL*4 C100(*), C101(*), C102(*), C103(*), C104(*)
	REAL*4 C105(*), C106(*), C107(*), C108(*), C109(*)
	REAL*4 C110(*), C111(*), C112(*), C113(*), C114(*)
	REAL*4 C115(*), C116(*), C117(*), C118(*), C119(*)
	REAL*4 C120(*), C121(*), C122(*), C123(*), C124(*)
	REAL*4 C125(*), C126(*), C127(*), C128(*), C129(*)
	REAL*4 C130(*), C131(*), C132(*), C133(*), C134(*)
	REAL*4 C135(*), C136(*), C137(*), C138(*), C139(*)
	REAL*4 C140(*)
	CHARACTER*(*) NAME
	CHARACTER*256 FILE	! file name
	PARAMETER (INUNIT=49)	! input unit number
	PARAMETER (MAXCOL=140)	! maximum number of columns that can be read
	CHARACTER*(15*MAXCOL) RECORD ! buffer into which data are read
	REAL*4 ROW( MAXCOL )

* entry points since UNIX requires number of arguments to match exactly


	ENTRY LOAD1D35( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28, C29, C30, C31, C32, C33, C34, C35 )
        GOTO 100
	ENTRY LOAD1D34( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28, C29, C30, C31, C32, C33, C34 )
        GOTO 100
	ENTRY LOAD1D33( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28, C29, C30, C31, C32, C33 )
        GOTO 100
	ENTRY LOAD1D32( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28, C29, C30, C31, C32 )
        GOTO 100
	ENTRY LOAD1D31( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28, C29, C30, C31 )
        GOTO 100

	ENTRY LOAD1D30( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28, C29, C30 )
        GOTO 100
	ENTRY LOAD1D29( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28, C29 )
        GOTO 100
	ENTRY LOAD1D28( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27, C28 )
        GOTO 100
	ENTRY LOAD1D27( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26, C27 )
        GOTO 100
	ENTRY LOAD1D26( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25,
     #	C26 )
        GOTO 100

	ENTRY LOAD1D25( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24, C25 )
        GOTO 100
	ENTRY LOAD1D24( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23, C24 )
        GOTO 100
	ENTRY LOAD1D23( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22, C23 )
        GOTO 100
	ENTRY LOAD1D22( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21, C22 )
        GOTO 100
	ENTRY LOAD1D21( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20, C21 )
        GOTO 100

	ENTRY LOAD1D20( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20 )
        GOTO 100
	ENTRY LOAD1D19( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19 )
        GOTO 100
	ENTRY LOAD1D18( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18 )
        GOTO 100
	ENTRY LOAD1D17( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17 )
        GOTO 100
	ENTRY LOAD1D16( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16 )
        GOTO 100
        ENTRY LOAD1D15( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15 )
        GOTO 100
        ENTRY LOAD1D14( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14 )
        GOTO 100
        ENTRY LOAD1D13( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13 )
        GOTO 100
        ENTRY LOAD1D12( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12 )
        GOTO 100
        ENTRY LOAD1D11( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11 )
        GOTO 100
        ENTRY LOAD1D10( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10 )
        GOTO 100
        ENTRY LOAD1D9( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9 )
        GOTO 100
        ENTRY LOAD1D8( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8 )
        GOTO 100
        ENTRY LOAD1D7( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7 )
        GOTO 100
        ENTRY LOAD1D6( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6 )
        GOTO 100
        ENTRY LOAD1D5( NAME, NCOL, NROW, C1, C2, C3, C4, C5 )
        GOTO 100
        ENTRY LOAD1D4( NAME, NCOL, NROW, C1, C2, C3, C4 )
        GOTO 100
        ENTRY LOAD1D3( NAME, NCOL, NROW, C1, C2, C3 )
        GOTO 100
        ENTRY LOAD1D2( NAME, NCOL, NROW, C1, C2 )
        GOTO 100
        ENTRY LOAD1D1( NAME, NCOL, NROW, C1 )
        GOTO 100

  100 IF( NROW.LE.0. OR. NCOL.EQ.0 ) THEN
	WRITE(*,*) '** INVALID DIMENSIONS.', NROW, NCOL
	GOTO 999
      ELSE IF( NCOL.GT.MAXCOL ) THEN
	WRITE(*,*) '** WARNING: Too many columns for LOAD1D.'
	WRITE(*,*) '** Columns', MAXCOL, ' thru', NCOL, ' skipped.'
      END IF

	MAXROW = NROW

* get name of input file

	FILE = NAME
c        WRITE(*,*) 'FILE"', NAME( :LEN1(NAME) ), '"'
      IF( FILE.EQ.' ' ) THEN
	WRITE(*,'(A,I3,A)')
     #	' Enter name of', IABS(NCOL),'-column free-format ASCII file :'
	READ(*,'(A)') FILE
	CALL WORD1( FILE, L1, L2 )
	IF( L1 .LE. 0 ) GOTO 99
	NAME = FILE( :LEN1( FILE ) )
      END IF

* get full path to file
c	CALL FULLPATH( NAME, FILE )
c        WRITE(*,*) 'PATH"', FILE( :LEN1(FILE) ), '"'

* open input disk file

C	OPEN( UNIT=INUNIT, NAME=FILE, FORM='FORMATTED', TYPE='OLD',
C    &	ERR=99, READONLY )
* this works on unix machines
C	OPEN( UNIT=INUNIT, NAME=FILE, FORM='FORMATTED', STATUS='OLD',
C     &	ERR=99 )
	CALL OPENFILE( INUNIT, FILE, 'FORMATTED', 'OLD', IER )
	IF( IER .NE. 0 ) GOTO 99

* read desired column by skipping unwanted columns that precede it.

      IF( NCOL.LE.-2 ) THEN
	NSKIP = IABS(NCOL)-1
      DO I=1,MAXROW
   51	continue
	READ( INUNIT, '(A)', ERR=51, END=100 ) RECORD
      DO J=1,NSKIP
	CALL WORD1( RECORD, L1, L2 )
	IF( L1.LT.1 ) GOTO 51
	RECORD = RECORD(L2+1:)
      END DO
	READ( RECORD, *, ERR=51, END=51 ) C1(I)
C	READ( RECORD, *, ERR=51, END=51 ) 
C     #	(DUMMY,J=1,NSKIP), C1(I)
      END DO

* read desired consecutive columns of data from the file

      ELSE IF( IABS(NCOL).EQ.1 ) THEN
      DO I=1,MAXROW
    1   continue
	READ( INUNIT, '(A)', ERR=1, END=200 ) RECORD
	READ( RECORD, *, ERR=1, END=1 ) 
     #	C1(I)
      END DO

      ELSE IF( NCOL.EQ.2 ) THEN
      DO I=1,MAXROW
    2	continue
	READ( INUNIT, '(A)', ERR=2, END=200 ) RECORD
	READ( RECORD, *, ERR=2, END=2 ) 
     #	C1(I), C2(I)
      END DO

      ELSE IF( NCOL.EQ.3 ) THEN
      DO I=1,MAXROW
    3	continue
	READ( INUNIT, '(A)', ERR=3, END=200 ) RECORD
	READ( RECORD, *, ERR=3, END=3 ) 
     #	C1(I), C2(I), C3(I)
      END DO

      ELSE IF( NCOL.EQ.4 ) THEN
      DO I=1,MAXROW
    4	continue
	READ( INUNIT, '(A)', ERR=4, END=200 ) RECORD
	READ( RECORD, *, ERR=4, END=4 ) 
     #	C1(I), C2(I), C3(I), C4(I)
      END DO

      ELSE IF( NCOL.EQ.5 ) THEN
      DO I=1,MAXROW
    5	continue
	READ( INUNIT, '(A)', ERR=5, END=200 ) RECORD
	READ( RECORD, *, ERR=5, END=5 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I)
      END DO

      ELSE IF( NCOL.EQ.6 ) THEN
      DO I=1,MAXROW
    6   continue
	READ( INUNIT, '(A)', ERR=6, END=200 ) RECORD
        READ( RECORD, *, ERR=6, END=6 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I)
      END DO


      ELSE IF( NCOL.EQ.7 ) THEN
      DO I=1,MAXROW
    7   continue
	READ( INUNIT, '(A)', ERR=7, END=200 ) RECORD
	READ( RECORD, *, ERR=7, END=7 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I)
      END DO


      ELSE IF( NCOL.EQ.8 ) THEN
      DO I=1,MAXROW
    8   continue
	READ( INUNIT, '(A)', ERR=8, END=200 ) RECORD
	READ( RECORD, *, ERR=8, END=8 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I)
      END DO


      ELSE IF( NCOL.EQ.9 ) THEN
      DO I=1,MAXROW
    9   continue
	READ( INUNIT, '(A)', ERR=9, END=200 ) RECORD
	READ( RECORD, *, ERR=9, END=9 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I)
      END DO


      ELSE IF( NCOL.EQ.10 ) THEN
      DO I=1,MAXROW
   10   continue
	READ( INUNIT, '(A)', ERR=10, END=200 ) RECORD
	READ( RECORD, *, ERR=10, END=10 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I)
      END DO

      ELSE IF( NCOL.EQ.11 ) THEN
      DO I=1,MAXROW
   11   continue
	READ( INUNIT, '(A)', ERR=11, END=200 ) RECORD
	READ( RECORD, *, ERR=11, END=11 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I)
      END DO


      ELSE IF( NCOL.EQ.12 ) THEN
      DO I=1,MAXROW
   12   continue
	READ( INUNIT, '(A)', ERR=12, END=200 ) RECORD
	READ( RECORD, *, ERR=12, END=12 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I)
      END DO


      ELSE IF( NCOL.EQ.13 ) THEN
      DO I=1,MAXROW
   13   continue
	READ( INUNIT, '(A)', ERR=13, END=200 ) RECORD
	READ( RECORD, *, ERR=13, END=13 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I)
      END DO


      ELSE IF( NCOL.EQ.14 ) THEN
      DO I=1,MAXROW
   14   continue
	READ( INUNIT, '(A)', ERR=14, END=200 ) RECORD
	READ( RECORD, *, ERR=14, END=14 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I)
      END DO


      ELSE IF( NCOL.EQ.15 ) THEN
      DO I=1,MAXROW
   15   continue
	READ( INUNIT, '(A)', ERR=15, END=200 ) RECORD
	READ( RECORD, *, ERR=15, END=15 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I)
      END DO


      ELSE IF( NCOL.EQ.16 ) THEN
      DO I=1,MAXROW
   16   continue
	READ( INUNIT, '(A)', ERR=16, END=200 ) RECORD
	READ( RECORD, *, ERR=16, END=16 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I)
      END DO

      ELSE IF( NCOL.EQ.17 ) THEN
      DO I=1,MAXROW
   17   continue
	READ( INUNIT, '(A)', ERR=17, END=200 ) RECORD
	READ( RECORD, *, ERR=17, END=17 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I)
      END DO

      ELSE IF( NCOL.EQ.18 ) THEN
      DO I=1,MAXROW
   18   continue
	READ( INUNIT, '(A)', ERR=18, END=200 ) RECORD
	READ( RECORD, *, ERR=18, END=18 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I), C18(I)
      END DO

      ELSE IF( NCOL.EQ.19 ) THEN
      DO I=1,MAXROW
   19   continue
	READ( INUNIT, '(A)', ERR=19, END=200 ) RECORD
	READ( RECORD, *, ERR=19, END=19 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I), C18(I), C19(I)
      END DO

      ELSE IF( NCOL.EQ.20 ) THEN
      DO I=1,MAXROW
   20   continue
	READ( INUNIT, '(A)', ERR=20, END=200 ) RECORD
	READ( RECORD, *, ERR=20, END=20 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I), C18(I), C19(I), C20(I)
      END DO

      ELSE IF( NCOL.LE.MAXCOL ) THEN
      DO I=1,MAXROW
   50   continue
	READ( INUNIT, '(A)', ERR=50, END=200 ) RECORD
	READ( RECORD, *, ERR=50, END=50 ) 
     #		(ROW(J),J=1,NCOL)
	IF( NCOL.GE.1 ) C1(I) = ROW(1)
	IF( NCOL.GE.2 ) C2(I) = ROW(2)
	IF( NCOL.GE.3 ) C3(I) = ROW(3)
	IF( NCOL.GE.4 ) C4(I) = ROW(4)
	IF( NCOL.GE.5 ) C5(I) = ROW(5)
	IF( NCOL.GE.6 ) C6(I) = ROW(6)
	IF( NCOL.GE.7 ) C7(I) = ROW(7)
	IF( NCOL.GE.8 ) C8(I) = ROW(8)
	IF( NCOL.GE.9 ) C9(I) = ROW(9)
	IF( NCOL.GE.10 ) C10(I) = ROW(10)
	IF( NCOL.GE.11 ) C11(I) = ROW(11)
	IF( NCOL.GE.12 ) C12(I) = ROW(12)
	IF( NCOL.GE.13 ) C13(I) = ROW(13)
	IF( NCOL.GE.14 ) C14(I) = ROW(14)
	IF( NCOL.GE.15 ) C15(I) = ROW(15)
	IF( NCOL.GE.16 ) C16(I) = ROW(16)
	IF( NCOL.GE.17 ) C17(I) = ROW(17)
	IF( NCOL.GE.18 ) C18(I) = ROW(18)
	IF( NCOL.GE.19 ) C19(I) = ROW(19)
	IF( NCOL.GE.20 ) C20(I) = ROW(20)
	IF( NCOL.GE.21 ) C21(I) = ROW(21)
	IF( NCOL.GE.22 ) C22(I) = ROW(22)
	IF( NCOL.GE.23 ) C23(I) = ROW(23)
	IF( NCOL.GE.24 ) C24(I) = ROW(24)
	IF( NCOL.GE.25 ) C25(I) = ROW(25)
	IF( NCOL.GE.26 ) C26(I) = ROW(26)
	IF( NCOL.GE.27 ) C27(I) = ROW(27)
	IF( NCOL.GE.28 ) C28(I) = ROW(28)
	IF( NCOL.GE.29 ) C29(I) = ROW(29)
	IF( NCOL.GE.30 ) C30(I) = ROW(30)
	IF( NCOL.GE.31 ) C31(I) = ROW(31)
	IF( NCOL.GE.32 ) C32(I) = ROW(32)
	IF( NCOL.GE.33 ) C33(I) = ROW(33)
	IF( NCOL.GE.34 ) C34(I) = ROW(34)
	IF( NCOL.GE.35 ) C35(I) = ROW(35)
	IF( NCOL.GE.36 ) C36(I) = ROW(36)
	IF( NCOL.GE.37 ) C37(I) = ROW(37)
	IF( NCOL.GE.38 ) C38(I) = ROW(38)
	IF( NCOL.GE.39 ) C39(I) = ROW(39)
	IF( NCOL.GE.40 ) C40(I) = ROW(40)
	IF( NCOL.GE.41 ) C41(I) = ROW(41)
	IF( NCOL.GE.42 ) C42(I) = ROW(42)
	IF( NCOL.GE.43 ) C43(I) = ROW(43)
	IF( NCOL.GE.44 ) C44(I) = ROW(44)
	IF( NCOL.GE.45 ) C45(I) = ROW(45)
	IF( NCOL.GE.46 ) C46(I) = ROW(46)
	IF( NCOL.GE.47 ) C47(I) = ROW(47)
	IF( NCOL.GE.48 ) C48(I) = ROW(48)
	IF( NCOL.GE.49 ) C49(I) = ROW(49)
	IF( NCOL.GE.50 ) C50(I) = ROW(50)
	IF( NCOL.GE.51 ) C51(I) = ROW(51)
	IF( NCOL.GE.52 ) C52(I) = ROW(52)
	IF( NCOL.GE.53 ) C53(I) = ROW(53)
	IF( NCOL.GE.54 ) C54(I) = ROW(54)
	IF( NCOL.GE.55 ) C55(I) = ROW(55)
	IF( NCOL.GE.56 ) C56(I) = ROW(56)
	IF( NCOL.GE.57 ) C57(I) = ROW(57)
	IF( NCOL.GE.58 ) C58(I) = ROW(58)
	IF( NCOL.GE.59 ) C59(I) = ROW(59)
	IF( NCOL.GE.60 ) C60(I) = ROW(60)
	IF( NCOL.GE.61 ) C61(I) = ROW(61)
	IF( NCOL.GE.62 ) C62(I) = ROW(62)
	IF( NCOL.GE.63 ) C63(I) = ROW(63)
	IF( NCOL.GE.64 ) C64(I) = ROW(64)
	IF( NCOL.GE.65 ) C65(I) = ROW(65)
	IF( NCOL.GE.66 ) C66(I) = ROW(66)
	IF( NCOL.GE.67 ) C67(I) = ROW(67)
	IF( NCOL.GE.68 ) C68(I) = ROW(68)
	IF( NCOL.GE.69 ) C69(I) = ROW(69)
	IF( NCOL.GE.70 ) C70(I) = ROW(70)
	IF( NCOL.GE.71 ) C71(I) = ROW(71)
	IF( NCOL.GE.72 ) C72(I) = ROW(72)
	IF( NCOL.GE.73 ) C73(I) = ROW(73)
	IF( NCOL.GE.74 ) C74(I) = ROW(74)
	IF( NCOL.GE.75 ) C75(I) = ROW(75)
	IF( NCOL.GE.76 ) C76(I) = ROW(76)
	IF( NCOL.GE.77 ) C77(I) = ROW(77)
	IF( NCOL.GE.78 ) C78(I) = ROW(78)
	IF( NCOL.GE.79 ) C79(I) = ROW(79)
	IF( NCOL.GE.80 ) C80(I) = ROW(80)
	IF( NCOL.GE.81 ) C81(I) = ROW(81)
	IF( NCOL.GE.82 ) C82(I) = ROW(82)
	IF( NCOL.GE.83 ) C83(I) = ROW(83)
	IF( NCOL.GE.84 ) C84(I) = ROW(84)
	IF( NCOL.GE.85 ) C85(I) = ROW(85)
	IF( NCOL.GE.86 ) C86(I) = ROW(86)
	IF( NCOL.GE.87 ) C87(I) = ROW(87)
	IF( NCOL.GE.88 ) C88(I) = ROW(88)
	IF( NCOL.GE.89 ) C89(I) = ROW(89)
	IF( NCOL.GE.90 ) C90(I) = ROW(90)
	IF( NCOL.GE.91 ) C91(I) = ROW(91)
	IF( NCOL.GE.92 ) C92(I) = ROW(92)
	IF( NCOL.GE.93 ) C93(I) = ROW(93)
	IF( NCOL.GE.94 ) C94(I) = ROW(94)
	IF( NCOL.GE.95 ) C95(I) = ROW(95)
	IF( NCOL.GE.96 ) C96(I) = ROW(96)
	IF( NCOL.GE.97 ) C97(I) = ROW(97)
	IF( NCOL.GE.98 ) C98(I) = ROW(98)
	IF( NCOL.GE.99 ) C99(I) = ROW(99)
	IF( NCOL.GE.100 ) C100(I) = ROW(100)
	IF( NCOL.GE.101 ) C101(I) = ROW(101)
	IF( NCOL.GE.102 ) C102(I) = ROW(102)
	IF( NCOL.GE.103 ) C103(I) = ROW(103)
	IF( NCOL.GE.104 ) C104(I) = ROW(104)
	IF( NCOL.GE.105 ) C105(I) = ROW(105)
	IF( NCOL.GE.106 ) C106(I) = ROW(106)
	IF( NCOL.GE.107 ) C107(I) = ROW(107)
	IF( NCOL.GE.108 ) C108(I) = ROW(108)
	IF( NCOL.GE.109 ) C109(I) = ROW(109)
	IF( NCOL.GE.110 ) C110(I) = ROW(110)
	IF( NCOL.GE.111 ) C111(I) = ROW(111)
	IF( NCOL.GE.112 ) C112(I) = ROW(112)
	IF( NCOL.GE.113 ) C113(I) = ROW(113)
	IF( NCOL.GE.114 ) C114(I) = ROW(114)
	IF( NCOL.GE.115 ) C115(I) = ROW(115)
	IF( NCOL.GE.116 ) C116(I) = ROW(116)
	IF( NCOL.GE.117 ) C117(I) = ROW(117)
	IF( NCOL.GE.118 ) C118(I) = ROW(118)
	IF( NCOL.GE.119 ) C119(I) = ROW(119)
	IF( NCOL.GE.120 ) C120(I) = ROW(120)
	IF( NCOL.GE.121 ) C121(I) = ROW(121)
	IF( NCOL.GE.122 ) C122(I) = ROW(122)
	IF( NCOL.GE.123 ) C123(I) = ROW(123)
	IF( NCOL.GE.124 ) C124(I) = ROW(124)
	IF( NCOL.GE.125 ) C125(I) = ROW(125)
	IF( NCOL.GE.126 ) C126(I) = ROW(126)
	IF( NCOL.GE.127 ) C127(I) = ROW(127)
	IF( NCOL.GE.128 ) C128(I) = ROW(128)
	IF( NCOL.GE.129 ) C129(I) = ROW(129)
	IF( NCOL.GE.130 ) C130(I) = ROW(130)
	IF( NCOL.GE.131 ) C131(I) = ROW(131)
	IF( NCOL.GE.132 ) C132(I) = ROW(132)
	IF( NCOL.GE.133 ) C133(I) = ROW(133)
	IF( NCOL.GE.134 ) C134(I) = ROW(134)
	IF( NCOL.GE.135 ) C135(I) = ROW(135)
	IF( NCOL.GE.136 ) C136(I) = ROW(136)
	IF( NCOL.GE.137 ) C137(I) = ROW(137)
	IF( NCOL.GE.138 ) C138(I) = ROW(138)
	IF( NCOL.GE.139 ) C139(I) = ROW(139)
	IF( NCOL.GE.140 ) C140(I) = ROW(140)
      END DO

      END IF
	I = MAXROW + 1

* final read to pick up the eof

	READ( INUNIT, '(A)', ERR=200, END=200 ) RECORD

* give warning if there was data past the final row

	WRITE(*,*)  '** WARNING: Data beyond row', MAXROW, ' was not read.'
  200	NROW = I - 1

* close input file

	CLOSE( UNIT = INUNIT )

* normal return

 1000	RETURN

* Error return

   99	WRITE(*,*) CHAR(7),'** Error opening file. '
	WRITE(*,*) '** ', FILE(:LEN1(FILE))
	GOTO 999

  999   WRITE(*,*) '** LOAD1D aborted.'
	NROW = 0
	RETURN
	END
C* DUMP1DH ... Dump NH header lines and NCOL arrays to a free-format ascii disk file.
C+
      SUBROUTINE DUMP1DH( FILE, NH, H, NCOL, NROW
     &	, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &	, X11, X12, X13, X14, X15, X16, X17, X18, X19, X20 )
* Input:
*	FILE	C* File name or ' ' for interactive selection
*	NH	i4 Number of header lines
*	H(NH)	C* HEADER LINES
*	NCOL	I4 Number of data arrays
*	NROW	I4 Number of data values in each array
*	X1..X20	R4(NROW) The data arrays
C--
* Oct 1985 by KDH at STScI
* Apr 1988 KDH @ STScI - generalized from DUMPMONGO
* May 1991 KDH @ STScI - install in XCAL
* Jan 1994 KDH @ Utrecht - maxcol=5, DUMP_DAT -> DUMP1D, improve error msgs
* Mar 1994 KDH @ Utrecht - entry points for 1-5 images
* May 1995 KDH @ St.And - fix bug causing no output when file specified
* 1999 Nov KDH @ St.And - maxcol=5->6
* 2000 Nov KDH @ Austin - open with type='unknown'      
* 2001 Aug KDH @ St.And - use OPENFILE
* 2002 Jul KDH @ St.And - add array 7
* 2007 Oct KDH @ Christchurch - arrays 8-20
* 2007 Oct KDH @ Christchurch - PARAMETER( IOUT = 93 )
* 2007 Oct KDH @ Christchurch -- WRITE(RECORD,*), then WRITE(IOUT,'(A)')
*	       since WRITE(IOUT,*) sometimes writes more than 1 line
* 2012 Oct KDH @ StA - extend 10 to 20 columns
* 2018 May KDH @ StA - write header lines H(NH)
	REAL*4 X1(*), X2(*), X3(*), X4(*), X5(*)
	REAL*4 X6(*), X7(*), X8(*), X9(*), X10(*)
	REAL*4 X11(*), X12(*), X13(*), X14(*), X15(*)
	REAL*4 X16(*), X17(*), X18(*), X19(*), X20(*)
	CHARACTER*(*) FILE
	CHARACTER*(*) H(*)
	CHARACTER*128 OFILE
	CHARACTER*512 RECORD
	CHARACTER*10 REPLY
	PARAMETER ( MAXCOL = 20 )
	PARAMETER ( IOUT = 93 )
	GOTO 100
* multiple entries because unix/linux can't handle more arrays in
* the subroutine argument list than in the calling program
	ENTRY DUMP1D20H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17, X18, X19, X20 )
	GOTO 100
	ENTRY DUMP1D19H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17, X18, X19 )
	GOTO 100
	ENTRY DUMP1D18H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17, X18 )
	GOTO 100
	ENTRY DUMP1D17H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17 )
	GOTO 100
	ENTRY DUMP1D16H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16 )
	GOTO 100
	ENTRY DUMP1D15H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15 )
	GOTO 100
	ENTRY DUMP1D14H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14 )
	GOTO 100
	ENTRY DUMP1D13H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13 )
	GOTO 100
	ENTRY DUMP1D12H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12 )
	GOTO 100
	ENTRY DUMP1D11H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11 )
	GOTO 100
	ENTRY DUMP1D10H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10 )
	GOTO 100
	ENTRY DUMP1D9H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9 )
	GOTO 100
	ENTRY DUMP1D8H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8 )
	GOTO 100
	ENTRY DUMP1D7H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7 )
	GOTO 100
	ENTRY DUMP1D6H( FILE, NH, H, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6 )
	GOTO 100
	ENTRY DUMP1D5H( FILE, NH, H, NCOL, NROW, X1, X2, X3, X4, X5 )
	GOTO 100
	ENTRY DUMP1D4H( FILE, NH, H, NCOL, NROW, X1, X2, X3, X4 )
	GOTO 100
	ENTRY DUMP1D3H( FILE, NH, H, NCOL, NROW, X1, X2, X3 )
	GOTO 100
	ENTRY DUMP1D2H( FILE, NH, H, NCOL, NROW, X1, X2 )
	GOTO 100
	ENTRY DUMP1D1H( FILE, NH, H, NCOL, NROW, X1 )

* check dimensions
  100 IF( NCOL .LT. 1 ) RETURN
      IF( NROW .LT. 1 ) RETURN
      NC = MIN( NCOL, MAXCOL )
      IF( NC .NE. NCOL ) THEN
        WRITE(*,*) '**DUMP1D: skipping columns', NC + 1,'-', NCOL
      END IF
      OFILE = FILE
* get filename
   10 IF( OFILE.EQ.' ' ) THEN
        WRITE(*,'(A,$)') ' Output filename : '
	READ(*,'(A)') OFILE
	REPLY = OFILE
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY .EQ. ' ') RETURN
	IF( REPLY .EQ. 'NONE' ) RETURN
      END IF
* open file
	CALL OPENFILE( IOUT, OFILE, 'FORMATTED', 'UNKNOWN', IER )
	IF( IER .NE. 0 ) GOTO 99
      WRITE(*,*) 'File open ', OFILE(:LEN1(OFILE))

* write header lines
      IF( NH .GT. 0 ) THEN
	ITRUNK = 0
      DO I = 1, NH
	IH = I
	RECORD = H( I )
	LR = LEN1( RECORD )
	LH = LEN1( H( I ) )
* truncated header line
      IF( LR .NE. LH ) THEN
	WRITE(*,*) '** DUMP1DH: HEADER LINE TRUNCATED FROM', LH, ' TO', LR
	WRITE(*,*) '** ', H(I)(:LH)
	ITRUNK = I
      END IF
      IF( RECORD(1:1) .NE. '#' .AND. RECORD(1:1) .NE. '!' ) THEN
	RECORD = '# ' // RECORD( : LEN1( RECORD ) )
      END IF
	WRITE( IOUT, '(A)', ERR=97 ) RECORD( : LEN1( RECORD ) )
      END DO
      END IF

* write data
      NR = 0
      DO I = 1, NROW
      IF( NC .EQ. 1 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I)
      ELSE IF( NC .EQ. 2 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I)
      ELSE IF( NC .EQ. 3 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I)
      ELSE IF( NC .EQ. 4 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I)
      ELSE IF( NC .EQ. 5 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
      ELSE IF( NC .EQ. 6 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I)
      ELSE IF( NC .EQ. 7 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I)
      ELSE IF( NC .EQ. 8 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I)
      ELSE IF( NC .EQ. 9 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I)
      ELSE IF( NC .EQ. 10 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I)
      ELSE IF( NC .EQ. 11 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I), x11(i)
      ELSE IF( NC .EQ. 12 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I), x11(i), x12(i)
      ELSE IF( NC .EQ. 13 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I), x11(i), x12(i), x13(i)
      ELSE IF( NC .EQ. 14 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I)
      ELSE IF( NC .EQ. 15 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i)
      ELSE IF( NC .EQ. 16 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i)
      ELSE IF( NC .EQ. 17 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i)
      ELSE IF( NC .EQ. 18 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i), x18(i)
      ELSE IF( NC .EQ. 19 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i), x18(i), x19(i)
      ELSE IF( NC .EQ. 20 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i), x18(i), x19(i), x20(i)
      ELSE
	WRITE(*,*) '** DUMP1DH TOO MANY COLUMNS', NC
	STOP ':(((((.'
      END IF
	WRITE( IOUT, '(A)', ERR=98 ) RECORD( : LEN1( RECORD ) )
        NR = I
      END DO

* close file
   50 WRITE(*,*) 'Dump columns:', NC, ' rows:', NR, ' of', NROW
      CLOSE( UNIT = IOUT )
* normal return
 1000 RETURN

* header write error
   97 WRITE(*,*) '**DUMP1DH: error writing header to file', ofile(:len1(ofile))
	goto 50

* file write error
 98   WRITE(*,*) '**DUMP1DH: error writing to file ', OFILE(:LEN1(OFILE))
      GOTO 50
       
* file open error
 99   WRITE(*,*) '**DUMP1DH: error opening file ', OFILE(:LEN1(OFILE))
      OFILE = ' '
      GOTO 10
      END
C* DUMP1D ... Dump NCOL arrays to a free-format ascii disk file.
C+
      SUBROUTINE DUMP1D( FILE, NCOL, NROW
     &	, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &	, X11, X12, X13, X14, X15, X16, X17, X18, X19, X20 )
* Input:
*	FILE	C* file name or ' ' for interactive selection
*	NCOL	I4 Number of data arrays
*	NROW	I4 Number of data values in each array
*	X1-XNCOL	R4(NROW) The data arrays
C--
* Oct 1985 by KDH at STScI
* Apr 1988 KDH @ STScI - generalized from DUMPMONGO
* May 1991 KDH @ STScI - install in XCAL
* Jan 1994 KDH @ Utrecht - maxcol=5, DUMP_DAT -> DUMP1D, improve error msgs
* Mar 1994 KDH @ Utrecht - entry points for 1-5 images
* May 1995 KDH @ St.And - fix bug causing no output when file specified
* 1999 Nov KDH @ St.And - maxcol=5->6
* 2000 Nov KDH @ Austin - open with type='unknown'      
* 2001 Aug KDH @ St.And - use OPENFILE
* 2002 Jul KDH @ St.And - add array 7
* 2007 Oct KDH @ Christchurch - arrays 8-20
* 2007 Oct KDH @ Christchurch - PARAMETER( IOUT = 93 )
* 2007 Oct KDH @ Christchurch -- WRITE(RECORD,*), then WRITE(IOUT,'(A)')
*	       since WRITE(IOUT,*) sometimes writes more than 1 line
* 2012 Oct KDH @ StA - extend 10 to 20 columns
	REAL*4 X1(*), X2(*), X3(*), X4(*), X5(*)
	REAL*4 X6(*), X7(*), X8(*), X9(*), X10(*)
	REAL*4 X11(*), X12(*), X13(*), X14(*), X15(*)
	REAL*4 X16(*), X17(*), X18(*), X19(*), X20(*)
	CHARACTER*(*) FILE
	CHARACTER*128 OFILE
	CHARACTER*512 RECORD
	CHARACTER*10 REPLY
	PARAMETER ( MAXCOL = 20 )
	PARAMETER ( IOUT = 93 )
	GOTO 100
* multiple entries because unix/linux can't handle more arrays in
* the subroutine argument list than in the calling program
	ENTRY DUMP1D20( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17, X18, X19, X20 )
	GOTO 100
	ENTRY DUMP1D19( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17, X18, X19 )
	GOTO 100
	ENTRY DUMP1D18( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17, X18 )
	GOTO 100
	ENTRY DUMP1D17( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16, X17 )
	GOTO 100
	ENTRY DUMP1D16( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15, X16 )
	GOTO 100
	ENTRY DUMP1D15( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14, X15 )
	GOTO 100
	ENTRY DUMP1D14( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13, X14 )
	GOTO 100
	ENTRY DUMP1D13( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12, X13 )
	GOTO 100
	ENTRY DUMP1D12( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11, X12 )
	GOTO 100
	ENTRY DUMP1D11( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10
     &		, X11 )
	GOTO 100
	ENTRY DUMP1D10( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9, X10 )
	GOTO 100
	ENTRY DUMP1D9( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8, X9 )
	GOTO 100
	ENTRY DUMP1D8( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7, X8 )
	GOTO 100
	ENTRY DUMP1D7( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6, X7 )
	GOTO 100
	ENTRY DUMP1D6( FILE, NCOL, NROW
     &		, X1, X2, X3, X4, X5, X6 )
	GOTO 100
	ENTRY DUMP1D5( FILE, NCOL, NROW, X1, X2, X3, X4, X5 )
	GOTO 100
	ENTRY DUMP1D4( FILE, NCOL, NROW, X1, X2, X3, X4 )
	GOTO 100
	ENTRY DUMP1D3( FILE, NCOL, NROW, X1, X2, X3 )
	GOTO 100
	ENTRY DUMP1D2( FILE, NCOL, NROW, X1, X2 )
	GOTO 100
	ENTRY DUMP1D1( FILE, NCOL, NROW, X1 )

* check dimensions
  100 IF( NCOL .LT. 1 ) RETURN
      IF( NROW .LT. 1 ) RETURN
      NC = MIN( NCOL, MAXCOL )
      IF( NC .NE. NCOL ) THEN
        WRITE(*,*) '**DUMP1D: skipping columns', NC + 1,'-', NCOL
      END IF
      OFILE = FILE
* get filename
   10 IF( OFILE.EQ.' ' ) THEN
        WRITE(*,'(A,$)') ' Output filename : '
	READ(*,'(A)') OFILE
	REPLY = OFILE
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY .EQ. ' ') RETURN
	IF( REPLY .EQ. 'NONE' ) RETURN
      END IF
* open file
	CALL OPENFILE( IOUT, OFILE, 'FORMATTED', 'UNKNOWN', IER )
	IF( IER .NE. 0 ) GOTO 99
      WRITE(*,*) 'File open ', OFILE(:LEN1(OFILE))
* write data
      NR = 0
      DO I=1,NROW
      IF( NC .EQ. 1 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I)
      ELSE IF( NC .EQ. 2 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I)
      ELSE IF( NC .EQ. 3 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I)
      ELSE IF( NC .EQ. 4 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I)
      ELSE IF( NC .EQ. 5 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
      ELSE IF( NC .EQ. 6 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I)
      ELSE IF( NC .EQ. 7 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I)
      ELSE IF( NC .EQ. 8 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I)
      ELSE IF( NC .EQ. 9 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I)
      ELSE IF( NC .EQ. 10 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I)
      ELSE IF( NC .EQ. 11 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I), x11(i)
      ELSE IF( NC .EQ. 12 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I), x11(i), x12(i)
      ELSE IF( NC .EQ. 13 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I), X10(I), x11(i), x12(i), x13(i)
      ELSE IF( NC .EQ. 14 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I)
      ELSE IF( NC .EQ. 15 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i)
      ELSE IF( NC .EQ. 16 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i)
      ELSE IF( NC .EQ. 17 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i)
      ELSE IF( NC .EQ. 18 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i), x18(i)
      ELSE IF( NC .EQ. 19 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i), x18(i), x19(i)
      ELSE IF( NC .EQ. 20 ) THEN
	WRITE( RECORD, *, ERR=98 ) X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X14(I), x15(i), x16(i), x17(i), x18(i), x19(i), x20(i)
      ELSE
	WRITE(*,*) '** DUMP1D TOO MANY COLUMNS', NC
	STOP ':(((((.'
      END IF
	WRITE( IOUT, '(A)', ERR=98 ) RECORD( : LEN1( RECORD ) )
        NR = I
      END DO

* close file
   50 WRITE(*,*) 'Dump columns:', NC, ' rows:', NR, ' of', NROW
      CLOSE( UNIT = IOUT )
* normal return
 1000 RETURN

* file write error
 98   WRITE(*,*) '**DUMP1D: error writing to file ', OFILE(:LEN1(OFILE))
      GOTO 50
       
* file open error
 99   WRITE(*,*) '**DUMP1D: error opening file ', OFILE(:LEN1(OFILE))
      OFILE = ' '
      GOTO 10
      END
C*LOADLC .. load multi-column data from ascii file - 1st column real*8
C+
      SUBROUTINE LOADLC( NAME, NCOL, NROW,
     #	HJD, C2, C3, C4, C5, C6, C7, C8, C9,
     #	C10, C11, C12, C13, C14, C15, C16, C17, C18, C19,
     #	C20, C21, C22, C23, C24, C25, C26, C27, C28, C29,
     #	C30, C31, C32, C33, C34, C35, C36, C37, C38, C39,
     #	C40, C41, C42, C43, C44, C45, C46, C47, C48, C49,
     #	C50, C51, C52, C53, C54, C55, C56, C57, C58, C59,
     #	C60, C61, C62, C63, C64, C65, C66, C67, C68, C69,
     #	C70, C71, C72, C73, C74, C75, C76, C77, C78, C79,
     #	C80, C81, C82, C83, C84, C85, C86, C87, C88, C89,
     #	C90, C91, C92, C93, C94, C95, C96, C97, C98, C99,
     #	C100, C101, C102, C103, C104, C105, C106, C107, C108, C109,
     #	C110, C111, C112, C113, C114, C115, C116, C117, C118, C119,
     #	C120, C121, C122, C123, C124, C125, C126, C127, C128, C129,
     #	C130, C131, C132, C133, C134, C135, C136, C137, C138, C139,
     #	C140 )
*
* Loads up to 140 columns of data from a free-format ASCII data file
* Use as follows:
*       parameter ( maxdat = 10000 )
*       real*4 c1(maxdat), c2(maxdat), c3(maxdat)
*       character*256 file
*       file = 'file.dat'
*       ndat = maxdat
*       call load1d( file, 3, ndat, c1, c2, c3 )
*
*  Input:
*	NAME	= C* Name of disk file, ' ' for interactive selection.
*	NCOL	= I4 Number of columns to be read (if NCOL > 0)
*		     (if NCOL < 0, then only column -NCOL is read)
*	NROW	= I4 Maximum allowed number of rows
*  Output:
*	NAME	= C* Name of disk file (only if selected interactively)
*	NROW	= I4 Number of data points (0 if none loaded)
*	C1(NROW)= R8 first column (REAL*8 TO HOLD HJD)
*	C2(NROW)= R4 second column
*	  ...
*	C140(NROW)= R4 140th column
C--
* May 1987 Keith Horne @ STScI
* Sep 1987 KDH - add NCOL<0 option to read specified column.
* May 1988 KDH - add final read to pick up eof after reading all rows.
* Jul 1988 KDH @ STScI - change name from LOAD_ASCII to LOAD_DAT
* Sep 1991 KDH @ STScI - skip words when COL < 0.
* Jan 1994 KDH @ Utrecht - split LOAD_DAT to LOAD1D,LOAD1D10,...
* Mar 1994 KDH @ Utrecht - entry points LOAD1DX, X=1...20
* Mar 1998 KDH @ St.Andrews - MAXCOL=20->140
* 1999 Oct KDH @ St.And - change OPEN for unix compatibility
* 2001 Jul KDH @ St.And -- no // of character*(*)
* 2001 Aug KDH @ St.And -- use OPENFILE
* 2002 Mar KDH @ St.And -- convert LOAD1D to LOADLC
* 2006 Jul KDH @ StA -- ENTRY LOADPLC for planet format data
* 2009 Jul KDH @ StA -- C(1) -> C(*)
* 2010 Mar KDH @ LCO - continue to avoid err=n branch to same line
	REAL*8 C1(*)
	REAL*4        C2(*), C3(*), C4(*), C5(*)
	REAL*4 C6(*), C7(*), C8(*), C9(*), C10(*)
	REAL*4 C11(*), C12(*), C13(*), C14(*), C15(*)
	REAL*4 C16(*), C17(*), C18(*), C19(*), C20(*)
	REAL*4 C21(*), C22(*), C23(*), C24(*), C25(*)
	REAL*4 C26(*), C27(*), C28(*), C29(*), C30(*)
	REAL*4 C31(*), C32(*), C33(*), C34(*), C35(*)
	REAL*4 C36(*), C37(*), C38(*), C39(*), C40(*)
	REAL*4 C41(*), C42(*), C43(*), C44(*), C45(*)
	REAL*4 C46(*), C47(*), C48(*), C49(*)
	REAL*4 C50(*), C51(*), C52(*), C53(*), C54(*)
	REAL*4 C55(*), C56(*), C57(*), C58(*), C59(*)
	REAL*4 C60(*), C61(*), C62(*), C63(*), C64(*)
	REAL*4 C65(*), C66(*), C67(*), C68(*), C69(*)
	REAL*4 C70(*), C71(*), C72(*), C73(*), C74(*)
	REAL*4 C75(*), C76(*), C77(*), C78(*), C79(*)
	REAL*4 C80(*), C81(*), C82(*), C83(*), C84(*)
	REAL*4 C85(*), C86(*), C87(*), C88(*), C89(*)
	REAL*4 C90(*), C91(*), C92(*), C93(*), C94(*)
	REAL*4 C95(*), C96(*), C97(*), C98(*), C99(*)
	REAL*4 C100(*), C101(*), C102(*), C103(*), C104(*)
	REAL*4 C105(*), C106(*), C107(*), C108(*), C109(*)
	REAL*4 C110(*), C111(*), C112(*), C113(*), C114(*)
	REAL*4 C115(*), C116(*), C117(*), C118(*), C119(*)
	REAL*4 C120(*), C121(*), C122(*), C123(*), C124(*)
	REAL*4 C125(*), C126(*), C127(*), C128(*), C129(*)
	REAL*4 C130(*), C131(*), C132(*), C133(*), C134(*)
	REAL*4 C135(*), C136(*), C137(*), C138(*), C139(*)
	REAL*4 C140(*)
	CHARACTER*(*) NAME
	CHARACTER*256 FILE	! file name
	PARAMETER (INUNIT=49)	! input unit number
	PARAMETER (MAXCOL=140)	! maximum number of columns that can be read
	CHARACTER*(15*MAXCOL) RECORD ! buffer into which data are read
	REAL*8 ROW( MAXCOL )


* entry points since UNIX requires number of arguments to match exactly

	ENTRY LOADLC20( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19, C20 )
        GOTO 100

	ENTRY LOADLC19( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18, C19 )
        GOTO 100

	ENTRY LOADLC18( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17, C18 )
        GOTO 100

	ENTRY LOADLC17( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16, C17 )
        GOTO 100

	ENTRY LOADLC16( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15,
     #	C16 )
        GOTO 100

        ENTRY LOADLC15( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14, C15 )
        GOTO 100

        ENTRY LOADLC14( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13, C14 )
        GOTO 100

        ENTRY LOADLC13( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12, C13 )
        GOTO 100

        ENTRY LOADLC12( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11, C12 )
        GOTO 100

        ENTRY LOADLC11( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10, C11 )
        GOTO 100

        ENTRY LOADLC10( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9, C10 )
        GOTO 100

        ENTRY LOADLC9( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8, C9 )
        GOTO 100

        ENTRY LOADLC8( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8 )
        GOTO 100
        ENTRY LOADLC8T( NAME, NCOL, NHJD, NROW, C1, C2, C3, C4, C5,
     #	C6, C7, C8 )
        GOTO 101

        ENTRY LOADLC7( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6, C7 )
        GOTO 100
        ENTRY LOADLC7T( NAME, NCOL, NHJD, NROW, C1, C2, C3, C4, C5,
     #	C6, C7 )
        GOTO 101

        ENTRY LOADLC6( NAME, NCOL, NROW, C1, C2, C3, C4, C5,
     #	C6 )
        GOTO 100
        ENTRY LOADLC6T( NAME, NCOL, NHJD, NROW, C1, C2, C3, C4, C5,
     #	C6 )
        GOTO 101

        ENTRY LOADLC5( NAME, NCOL, NROW, C1, C2, C3, C4, C5 )
        GOTO 100
        ENTRY LOADLC5T( NAME, NCOL, NHJD, NROW, C1, C2, C3, C4, C5 )
        GOTO 101

        ENTRY LOADLC4( NAME, NCOL, NROW, C1, C2, C3, C4 )
        GOTO 100
        ENTRY LOADLC4T( NAME, NCOL, NHJD, NROW, C1, C2, C3, C4 )
        GOTO 101

        ENTRY LOADLC3( NAME, NCOL, NROW, C1, C2, C3 )
        GOTO 100
        ENTRY LOADLC3T( NAME, NCOL, NHJD, NROW, C1, C2, C3 )
        GOTO 101

        ENTRY LOADLC2( NAME, NCOL, NROW, C1, C2 )
        GOTO 100
        ENTRY LOADLC2T( NAME, NCOL, NHJD, NROW, C1, C2 )
        GOTO 101

        ENTRY LOADLC1( NAME, NCOL, NROW, C1 )
        GOTO 100

  100	NT = 1
	GOTO 102
  101	NT = NHJD
  102	NC = NCOL
	write(*,*) 'NCOL', NC, ' HJD COL', NT, ' NROW', nrow

* trap errors
      IF( NROW.LE.0. OR. NC.EQ.0 ) THEN
	WRITE(*,*) '** INVALID DIMENSIONS.', NROW, NC
	GOTO 999
      ELSE IF( NC.GT.MAXCOL ) THEN
	WRITE(*,*) '** WARNING: Too many columns for LOADLC.'
	WRITE(*,*) '** Columns', MAXCOL, ' thru', NC, ' skipped.'
      END IF

	MXT = MIN( NC, 8 )
      IF( NT .GT. MXT ) THEN
	WRITE(*,*) '** ERROR: NT=', NT, ' > MAX =', MXT
	GOTO 999
      END IF

	MAXROW = NROW

* get name of input file

	FILE = NAME
c        WRITE(*,*) 'FILE"', NAME( :LEN1(NAME) ), '"'
      IF( FILE.EQ.' ' ) THEN
	WRITE(*,'(A,I3,A)')
     #	' Enter name of', IABS(NC),'-column free-format ASCII file :'
	READ(*,'(A)') FILE
	CALL WORD1( FILE, L1, L2 )
	IF( L1 .LE. 0 ) GOTO 99
	NAME = FILE( :LEN1( FILE ) )
      END IF

* open input disk file

	CALL OPENFILE( INUNIT, FILE, 'FORMATTED', 'OLD', IER )
	IF( IER .NE. 0 ) GOTO 99

* read desired column by skipping unwanted columns that precede it.

      IF( NC .LE. -2 ) THEN
	NSKIP = IABS(NC)-1
      DO I=1,MAXROW
   51	continue
	READ( INUNIT, '(A)', ERR=51, END=100 ) RECORD
      DO J=1,NSKIP
	CALL WORD1( RECORD, L1, L2 )
	IF( L1.LT.1 ) GOTO 51
	RECORD = RECORD(L2+1:)
      END DO
	READ( RECORD, *, ERR=51, END=51 ) C1(I)
      END DO

* read desired consecutive columns of data from the file

      ELSE IF( IABS(NC) .EQ. 1 ) THEN
      DO I=1,MAXROW
    1	continue
	READ( INUNIT, '(A)', ERR=1, END=200 ) RECORD
	READ( RECORD, *, ERR=1, END=1 ) C1(I)
c	WRITE(*,*) nc, nt, i, C1(I)
      END DO

* 2 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 2 ) THEN
      DO I=1,MAXROW
    2	continue
	READ( INUNIT, '(A)', ERR=2, END=200 ) RECORD
      IF( NT .EQ. 1 ) THEN
	READ( RECORD, *, ERR=2, END=2 ) C1(I), C2(I)
      ELSE IF( NT .EQ. 2 ) THEN
	READ( RECORD, *, ERR=2, END=2 ) C2(I), C1(I)
      END IF
c	WRITE(*,*) nc, nt, i, C1(I), C2(i)
      END DO

* 3 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 3 ) THEN
      DO I=1,MAXROW
    3	continue
	READ( INUNIT, '(A)', ERR=3, END=200 ) RECORD
      IF( NT .EQ. 1 ) THEN
	READ( RECORD, *, ERR=3, END=3 ) C1(I), C2(I), C3(I)
      ELSE IF( NT .EQ. 2 ) THEN
	READ( RECORD, *, ERR=3, END=3 ) C2(I), C1(I), C3(I)
      ELSE IF( NT .EQ. 3 ) THEN
	READ( RECORD, *, ERR=3, END=3 ) C2(I), C3(I), C1(I)
      END IF
c	WRITE(*,*) nc, nt, i, C1(I), C2(i), C3(i)
      END DO

* 4 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 4 ) THEN
      DO I=1,MAXROW
    4	continue
	READ( INUNIT, '(A)', ERR=4, END=200 ) RECORD
      IF( NT .EQ. 1 ) THEN
	READ( RECORD, *, ERR=4, END=4 ) C1(I), C2(I), C3(I), C4(I)
      ELSE IF( NT .EQ. 2 ) THEN
	READ( RECORD, *, ERR=4, END=4 ) C2(I), C1(I), C3(I), C4(I)
      ELSE IF( NT .EQ. 3 ) THEN
	READ( RECORD, *, ERR=4, END=4 ) C2(I), C3(I), C1(I), C4(I)
      ELSE IF( NT .EQ. 4 ) THEN
	READ( RECORD, *, ERR=4, END=4 ) C2(I), C3(I), C4(I), C1(I)
      END IF
c	WRITE(*,*) nc, nt, i, C1(I), C2(i), C3(i), C4(i)
      END DO

* 5 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 5 ) THEN
      DO I=1,MAXROW
    5	continue
	READ( INUNIT, '(A)', ERR=5, END=200 ) RECORD
      IF( NT .EQ. 1 ) THEN
	READ( RECORD, *, ERR=5, END=5 )
     #  C1(I), C2(I), C3(I), C4(I), C5(I)
      ELSE IF( NT .EQ. 2 ) THEN
	READ( RECORD, *, ERR=5, END=5 ) 
     #	C2(I), C1(I), C3(I), C4(I), C5(I)
      ELSE IF( NT .EQ. 3 ) THEN
	READ( RECORD, *, ERR=5, END=5 ) 
     #	C2(I), C3(I), C1(I), C4(I), C5(I)
      ELSE IF( NT .EQ. 4 ) THEN
	READ( RECORD, *, ERR=5, END=5 ) 
     #	C2(I), C3(I), C4(I), C1(I), C5(I)
      ELSE IF( NT .EQ. 5 ) THEN
	READ( RECORD, *, ERR=5, END=5 ) 
     #	C2(I), C3(I), C4(I), C5(I), C1(I)
      END IF

c	WRITE(*,*) nc, nt, i, C1(I), C2(i), C3(i), C4(i), C5(i)
      END DO

* 6 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 6 ) THEN
      DO I=1,MAXROW
    6	continue
	READ( INUNIT, '(A)', ERR=6, END=200 ) RECORD
      IF( NT .EQ. 1 ) THEN
        READ( RECORD, *, ERR=6, END=6 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I), C6(I)
      ELSE IF( NT .EQ. 2 ) THEN
        READ( RECORD, *, ERR=6, END=6 ) 
     #	C2(I), C1(I), C3(I), C4(I), C5(I), C6(I)
      ELSE IF( NT .EQ. 3 ) THEN
        READ( RECORD, *, ERR=6, END=6 ) 
     #	C2(I), C3(I), C1(I), C4(I), C5(I), C6(I)
      ELSE IF( NT .EQ. 4 ) THEN
        READ( RECORD, *, ERR=6, END=6 ) 
     #	C2(I), C3(I), C4(I), C1(I), C5(I), C6(I)
      ELSE IF( NT .EQ. 5 ) THEN
        READ( RECORD, *, ERR=6, END=6 ) 
     #	C2(I), C3(I), C4(I), C5(I), C1(I), C6(I)
      ELSE IF( NT .EQ. 6 ) THEN
        READ( RECORD, *, ERR=6, END=6 ) 
     #	C2(I), C3(I), C4(I), C5(I), C6(I), C1(I)
      END IF
c	WRITE(*,*) nc, nt, i, C1(I), C2(i), C3(i), C4(i), C5(i)
c     &	, C6(i)
      END DO

* 7 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 7 ) THEN
      DO I=1,MAXROW
    7	continue
	READ( INUNIT, '(A)', ERR=7, END=200 ) RECORD
      IF( NT  .EQ. 1 ) THEN
        READ( RECORD, *, ERR=7, END=7 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I), C6(I), C7(I)
      ELSE IF( NT .EQ. 2 ) THEN
        READ( RECORD, *, ERR=7, END=7 ) 
     #	C2(I), C1(I), C3(I), C4(I), C5(I), C6(I), C7(I)
      ELSE IF( NT .EQ. 3 ) THEN
        READ( RECORD, *, ERR=7, END=7 ) 
     #	C2(I), C3(I), C1(I), C4(I), C5(I), C6(I), C7(I)
      ELSE IF( NT .EQ. 4 ) THEN
        READ( RECORD, *, ERR=7, END=7 ) 
     #	C2(I), C3(I), C4(I), C1(I), C5(I), C6(I), C7(I)
      ELSE IF( NT .EQ. 5 ) THEN
        READ( RECORD, *, ERR=7, END=7 ) 
     #	C2(I), C3(I), C4(I), C5(I), C1(I), C6(I), C7(I)
      ELSE IF( NT .EQ. 6 ) THEN
        READ( RECORD, *, ERR=7, END=7 ) 
     #	C2(I), C3(I), C4(I), C5(I), C6(I), C1(I), C7(I)
      ELSE IF( NT .EQ. 7 ) THEN
        READ( RECORD, *, ERR=7, END=7 ) 
     #	C2(I), C3(I), C4(I), C5(I), C6(I), C7(I), C1(I)
      END IF

c	WRITE(*,*) nc, nt, i, C1(I), C2(i), C3(i), C4(i), C5(i)
c     &	, C6(i), C7(i)
      END DO

* 8 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 8 ) THEN
      DO I=1,MAXROW
    8	continue
	READ( INUNIT, '(A)', ERR=8, END=200 ) RECORD
c	write(*,*) nc, nt, i, ' ', record(:len1(record))
      IF( NT .EQ. 1 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I), C6(I), C7(I), C8(I)
      ELSE IF( NT .EQ. 2 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C2(I), C1(I), C3(I), C4(I), C5(I), C6(I), C7(I), C8(I)
      ELSE IF( NT .EQ. 3 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C2(I), C3(I), C1(I), C4(I), C5(I), C6(I), C7(I), C8(I)
      ELSE IF( NT .EQ. 4 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C2(I), C3(I), C4(I), C1(I), C5(I), C6(I), C7(I), C8(I)
      ELSE IF( NT .EQ. 5 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C2(I), C3(I), C4(I), C5(I), C1(I), C6(I), C7(I), C8(I)
      ELSE IF( NT .EQ. 6 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C2(I), C3(I), C4(I), C5(I), C6(I), C1(I), C7(I), C8(I)
      ELSE IF( NT .EQ. 7 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C2(I), C3(I), C4(I), C5(I), C6(I), C7(I), C1(I), C8(I)
      ELSE IF( NT .EQ. 8 ) THEN
        READ( RECORD, *, ERR=8, END=8 ) 
     #	C2(I), C3(I), C4(I), C5(I), C6(I), C7(I), C8(I), C1(I)
      END IF
c	WRITE(*,*) nc, nt, i, C1(I), C2(i), C3(i), C4(i), C5(i)
c     &	, C6(i), C7(i), C8(i)
      END DO

* 9 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 9 ) THEN
      DO I=1,MAXROW
    9   continue
	READ( INUNIT, '(A)', ERR=9, END=200 ) RECORD
	READ( RECORD, *, ERR=9, END=9 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I)
      END DO

* 10 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 10 ) THEN
      DO I=1,MAXROW
   10   continue
	READ( INUNIT, '(A)', ERR=10, END=200 ) RECORD
	READ( RECORD, *, ERR=10, END=10 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I)
      END DO

* 11 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 11 ) THEN
      DO I=1,MAXROW
   11   continue
	READ( INUNIT, '(A)', ERR=11, END=200 ) RECORD
	READ( RECORD, *, ERR=11, END=11 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I)
      END DO

* 12 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 12 ) THEN
      DO I=1,MAXROW
   12	continue
	READ( INUNIT, '(A)', ERR=12, END=200 ) RECORD
	READ( RECORD, *, ERR=12, END=12 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I)
      END DO

* 13 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 13 ) THEN
      DO I=1,MAXROW
   13   continue
	READ( INUNIT, '(A)', ERR=13, END=200 ) RECORD
	READ( RECORD, *, ERR=13, END=13 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I)
      END DO

* 14 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 14 ) THEN
      DO I=1,MAXROW
   14   continue
	READ( INUNIT, '(A)', ERR=14, END=200 ) RECORD
	READ( RECORD, *, ERR=14, END=14 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I)
      END DO

* 15 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 15 ) THEN
      DO I=1,MAXROW
   15   continue
	READ( INUNIT, '(A)', ERR=15, END=200 ) RECORD
	READ( RECORD, *, ERR=15, END=15 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I)
      END DO

* 16 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 16 ) THEN
      DO I=1,MAXROW
   16   continue
	READ( INUNIT, '(A)', ERR=16, END=200 ) RECORD
	READ( RECORD, *, ERR=16, END=16 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I)
      END DO

* 17 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 17 ) THEN
      DO I=1,MAXROW
   17   continue
	READ( INUNIT, '(A)', ERR=17, END=200 ) RECORD
	READ( RECORD, *, ERR=17, END=17 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I)
      END DO
* 18 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 18 ) THEN
      DO I=1,MAXROW
   18   continue
	READ( INUNIT, '(A)', ERR=18, END=200 ) RECORD
	READ( RECORD, *, ERR=18, END=18 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I), C18(I)
      END DO

* 19 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 19 ) THEN
      DO I=1,MAXROW
   19   continue
	READ( INUNIT, '(A)', ERR=19, END=200 ) RECORD
	READ( RECORD, *, ERR=19, END=19 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I), C18(I), C19(I)
      END DO

* 20 COLUMNS ----------------------------------------------
      ELSE IF( NC .EQ. 20 ) THEN
      DO I=1,MAXROW
   20   continue
	READ( INUNIT, '(A)', ERR=20, END=200 ) RECORD
	READ( RECORD, *, ERR=20, END=20 ) 
     #	C1(I), C2(I), C3(I), C4(I), C5(I),
     #	C6(I), C7(I), C8(I), C9(I), C10(I),
     #	C11(I), C12(I), C13(I), C14(I), C15(I),
     #	C16(I), C17(I), C18(I), C19(I), C20(I)
      END DO

      ELSE IF( NC .LE. MAXCOL ) THEN
      DO I=1,MAXROW
   50   continue
	READ( INUNIT, '(A)', ERR=50, END=200 ) RECORD
	READ( RECORD, *, ERR=50, END=50 ) 
     #		(ROW(J),J=1,NC )
	IF( NC .GE.1 ) C1(I) = ROW(1)
	IF( NC .GE.2 ) C2(I) = ROW(2)
	IF( NC .GE.3 ) C3(I) = ROW(3)
	IF( NC .GE.4 ) C4(I) = ROW(4)
	IF( NC .GE.5 ) C5(I) = ROW(5)
	IF( NC .GE.6 ) C6(I) = ROW(6)
	IF( NC .GE.7 ) C7(I) = ROW(7)
	IF( NC .GE.8 ) C8(I) = ROW(8)
	IF( NC .GE.9 ) C9(I) = ROW(9)
	IF( NC .GE.10 ) C10(I) = ROW(10)
	IF( NC .GE.11 ) C11(I) = ROW(11)
	IF( NC .GE.12 ) C12(I) = ROW(12)
	IF( NC .GE.13 ) C13(I) = ROW(13)
	IF( NC .GE.14 ) C14(I) = ROW(14)
	IF( NC .GE.15 ) C15(I) = ROW(15)
	IF( NC .GE.16 ) C16(I) = ROW(16)
	IF( NC .GE.17 ) C17(I) = ROW(17)
	IF( NC .GE.18 ) C18(I) = ROW(18)
	IF( NC .GE.19 ) C19(I) = ROW(19)
	IF( NC .GE.20 ) C20(I) = ROW(20)
	IF( NC .GE.21 ) C21(I) = ROW(21)
	IF( NC .GE.22 ) C22(I) = ROW(22)
	IF( NC .GE.23 ) C23(I) = ROW(23)
	IF( NC .GE.24 ) C24(I) = ROW(24)
	IF( NC .GE.25 ) C25(I) = ROW(25)
	IF( NC .GE.26 ) C26(I) = ROW(26)
	IF( NC .GE.27 ) C27(I) = ROW(27)
	IF( NC .GE.28 ) C28(I) = ROW(28)
	IF( NC .GE.29 ) C29(I) = ROW(29)
	IF( NC .GE.30 ) C30(I) = ROW(30)
	IF( NC .GE.31 ) C31(I) = ROW(31)
	IF( NC .GE.32 ) C32(I) = ROW(32)
	IF( NC .GE.33 ) C33(I) = ROW(33)
	IF( NC .GE.34 ) C34(I) = ROW(34)
	IF( NC .GE.35 ) C35(I) = ROW(35)
	IF( NC .GE.36 ) C36(I) = ROW(36)
	IF( NC .GE.37 ) C37(I) = ROW(37)
	IF( NC .GE.38 ) C38(I) = ROW(38)
	IF( NC .GE.39 ) C39(I) = ROW(39)
	IF( NC .GE.40 ) C40(I) = ROW(40)
	IF( NC .GE.41 ) C41(I) = ROW(41)
	IF( NC .GE.42 ) C42(I) = ROW(42)
	IF( NC .GE.43 ) C43(I) = ROW(43)
	IF( NC .GE.44 ) C44(I) = ROW(44)
	IF( NC .GE.45 ) C45(I) = ROW(45)
	IF( NC .GE.46 ) C46(I) = ROW(46)
	IF( NC .GE.47 ) C47(I) = ROW(47)
	IF( NC .GE.48 ) C48(I) = ROW(48)
	IF( NC .GE.49 ) C49(I) = ROW(49)
	IF( NC .GE.50 ) C50(I) = ROW(50)
	IF( NC .GE.51 ) C51(I) = ROW(51)
	IF( NC .GE.52 ) C52(I) = ROW(52)
	IF( NC .GE.53 ) C53(I) = ROW(53)
	IF( NC .GE.54 ) C54(I) = ROW(54)
	IF( NC .GE.55 ) C55(I) = ROW(55)
	IF( NC .GE.56 ) C56(I) = ROW(56)
	IF( NC .GE.57 ) C57(I) = ROW(57)
	IF( NC .GE.58 ) C58(I) = ROW(58)
	IF( NC .GE.59 ) C59(I) = ROW(59)
	IF( NC .GE.60 ) C60(I) = ROW(60)
	IF( NC .GE.61 ) C61(I) = ROW(61)
	IF( NC .GE.62 ) C62(I) = ROW(62)
	IF( NC .GE.63 ) C63(I) = ROW(63)
	IF( NC .GE.64 ) C64(I) = ROW(64)
	IF( NC .GE.65 ) C65(I) = ROW(65)
	IF( NC .GE.66 ) C66(I) = ROW(66)
	IF( NC .GE.67 ) C67(I) = ROW(67)
	IF( NC .GE.68 ) C68(I) = ROW(68)
	IF( NC .GE.69 ) C69(I) = ROW(69)
	IF( NC .GE.70 ) C70(I) = ROW(70)
	IF( NC .GE.71 ) C71(I) = ROW(71)
	IF( NC .GE.72 ) C72(I) = ROW(72)
	IF( NC .GE.73 ) C73(I) = ROW(73)
	IF( NC .GE.74 ) C74(I) = ROW(74)
	IF( NC .GE.75 ) C75(I) = ROW(75)
	IF( NC .GE.76 ) C76(I) = ROW(76)
	IF( NC .GE.77 ) C77(I) = ROW(77)
	IF( NC .GE.78 ) C78(I) = ROW(78)
	IF( NC .GE.79 ) C79(I) = ROW(79)
	IF( NC .GE.80 ) C80(I) = ROW(80)
	IF( NC .GE.81 ) C81(I) = ROW(81)
	IF( NC .GE.82 ) C82(I) = ROW(82)
	IF( NC .GE.83 ) C83(I) = ROW(83)
	IF( NC .GE.84 ) C84(I) = ROW(84)
	IF( NC .GE.85 ) C85(I) = ROW(85)
	IF( NC .GE.86 ) C86(I) = ROW(86)
	IF( NC .GE.87 ) C87(I) = ROW(87)
	IF( NC .GE.88 ) C88(I) = ROW(88)
	IF( NC .GE.89 ) C89(I) = ROW(89)
	IF( NC .GE.90 ) C90(I) = ROW(90)
	IF( NC .GE.91 ) C91(I) = ROW(91)
	IF( NC .GE.92 ) C92(I) = ROW(92)
	IF( NC .GE.93 ) C93(I) = ROW(93)
	IF( NC .GE.94 ) C94(I) = ROW(94)
	IF( NC .GE.95 ) C95(I) = ROW(95)
	IF( NC .GE.96 ) C96(I) = ROW(96)
	IF( NC .GE.97 ) C97(I) = ROW(97)
	IF( NC .GE.98 ) C98(I) = ROW(98)
	IF( NC .GE.99 ) C99(I) = ROW(99)
	IF( NC .GE.100 ) C100(I) = ROW(100)
	IF( NC .GE.101 ) C101(I) = ROW(101)
	IF( NC .GE.102 ) C102(I) = ROW(102)
	IF( NC .GE.103 ) C103(I) = ROW(103)
	IF( NC .GE.104 ) C104(I) = ROW(104)
	IF( NC .GE.105 ) C105(I) = ROW(105)
	IF( NC .GE.106 ) C106(I) = ROW(106)
	IF( NC .GE.107 ) C107(I) = ROW(107)
	IF( NC .GE.108 ) C108(I) = ROW(108)
	IF( NC .GE.109 ) C109(I) = ROW(109)
	IF( NC .GE.110 ) C110(I) = ROW(110)
	IF( NC .GE.111 ) C111(I) = ROW(111)
	IF( NC .GE.112 ) C112(I) = ROW(112)
	IF( NC .GE.113 ) C113(I) = ROW(113)
	IF( NC .GE.114 ) C114(I) = ROW(114)
	IF( NC .GE.115 ) C115(I) = ROW(115)
	IF( NC .GE.116 ) C116(I) = ROW(116)
	IF( NC .GE.117 ) C117(I) = ROW(117)
	IF( NC .GE.118 ) C118(I) = ROW(118)
	IF( NC .GE.119 ) C119(I) = ROW(119)
	IF( NC .GE.120 ) C120(I) = ROW(120)
	IF( NC .GE.121 ) C121(I) = ROW(121)
	IF( NC .GE.122 ) C122(I) = ROW(122)
	IF( NC .GE.123 ) C123(I) = ROW(123)
	IF( NC .GE.124 ) C124(I) = ROW(124)
	IF( NC .GE.125 ) C125(I) = ROW(125)
	IF( NC .GE.126 ) C126(I) = ROW(126)
	IF( NC .GE.127 ) C127(I) = ROW(127)
	IF( NC .GE.128 ) C128(I) = ROW(128)
	IF( NC .GE.129 ) C129(I) = ROW(129)
	IF( NC .GE.130 ) C130(I) = ROW(130)
	IF( NC .GE.131 ) C131(I) = ROW(131)
	IF( NC .GE.132 ) C132(I) = ROW(132)
	IF( NC .GE.133 ) C133(I) = ROW(133)
	IF( NC .GE.134 ) C134(I) = ROW(134)
	IF( NC .GE.135 ) C135(I) = ROW(135)
	IF( NC .GE.136 ) C136(I) = ROW(136)
	IF( NC .GE.137 ) C137(I) = ROW(137)
	IF( NC .GE.138 ) C138(I) = ROW(138)
	IF( NC .GE.139 ) C139(I) = ROW(139)
	IF( NC .GE.140 ) C140(I) = ROW(140)
      END DO

      END IF
	I = MAXROW + 1

* final read to pick up the eof

	READ( INUNIT, '(A)', ERR=200, END=200 ) RECORD

* give warning if there was data past the final row

	WRITE(*,*)  '** WARNING: Data beyond row', MAXROW, ' was not read.'
  200	NROW = I - 1

* close input file

	CLOSE( UNIT = INUNIT )

* normal return

 1000	RETURN

* Error return

   99	WRITE(*,*) CHAR(7),'** Error opening file. '
	WRITE(*,*) '** ', FILE(:LEN1(FILE))
	GOTO 999

  999   WRITE(*,*) '** LOADLC aborted.'
	NROW = 0
	RETURN
	END
C* DUMPLC ... Dump HJD and up to 7 arrays to free-format ascii file.
C+
      SUBROUTINE DUMPLC( FILE, NCOL,NROW, HJD
     &	, X1, X2, X3, X4, X5, X6, X7, X8, X9 )
*
* Dump HJD and up to 7 arrays to  free-format ascii disk file.
*
* Input:
*	FILE	C* file name or ' ' for interactive selection
*	NCOL	I4 Number of data arrays
*	NROW	I4 Number of data values in each array
*	HJD	R8 HJDs
*	X2-XNCOL R4(NROW) The data arrays
*
C--
* Oct 1985 by KDH at STScI
* Apr 1988 KDH @ STScI - generalized from DUMPMONGO
* May 1991 KDH @ STScI - install in XCAL
* Jan 1994 KDH @ Utrecht - maxcol=5, DUMP_DAT -> DUMP1D, improve error msgs
* Mar 1994 KDH @ Utrecht - entry points for 1-5 images
* May 1995 KDH @ St.And - fix bug causing no output when file specified
* 1999 Nov KDH @ St.And - maxcol=5->6
* 2000 Nov KDH @ Austin - open with type='unknown'      
* 2001 Aug KDH @ St.And - use OPENFILE
* 2002 Jul KDH @ St.And - add array 7
* 2002 Sep KDH @ St.And - DUMPLC adapted from DUMP1D
* 2002 Sep KDH @ St.And - FMT (linux g77 * format truncates real*8 )	
* 2007 Sep KDH @ Christchurch -- dumplc9 and 10
* 2018 Sep KDH @ StA - parameter( iout=93 )
	REAL*8 HJD(*)
	REAL*4 X1(*), X2(*), X3(*), X4(*), X5(*), X6(*), X7(*)
	REAL*4 X8(*), X9(*)
	CHARACTER*(*) FILE
	CHARACTER*128 OFILE
	CHARACTER*128 FMT/ '( F18.8, 1P7G14.6 )' /
	CHARACTER*10 REPLY
	PARAMETER ( MAXCOL = 9 )
	parameter ( iout = 93 )

	GOTO 100
	ENTRY DUMPLC10( FILE, NCOL, NROW, HJD, X1, X2, X3, X4, X5
     &	, X6, X7, X8, X9 )
	GOTO 100
	ENTRY DUMPLC9( FILE, NCOL, NROW, HJD, X1, X2, X3, X4, X5
     &	, X6, X7, X8 )
	GOTO 100
	ENTRY DUMPLC8( FILE, NCOL, NROW, HJD, X1, X2, X3, X4, X5, X6, X7 )
	GOTO 100
	ENTRY DUMPLC7( FILE, NCOL, NROW, HJD, X1, X2, X3, X4, X5, X6 )
	GOTO 100
	ENTRY DUMPLC6( FILE, NCOL, NROW, HJD, X1, X2, X3, X4, X5 )
	GOTO 100
	ENTRY DUMPLC5( FILE, NCOL, NROW, HJD, X1, X2, X3, X4 )
	GOTO 100
	ENTRY DUMPLC4( FILE, NCOL, NROW, HJD, X1, X2, X3 )
	GOTO 100
	ENTRY DUMPLC3( FILE, NCOL, NROW, HJD, X1, X2 )
	GOTO 100
	ENTRY DUMPLC2( FILE, NCOL, NROW, HJD, X1 )
	GOTO 100
	ENTRY DUMPLC1( FILE, NCOL, NROW, HJD )

* check dimensions
  100 IF( NCOL .LT. 1 ) RETURN
      IF( NROW .LT. 1 ) RETURN
	NC = MIN( NCOL, MAXCOL )
      IF( NC .NE. NCOL ) THEN
        WRITE(*,*) '**DUMP1D: skipping columns', NC+1,'-', NCOL
      END IF
	OFILE = FILE
* get filename
   10 IF( OFILE .EQ. ' ' ) THEN
        WRITE(*,'(A,$)') ' Output filename : '
	READ(*,'(A)') OFILE
	REPLY = OFILE
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ.' ') RETURN
	IF( REPLY.EQ.'NONE' ) RETURN
      END IF
* open file
	CALL OPENFILE( iout, OFILE, 'FORMATTED', 'UNKNOWN', IER )
	IF( IER .NE. 0 ) GOTO 99
	WRITE(*,*) 'File open ', OFILE(:LEN1(OFILE))
* write data
	NR = 0
      IF( NC .EQ. 1 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 2 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 3 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I),X2(I)
	NR = I
      END DO

      ELSE IF( NC.EQ.4 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I), X2(I), X3(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 5 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I), X2(I), X3(I), X4(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 6 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 7 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I), X6(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 8 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I), X6(I), X7(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 9 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I), X6(I), X7(I), X8(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 10 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I)
     &	, X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I)
	NR = I
      END DO

      END IF

* close file
   50 WRITE(*,*) 'Dump columns:', NC, ' rows:', NR, ' of', NROW
	CLOSE( UNIT=iout )
* normal return
 1000 RETURN

* file write error
 98   WRITE(*,*) '**DUMPLC: error writing to file ', OFILE(:LEN1(OFILE))
	GOTO 50
       
* file open error
 99   WRITE(*,*) '**DUMPLC: error opening file ', OFILE(:LEN1(OFILE))
	OFILE = ' '
	GOTO 10
	END
C* DUMPLC ... Dump HJD and up to 7 arrays to free-format ascii file.
C+
      SUBROUTINE DUMPLCH( FILE, NH, H, NCOL, NROW, HJD
     &	, X1, X2, X3, X4, X5, X6, X7, X8, X9 )
*
* Dump HJD and up to 7 arrays to  free-format ascii disk file.
*
* Input:
*	FILE	C* file name or ' ' for interactive selection
*	NH	I4 Number of header lines
*	H(NH)	C* Header lines
*	NCOL	I4 Number of data arrays
*	NROW	I4 Number of data values in each array
*	HJD	R8 HJDs
*	X2-XNCOL R4(NROW) The data arrays
*
C--
* Oct 1985 by KDH at STScI
* Apr 1988 KDH @ STScI - generalized from DUMPMONGO
* May 1991 KDH @ STScI - install in XCAL
* Jan 1994 KDH @ Utrecht - maxcol=5, DUMP_DAT -> DUMP1D, improve error msgs
* Mar 1994 KDH @ Utrecht - entry points for 1-5 images
* May 1995 KDH @ St.And - fix bug causing no output when file specified
* 1999 Nov KDH @ St.And - maxcol=5->6
* 2000 Nov KDH @ Austin - open with type='unknown'      
* 2001 Aug KDH @ St.And - use OPENFILE
* 2002 Jul KDH @ St.And - add array 7
* 2002 Sep KDH @ St.And - DUMPLC adapted from DUMP1D
* 2002 Sep KDH @ St.And - FMT (linux g77 * format truncates real*8 )	
* 2007 Sep KDH @ Christchurch -- dumplc9 and 10
* 2018 May KDH @ St.And - DUMPLC -> DUMPLCH with header lines
* 2018 Sep KDH @ St.A - parameter( iout=93 )
	REAL*8 HJD(*)
	REAL*4 X1(*), X2(*), X3(*), X4(*), X5(*), X6(*), X7(*)
	REAL*4 X8(*), X9(*)
	CHARACTER*(*) H(*)
	CHARACTER*(*) FILE
	CHARACTER*256 RECORD
	CHARACTER*128 OFILE
	CHARACTER*128 FMT/ '( F18.8, 1P7G14.6 )' /
	CHARACTER*10 REPLY
	PARAMETER ( MAXCOL = 9 )
	parameter ( iout = 93 )
* entry points for dumb linux compiler
	GOTO 100
	ENTRY DUMPLC10H( FILE, NH, H, NCOL, NROW, HJD, X1, X2, X3, X4, X5
     &		, X6, X7, X8, X9 )
	GOTO 100
	ENTRY DUMPLC9H( FILE, NH, H, NCOL, NROW, HJD, X1, X2, X3, X4, X5
     &		, X6, X7, X8 )
	GOTO 100
	ENTRY DUMPLC8H( FILE, NH, H, NCOL, NROW, HJD, X1, X2, X3, X4, X5
     &		, X6, X7 )
	GOTO 100
	ENTRY DUMPLC7H( FILE, NH, H, NCOL, NROW, HJD, X1, X2, X3, X4, X5
     &		, X6 )
	GOTO 100
	ENTRY DUMPLC6H( FILE, NH, H, NCOL, NROW, HJD, X1, X2, X3, X4, X5 )
	GOTO 100
	ENTRY DUMPLC5H( FILE, NH, H, NCOL, NROW, HJD, X1, X2, X3, X4 )
	GOTO 100
	ENTRY DUMPLC4H( FILE, NH, H, NCOL, NROW, HJD, X1, X2, X3 )
	GOTO 100
	ENTRY DUMPLC3H( FILE, NH, H, NCOL, NROW, HJD, X1, X2 )
	GOTO 100
	ENTRY DUMPLC2H( FILE, NH, H, NCOL, NROW, HJD, X1 )
	GOTO 100
	ENTRY DUMPLC1H( FILE, NH, H, NCOL, NROW, HJD )

* check dimensions
  100 IF( NCOL .LT. 1 ) RETURN
      IF( NROW .LT. 1 ) RETURN
	NC = MIN( NCOL, MAXCOL )
      IF( NC .NE. NCOL ) THEN
        WRITE(*,*) '**DUMP1D: skipping columns', NC+1,'-', NCOL
      END IF
	OFILE = FILE
* get filename
   10 IF( OFILE .EQ. ' ' ) THEN
        WRITE(*,'(A,$)') ' Output filename : '
	READ(*,'(A)') OFILE
	REPLY = OFILE
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ.' ') RETURN
	IF( REPLY.EQ.'NONE' ) RETURN
      END IF
* open file
	CALL OPENFILE( iout, OFILE, 'FORMATTED', 'UNKNOWN', IER )
	IF( IER .NE. 0 ) GOTO 99
	WRITE(*,*) 'File open ', OFILE(:LEN1(OFILE))

* write header lines
      IF( NH .GT. 0 ) THEN
	ITRUNK = 0
      DO I = 1, NH
	IH = I
	RECORD = H( I )

* report truncated header line
	LR = LEN1( RECORD )
	LH = LEN1( H( I ) )
      IF( LR .NE. LH ) THEN
	WRITE(*,*) '** DUMPLCH: HEADER LINE TRUNCATED FROM', LH, ' TO', LR
	WRITE(*,*) '** ', H(I)(:LH)
	ITRUNK = I
      END IF

* write header line
      IF( RECORD(1:1) .NE. '#' .AND. RECORD(1:1) .NE. '!' ) THEN
	RECORD = '# ' // RECORD( : LEN1( RECORD ) )
      END IF
	WRITE( iout, '(A)', ERR=97 ) RECORD( : LEN1( RECORD ) )
      END DO
      END IF

* write data
	NR = 0
      IF( NC .EQ. 1 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 2 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 3 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I),X2(I)
	NR = I
      END DO

      ELSE IF( NC.EQ.4 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I), X2(I), X3(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 5 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I), X1(I), X2(I), X3(I), X4(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 6 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 7 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I), X6(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 8 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I), X6(I), X7(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 9 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I),
     &	X1(I), X2(I), X3(I), X4(I), X5(I), X6(I), X7(I), X8(I)
	NR = I
      END DO

      ELSE IF( NC .EQ. 10 ) THEN
      DO I=1,NROW
	WRITE( iout, FMT, ERR=98 ) HJD(I)
     &	, X1(I), X2(I), X3(I), X4(I), X5(I)
     &	, X6(I), X7(I), X8(I), X9(I)
	NR = I
      END DO

      END IF

* close file
   50 WRITE(*,*) 'Dump columns:', NC, ' rows:', NR, ' of', NROW
	CLOSE( UNIT=iout )
* normal return
 1000 RETURN


* header write error
   97 WRITE(*,*) '**DUMPLCH: error writing header to file', ofile(:len1(ofile))
	goto 50

* file write error
 98   WRITE(*,*) '**DUMPLCH: error writing to file ', OFILE(:LEN1(OFILE))
	GOTO 50
       
* file open error
 99   WRITE(*,*) '**DUMPLCH: error opening file ', OFILE(:LEN1(OFILE))
	OFILE = ' '
	GOTO 10
	END
        SUBROUTINE LOAD2D( FILE, NIM, NX, NY, X, Y, D1,
     #			D2, D3, D4, D5 )
*
* Load up to 5 2D images from a disk file
*
* Input:
*	FILE	C* file from which to read data
*	NIM	I4 number of images to read
*	NX,NY	I4 max allowed number of pixels
* Output:
*	NX,NY	I4 actual number of pixels (0 if error)
*	X(NX)	R4 X values
*	Y(NY)	R4 Y values
*	D1(NX,NY)	R4 data values for image 1
*	D2..	R4 data values for subsequent images
*
* Apr 1988 Keith Horne @ STScI
* Aug 1990 Keith Horne @ STScI - add NIM parameter and multiple images
* Apr 1991 KDH @ STScI - fix error closing the file found by J.Krolik
* Jan 1994 KDH @ Utrecht - MAXIM = 5
* Mar 1994 KDH @ Utrecht - entry points for multi-image loads
* Aug 1997 KDH @ St.Andrews - eliminate TYPE, on error return nx,ny=0
* 2001 Aug KDH @ St.And - use OPENFILE
* 2003 Sep KDH @ St.And - silence
* 2009 Jul KDH @ StA - X(1) -> X(*) etc.
        CHARACTER*(*) FILE
	REAL*4 X(*), Y(*)
	REAL*4 D1(*), D2(*), D3(*), D4(*), D5(*)
	PARAMETER ( MAXIM = 5 )
	LOGICAL SILENCE
	COMMON/SILENCE/ SILENCE
* entry points since UNIX requires exact match with number of arguments

	GOTO 100
        ENTRY LOAD2D5( FILE, NIM, NX, NY, X, Y, D1, D2, D3, D4, D5 )
	GOTO 100
        ENTRY LOAD2D4( FILE, NIM, NX, NY, X, Y, D1, D2, D3, D4 )
	GOTO 100
        ENTRY LOAD2D3( FILE, NIM, NX, NY, X, Y, D1, D2, D3 )
	GOTO 100
        ENTRY LOAD2D2( FILE, NIM, NX, NY, X, Y, D1, D2 )
	GOTO 100
        ENTRY LOAD2D1( FILE, NIM, NX, NY, X, Y, D1 )

* check dimensions

  100 IF( NIM.LE.0 .OR. NX.LE.0 .OR. NY.LE.0 ) THEN
	WRITE(*,*) '** Invalid dimensions', NIM, NX, NY
	GOTO 999
      ELSE IF( NIM.GT.MAXIM ) THEN
	WRITE(*,*) '** Too many images ', NIM, MAXIM
	GOTO 999
      END IF
	MAXPIX = NX*NY

* open the file

	INUNIT = 57
	CALL OPENFILE( INUNIT, FILE, 'UNFORMATTED', 'OLD', IER )
	IF( IER .NE. 0 ) GOTO 996
C	OPEN( UNIT=INUNIT, NAME=FILE, FORM='UNFORMATTED', TYPE='OLD',
C     #	ERR=996, READONLY )
      IF( .NOT. SILENCE ) THEN
	WRITE(*,*) 'File open ', FILE(:LEN1(FILE))
      END IF
* read actual number of pixels

	READ( INUNIT, ERR=997, END=998 ) NX, NY, IM
      IF( .NOT. SILENCE ) THEN
	WRITE(*,*) 'NX=', NX, ' NY=', NY, ' NIM=', IM
      END IF
      IF( NX.GT.MAXPIX .OR. NY.GT.MAXPIX ) THEN
	WRITE(*,*) '** too many pixels.  max=', MAXPIX
	GOTO 999
      END IF

* read the data

	READ( INUNIT, ERR=997, END=998 ) (X(I),I=1,NX)
	READ( INUNIT, ERR=997, END=998 ) (Y(I),I=1,NY)
	LOAD = MIN( MAXIM, IM, NIM )
	IF( LOAD.GE.1 )
     #	READ( INUNIT, ERR=997, END=998 ) (D1(I),I=1,NX*NY)
	IF( LOAD.GE.2 )
     #	READ( INUNIT, ERR=997, END=998 ) (D2(I),I=1,NX*NY)
	IF( LOAD.GE.3 )
     #	READ( INUNIT, ERR=997, END=998 ) (D3(I),I=1,NX*NY)
	IF( LOAD.GE.4 )
     #	READ( INUNIT, ERR=997, END=998 ) (D4(I),I=1,NX*NY)
	IF( LOAD.GE.5 )
     #	READ( INUNIT, ERR=997, END=998 ) (D5(I),I=1,NX*NY)

	CLOSE( INUNIT )
 1000	RETURN

* error messages

  996	WRITE(*,*) '** Error on file open.'
	GOTO 999
  997	WRITE(*,*) '** Error on file read.'
	CLOSE( UNIT=INUNIT )
	GOTO 999
  998	WRITE(*,*) '** Premature end of file.'
	CLOSE( UNIT=INUNIT )
	GOTO 999
  999	WRITE(*,*) '** LOAD2D aborted.'
	NX = 0
	NY = 0
	RETURN
	END
      SUBROUTINE DUMP2D( FILE, NIM, NX, NY, X, Y,
     #  D1, D2, D3, D4, D5 )
*    
* Load one or more 2D images to a disk file
*
* Input:
*	FILE	C* file into which to dump data
*	NIM	I4 number of images
*	NX,NY	I4 actual number of pixels
*	X(NX)	R4 X values
*	Y(NY)	R4 Y values
*	D1(NX,NY)	R4 data values in first image
*	D2,D3...	R4 data values in subsequent images
*
* Apr 1988 Keith Horne @ STScI
* Aug 1990 KDH @ STScI - add nim and multi-image capability
* Apr 1991 KDH @ STScI - fix bug on file close found by J.Krolik
* Jan 1994 KDH @ Utrecht - MAXIM=5, DUMP_2D -> DUMP2D
* Mar 1994 KDH @ Utrecht - entry points for multiple image dumps
* 2000 Nov KDH @ Austin - open type=unknown
* 2001 Aug KDH @ Austin - use OPENFILE
* 2019 Nov KDH @ StA - omit comma after write(*,*)
	CHARACTER*(*) FILE
	CHARACTER*256 OUTFILE
	PARAMETER (MAXIM=5)
	REAL*4 X(*), Y(*)
	REAL*4 D1(*), D2(*), D3(*), D4(*), D5(*)

* entry points since UNIX needs exact match to number of arguments
	GOTO 100
	ENTRY DUMP2D5( FILE, NIM, NX,NY, X,Y, D1, D2, D3, D4, D5 )
	GOTO 100
	ENTRY DUMP2D4( FILE, NIM, NX,NY, X,Y, D1, D2, D3, D4 )
	GOTO 100
	ENTRY DUMP2D3( FILE, NIM, NX,NY, X,Y, D1, D2, D3 )
	GOTO 100
	ENTRY DUMP2D2( FILE, NIM, NX,NY, X,Y, D1, D2 )
	GOTO 100
	ENTRY DUMP2D1( FILE, NIM, NX,NY, X,Y, D1 )

* check dimensions

  100   IF( NIM.LE.0 .OR. NX.LE.0 .OR. NY.LE.0 ) THEN
	WRITE(*,*) '** Invalid dimensions', NIM, NX, NY
	GOTO 999
      ELSE IF( NIM.GT.MAXIM ) THEN
	WRITE(*,*) '** Too many images', NIM, MAXIM
      END IF

	OUTFILE = FILE
      IF( FILE.EQ.' ' ) THEN
	WRITE(*,'(A,$)') ' Output file for 2D data ? '
	READ(*,'(A)') OUTFILE
      END IF

* open the file

c	IUNIT = 57
c	OPEN( UNIT=IUNIT,
c    #		NAME=FILE,
c    #		FORM='UNFORMATTED',
c    #		TYPE='UNKNOWN',
c    #		ERR=996 )

	CALL OPENFILE( IUNIT, FILE, 'UNFORMATTED', 'UNKNOWN', IER )
	IF( IER .NE. 0 ) GOTO 996

* write the data

	WRITE( IUNIT, ERR=997 ) NX, NY, NIM
	WRITE( IUNIT, ERR=997 ) (X(I),I=1,NX)
	WRITE( IUNIT, ERR=997 ) (Y(I),I=1,NY)
	IF( NIM.GE.1 )
     #	WRITE( IUNIT, ERR=997 ) (D1(I),I=1,NX*NY)
	IF( NIM.GE.2 )
     #	WRITE( IUNIT, ERR=997 ) (D2(I),I=1,NX*NY)
	IF( NIM.GE.3 )
     #	WRITE( IUNIT, ERR=997 ) (D3(I),I=1,NX*NY)
	IF( NIM.GE.4 )
     #	WRITE( IUNIT, ERR=997 ) (D4(I),I=1,NX*NY)
	IF( NIM.GE.5 )
     #	WRITE( IUNIT, ERR=997 ) (D5(I),I=1,NX*NY)

        CLOSE( IUNIT )
 1000	RETURN

* error messages

  996	WRITE(*,*) '** Error on file open.'
	GOTO 999
  997	WRITE(*,*) '** Error on file write.'
	CLOSE( UNIT=IUNIT )
	GOTO 999
  999	WRITE(*,*) '** DUMP2D aborted.'
	RETURN
	END
	SUBROUTINE SIGFAKE( NPIX, DATA, SIGMA )
*
*  Uses pixel-to-pixel fluctuations in a spectrum
*  to estimate the corresponding error bar spectrum.
*  Assumes that the local variance is proportional to the data number,
*  as it would be for Poisson statistics, but that the constant of
*  proportionality varies slowly along the spectrum,
*  as it would for fluxes if the instrumental response is not uniform.
*
*  Inputs:
*	NPIX	= Number of pixels in the spectrum
*	DATA	= Spectrum data values
*  Outputs:
*	SIGMA	= Local standard deviation spectrum
*
*  Feb 1985 by Keith Horne at IOA
*  Oct 1986 KDH @ STScI - tried spline and poly options
*  Dec 1986 KDH @ STScI - spline,poly,boxcar,median options
* Jul 1988 KDH @ STScI - correct for median filter bias.
* 2000 Oct KDH @ Austin - parenthesize parameter, eliminate type
* 2009 Jul KDH @ StA - MAXPIX 1000 -> 5000
* 2010 Jun KDH @ StA - comment out D lines
* 2018 Feb KDH @ StA - x1(1) for fussy gfortran
* 2020 Apr KDH @ StA - silent
	REAL*4 DATA( NPIX )
	REAL*4 SIGMA( NPIX )
	PARAMETER ( MAXPIX=5000 )
	REAL*4 XDATA( MAXPIX )
	REAL*4 YDATA( MAXPIX )
	REAL*4 YSIGMA( MAXPIX )
	REAL*4 X1(1)
	REAL*8 SUM
* default option is spline filtering
	CHARACTER*1 OPTION/'S'/
	LOGICAL FIRSTCALL/.TRUE./

	logical silent, gabby
	common/silent/ silent
	gabby = .not. silent

* introduction
      if( gabby ) then
	WRITE(*,*) 'SIGFAKE estimate error bars from data fluctuations.'
      end if

* check input arguments
      IF( NPIX.LE.10 ) THEN
      if( gabby ) then
	WRITE(*,*) '** TOO FEW PIXELS FOR ERROR BAR ESTIMATION', NPIX
      end if
  999	RETURN
      END IF

* first call tasks
      IF( FIRSTCALL ) THEN
	FIRSTCALL = .FALSE.
      if( .false. ) then
  10	WRITE(*,*) 'M(edian) B(oxcar) P(olynomial) or S(pline) smoothing?'
	READ(*,'(A)') OPTION
	IF(   OPTION .NE. 'B' .AND. OPTION .NE. 'P'
     &	.AND. OPTION .NE. 'M' .AND. OPTION .NE. 'S' ) GOTO 10
      end if
      END IF

*  Determine the largest and smallest data number in the spectrum.
*  Also zero the error bar array.

	DATAMAX = DATA(1)
	DATAMIN = DATA(1)
      DO I=1,NPIX
	DATAMAX = MAX( DATAMAX, DATA(I) )
	DATAMIN = MIN( DATAMIN, DATA(I) )
	SIGMA(I) = 0.
      END DO

      IF( DATAMAX .LE. DATAMIN ) THEN
      if( gabby ) then
	WRITE(*,*) '** WARNING: DATA DO NOT FLUCTUATE.', DATAMAX, DATAMIN
      end if
	RETURN
      END IF

* A (hopefully small) constant can be added to the data values 
* to force them to be positive.  This is sort of like guessing
* that a background rate EXTRA has been subtracted from the data.

	EXTRA = 1.5 * ABS( MIN( -1.E-5*ABS(DATAMAX), DATAMIN ))

      IF( EXTRA .GT. 0. ) THEN
      if( gabby ) then
	WRITE(*,*) 'Data range:', datamin, datamax
	WRITE(*,*) 'Constant added to make data positive:', extra
      end if
      END IF

*  Estimate the effective DATA NUMBER PER PHOTON from
*  the ratio of the local fluctuation to the square root of
*  the local mean data value.
*  Use a 3-point formula for the local fluctuation amplitude.

	sum = 0.d0
      DO I=1,NPIX
	IM = MAX(I-1,1)
	IP = MIN(I+1,NPIX)
	AVG = 0.5 * ( DATA(IM) + DATA(IP) )
	FLUCT = ABS( DATA(I) - AVG )
	VAR = DATA(I) + 0.5 * AVG
	SIGMA(I) = FLUCT / SQRT( VAR + EXTRA )
	sum = sum + sigma(i)
      END DO

      if( gabby ) then
	WRITE(*,*) 'Mean photons per data number:', npix/sum
      end if

* Smooth out fluctuations in the ratio true / predicted sigma.
* (There are several different options)

      IF( OPTION .EQ. 'P' .OR. OPTION .EQ. 'S' ) THEN

* load arrays for spline or poly fit

      IF( NPIX .LE. MAXPIX ) THEN
	NBLOCK = NPIX
      DO I=1,NPIX
	XDATA(I) = FLOAT(I)/NPIX
	YDATA(I) = SIGMA(I)
	YSIGMA(I) = SIGMA(I)
      END DO

* Block the data if too many pixels for internal buffer

      ELSE 
	LBLOCK = 1 + (NPIX-1)/MAXPIX
	NBLOCK = 0
      DO I1 = 1, NPIX, LBLOCK
	NBLOCK = NBLOCK + 1
	I2 = MIN( I1+LBLOCK-1, NPIX)
	SUM = 0.
      DO I = I1, I2
	SUM = SUM + SIGMA(I)
      END DO
	XDATA( NBLOCK ) = FLOAT(I2+I1)/ FLOAT(NPIX+NPIX)
	YDATA( NBLOCK ) = SUM / (I2-I1+1)
	YSIGMA( NBLOCK ) = YDATA( NBLOCK )
      END DO
      END IF

* Median-filter the noisy uncertainty estimates.
* Not too worried here about the 0.675 median bias,
* because these sigmas are only needed for relative weights in fitting.

	MAXWINDOW = 301		! for about 3-percent accuracy
	CALL MEDFILT( YSIGMA, YSIGMA, NBLOCK, MAXWINDOW, IFAIL )

* spline fit with reject cycles

	NCYCLE = 10
	THRHI = 5.
	THRLO = -5.
      IF( OPTION .EQ. 'S' ) THEN
	NSPLINE = MAX(1, NBLOCK/500 )

      if( gabby ) then
	WRITE(*,*) 'Fitting', NSPLINE, ' splines to', NBLOCK, ' points.'
      end if

	CALL SPLFITA( NBLOCK, XDATA, YDATA, YSIGMA, SIGMA, 
     #		NSPLINE, NCYCLE, THRHI, THRLO, IFAIL )
      ELSE
	NPOLY = MIN( 9, MAX(1, NBLOCK/200 ) )
	NPOLY = 2*(NPOLY/2) + 1

      if( gabby ) then
	WRITE(*,*) 'Fitting', NPOLY, ' polyterms to', NBLOCK, ' points.'
      end if

	CALL POLYFITA( NBLOCK, XDATA, YDATA, YSIGMA, SIGMA, 
     #		NPOLY, NCYCLE, THRHI, THRLO, IFAIL )
      END IF

* Re-evaluate spline on full pixel grid if data were blocked for the fit

      IF( NBLOCK.NE.NPIX ) THEN
      IF( OPTION.EQ.'S' ) THEN
      DO I=1,NPIX
* satisfy fussy gfortran
	x1( 1 ) = float( i ) / npix
	CALL SPLCALC( 1, x1, SIGMA(I), IFAIL )
      END DO
      ELSE
      DO I=1,NPIX
* satisfy fussy gfortran
	x1( 1 ) = float( i ) / npix
	CALL POLYCALC( 1, x1, SIGMA(I), IFAIL )
      END DO
      END IF
      END IF

* Smooth using boxcar filter

      ELSE IF( OPTION .EQ.'B' ) THEN
	MAXWINDOW = 301		! for about 3-percent accuracy
      if( gabby ) then
	WRITE(*,*) 'Boxcar filtering', NPIX, ' points.'
      end if
	CALL BOXFILT( NPIX, SIGMA, MAXWINDOW )

* Smooth using median filter

      ELSE
	MAXWINDOW = 301		! for about 3-percent accuracy
      if( gabby ) then
	WRITE(*,*) 'Median filtering', NPIX, ' points.'
      end if
	CALL MEDFILT( SIGMA, SIGMA, NPIX, MAXWINDOW, IFAIL )
	BIAS = 0.675	! the median filter is biased.
      DO I=1,NPIX
	SIGMA(I) = SIGMA(I) / BIAS
      END DO
      END IF

*  Loop thru pixels, evaluating error bars

      DO I=1,NPIX
	ROOT = SIGMA(I)		! = SQRT( DATA NUMBER / PHOTON )
	IM = MAX(I-1,1)
	IP = MIN(I+1,NPIX)
	AVG = ( DATA(IM) + DATA(I) + DATA(IP) ) / 3.
	SIGAVG = ROOT * SQRT( AVG + EXTRA + ROOT*ROOT )
	SIGDAT = ROOT * SQRT( DATA(I) + EXTRA + ROOT*ROOT )
	SIGMA(I) = MAX( SIGAVG, SIGDAT )

      if( gabby ) then
c	WRITE(*,*) i, data(i), SIGMA(I), root, sigma(i)
      end if
*  Note: the term ROOT*ROOT above effectively adds 1 photon to the count
      END DO

	RETURN
	END
C*LOOKUP -- inverse linear interpolation
C+
	SUBROUTINE LOOKUP( NPIX, DATA, TARGET, ILO, IHI, PART )
*
* Inverse linear interpolator. Finds ILO, IHI, PART such that
*   TARGET = DATA(ILO) * (1.-PART) + DATA(IHI) * PART
*
* This version uses safe but slow method of one-pixel steps
*
* Input:
*	NPIX	= Number of data points
*	DATA	= Data values ( must be monotonic )
*	TARGET	= Target value
* Output:
*	ILO	= Low pixel
*	IHI	= Hi pixel
*	PART	= fraction (0-1) for interpolation
C--
* Nov 1985 KDH @ STScI
* 2001 Aug KDH @ St.And - single point, IBEG
	REAL*4 DATA(*)
	DATA NLAST,IHILAST,ILOLAST/1,1,1/

* Null array
      IF( NPIX.LE.0 ) THEN
	ILO = 0
	IHI = 0
	PART = 0.
	RETURN
      END IF

* Single point
      IF( NPIX .EQ. 1 ) THEN
	ILO = 1
	IHI = 1
	PART = 0.
	RETURN
      END IF

* Use previous location
      IF( NPIX .EQ. NLAST ) THEN
      IF( DATA(IHILAST) .GE. TARGET .AND.
     *	  DATA(ILOLAST) .LE. TARGET ) THEN
	IHI = IHILAST
	ILO = ILOLAST
	GOTO 50
      END IF
	IBEG = ILOLAST
      ELSE
	IBEG = ( 1 + NPIX ) / 2
      END IF

* Determine uphill direction

      IF( DATA(1) .LE. DATA(NPIX) ) THEN
	ILOEND = 1
	IHIEND = NPIX
	IUP = 1
      ELSE
	ILOEND = NPIX
	IHIEND = 1
	IUP = -1
      END IF

* Locate an uphill point

      DO I = IBEG, IHIEND, IUP
	IF( DATA(I) .GE. TARGET ) GOTO 10
      END DO
	I = IHIEND
   10	IHI = I

* Locate nearest downhill point

      DO I = IHI, ILOEND, -IUP
	IF( DATA(I) .LE. TARGET ) GOTO 20
      END DO
	I = ILOEND
   20	ILO = I

* Locate nearest uphill point

      DO I = ILO, IHI, IUP
	IF( DATA(I) .GE. TARGET ) GOTO 30
      END DO
	I = IHI
   30	IHI = I

* Compute fractional part

   50	PART = DATA(IHI) - DATA(ILO)
	IF( PART.NE.0. ) PART = ( TARGET - DATA(ILO) ) / PART

	NLAST = NPIX
	ILOLAST = ILO
	IHILAST = IHI

	RETURN
	END
	function terp1( n, x, i1, i2, p )
* linear interpolation
* 2001 Aug Keith Horne @ St-Andrews
	real*4 x(n)
	terp1 = x(i1) * (1.-p) + x(i2) * p
	return
	end

	SUBROUTINE SPLFITA( NDATA, XDATA, YDATA, YSIGMA, YFIT,
     #	NSPLINE, NCYCLE, THRHI, THRLO, IFAIL )
*
* Fits spline to data and performs reject cycles with
* no user interaction.
*
*  Inputs:
*	NDATA	= number of data values
*	XDATA	= X data values
*	YDATA	= Y data values
*	YSIGMA	= Y uncertainties (1-sigma) (negative to reject)
*	NSPLINE = Number of spline nodes
*	NCYCLE	= Max number of reject cycles
*	THRHI	= high threshold for sigma clipping
*	THRLO	= low threshold for sigma clipping
*
*  Output:
*	YFIT	= Y FIT VALUES
*	IFAIL	= 0 IF SUCCESSFUL, 1 IF FAILED.
*
* Oct 1986 KDH @ STScI
* May 1991 KDH @ STScI - FITSPL common block
* Aug 1997 KDH @ ST-ANDREWS -- COMMON/SILENT/
* 2000 Oct KDH @ Austin - split common/fitspl/
* 2000 Oct KDH @ Austin - remove data statement setting silent to .false.
* 2019 Nov KDH @ StA - omit comma after write(*,*)
	REAL*4 XDATA(*), YDATA(*), YSIGMA(*), YFIT(*)
        COMMON/NFITSPL/ NFITSPL
        COMMON/NREJSPL/ NREJSPL
        COMMON/THRHISPL/ THRHISPL
        COMMON/THRLOSPL/ THRLOSPL
	LOGICAL SILENT
	COMMON/SILENT/ SILENT

* Test inputs

      IF(NDATA.LE.0) THEN
	WRITE(*,*) '** No data.', NDATA
	GOTO 999
      END IF

	NREJ = 0	! count rejected pixels
	ICYCLE = -1	! count the fit-reject cycles
  100	ICYCLE = ICYCLE + 1
	LASTREJ = NREJ	! stow reject count from previous fit

* Fit the spline

	CALL SPLFIT1( NDATA, XDATA, YDATA, YSIGMA, YFIT, NSPLINE, IFAIL)
	IF( IFAIL.NE.0 ) GOTO 999

* Evaluate the fit

      IF( NCYCLE.EQ.0 ) THEN

	CALL REJECT( NDATA, YDATA, YSIGMA, YFIT, 1.E20, -1.E20, RMS, NREJ )

* Evaluate the fit and reject large outliers

      ELSE

	CALL REJECT( NDATA, YDATA, YSIGMA, YFIT, THRHI, THRLO, RMS, NREJ )

      END IF

* Report results of this reject

      IF( .NOT. SILENT ) THEN
	WRITE(*,*) ' Cycle', ICYCLE, '  RMS =', RMS,
     #	' (sigma)  Rejects =', NREJ
      END IF

* Next fit-reject cycle

	IF( ICYCLE.LT.NCYCLE .AND. NREJ.NE.LASTREJ ) GOTO 100

* normal return

	IFAIL = 0
	NFITSPL = NSPLINE
	NREJSPL = NCYCLE
	THRHISPL = THRHI
	THRLOSPL = THRLO
	RETURN

* error return

  999	IFAIL = 1
	WRITE(*,*) 'SPLFITA aborted.'
	RETURN

	END
	SUBROUTINE SPLFITR( NDATA, XDATA, YDATA, YSIGMA, YFIT, IFAIL)
*
* Computes weighted least-squares spline fit to (x-y) data pairs.
* with reject cycles.  Interactively controlled.
*
*  Inputs:
*	NDATA	= NUMBER OF DATA VALUES
*	XDATA	= X DATA VALUES
*	YDATA	= Y DATA VALUES
*	YSIGMA	= Y UNCERTAINTIES (1-SIGMA) (NEGATIVE TO REJECT)
*  Output:
*	YFIT	= Y FIT VALUES
*	IFAIL	= 0 IF SUCCESSFUL, 1 IF FAILED.
*
* 1984 Jul 1984 Keith Horne @ IoA Cambridge - Original version.
* 1986 Oct 1986 @ STScI - SPLFITA separated from SPLFITR.
* 1988 Jul 1988 @ STScI - PGSETLABS to edit plot labels
* 1989 Jul 1989 @ STSCI - PGSETLABS changed to PGSLAB
* 1992 Mar 1992 @ STScI - PGSLAB -> PGELAB
* 1995 Jul 1995 @ St-And - IERSET -> IRESET
* 2000 Nov KDH @ Austin - parameter()
* 2001 Aug KDH @ St.A - PLOTFIT -> PLTFIT
* 2014 Aug KDH @ St.A - MAXSPLINE = 500 -> 2000
	REAL*4 XDATA(*), YDATA(*), YSIGMA(*), YFIT(*)
	CHARACTER*1 REPLY
	CHARACTER*60 XLABEL/' '/
	CHARACTER*60 YLABEL/' '/
	CHARACTER*60 TITLE/' '/

* Default spline fit parameters

	PARAMETER ( MAXSPLINE = 2000 )
	DATA NSPLINE/3/
	DATA NCYCLE/10/
	DATA THRHI/100./
	DATA THRLO/-2./

* Trap invalid inputs.

      IF(NDATA.LE.0) THEN
	WRITE(*,*) '** No data.', NDATA
	GOTO 999
      END IF

	GOTO 100

* command node

   10	WRITE(*,*)
	WRITE(*,'(A,$)') ' SPLFITR > '
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )

	IF( REPLY.EQ.'Q') GOTO 1000
	IF( REPLY.EQ.'A') GOTO 999
	IF( REPLY.EQ.'C') GOTO 100
	IF( REPLY.EQ.'P') GOTO 200
	IF( REPLY.EQ.'R') GOTO 300

* command summary

   20	WRITE(*,*) 'Type P -- to PLOT the fit'
	WRITE(*,*) '     C -- for more reject CYCLES'
	WRITE(*,*) '     R -- to RESTORE rejected pixels and try again'
	WRITE(*,*) '     A -- to ABORT'
	WRITE(*,*) '     Q -- to adopt this fit and continue'
	GOTO 10

* Report spline fit parameters

  100	WRITE(*,*) '    Number of data pairs =', NDATA
	WRITE(*,*) '       Number of SPLINES =', NSPLINE
     &		, ' max:', MAXSPLINE
	WRITE(*,*) ' Number of reject CYCLES =', NCYCLE
	WRITE(*,*) 'HIGH rejection threshold =', THRHI, ' sigma.'
	WRITE(*,*) ' LOW rejection threshold =', THRLO, ' sigma.'
	WRITE(*,*)
	WRITE(*,*) 'Type A -- to ABORT this fit'
	WRITE(*,*) '     C -- to CHANGE spline parameters'
	WRITE(*,*) '   <CR>-- to proceed with the fit'
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ.'A') GOTO 10
	IF( REPLY.EQ.'C') GOTO 150
	IF( REPLY.EQ.' ') GOTO 180
	GOTO 100

* get new spline fit parameters

  150	WRITE(*,*) 'Enter (1) Number of SPLINES'
	WRITE(*,*) '      (2) Number of reject CYCLES'
	WRITE(*,*) '      (3) HIGH (>0) reject threshold'
	WRITE(*,*) '      (4) LOW (<0) reject threshold'
	WRITE(*,*) '(Note: Enter 0 to keep a default value.)'
	READ(*,*,ERR=150) NEWSPLINE, NEWCYCLE, THRHINEW, THRLONEW

	IF( NEWSPLINE.GT.0) NSPLINE = MIN(MAXSPLINE, NEWSPLINE)
	IF( NEWSPLINE.GT.NSPLINE) 
     &	WRITE(*,*) '** MAXIMUM ALLOWED NUMBER OF SPLINES IS', MAXSPLINE
	IF( NEWCYCLE.GT.0) NCYCLE = NEWCYCLE
	IF( THRHINEW.GT.0.) THRHI = THRHINEW
	IF( THRLONEW.LT.0.) THRLO = THRLONEW
	GOTO 100

* fit the spline with automatic reject cycles

  180	CALL SPLFITA( NDATA, XDATA, YDATA, YSIGMA, YFIT, 
     &	NSPLINE, NCYCLE, THRHI, THRLO, IFAIL)
	GOTO 10

* plot fit

  200	WRITE( TITLE,'(A,I3,A)' )
     #	'weighted least-squares fit of', NSPLINE,' cubic splines.'
	CALL PGELAB( XLABEL, YLABEL, TITLE )
	CALL PLTFIT( NDATA, XDATA, YDATA, YSIGMA, YFIT,
     #	XLABEL, YLABEL, TITLE )
	GOTO 10

* restore rejected data points

  300	IRESET = 0
      DO I=1,NDATA
	IF( YSIGMA(I).LE.0. ) IRESET = IRESET + 1
	YSIGMA(I) = ABS(YSIGMA(I))
      END DO
	WRITE(*,*) IRESET, ' rejected data pairs restored.'
	GOTO 100

* normal return

 1000	IFAIL = 0
	RETURN

* error return

  999	IFAIL = 1
	WRITE(*,*) 'SPLFITR aborted.'
	RETURN

	END
**----------------------------------------------
	SUBROUTINE SPLFIT1( NDATA, XDATA, YDATA, YSIGMA, 
     #		YFIT, KNOTREQ, IFAIL )
*
*  COMPUTES WEIGHTED LEAST-SQUARES SPLINE FIT TO DATA PAIRS
*
*  Input:
*	NDATA	= NUMBER OF DATA PAIRS
*	XDATA	= DATA X VALUES
*	YDATA	= DATA Y VALUES
*	YSIGMA	= UNCERTAINTY IN Y (1-SIGMA) (NEGATIVE TO REJECT)
*	KNOTREQ	= NUMBER OF SPLINES REQUESTED
*  Output:
*	YFIT	= FITTED Y VALUES
*	IFAIL	= 0 IF SUCCESSFUL, 1 IF FAILED.
*
*	USES NAG ROUTINE E02BAF
*
*  SEPT 1984 SORTING AND EXTRAPOLATION ADDED BY KDH
*  JULY 1984 BY KEITH HORNE
* Jan 1995 KDH @ St-And - common/splfit1 -> splfit0 and splfit1
* Jan 1995 KDH @ St-And - eliminate type
* Nov 1995 KDH @ St-And - parameter ()
* 2000 Oct KDH @ Austin - rename common blocks
* 2005 Dec KDH @ St-And - MAXFIT 5000 -> 35000
* 2009 Apr KDH @ St A - MAXKNOT 500 -> 2000
* 2009 Sep KDH @ St A - QUICKSORT -> QUICKSORT8
* 2010 Jul KDH @ St A - g77 -> ifort
	REAL*4 XDATA(*), YDATA(*), YSIGMA(*), YFIT(*)
	PARAMETER ( MAXFIT = 50000 )
	PARAMETER ( MAXKNOT = 2000 )
	REAL*8 X( MAXFIT + 2 )
	REAL*8 Y( MAXFIT + 2 )
	REAL*8 W( MAXFIT + 2 )
* Key to sorted data
	INTEGER*4 KEY( MAXFIT + 2 )
	REAL*8 XKNOT( MAXKNOT + 7 )
	REAL*8 WORK1( MAXFIT + 2 )
	REAL*8 WORK2( 4 * ( MAXKNOT + 7 ) )
	REAL*8 CSPLINE( MAXKNOT + 7 )
	REAL*8 CALC
	COMMON/NCAP7/NCAP7
	COMMON/XKNOT/XKNOT
	COMMON/CSPLINE/CSPLINE

	IF(NDATA.LE.0) GOTO 998
*  Count and compute mean of YDATA with positive YSIGMA,
*  and locate extreme values of XDATA.
	NFIT = 0
	CALC = 0.D0
	LOCMAX = 1
	LOCMIN = 1
      DO I=1,NDATA
      IF( XDATA(I) .GE. XDATA(LOCMAX) ) LOCMAX = I
      IF( XDATA(I) .LT. XDATA(LOCMIN) ) LOCMIN = I
      IF( YSIGMA(I).GT.0. ) THEN
	NFIT = NFIT + 1
	CALC = CALC + YDATA(I)
      END IF
      END DO
	IF(NFIT.LE.0) GOTO 998
	YMEAN = CALC/NFIT

*  Use mean of YDATA if there is not enough data for a spline fit
      IF(NFIT.LT.3) THEN
	WRITE(*,*) '** WARNING: MEAN OF',  NFIT,
     #		' DATA POINTS INSTEAD SPLINE FIT.'
      DO I=1,NDATA
	YFIT(I) = YMEAN
      END DO
	GOTO 1000
      END IF

* Decide in which direction to load the data values
* Forward loading
      IF( LOCMAX .GT. LOCMIN ) THEN
	ISTEP = 1
	IGET1 = 1
	IGET2 = NDATA
* Backward loading
      ELSE
	ISTEP = -1
	IGET1 = NDATA
	IGET2 = 1
      END IF
* Skip one datum at beginning 
	IPUT1 = 2

*  Load data arrays for spline fit
      IF( NFIT .LE. MAXFIT ) THEN
	IPUT = IPUT1 - 1
      DO IGET= IGET1, IGET2, ISTEP
* Load only data with positive sigma
      IF( YSIGMA( IGET ) .GT. 0.) THEN
	IPUT = IPUT + 1
	X( IPUT ) = XDATA( IGET )
	Y( IPUT ) = YDATA( IGET )
	W( IPUT ) = YSIGMA( IGET )
      END IF
      END DO
	IPUT2 = IPUT
	NFIT = IPUT2 - IPUT1 + 1

*  Too much data, some points must be skipped
      ELSE 
	WRITE(*,*) '** TOO MUCH DATA FOR ''SPLFIT1''.', NFIT, MAXFIT
	WRITE(*,*) '** INTERSPERSED DATA WILL BE SKIPPED.'
	IGET = IGET1
	IPUT = IPUT1 - 1
	IGOT = 0
      DO I=1,MAXFIT
	PART = (I-1.)/(MAXFIT-1.)
	IWISH = NINT( 1.-PART + NFIT*PART )
   30 IF(IWISH .GT. IGOT ) THEN
   32 IF( YSIGMA( IGET ) .LE. 0. ) THEN
	IGET = IGET + ISTEP
	GOTO 32
      END IF
	IGOT = IGOT + 1
	GOTO 30
      END IF
	IPUT = IPUT + 1
	X( IPUT ) = XDATA( IGET )
	Y( IPUT ) = YDATA( IGET )
	W( IPUT ) = YSIGMA( IGET )
      END DO
	IPUT2 = IPUT
	NFIT = IPUT2 - IPUT1 + 1
      END IF

*  Re-scale weights to their RMS value
	CALC = 0.D0
      DO I = IPUT1, IPUT2
	CALC = CALC + W( I ) * W( I )
      END DO
	RMS = SQRT( CALC / NFIT )
      DO I=IPUT1,IPUT2
	W( I ) = RMS / W( I )
      END DO

*  Sort data so that X values increase -------------------------------

   40 continue
      DO ITEST = IPUT1+1, IPUT2
      IF( X(ITEST) .LT. X(ITEST-1) ) THEN

	write(*,*) iput1, x(iput1), y(iput1), w(iput1)
	write(*,*) iput2, x(iput2), y(iput2), w(iput2)
	write(*,*) 'X(', itest-1,')', x(itest-1), ' X(', itest, ')', x(itest)
	WRITE(*,*) 'Sort to make X-values ascend.', iput1, iput2, nfit
      do i = max( iput1, itest-10 ), min( iput2, itest+10 )
	write(*,*) i, x(i), x(i) - x( i - 1 )
      end do
	stop

	CALL QUICKSORT8( NFIT, X(IPUT1), KEY(IPUT1) )

      DO I=IPUT1,IPUT2
	WORK1(I) = X(KEY(I))
      END DO
      DO I=IPUT1,IPUT2
	X(I) = WORK1(I)
      END DO

      DO I=IPUT1,IPUT2
	WORK1(I) = Y(KEY(I))
      END DO
      DO I=IPUT1,IPUT2
	Y(I) = WORK1(I)
      END DO

      DO I=IPUT1,IPUT2
	WORK1(I) = W(KEY(I))
      END DO
      DO I=IPUT1,IPUT2
	W(I) = WORK1(I)
      END DO
	WRITE(*,*) 'Sort finished', iput1, iput2, nfit
	GOTO 40
      END IF

      END DO
c	write(*,*) 'X values ascend', nfit

*  Decide how many splines will be used
   50	NSPLINE = MAX(1, MIN(KNOTREQ, MIN(NFIT/2+1, MAXKNOT) ) )
      IF(NSPLINE.LT.KNOTREQ) THEN
	WRITE(*,*) '** NUMBER OF SPLINES REDUCED FROM', KNOTREQ,' TO', NSPLINE
      END IF

*  Distribute spline knots
   70 DO I = 1, NSPLINE+1
	PART = (I-1.)/NSPLINE
	LOOKUP = NINT( IPUT1*(1.-PART) + IPUT2*PART )
	XKNOT(I+3) = X(LOOKUP)
      END DO

*  Call NAG routine to compute spline fit
	IFAIL = 1
	CALL E02BAF( NFIT, NSPLINE+7, X(IPUT1), Y(IPUT1), W(IPUT1), XKNOT, 
     *		WORK1, WORK2, CSPLINE, CALC, IFAIL )
      IF( IFAIL.NE.0) THEN
	WRITE(*,*) '** E02BAF FAILED.  IFAIL=',IFAIL
	write(*,*) '** NFIT', nfit, ' NSPLINE', nspline
	RETURN
      END IF
	NCAP7 = NSPLINE+7

*  Evaluate spline at required points
	CALL SPLCALC( NDATA, XDATA, YFIT, IFAIL )
      IF(IFAIL.NE.0) THEN
	WRITE(*,*) '** ''SPLCALC'' FAILED.  IFAIL=',IFAIL
	RETURN
      END IF

*  normal return
 1000	IFAIL = 0
	RETURN
* no data
  998	WRITE(*,*) '** NO DATA IN ''SPLFIT1'','
	GOTO 999
*  error return
  999	IFAIL = 1
	RETURN
	END
	SUBROUTINE SPLCALC( NDATA, XDATA, YFIT, IFAIL )
*
*  EVALUATES SPLINE FIT
*
*  Input:
*	NDATA	= NUMBER OF DATA PAIRS
*	XDATA	= DATA X VALUES 
*  Output:
*	YFIT	= CORRESPONDING Y VALUE OF SPLINE FIT
*	IFAIL	= 0 IF SUCCESSFUL, 1 IF FAILED.
*
*	USES NAG ROUTINE E02BBF
*
*  JULY 1984 BY KEITH HORNE
* Jan 1995 KDH @ St.And -- common/splfit1 -> splfit0 and splfit1
* Jan 1995 KDH @ St.And -- eliminate type
* 2000 Oct KDH @ Austin - rename common blocks
* 2009 Aug KDH @ StA - MAXKNOT = 2000 + explicit dimension.
* 2010 Jul KDH @ StA - g77 -> ifort, can't branch to end of loop
* 2012 Jul KDH @ DARK - silent
* 2018 Feb KDH @ StA - SPL (fussy gfortran)

	PARAMETER( MAXKNOT = 2000 )
	REAL*4 XDATA(*), YFIT(*)

	REAL*8 SPL, SPLINE(4)
	REAL*8 CALC, XKNOT, CSPLINE
	COMMON/NCAP7/NCAP7
	COMMON/XKNOT/XKNOT(MAXKNOT+7)
	COMMON/CSPLINE/CSPLINE(MAXKNOT+7)
	logical silent
	common/silent/silent

	IF( NDATA.LE.0 ) RETURN
      IF( NCAP7.LE.0 ) THEN
	WRITE(*,*) '** Splines unknown to SPLCALC.'
	GOTO 999
      END IF

*  Loop thru the data
      DO I=1,NDATA
*  Evaluate spline at desired x-value
      IF( XDATA(I).GE.XKNOT(1) .AND. XDATA(I).LE.XKNOT(NCAP7) ) THEN
	CALC = XDATA(I)
	IFAIL = 1
C	CALL E02BBF( NCAP7, XKNOT, CSPLINE, CALC, SPLINE, IFAIL )
	CALL E02BBF( NCAP7, XKNOT, CSPLINE, CALC, SPL, IFAIL )
      IF( IFAIL.NE.0) THEN
	WRITE(*,*) '** E02BBF FAILED. IFAIL=',IFAIL
	GOTO 999
      END IF
C	YFIT(I) = SPLINE(1)
	YFIT(I) = SPL
*  Extrapolation required
      ELSE
      IF( XDATA(I) .LT. XKNOT(1) ) THEN
	KNOT = 1
	LEFT = 0
      ELSE
	KNOT = NCAP7
	LEFT = 1
      END IF
*  Evaluate spline and first three derivatives at the end knot
	IFAIL = 1
	CALL E02BCF( NCAP7, XKNOT, CSPLINE, XKNOT(KNOT), LEFT, SPLINE, IFAIL )
      IF( IFAIL.NE.0) THEN
	WRITE(*,*) '** E02BCF FAILED. IFAIL=',IFAIL
	GOTO 999
      END IF
	YFIT(I) = SPLINE(1) + SPLINE(2) * ( XDATA(I) - XKNOT(KNOT) )
      if( .not. silent ) then
	write(*,*) 'E02BCF', i, ' x', xdata(i), ' y', yfit(i)
      end if
      END IF
* next I
      END DO

* normal return
 1000	IFAIL = 0
	RETURN
* error return
  999	IFAIL = 1
	RETURN
	END
	SUBROUTINE PLTFIT( NDATA, XDATA, YDATA, YSIGMA, YFIT,
     *		XLABEL, YLABEL, TITLE )
*
*  PLOT RESULT OF A DATA FIT
*
*  Inputs:
*	NDATA	= NUMBER OF DATA PAIRS
*	XDATA	= DATA X VALUE
*	YDATA	= DATA Y VALUE
*	YSIGMA	= UNCERTAINTY IN Y (1-SIGMA) (NEGATIVE IF REJECTED FROM FIT)
*	YFIT	= FIT Y VALUE
*	XLABEL	= LABEL FOR X AXIS OF THE PLOT
*	YLABEL	= LABEL FIR Y AXIS OF THE PLOT
*	TITLE	= PLOT TITLE
*
* 1984 Jul KEITH HORNE AT IOA.
* 1992 Mar KDH @ STScI - use PGEWIN
* 1995 Oct KDH @ St.Andrews - protect divide by NSUM, RMS=0.
* 2001 Aug KDH @ St-A - eliminate type, pgagain
* 2001 Aug KDH @ St-A - change name from plotfit to pltfit
* 2014 Aug KDH @ St-A - pgbgw, and kolor indices
	REAL*4 XDATA(*), YDATA(*), YSIGMA(*), YFIT(*)
	CHARACTER*(*) XLABEL, YLABEL, TITLE
	PARAMETER ( MXPLOT = 500 )
	REAL*4 XPLOT( MXPLOT )
	REAL*4 YPLOT( MXPLOT )
	LOGICAL ASCENT	! X-VALUES ASCEND
	LOGICAL MONOTONE! X-VALUES MONOTONIC
	LOGICAL PENDOWN	! PLOT PEN IS 'DOWN'
	REAL*8 CALC
	CHARACTER*10 REPLY
	INTEGER PGEWIN
	LOGICAL PGAGAIN
	IPLOTSYM=20

* kolor indices
	kolor_axis = 1
	kolor_text = 1
	kolor_data = 1
	kolor_model = 2
	kolor_sigma = 3
	kolor_reject = 4

      IF( NDATA.LE.0) THEN
	WRITE(*,*) '** NO DATA IN ''PLOTFIT'''
	RETURN
      END IF

*  COMPUTE RMS OF NORMALIZED RESIDUALS AND DETERMINE IF DATA ARE MONOTONIC

	NSUM = 0
	CALC = 0.D0
	XMAX = XDATA(1)
	XMIN = XMAX
	ASCENT = XDATA(NDATA).GT.XDATA(1)
	MONOTONE=.TRUE.
      DO I=1,NDATA
	XMAX = MAX(XMAX, XDATA(I))
	XMIN = MIN(XMIN, XDATA(I))
	IF( ASCENT .AND. XMAX.NE.XDATA(I) ) MONOTONE = .FALSE.
	IF( .NOT.ASCENT .AND. XMIN.NE.XDATA(I) ) MONOTONE = .FALSE.
      IF(YSIGMA(I).GT.0) THEN
	NSUM = NSUM + 1
	RESIDUAL = (YDATA(I) - YFIT(I)) / YSIGMA(I)
	CALC = CALC + RESIDUAL*RESIDUAL
      END IF
      END DO
	RMS = 1.
	IF(NSUM.GT.0) RMS = SQRT(CALC/MAX(1,NSUM))
	WRITE(*,*) 'RMS of normalized residuals =', RMS
	IF( RMS.LE.0. ) RMS = 1.
	IF(MONOTONE) WRITE(*,*) 'X-values are monotonic'
	IF(.NOT.MONOTONE) WRITE(*,*) 'X-values are NOT monotonic.'

*  GET DEFAULT PLOT RANGES

	CALL PGLIMIT( NDATA, XDATA, XMIN, XMAX, 0. )
	CALL PGLIMIT( NDATA, YDATA, YMIN, YMAX, 0. )

*  OVERRIDE DEFAULT PLOT RANGES

   10	IFAIL = PGEWIN( XMIN, XMAX, YMIN, YMAX )
	IF( IFAIL.NE.0 ) RETURN

*  FRAME THE FIRST PLOT (DATA PLUS FIT)


   50	CALL PGSTART(1,2,NEW)
	call pgbgw
	CALL PGSLW(1)
	CALL PGSCI( kolor_axis )
	CALL PGENV( XMIN, XMAX, YMIN, YMAX, 0, 1 )
	CALL PGSCI( kolor_text )
	CALL PGLABEL( XLABEL, YLABEL, TITLE )

*  LOOP TO PLOT THE DATA (IN WHITE AND BLUE) ------------------------

	NPLOT = 0
	PENDOWN = .TRUE.
	CALL PGSCI( kolor_data )
      DO I=1,NDATA

*  DUMP DATA SEGMENT IN WHITE

      IF( PENDOWN .AND. YSIGMA(I).LE.0.) THEN
      IF( NPLOT.GT.0 ) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
	XPLOT(1) = XPLOT(NPLOT)
	YPLOT(1) = YPLOT(NPLOT)
	NPLOT = 1
	PENDOWN = .FALSE.
	CALL PGSCI( kolor_reject )
      END IF

*  DUMP MASKED DATA SEGMENT IN BLUE

      ELSE IF( .NOT.PENDOWN .AND. YSIGMA(I).GT.0.) THEN
	NPLOT = NPLOT + 1
	XPLOT(NPLOT) = XDATA(I)
	YPLOT(NPLOT) = YDATA(I)
      IF(NPLOT.GT.0) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
	NPLOT = 0
	PENDOWN = .TRUE.
	CALL PGSCI( kolor_data )
      END IF
      END IF

*  EMPTY PLOT BUFFER IF FULL

      IF(NPLOT.GE.MXPLOT) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
	XPLOT(1) = XPLOT(NPLOT)
	YPLOT(1) = YPLOT(NPLOT)
	NPLOT = 1
      END IF

*  ADD NEW DATA PAIR TO PLOT BUFFER

	NPLOT = NPLOT + 1
	XPLOT(NPLOT) = XDATA(I)
	YPLOT(NPLOT) = YDATA(I)

      END DO	

*  DUMP FINAL PLOT SEGMENT

      IF(NPLOT.GT.0) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
      END IF

*  PLOT THE FIT (IN RED) ----------------------------------

	CALL PGSCI( kolor_model )
      IF(MONOTONE) THEN
	CALL PGLINE( NDATA, XDATA, YFIT)
      ELSE
	NPLOT = 0
      DO I=1,NDATA
	NPLOT = NPLOT + 1
	XPLOT(NPLOT) = XDATA(I)
	YPLOT(NPLOT) = YFIT(I)
      IF(NPLOT.GE.MXPLOT) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT )
	NPLOT = 0
      END IF
      END DO
      END IF

*  FRAME THE SECOND PLOT (NORMALIZED RESIDUALS) --------------------

	CALL PGSLW(1)
	CALL PGSCI( kolor_axis )
	CALL PGENV( XMIN, XMAX, -5., +5., 0, 1)
	CALL PGSCI( kolor_text )
	CALL PGLABEL( XLABEL, 'Sigma', 'Normalized Residuals' )

*  LOOP TO PLOT THE DATA

	NPLOT = 0
	PENDOWN = .TRUE.
	CALL PGSCI( kolor_data )
      DO I=1,NDATA

*  DUMP DATA SEGMENT IN WHITE

      IF( PENDOWN .AND. YSIGMA(I).LE.0.) THEN
      IF( NPLOT.GT.0 ) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
	XPLOT(1) = XPLOT(NPLOT)
	YPLOT(1) = YPLOT(NPLOT)
	NPLOT = 1
	PENDOWN = .FALSE.
	CALL PGSCI( kolor_reject )
      END IF

*  DUMP MASKED DATA SEGMENT IN BLUE

      ELSE IF( .NOT.PENDOWN .AND. YSIGMA(I).GT.0.) THEN
	NPLOT = NPLOT + 1
	XPLOT(NPLOT) = XDATA(I)
	YPLOT(NPLOT) = (YDATA(I) -YFIT(I)) / ABS(RMS*YSIGMA(I))
      IF(NPLOT.GT.0) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
	NPLOT = 0
	PENDOWN = .TRUE.
	CALL PGSCI( kolor_data )
      END IF
      END IF

*  EMPTY PLOT BUFFER IF FULL

      IF(NPLOT.GE.MXPLOT) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
	XPLOT(1) = XPLOT(NPLOT)
	YPLOT(1) = YPLOT(NPLOT)
	NPLOT = 1
      END IF

*  ADD NEW DATA PAIR TO PLOT BUFFER

	NPLOT = NPLOT + 1
	XPLOT(NPLOT) = XDATA(I)
	IF(YSIGMA(I).NE.0.)
     #	YPLOT(NPLOT) = (YDATA(I) -YFIT(I)) / ABS(RMS*YSIGMA(I))

      END DO	

*  DUMP FINAL PLOT SEGMENT

      IF(NPLOT.GT.0) THEN
      IF(MONOTONE) THEN
	CALL PGLINE(NPLOT, XPLOT, YPLOT)
      ELSE
	CALL PGPOINT(NPLOT, XPLOT, YPLOT, IPLOTSYM )
      END IF
      END IF

*  PLOT -1,0,1 SIGMA LEVELS ---------------------------------

	XPLOT(1) = XMIN
	XPLOT(2) = XMAX
      DO I=-1,1,1
	YPLOT(1) = I
	YPLOT(2) = I
	CALL PGSCI( kolor_sigma )
	IF( I.EQ.0 ) CALL PGSCI( kolor_model )
	CALL PGLINE( 2, XPLOT, YPLOT )
      END DO

	CALL PGSCI( kolor_text )
	CALL PGIDEN
	CALL PGSTOP

	IF( PGAGAIN() ) GOTO 10

	RETURN
	END
*UPTODATE E02BAFTEXT
      SUBROUTINE E02BAF(M, NCAP7, X, Y, W, K, WORK1, WORK2, C, SS,IFAIL)
C     NAG COPYRIGHT 1975
C     MARK 5 RELEASE
C     MARK 6 REVISED  IER-84
C     MARK 8 RE-ISSUE. IER-224 (APR 1980).
C     MARK 9A REVISED. IER-356 (NOV 1981)
C
C     NAG LIBRARY SUBROUTINE  E02BAF
C
C     E02BAF  COMPUTES A WEIGHTED LEAST-SQUARES APPROXIMATION
C     TO AN ARBITRARY SET OF DATA POINTS BY A CUBIC SPLINE
C     WITH KNOTS PRESCRIBED BY THE USER.  CUBIC SPLINE
C     INTERPOLATION CAN ALSO BE CARRIED OUT.
C
C     COX-DE BOOR METHOD FOR EVALUATING B-SPLINES WITH
C     ADAPTATION OF GENTLEMAN*S PLANE ROTATION SCHEME FOR
C     SOLVING OVER-DETERMINED LINEAR SYSTEMS.
C
C     USES NAG LIBRARY ROUTINE  P01AAF.
C
C     STARTED - 1973.
C     COMPLETED - 1976.
C     AUTHOR - MGC AND JGH.
C
C     REDESIGNED TO USE CLASSICAL GIVENS ROTATIONS IN
C     ORDER TO AVOID THE OCCASIONAL UNDERFLOW (AND HENCE
C     OVERFLOW) PROBLEMS EXPERIENCED BY GENTLEMAN*S 3-
C     MULTIPLICATION PLANE ROTATION SCHEME
C
C     WORK1  AND  WORK2  ARE WORKSPACE AREAS.
C     WORK1(R)  CONTAINS THE VALUE OF THE  R TH  DISTINCT DATA
C     ABSCISSA AND, SUBSEQUENTLY, FOR  R = 1, 2, 3, 4,  THE
C     VALUES OF THE NON-ZERO B-SPLINES FOR EACH SUCCESSIVE
C     ABSCISSA VALUE.
C     WORK2(L, J)  CONTAINS, FOR  L = 1, 2, 3, 4,  THE VALUE OF
C     THE  J TH  ELEMENT IN THE  L TH  DIAGONAL OF THE
C     UPPER TRIANGULAR MATRIX OF BANDWIDTH  4  IN THE
C     TRIANGULAR SYSTEM DEFINING THE B-SPLINE COEFFICIENTS.
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION SS
      INTEGER IFAIL, M, NCAP7
C     .. ARRAY ARGUMENTS ..
      DOUBLE PRECISION C(NCAP7), K(NCAP7), W(M), WORK1(M), WORK2(4,
     *NCAP7),X(M), Y(M)
C     ..
C     .. LOCAL SCALARS ..
C$P 1
      DOUBLE PRECISION ACOL, AROW, CCOL, COSINE, CROW, D4, D5, D6, D7,
     * D8, D9,D, DPRIME, E2, E3, E4, E5, K0, K1, K2, K3, K4, K5, K6, N1,
     *N2, N3, RELEMT, S, SIGMA, SINE, WI, XI
      INTEGER I, IERROR, IPLUSJ, IU, J, JOLD, JPLUSL, JREV, L4,L,
     * LPLUS1, LPLUSU, NCAP3, NCAP, NCAPM1, R
C     .. FUNCTION REFERENCES ..
      DOUBLE PRECISION DSQRT
      INTEGER P01AAF
C     ..
C 2010 Jun Keith Horne @ St.Andrews - character*8 SRNAME
C      DOUBLE PRECISION SRNAME
C      DATA SRNAME /8H E02BAF /
      CHARACTER*8 SRNAME
      DATA SRNAME /' E02BAF ' /
      IERROR = 4
C     CHECK THAT THE VALUES OF  M  AND  NCAP7  ARE REASONABLE
      IF (NCAP7.LT.8 .OR. M.LT.NCAP7-4) GO TO 420
      NCAP = NCAP7 - 7
      NCAPM1 = NCAP - 1
      NCAP3 = NCAP + 3
C
C     IN ORDER TO DEFINE THE FULL B-SPLINE BASIS, AUGMENT THE
C     PRESCRIBED INTERIOR KNOTS BY KNOTS OF MULTIPLICITY FOUR
C     AT EACH END OF THE DATA RANGE.
C
      DO 20 J=1,4
         I = NCAP3 + J
         K(J) = X(1)
         K(I) = X(M)
   20 CONTINUE
C
C     TEST THE VALIDITY OF THE DATA.
C
C     CHECK THAT THE KNOTS ARE ORDERED AND ARE INTERIOR
C     TO THE DATA INTERVAL.
C
      IERROR = 1
      IF (K(5).LE.X(1) .OR. K(NCAP3).GE.X(M)) GO TO 420
      DO 40 J=4,NCAP3
         IF (K(J).GT.K(J+1)) GO TO 420
   40 CONTINUE
C
C     CHECK THAT THE WEIGHTS ARE STRICTLY POSITIVE.
C
      IERROR = 2
      DO 60 I=1,M
         IF (W(I).LE.0.0D0) GO TO 420
   60 CONTINUE
C
C     CHECK THAT THE DATA ABSCISSAE ARE ORDERED, THEN FORM THE
C     ARRAY  WORK1  FROM THE ARRAY  X.  THE ARRAY  WORK1  CONTAINS
C     THE
C     SET OF DISTINCT DATA ABSCISSAE.
C
      IERROR = 3
      WORK1(1) = X(1)
      J = 2
      DO 80 I=2,M
         IF (X(I).LT.WORK1(J-1)) GO TO 420
         IF (X(I).EQ.WORK1(J-1)) GO TO 80
         WORK1(J) = X(I)
         J = J + 1
   80 CONTINUE
      R = J - 1
C
C     CHECK THAT THERE ARE SUFFICIENT DISTINCT DATA ABSCISSAE FOR
C     THE PRESCRIBED NUMBER OF KNOTS.
C
      IERROR = 4
      IF (R.LT.NCAP3) GO TO 420
C
C     CHECK THE FIRST  S  AND THE LAST  S  SCHOENBERG-WHITNEY
C     CONDITIONS ( S = MIN(NCAP - 1, 4) ).
C
      IERROR = 5
      DO 100 J=1,4
         IF (J.GE.NCAP) GO TO 160
         I = NCAP3 - J + 1
         L = R - J + 1
         IF (WORK1(J).GE.K(J+4) .OR. K(I).GE.WORK1(L)) GO TO 420
  100 CONTINUE
C
C     CHECK ALL THE REMAINING SCHOENBERG-WHITNEY CONDITIONS.
C
      IF (NCAP.LE.5) GO TO 160
      R = R - 4
      I = 4
      DO 140 J=5,NCAPM1
         K0 = K(J+4)
         K4 = K(J)
  120    I = I + 1
         IF (WORK1(I).LE.K4) GO TO 120
         IF (I.GT.R .OR. WORK1(I).GE.K0) GO TO 420
  140 CONTINUE
C
C     INITIALISE A BAND TRIANGULAR SYSTEM (I.E. A
C     MATRIX AND A RIGHT HAND SIDE) TO ZERO. THE
C     PROCESSING OF EACH DATA POINT IN TURN RESULTS
C     IN AN UPDATING OF THIS SYSTEM. THE SUBSEQUENT
C     SOLUTION OF THE RESULTING BAND TRIANGULAR SYSTEM
C     YIELDS THE COEFFICIENTS OF THE B-SPLINES.
C
  160 DO 200 I=1,NCAP3
         DO 180 L=1,4
            WORK2(L,I) = 0.0D0
  180    CONTINUE
         C(I) = 0.0D0
  200 CONTINUE
      SIGMA = 0.0D0
      J = 0
      JOLD = 0
      DO 340 I=1,M
C
C     FOR THE DATA POINT  (X(I), Y(I))  DETERMINE AN INTERVAL
C     K(J + 3) .LE. X .LT. K(J + 4)  CONTAINING  X(I).  (IN THE
C     CASE  J + 4 .EQ. NCAP  THE SECOND EQUALITY IS RELAXED TO
C     INCLUDE
C     EQUALITY).
C
         WI = W(I)
         XI = X(I)
  220    IF (XI.LT.K(J+4) .OR. J.GT.NCAPM1) GO TO 240
         J = J + 1
         GO TO 220
  240    IF (J.EQ.JOLD) GO TO 260
C
C     SET CERTAIN CONSTANTS RELATING TO THE INTERVAL
C     K(J + 3) .LE. X .LE. K(J + 4).
C
         K1 = K(J+1)
         K2 = K(J+2)
         K3 = K(J+3)
         K4 = K(J+4)
         K5 = K(J+5)
         K6 = K(J+6)
         D4 = 1.0D0/(K4-K1)
         D5 = 1.0D0/(K5-K2)
         D6 = 1.0D0/(K6-K3)
         D7 = 1.0D0/(K4-K2)
         D8 = 1.0D0/(K5-K3)
         D9 = 1.0D0/(K4-K3)
         JOLD = J
C
C     COMPUTE AND STORE IN  WORK1(L) (L = 1, 2, 3, 4)  THE VALUES
C     OF
C     THE FOUR NORMALIZED CUBIC B-SPLINES WHICH ARE NON-ZERO AT
C     X=X(I).
C
  260    E5 = K5 - XI
         E4 = K4 - XI
         E3 = XI - K3
         E2 = XI - K2
         N1 = WI*D9
         N2 = E3*N1*D8
         N1 = E4*N1*D7
         N3 = E3*N2*D6
         N2 = (E2*N1+E5*N2)*D5
         N1 = E4*N1*D4
         WORK1(4) = E3*N3
         WORK1(3) = E2*N2 + (K6-XI)*N3
         WORK1(2) = (XI-K1)*N1 + E5*N2
         WORK1(1) = E4*N1
         CROW = Y(I)*WI
C
C     ROTATE THIS ROW INTO THE BAND TRIANGULAR SYSTEM USING PLANE
C     ROTATIONS.
C
         DO 320 LPLUS1=1,4
            L = LPLUS1 - 1
            RELEMT = WORK1(LPLUS1)
            IF (RELEMT.EQ.0.0D0) GO TO 320
            JPLUSL = J + L
            L4 = 4 - L
            D = WORK2(1,JPLUSL)
            IF (DABS(RELEMT).GE.D) DPRIME =
     *       DABS(RELEMT)*DSQRT(1.0D0+(D/RELEMT)**2)
            IF (DABS(RELEMT).LT.D) DPRIME = D*DSQRT(1.0D0+(RELEMT/D)**2)
            WORK2(1,JPLUSL) = DPRIME
            COSINE = D/DPRIME
            SINE = RELEMT/DPRIME
            IF (L4.LT.2) GO TO 300
            DO 280 IU=2,L4
               LPLUSU = L + IU
               ACOL = WORK2(IU,JPLUSL)
               AROW = WORK1(LPLUSU)
               WORK2(IU,JPLUSL) = COSINE*ACOL + SINE*AROW
               WORK1(LPLUSU) = COSINE*AROW - SINE*ACOL
  280       CONTINUE
  300       CCOL = C(JPLUSL)
            C(JPLUSL) = COSINE*CCOL + SINE*CROW
            CROW = COSINE*CROW - SINE*CCOL
  320    CONTINUE
         SIGMA = SIGMA + CROW**2
  340 CONTINUE
      SS = SIGMA
C
C     SOLVE THE BAND TRIANGULAR SYSTEM FOR THE B-SPLINE
C     COEFFICIENTS. IF A DIAGONAL ELEMENT IS ZERO, AND HENCE
C     THE TRIANGULAR SYSTEM IS SINGULAR, THE IMPLICATION IS
C     THAT THE SCHOENBERG-WHITNEY CONDITIONS ARE ONLY JUST
C     SATISFIED. THUS IT IS APPROPRIATE TO EXIT IN THIS
C     CASE WITH THE SAME VALUE  (IFAIL=5)  OF THE ERROR
C     INDICATOR.
C
      L = -1
      DO 400 JREV=1,NCAP3
         J = NCAP3 - JREV + 1
         D = WORK2(1,J)
         IF (D.EQ.0.0D0) GO TO 420
         IF (L.LT.3) L = L + 1
         S = C(J)
         IF (L.EQ.0) GO TO 380
         DO 360 I=1,L
            IPLUSJ = I + J
            S = S - WORK2(I+1,J)*C(IPLUSJ)
  360    CONTINUE
  380    C(J) = S/D
  400 CONTINUE
      IERROR = 0
  420 IF (IERROR) 440, 460, 440
  440 IFAIL = P01AAF(IFAIL,IERROR,SRNAME)
      RETURN
  460 IFAIL = 0
      RETURN
      END
** END OF E02BAFTEXT

*UPTODATE E02BBFTEXT
      SUBROUTINE E02BBF(NCAP7, K, C, X, S, IFAIL)
C     NAG LIBRARY SUBROUTINE  E02BBF
C
C     E02BBF  EVALUATES A CUBIC SPLINE FROM ITS
C     B-SPLINE REPRESENTATION.
C
C     DE BOOR*S METHOD OF CONVEX COMBINATIONS.
C
C     USES NAG LIBRARY ROUTINE  P01AAF.
C
C     STARTED - 1973.
C     COMPLETED - 1976.
C     AUTHOR - MGC AND JGH.
C
C     NAG COPYRIGHT 1975
C     MARK 5 RELEASE
C     MARK 7 REVISED IER-141 (DEC 1978)

      INTEGER NCAP7, IFAIL, P01AAF, IERROR, J, J1, L
C$P 1
      DOUBLE PRECISION K(NCAP7), C(NCAP7), X, S, C1, C2, C3,
     * E2, E3, E4, E5,K1, K2, K3, K4, K5, K6
C 2010 Jun Keith Horne @ St.Andrews - character*8 SRNAME
C      DOUBLE PRECISION SRNAME
C      DATA SRNAME /8H E02BBF /
      CHARACTER*8 SRNAME
      DATA SRNAME /' E02BBF '/
C
      IERROR = 0
      IF (NCAP7.GE.8) GO TO 10
      IERROR = 2
      GO TO 100
   10 IF (X.GE.K(4) .AND. X.LE.K(NCAP7-3)) GO TO 20
      IERROR = 1
      S = 0.0D0
      GO TO 100
C
C     DETERMINE  J  SUCH THAT  K(J + 3) .LE. X .LE. K(J + 4).
C
   20 J1 = 0
      J = NCAP7 - 7
   40 L = (J1+J)/2
      IF (J-J1.LE.1) GO TO 80
      IF (X.GE.K(L+4)) GO TO 60
      J = L
      GO TO 40
   60 J1 = L
      GO TO 40
C
C     USE THE METHOD OF CONVEX COMBINATIONS TO COMPUTE  S(X).
C
   80 K1 = K(J+1)
      K2 = K(J+2)
      K3 = K(J+3)
      K4 = K(J+4)
      K5 = K(J+5)
      K6 = K(J+6)
      E2 = X - K2
      E3 = X - K3
      E4 = K4 - X
      E5 = K5 - X
      C2 = C(J+1)
      C3 = C(J+2)
      C1 = ((X-K1)*C2+E4*C(J))/(K4-K1)
      C2 = (E2*C3+E5*C2)/(K5-K2)
      C3 = (E3*C(J+3)+(K6-X)*C3)/(K6-K3)
      C1 = (E2*C2+E4*C1)/(K4-K2)
      C2 = (E3*C3+E5*C2)/(K5-K3)
      S = (E3*C2+E4*C1)/(K4-K3)
  100 IF (IERROR) 120, 140, 120
  120 IFAIL = P01AAF(IFAIL,IERROR,SRNAME)
      RETURN
  140 IFAIL = 0
      RETURN
      END
** END OF E02BBFTEXT

*UPTODATE E02BCFTEXT
      SUBROUTINE E02BCF(NCAP7, K, C, X, LEFT, S, IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C
C     **************************************************
C     *                                                *
C     *         NAG LIBRARY SUBROUTINE  E02BCF         *
C     *                                                *
C     *  EVALUATION OF CUBIC SPLINE AND ITS            *
C     *  DERIVATIVES FROM ITS B-SPLINE REPRESENTATION  *
C     *                                                *
C     *  ROUTINE CREATED ... 17 NOV 1977               *
C     *  LATEST UPDATE ....  24 APR 1978               *
C     *  RELEASE NUMBER ...  01                        *
C     *  AUTHORS ... MAURICE G. COX AND                *
C     *              J. GEOFFREY HAYES, N.P.L.         *
C     *                                                *
C     **************************************************
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION X
      INTEGER IFAIL, LEFT, NCAP7
C     .. ARRAY ARGUMENTS ..
      DOUBLE PRECISION C(NCAP7), K(NCAP7), S(4)
C     ..
C     .. LOCAL SCALARS ..
C$P 1
      DOUBLE PRECISION C1, C2, C3, C4, D1N41, D1N42, D1N43, D1N44,
     * D2N41,D2N42, D2N43, D2N44, D3N41, D3N42, D3N43, D3N44, E2, E3,
     * E4,E5, HALF, K1, K2, K3, K4, K5, K6, M11, M21, M22, M32, N41,N42,
     * N43, N44, P4, P5, P6, SIX, THREE
      INTEGER IERROR, J1, J, L
C     .. FUNCTION REFERENCES ..
      INTEGER P01AAF
C     ..
C 2010 Jun Keith Horne @ St.Andrews - character*8 SRNAME
C      DOUBLE PRECISION SRNAME
C      DATA SRNAME /8H E02BCF /
      CHARACTER*8 SRNAME
      DATA SRNAME /' E02BCF '/
      HALF = 0.5D+00
      THREE = 3.0D+00
      SIX = 6.0D+00
C
C     *********  DATA VALIDATION  *********
C
C     CHECK WHETHER AT LEAST ONE INTERVAL HAS BEEN SPECIFIED -
C
      IERROR = 1
      IF (NCAP7.LT.8) GO TO 80
C
C     CHECK WHETHER THE RANGE OF DEFINITION OF THE SPLINE IS
C     STRICTLY POSITIVE IN LENGTH -
C
      IERROR = 2
      IF (K(4).GE.K(NCAP7-3)) GO TO 80
C
C     CHECK WHETHER  X  IS A VALID ARGUMENT -
C
      IF (X.LT.K(4) .OR. X.GT.K(NCAP7-3)) GO TO 80
C
C     *********  COMPUTATION  *********
C
C     BINARY SEARCH FOR INTERVAL CONTAINING  X  -
C
C     IF RIGHT-HAND DERIVATIVES ARE REQUIRED  (LEFT .NE. 1)
C     SEARCH FOR  J  SATISFYING
C     K(J + 3) .LE. X .LT. K(J + 4)
C     (SETTING  J = NCAP  IN THE EXCEPTIONAL CASE  X = K(NCAP +
C     4)).
C
C     IF LEFT-HAND DERIVATIVES ARE REQUIRED  (LEFT .EQ. 1)
C     SEARCH FOR  J  SATISFYING
C     K(J + 3) .LT. X .LE. K(J + 4)
C     (SETTING  J = 1  IN THE EXCEPTIONAL CASE  X = K(4)).
C
      IERROR = 0
      J1 = 4
      J = NCAP7 - 3
   20 L = (J1+J)/2
      IF (J-J1.LE.1) GO TO 60
      IF (LEFT.NE.1 .AND. X.GE.K(L)) GO TO 40
      IF (LEFT.EQ.1 .AND. X.GT.K(L)) GO TO 40
      J = L
      GO TO 20
   40 J1 = L
      GO TO 20
   60 J = J - 4
C
C     FORM CERTAIN CONSTANTS -
C
      K1 = K(J+1)
      K2 = K(J+2)
      K3 = K(J+3)
      K4 = K(J+4)
      K5 = K(J+5)
      K6 = K(J+6)
      E2 = X - K2
      E3 = X - K3
      E4 = K4 - X
      E5 = K5 - X
      P4 = K4 - K1
      P5 = K5 - K2
      P6 = K6 - K3
C
C     FORM BASIS FUNCTIONS AND THEIR DERIVATIVES -
C
C     THE VALUES OF THE NON-ZERO UN-NORMALIZED B-SPLINES OF ORDER R
C     ARE DENOTED BY  MR1, MR2,...  .  THE CORRESPONDING NORMALIZED
C     B-SPLINES ARE DENOTED BY  NR1, NR2,...  AND THEIR DERIVATIVES
C     OF ORDER  L  BY  DLNR1, DLNR2,...  .
C
      M11 = SIX/(K4-K3)
      M21 = -M11/(K4-K2)
      M22 = M11/(K5-K3)
      D3N41 = M21/P4
      M32 = (M21-M22)/P5
      D3N44 = M22/P6
      D3N42 = -D3N41 - M32
      D3N43 = M32 - D3N44
      M21 = -E4*M21
      M22 = E3*M22
      D2N41 = M21/P4
      M32 = (M21-M22)/P5
      D2N44 = M22/P6
      D2N42 = -D2N41 - M32
      D2N43 = M32 - D2N44
      M21 = HALF*M21
      M22 = HALF*M22
      D1N41 = -E4*M21/P4
      M32 = (E2*M21+E5*M22)/P5
      D1N44 = E3*M22/P6
      D1N42 = -D1N41 - M32
      D1N43 = M32 - D1N44
      N41 = -E4*D1N41/THREE
      N42 = (-(X-K1)*D1N41+E5*M32)/THREE
      N43 = (E2*M32+(K6-X)*D1N44)/THREE
      N44 = E3*D1N44/THREE
C
C     FORM THE VALUES OF THE CUBIC SPLINE AND ITS DERIVATIVES -
C
      C1 = C(J)
      C2 = C(J+1)
      C3 = C(J+2)
      C4 = C(J+3)
      S(1) = C1*N41 + C2*N42 + C3*N43 + C4*N44
      S(2) = C1*D1N41 + C2*D1N42 + C3*D1N43 + C4*D1N44
      S(3) = C1*D2N41 + C2*D2N42 + C3*D2N43 + C4*D2N44
      S(4) = C1*D3N41 + C2*D3N42 + C3*D3N43 + C4*D3N44
C
C     *********  ERROR DIAGNOSTICS  *********
C
   80 IFAIL = P01AAF(IFAIL,IERROR,SRNAME)
      RETURN
C
C     END OF SUBROUTINE  E02BCF
C
      END
** END OF E02BCFTEXT

*UPTODATE E02BDFTEXT
      SUBROUTINE E02BDF(NCAP7, K, C, DEFINT, IFAIL)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978.
C
C     **************************************************
C     *                                                *
C     *         NAG LIBRARY SUBROUTINE  E02BDF         *
C     *                                                *
C     *  DEFINITE INTEGRAL OF CUBIC SPLINE FROM ITS    *
C     *  B-SPLINE REPRESENTATION                       *
C     *                                                *
C     *  ROUTINE CREATED ... 17 NOV 1977               *
C     *  LATEST UPDATE ....  24 APR 1978               *
C     *  RELEASE NUMBER ...  01                        *
C     *  AUTHORS ... MAURICE G. COX AND                *
C     *              J. GEOFFREY HAYES, N.P.L.         *
C     *                                                *
C     **************************************************
C
C     .. SCALAR ARGUMENTS ..
      DOUBLE PRECISION DEFINT
      INTEGER IFAIL, NCAP7
C     .. ARRAY ARGUMENTS ..
      DOUBLE PRECISION C(NCAP7), K(NCAP7)
C     ..
C     .. LOCAL SCALARS ..
C$P 1
      DOUBLE PRECISION FOUR, SUM, ZERO
      INTEGER IERROR, J, NCAP3, NCAP4, NCAP
C     .. FUNCTION REFERENCES ..
      INTEGER P01AAF
C     ..
C 2010 Jun Keith Horne @ St.Andrews - character*8 SRNAME
c      DOUBLE PRECISION SRNAME
C      DATA SRNAME /8H E02BDF /
      CHARACTER*8 SRNAME
      DATA SRNAME /' E02BDF '/
      ZERO = 0.0D+0
      FOUR = 4.0D+0
C
C     *********  DATA VALIDATION  *********
C
C     CHECK WHETHER AT LEAST ONE INTERVAL HAS BEEN SPECIFIED -
C
      IERROR = 1
      IF (NCAP7.LT.8) GO TO 60
C
C     CHECK WHETHER THE KNOTS SUPPLIED ARE REASONABLE -
C
      IERROR = 2
      NCAP = NCAP7 - 7
      NCAP4 = NCAP + 4
      IF (K(4).GE.K(NCAP4)) GO TO 60
      IF (K(1).NE.K(2) .OR. K(2).NE.K(3) .OR. K(3).NE.K(4)) GO TO 60
      IF (K(NCAP4).NE.K(NCAP+5) .OR. K(NCAP+5).NE.K(NCAP+6) .OR.K(NCAP+
     *6).NE.K(NCAP+7)) GO TO 60
      DO 20 J=5,NCAP4
         IF (K(J).LT.K(J-1)) GO TO 60
   20 CONTINUE
C
C     *********  COMPUTATION  *********
C
      IERROR = 0
      NCAP3 = NCAP + 3
      SUM = ZERO
      DO 40 J=1,NCAP3
         SUM = SUM + (K(J+4)-K(J))*C(J)
   40 CONTINUE
      DEFINT = SUM/FOUR
C
C     *********  ERROR DIAGNOSTICS  *********
C
   60 IFAIL = P01AAF(IFAIL,IERROR,SRNAME)
      RETURN
C
C     END OF SUBROUTINE  E02BDF
C
      END
** END OF E02BDFTEXT

*UPTODATE P01AAFTEXT
      INTEGER FUNCTION P01AAF(IFAIL, ERROR, SRNAME)
C     MARK 1 RELEASE.  NAG COPYRIGHT 1971
C     MARK 3 REVISED
C     MARK 4A REVISED, IER-45
C     MARK 4.5 REVISED
C     MARK 7 REVISED (DEC 1978)
C     RETURNS THE VALUE OF ERROR OR TERMINATES THE PROGRAM.
      INTEGER ERROR, IFAIL, NOUT
C$P 1
C 2010 Jun Keith Horne @ St.Andrews - character*(*) SRNAME
C      DOUBLE PRECISION SRNAME
      CHARACTER*(*) SRNAME
C     TEST IF NO ERROR DETECTED
      IF (ERROR.EQ.0) GO TO 20
C     DETERMINE OUTPUT UNIT FOR MESSAGE
      CALL X04AAF (0,NOUT)
C     TEST FOR SOFT FAILURE
      IF (MOD(IFAIL,10).EQ.1) GO TO 10
C     HARD FAILURE
      WRITE (NOUT,99999) SRNAME, ERROR
C     STOPPING MECHANISM MAY ALSO DIFFER
C     CALL P01AAZ
      STOP
C     SOFT FAIL
C     TEST IF ERROR MESSAGES SUPPRESSED
   10 IF (MOD(IFAIL/10,10).EQ.0) GO TO 20
      WRITE (NOUT,99999) SRNAME, ERROR
   20 P01AAF = ERROR
      RETURN
99999 FORMAT (1H0, 38HERROR DETECTED BY NAG LIBRARY ROUTINE , A8,
     * 11H - IFAIL = , I5//)
      END
** END OF P01AAFTEXT
*UPTODATE X04AAFTEXT
      SUBROUTINE X04AAF(I,NERR)
C     MARK 7 RELEASE. NAG COPYRIGHT 1978
C     MARK 7C REVISED IER-190 (MAY 1979)
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     *** NOTE ***
C     THIS ROUTINE ASSUMES THAT THE VALUE OF NERR1 IS SAVED
C     BETWEEN CALLS.  IN SOME IMPLEMENTATIONS IT MAY BE
C     NECESSARY TO STORE NERR1 IN A LABELLED COMMON
C     BLOCK /AX04AA/ TO ACHIEVE THIS.
C     IN THE VAX IMPLEMENTATION, THE SAVE STATEMENT IS USED.
C
C     .. SCALAR ARGUMENTS ..
      INTEGER I, NERR
C     ..
C     .. LOCAL SCALARS ..
      INTEGER NERR1
C     ..
      SAVE NERR1
      DATA NERR1 /6/
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END
** END OF X04AAFTEXT

	SUBROUTINE POLYFITA( NDATA, XDATA, YDATA, YSIGMA, YFIT,
     #	NPOLY, NCYCLE, THRHI, THRLO, IFAIL )
*
* Fits polynomial to data and performs reject cycles with
* no user interaction.
*
*  Inputs:
*	NDATA	= NUMBER OF DATA VALUES
*	XDATA	= X DATA VALUES
*	YDATA	= Y DATA VALUES
*	YSIGMA	= Y UNCERTAINTIES (1-SIGMA) (NEGATIVE TO REJECT)
*	NPOLY	= Number of terms in polynomial (0-maxpoly)
*	NCYCLE	= Max number of reject cycles
*	THRHI	= high threshold for sigma clipping
*	THRLO	= low threshold for sigma clipping
*
*  Output:
*	YFIT	= Y FIT VALUES
*	IFAIL	= 0 IF SUCCESSFUL, 1 IF FAILED.
*
* Oct 1986 KDH @ STScI
* May 1991 KDH @ STScI - FITPLY common block
* Aug 1997 KDH @ St-Andrews -- eliminate TYPE, common/silent/
* 2000 Dec KDH @ Austin - remove data statement setting silent to false
* 2019 Dec KDH @ StA - omit comma after write(*,*),
	REAL*4 XDATA(*), YDATA(*), YSIGMA(*), YFIT(*)
        COMMON/FITPLY/ NFITPLY, NREJPLY, THRHIPLY, THRLOPLY
	LOGICAL SILENT
	COMMON/SILENT/ SILENT

* Test inputs

      IF(NDATA.LE.0) THEN
	WRITE(*,*) '** No data.', NDATA
	GOTO 999
      END IF

	NREJ = 0	! count rejected pixels
	ICYCLE = -1	! count the fit-reject cycles
  100	ICYCLE = ICYCLE + 1
	LASTREJ = NREJ	! stow reject count from previous fit

* Fit the polynomial

	CALL POLYFIT1( NDATA, XDATA, YDATA, YSIGMA, YFIT, NPOLY, IFAIL)
	IF( IFAIL.NE.0 ) GOTO 999

* Evaluate the fit

      IF( NCYCLE.EQ.0 ) THEN

	CALL REJECT( NDATA, YDATA, YSIGMA, YFIT, 1.E20, -1.E20, RMS, NREJ )

* Evaluate the fit and reject large outliers

      ELSE

	CALL REJECT( NDATA, YDATA, YSIGMA, YFIT, THRHI, THRLO, RMS, NREJ )

      END IF

* Report results of this reject

      IF( .NOT. SILENT ) THEN
	WRITE(*,*) ' Cycle', ICYCLE, '  RMS =', RMS,
     #	' (sigma)  Rejects =', NREJ
      END IF

* Next fit-reject cycle

	IF( ICYCLE.LT.NCYCLE .AND. NREJ.NE.LASTREJ ) GOTO 100

* normal return

	IFAIL = 0
	NFITPLY = NPOLY
	NREJPLY = NCYCLE
	THRHIPLY = THRHI
	THRLOPLY = THRLO
	RETURN

* error return

  999	IFAIL = 1
	WRITE(*,*) 'POLYFITA aborted.'
	RETURN

	END
	SUBROUTINE POLYFITR(  NDATA, XDATA, YDATA, YSIGMA, YFIT, IFAIL )
*
*  Computes weighted least-squares polynomial fit to (x-y) data pairs.
*  with reject cycles.  Interactively controlled.
*
*  Inputs:
*	NDATA	= NUMBER OF DATA VALUES
*	XDATA	= X DATA VALUES
*	YDATA	= Y DATA VALUES
*	YSIGMA	= Y UNCERTAINTIES (1-SIGMA) (NEGATIVE TO REJECT)
*  Output:
*	YFIT	= Y FIT VALUES
*	IFAIL	= 0 IF SUCCESSFUL, 1 IF FAILED.
*
* 1984 Sep Keith Horne and Tom Marsh @ IoA Cambridge.
* 1986 Oct KDH @ STScI -- Separate POLYFITR from POLYFITA.
* 1988 Jul KDH @ STScI -- PGSETLABS to edit plot labels
* 1988 Nov KDH @ STScI -- PGSETLABS change to PGSLAB
* 1992 Mar KDH @ STScI - PGSLAB -> PGELAB
* 1995 Jan KDH @ St.And - IERSET -> IRESET, eliminate TYPE
* 2001 Aug KDH @ St.A - PLOTFIT -> PLTFIT
* 2012 Jan KDH @ St.A - MAXPOLY 20->30
	REAL*4 XDATA(*), YDATA(*), YSIGMA(*), YFIT(*)
	CHARACTER*1 REPLY
	CHARACTER*60 XLABEL/' '/
	CHARACTER*60 YLABEL/' '/
	CHARACTER*60 TITLE/' '/

* default poly fit parameters

	PARAMETER ( MAXPOLY = 30 )
	DATA NPOLY/3/
	DATA NCYCLE/10/
	DATA THRHI/100./
	DATA THRLO/-2./

* Test inputs

	IFAIL = 0
      IF(NDATA.LE.0) THEN
	WRITE(*,*) '** No data.'
	GOTO 999
      END IF

	GOTO 100

* Command node

   10	WRITE(*,'(A,$)') ' POLYFITR > '
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )
	IF( REPLY.EQ.'Q') GOTO 1000
	IF( REPLY.EQ.'A') GOTO 999
	IF( REPLY.EQ.'C') GOTO 100
	IF( REPLY.EQ.'P') GOTO 200
	IF( REPLY.EQ.'R') GOTO 300

* Command summary

   20	WRITE(*,*) 'Type P -- to PLOT the fit'
	WRITE(*,*) '     C -- CHANGE parameters and run more reject CYCLES'
	WRITE(*,*) '     R -- to RESTORE rejected pixels and try again'
	WRITE(*,*) '     A -- to ABORT'
	WRITE(*,*) '     Q -- to adopt this fit and continue'
	GOTO 10
C
C  REPORT POLY FIT PARAMETERS
C
  100	WRITE(*,*) '   Number of data points =', NDATA
	WRITE(*,*) ' Number of polyfit TERMS =', NPOLY
	WRITE(*,*) ' Number of reject CYCLES =', NCYCLE
	WRITE(*,*) 'HIGH rejection threshold =', THRHI, ' sigma.'
	WRITE(*,*) ' LOW rejection threshold =', THRLO, ' sigma.'
	WRITE(*,*) 'Type A -- to ABORT this fit'
	WRITE(*,*) '     C -- to CHANGE poly parameters'
	WRITE(*,*) '   <CR>-- to proceed with the fit'
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )

	IF( REPLY.EQ.'A') GOTO 10
	IF( REPLY.EQ.'C') GOTO 150
	IF( REPLY.EQ.' ') GOTO 180
	GOTO 100

* Get new poly fit parameters

  150	WRITE(*,*) 'Enter (1) Number of polyfit TERMS'
	WRITE(*,*) '      (2) Number of reject CYCLES'
	WRITE(*,*) '      (3) HIGH (>0) reject threshold'
	WRITE(*,*) '      (4) LOW (<0) reject threshold'
	WRITE(*,*) '(Note: Enter 0 to keep a default value.)'
	READ(*,*,ERR=150) NEWPOLY, NEWCYCLE, THRHINEW, THRLONEW

	IF( NEWPOLY.GT.0) NPOLY = MIN(MAXPOLY, NEWPOLY)
      IF( NEWPOLY.GT.NPOLY) THEN
	WRITE(*,*) CHAR(7),'** Maximum number of poly terms is', MAXPOLY
      END IF
	IF( NEWCYCLE.GT.0) NCYCLE = NEWCYCLE
	IF( THRHINEW.GT.0.) THRHI = THRHINEW
	IF( THRLONEW.LT.0.) THRLO = THRLONEW
	GOTO 100

* polyfit with automatic reject cycles

  180	CALL POLYFITA( NDATA, XDATA, YDATA, YSIGMA, YFIT,
     #	NPOLY, NCYCLE, THRHI, THRLO, IFAIL )
	GOTO 10

* plot the fit and normalized residuals

  200	WRITE( TITLE, '(A,I3,A)')
     #	'weighted least-squares fit of', NPOLY, ' poly-terms'
	CALL PGELAB( XLABEL, YLABEL, TITLE )
	CALL PLTFIT( NDATA, XDATA, YDATA, YSIGMA, YFIT,
     #	XLABEL, YLABEL, TITLE )
	GOTO 10

* restore rejected data points

  300	IRESET = 0
      DO I=1,NDATA
	IF( YSIGMA(I).LE.0. ) IRESET = IRESET + 1
	YSIGMA(I) = ABS(YSIGMA(I))
      END DO
	WRITE(*,*) IRESET, ' rejected data pairs restored.'
	GOTO 100

* normal return

 1000	IFAIL = 0
	RETURN

* error return

  999	IFAIL = 1
	WRITE(*,*) 'POLYFITR aborted.'
	RETURN

	END
	SUBROUTINE POLYFIT1( NDATA, XDATA, YDATA, YSIGMA, 
     *		YFIT, NPOLY, IFAIL )
*
*  COMPUTES WEIGHTED LEAST-SQUARES POLY FIT TO DATA PAIRS
*
*  Input:
*	NDATA	I4 NUMBER OF DATA PAIRS
*	XDATA	R4 DATA X VALUES
*	YDATA	R4 DATA Y VALUES
*	YSIGMA	R4 UNCERTAINTY IN Y (1-SIGMA) (NEGATIVE TO REJECT)
*	NPOLY	I4 NUMBER OF POLY TERMS REQUESTED
*  Output:
*	YFIT	R4 FITTED Y VALUES
*	IFAIL	I4 0 IF SUCCESSFUL, 1 IF FAILED.
*
*	USES LSQUAR
*
* Jan 1995 KDH @ St.And - split common blocks, eliminate type
* Mar 1997 KDH @ St.And - MAXFIT -> 50000
* Jan 2012 KDH @ St.A - MAXPOLY 20 -> 30

	REAL*4 XDATA(*), YDATA(*), YSIGMA(*), YFIT(*)

	PARAMETER ( MAXFIT = 50000 )
	PARAMETER ( MAXPOLY = 30 )
	REAL*8 X(3,MAXFIT)
	REAL*8 PFT(MAXPOLY)
	REAL*8 XM(MAXPOLY,2*MAXPOLY+3)
	REAL*8 CHISQ, CALC, POLY, PFTX1, PFTX2
	LOGICAL SILENT
	COMMON/SILENT/  SILENT
	COMMON/NPFT/	NPFT
	COMMON/PFT/	PFT
	COMMON/PFTX1/	PFTX1
	COMMON/PFTX2/	PFTX2

*  Check input data

      IF(NDATA.LE.0) THEN
	WRITE(*,*)'** POLYFIT1: No data.', NDATA
	GOTO 999
      END IF

* Error return if NPOLY > NFIT OR MAXPOLY

	NFIT=0
      DO I=1,NDATA
	IF( YSIGMA(I) .GT. 0. ) NFIT = NFIT + 1
      END DO
      IF( NPOLY .GT. NFIT ) THEN
	WRITE(*,*)'** POLYFIT1: INSUFFICIENT DATA. NPOLY=', 
     &		NPOLY, 'NFIT=', NFIT
	GOTO 999
      ELSE IF( NPOLY .GT. MAXPOLY ) THEN
	WRITE(*,*)'** POLYFIT1: TOO MANY POLY TERMS. NPOLY=', 
     &		NPOLY, 'MAXPOLY=', MAXPOLY
	GOTO 999
      END IF

* Decide in which direction to load the data values
* Forward loading
      IF( XDATA(1) .LT. XDATA(NDATA) ) THEN
        ISTEP = 1
        IGET1 = 1
        IGET2 = NDATA
* Backward loading
      ELSE
        ISTEP = -1
        IGET1 = NDATA
        IGET2 = 1
      END IF

*  Load data arrays for poly fit
      IF( NFIT.LE.MAXFIT ) THEN
	IPUT = 0
      DO IGET= IGET1, IGET2, ISTEP
* Load only data with positive sigma
	IF( YSIGMA(IGET).GT.0.) THEN
	  IPUT = IPUT + 1
	  X(1,IPUT) = XDATA(IGET)
	  X(2,IPUT) = YDATA(IGET)
	  X(3,IPUT) = YSIGMA(IGET)
	END IF
      END DO
	NFIT = IPUT

*  Too much data, some points must be skipped
      ELSE 
	WRITE(*,*)'** WARNING: Too much data for POLYFIT1.',
     #		NFIT, MAXFIT
	WRITE(*,*)'** Interspersed data will be skipped.'
	IGET = IGET1
	IPUT = 0
	IGOT = 0
	DO I=1,MAXFIT
	  PART = (I-1.)/(MAXFIT-1.)
	  IWISH = NINT( 1.-PART + NFIT*PART )
   30     IF(IWISH .GT. IGOT ) THEN
   32       IF( YSIGMA(IGET).LE.0. ) THEN
	      IGET = IGET + ISTEP
	      GOTO 32
	    END IF
	    IGOT = IGOT + 1
	    GOTO 30
	  END IF
	  IPUT = IPUT + 1
	  X(1,IPUT) = XDATA(IGET)
	  X(2,IPUT) = YDATA(IGET)
	  X(3,IPUT) = YSIGMA(IGET)
        END DO
	NFIT = IPUT
      END IF

*  Re-scale weights to their RMS value
	CALC = 0.D0
      DO I = 1,NFIT
	CALC = CALC + X(3,I)*X(3,I)
      END DO
	RMS = SQRT(CALC/NFIT)
      DO I=1,NFIT
	X(3,I) = X(3,I)/RMS
      END DO

*  Call LSQUAR routine to compute poly fit
	CALL LSQUAR(X,NFIT,NPOLY,PFT,CHISQ,XM,1)

*  Evaluate poly at required points
	DO I=1,NDATA
	  YFIT(I) = SNGL( POLY( PFT, NPOLY, DBLE(XDATA(I)) ))
	END DO
	NPFT = NPOLY
c	if( .not. silent ) write(*,*) 'POLYFIT1 NPFT=', npft, npoly
	PFTX1 = X(1,1)
	PFTX2   = PFTX1
	DO I=1,NFIT
	  PFTX1 = MIN(PFTX1,X(1,I))
	  PFTX2   = MAX(PFTX2,  X(1,I))
	END DO

* normal return
	IFAIL = 0
	RETURN

* error return
  999	WRITE(*,*)'** POLYFIT1 aborted.'
	IFAIL = 1
	RETURN
	END
	SUBROUTINE POLYCALC( NDATA, XDATA, YFIT, IFAIL )
*
* CALCUALTES POLY FIT FROM 'POLYFIT1' AT ALL POINTS REQUESTED
* EXTRAPOLATES LINEARLY OUTSIDE THE RANG OF THE FIT.
*
*  Input:
*	NDATA	= NUMBER OF DATA PAIRS
*	XDATA	= DATA X VALUES 
*  Output:
*	YFIT	= CORRESPONDING Y VALUE OF POLY FIT
*	IFAIL	= 0 IF SUCCESSFUL, 1 IF FAILED.
*
* 1995 Jan KDH @ St.And - split up common, eliminate type
* 2009 Aug KDH @ St.A - MAXPOLY = 20 
* 2012 Jan KDH @ St.A - MAXPOLY 20->30 
* 2020 Apr KDH @ St.A - This extrapolates linearly outside range of fit
* 2020 Apr KDH @ St.A - ENTRY POLYCALC0 and POLYCALC1

	PARAMETER( MAXPOLY = 30 )
	REAL*4 XDATA(*), YFIT(*)
	REAL*8 PFT( MAXPOLY )
	REAL*8 DUM( MAXPOLY )
	REAL*8 POLY, PFTX1, PFTX2, DSTART,DEND, START, END
	COMMON/NPFT/	NPFT
	COMMON/PFTX1/	PFTX1
	COMMON/PFTX2/	PFTX2
	COMMON/PFT/	PFT
	LOGICAL EXTRAPOLATE

	EXTRAPOLATE = .TRUE.
	GOTO 10

	ENTRY POLYCALC0( NDATA, XDATA, YFIT, IFAIL )
	EXTRAPOLATE = .FALSE.
	GOTO 10

	ENTRY POLYCALC1( NDATA, XDATA, YFIT, IFAIL )
	EXTRAPOLATE = .TRUE.
   10	CONTINUE


      IF( NDATA.LE.0) THEN
	WRITE(*,*) '** POLYCALC NDATA =', NDATA
	GOTO 999
      END IF

      IF( NPFT .LE. 0 ) THEN
	WRITE(*,*) '** POLYCALC NPFT =', NPFT
      END IF

c	WRITE(*,*) '** POLYCALC NPFT =', NPFT

*  Extrapolate linearly outside range used for poly fit
	IF( EXTRAPOLATE ) THEN
	DO I = 1, NPFT - 1
	  DUM(I) = PFT( I + 1 ) * DBLE( I )
	END DO
* Evaluate derivatives at PFTX1,PFTX2, and value of poly.
	START  = POLY( PFT, NPFT  , PFTX1 )
	END    = POLY( PFT, NPFT  , PFTX2 )
	DSTART = POLY( DUM, NPFT-1, PFTX1 )
	DEND   = POLY( DUM, NPFT-1, PFTX2 )

*  Loop thru the data
        DO I = 1, NDATA
	IF( DBLE( XDATA(I) ) .LT. PFTX1 ) THEN
	  YFIT(I) = SNGL( START - DSTART * ( PFTX1 - DBLE( XDATA(I) ) ) )
	ELSE IF( DBLE( XDATA(I) ) .GT. PFTX2 ) THEN
	  YFIT(I) = SNGL( END + DEND * ( DBLE( XDATA(I) ) - PFTX2 ) ) 
	ELSE
	  YFIT(I) = SNGL( POLY( PFT, NPFT, DBLE( XDATA(I) ) ) )
	END IF
	END DO

*  Evaluate poly at desired x-values
	ELSE
        DO I = 1, NDATA
	  YFIT(I) = SNGL( POLY( PFT, NPFT, DBLE( XDATA(I) ) ) )
	END DO
	END IF

* normal return
 1000	IFAIL = 0
	RETURN

* error return
  999	IFAIL = 1
	WRITE(*,*) 'POLYCALC aborted.'
	RETURN
	END
      FUNCTION POLY(A,N,X)
C
C               N
C  EVALUATES   SUM A(J) * X**(J-1)
C              J=1
* 2001 Jul Keith Horne @ St.Andrews - A(*), no TYPE
      REAL*8 POLY, X, A(*)
C 
      IF(N.LT.1) THEN
      POLY=0.D0
      WRITE(*,*) '*** N WAS NONPOSITIVE IN POLY ***', N
      RETURN
      END IF
C
      GOTO (1,2,3,4,5,6,7,8,9,10,11) N
C
      POLY=A(N)
      IF(N.LE.1) RETURN
      IC=N
      DO 100 I=2,N
      IC=IC-1
      POLY=POLY*X+A(IC)
  100 CONTINUE
      RETURN
C
    1 POLY=A(1)
      RETURN
C
    2 POLY=X*A(2)+A(1)
      RETURN
C
    3 POLY=X*(X*A(3)+A(2))+A(1)
      RETURN
C
    4 POLY=X*(X*(X*A(4)+A(3))+A(2))+A(1)
      RETURN
C
    5 POLY=X*(X*(X*(X*A(5)+A(4))+A(3))+A(2))+A(1)
      RETURN
C
    6 POLY=X*(X*(X*(X*(X*A(6)+A(5))+A(4))+A(3))+A(2))+A(1)
      RETURN
C
    7 POLY=X*(X*(X*(X*(X*(X*A(7)+A(6))+A(5))+A(4))+A(3))+A(2))+A(1)
      RETURN
C
    8 POLY=X*(X*(X*(X*(X*(X*(X*A(8)+A(7))+A(6))+A(5))+A(4))+A(3))
     #+A(2))+A(1)
      RETURN
C
    9 POLY=X*(X*(X*(X*(X*(X*(X*(X*A(9)+A(8))+A(7))+A(6))+A(5))+A(4))
     #+A(3))+A(2))+A(1)
      RETURN
C
   10 POLY=X*(X*(X*(X*(X*(X*(X*(X*(X*A(10)+A(9))+A(8))+A(7))+A(6))
     #+A(5))+A(4))+A(3))+A(2))+A(1)
      RETURN
C
   11 POLY=X*(X*(X*(X*(X*(X*(X*(X*(X*(X*A(11)+A(10))+A(9))+A(8))
     #+A(7))+A(6))+A(5))+A(4))+A(3))+A(2))+A(1)
      RETURN
C
      END
      FUNCTION POLY4(N,A,X)
C               N
C  EVALUATES   SUM A(J) * X**(J-1)
C              J=1
* 2001 Jul Keith Horne @ St.Andrews - A(*), no TYPE
* 2016 Sep KDH @ StA - real*4 version POLY4 adapted from POLY
      REAL*4 POLY4, X, A(*)
	REAL*8 POLY

* TRAP INVALID INPUT 
      IF( N .LT. 1 ) THEN
	POLY4 = 0.D0
	WRITE(*,*) '*** N WAS NONPOSITIVE IN POLY ***', N
	RETURN
      END IF
* HARDWIRE FOR N = 1 ... 11
	GOTO (1,2,3,4,5,6,7,8,9,10,11) N

* LOOP FOR N > 11
	POLY = A( N )
	IC = N
      DO I = 2, N
	IC = IC - 1
	POLY = A( IC ) + X * POLY
      END DO
	GOTO 100

    1 POLY=A(1)
	GOTO 100
    2 POLY=X*A(2)+A(1)
	GOTO 100
    3 POLY=X*(X*A(3)+A(2))+A(1)
	GOTO 100
    4 POLY=X*(X*(X*A(4)+A(3))+A(2))+A(1)
	GOTO 100
    5 POLY=X*(X*(X*(X*A(5)+A(4))+A(3))+A(2))+A(1)
	GOTO 100
    6 POLY=X*(X*(X*(X*(X*A(6)+A(5))+A(4))+A(3))+A(2))+A(1)
	GOTO 100
    7 POLY=X*(X*(X*(X*(X*(X*A(7)+A(6))+A(5))+A(4))+A(3))+A(2))+A(1)
	GOTO 100
    8 POLY=X*(X*(X*(X*(X*(X*(X*A(8)+A(7))+A(6))+A(5))+A(4))+A(3))
     #+A(2))+A(1)
	GOTO 100
    9 POLY=X*(X*(X*(X*(X*(X*(X*(X*A(9)+A(8))+A(7))+A(6))+A(5))+A(4))
     #+A(3))+A(2))+A(1)
	GOTO 100
   10 POLY=X*(X*(X*(X*(X*(X*(X*(X*(X*A(10)+A(9))+A(8))+A(7))+A(6))
     #+A(5))+A(4))+A(3))+A(2))+A(1)
	GOTO 100
   11 POLY=X*(X*(X*(X*(X*(X*(X*(X*(X*(X*A(11)+A(10))+A(9))+A(8))
     #+A(7))+A(6))+A(5))+A(4))+A(3))+A(2))+A(1)

  100 POLY4 = POLY
      RETURN
      END

	SUBROUTINE REJECT( NDATA, DATA, SIGMA, FIT, 
     &			THRHI, THRLO, RMS, NREJ )
*
*  FLAGS OUTLIERS BY MAKING SIGMA NEGATIVE
*
*  Input:
*	NDATA	= NUMBER OF DATA VALUES
*	DATA	= DATA VALUES
*	SIGMA	= UNCERTAINTIES
*	FIT	= PREDICTED DATA VALUES
*	THRHI	= HIGH REJECT THRESHOLD
*	THRLO	= LOW REJECT THRESHOLD
*  Output:
*	RMS	= RMS RESIDUAL OF POINTS NOT REJECTED
*	NREJ	= NUMBER OF REJECTED DATA POINTS
*
*  JULY 1984 BY KEITH HORNE
* 2001 Jul KDH @ St.And - eliminate TYPE
* 2010 Mar KDH @ LCO - logical good
	REAL*4 DATA(*), SIGMA(*), FIT(*)
	REAL*8 sum
	logical good

      IF( NDATA.LE.0) THEN
	WRITE(*,*) '** No data.'
	GOTO 999
      END IF

* Compute scale-up factor for uncertainties

	sum = 0.D0
	NSUM = 0
      DO I=1,NDATA
      IF(SIGMA(I).GT.0.) THEN
	NSUM = NSUM + 1
	eta = ( DATA(I) - FIT(I) ) / SIGMA(I)
	sum = sum + eta * eta
      END IF
      END DO
	RMS = 1.
	IF( NSUM.GT.0 ) RMS = SQRT(sum/NSUM)

* Reject outlying data

	THI = THRHI * RMS
	TLO = THRLO * RMS
	sum = 0.D0
	NREJ = 0
      DO I=1,NDATA
	good = sigma(i) .gt. 0.
      if( good ) then
	eta = ( DATA(I) - FIT(I) ) / SIGMA(I)
	good = eta .le. thi .and. eta .ge. tlo
      end if
      if( good ) then
	sum = sum + eta * eta
      else
	NREJ = NREJ + 1
	SIGMA(I) = - ABS(SIGMA(I))
      end if
      END DO
c	RMS = 1.
c	IF( NREJ.LT.NDATA ) RMS = SQRT(sum/(NDATA-NREJ))
	RMS = SQRT(sum/max(1,NDATA-NREJ))

* normal return

	RETURN

* error return

  999	WRITE(*,*) '** REJECT aborted.'
	RETURN

	END
*================================================
	subroutine fe2spec( nw, w_w, f_w, ufac, ofac, sigkms, sigang )
* evaluate blurred FeII spectrum on given wavelength grid
* In:	nw	i4 number of wavelengths
*	w_w(nw)	r8 wavelengths
*	ufac	r4 uv scale factor
*	ofac	r4 optical scale factor
*	sigkms	r4 velocity dispersion (km/s)
*	sigang	r4 spectral resolution (Angstroms)
* Out:	f_w(nw)	r4 fe2 spectrum
* 2018 Mar Keith Horne @ St-Andrews
* 2018 Oct KDH @ StA - getfe2uv, getfe2opt
* 2018 Oct KDH @ StA - ufac, ofac

	real*8 w_w( nw )
	real*4 f_w( nw )
	parameter( maxw = 10000 )
	real*4 wopt( maxw )
	real*4 fopt( maxw )
	real*4 wuv( maxw )
	real*4 fuv( maxw )
	real*8 sum, sumg
	logical firstcall/.true./
	logical optical
* sanity checks
	if( nw .le. 0 ) return
* first call
      if( firstcall ) then
* fe2 optical data
	nopt = maxw
	call getfe2opt( nopt, wopt, fopt )
      if( nopt .ge. maxw ) then
	write(*,*) '** WARNING : fe2opt OVERFLOW', maxw
      end if
* fe2 uv data
	nuv = maxw
	call getfe2uv( nuv, wuv, fuv )
      if( nuv .ge. maxw ) then
	write(*,*) '** WARNING : fe2uv OVERFLOW', maxw
      end if

* rescale 
	sum = 0.d0
      do i = 1, nuv
	sum = sum + fuv( i )
      end do
	uv = sum / nuv
	sum = 0.d0
      do i = 1, nopt
	sum = sum + fopt( i )
      end do
	opt = sum / nopt
	div = sqrt( uv ) * sqrt( opt )
      do i = 1, nuv
	fuv( i ) = fuv( i ) / div
      end do
      do i = 1, nopt
	fopt( i ) = fopt( i ) / div
      end do

* light speed
	ckms = cgs( 'C' ) / cgs( 'KMS' )
	firstcall = .false. 
      end if
* report
c	write(*,*) '* fe2spec'
c	write(*,*) 'Nuv ', nuv, 10.**wuv(1), 10.**wuv(nuv)
c	write(*,*) 'Nopt', nopt, 10.**wopt(1), 10.**wopt(nopt)

	beta = sigkms / ckms
	ww = sigang * sigang

* wavelength loop
      do iw = 1, nw
	w = w_w( iw )
	fe2 = 0.
* dispersion (Angstroms)
	wkms = w * beta
	wrms = sqrt( ww + wkms * wkms )
* range for gaussian
	add = wrms * 6
	wm = w - add
	wp = w + add
* optical/uv loop
	iu = 1
	io = 2
      do iou = 1,2
	optical = iou .eq. io
      if( optical ) then
	n = nopt
	wlog1 = wopt( 1 )
	wlog2 = wopt( nopt )
      else
	n = nuv
	wlog1 = wuv( 1 )
	wlog2 = wuv( nuv )
      end if
	dwlog = ( wlog2 - wlog1 ) / max( 1, n - 1 )
	wlo = 10. ** wlog1
	whi = 10. ** wlog2
* inside fe2 range
      if( wp .gt. wlo .and. wm .lt. whi ) then	
* calculate pixel range
	p = ( alog10( wm ) - wlog1 ) / ( wlog2 - wlog1 )
	p = 1 + p * ( n - 1 )
	ilo = nint( p )
	p = ( alog10( wp ) - wlog1 ) / ( wlog2 - wlog1 )
	p = 1 + p * ( n - 1 )
	ihi = nint( p )
* convolve with a gaussian line profile
	sum  = 0.d0
	sumg = 0.d0
      do i = ilo, ihi
	f = 0.
	wi = 10. ** ( wlog1 + ( i - 1 ) * dwlog )
      if( i .ge. 1 .and. i .le. n ) then
      if( optical ) then
	f = ofac * fopt( i )
c	wi = wopt( i )
      else
	f = ufac * fuv( i )
c	wi = wuv( i )
      end if
      end if
* KDH : SHOULD IT BE A GAUSSIAN IN LOG(LAM) ?
	x = ( w - wi ) / wrms
	g = exp( - 0.5 * x * x )
	sum  = sum  + g * f
	sumg = sumg + g
      end do
	if( sumg .ne. 0.d0 ) fe2 = fe2 + sum / sumg
      end if
* end opt/uv loop
      end do
* stow 
	f_w( iw ) = fe2
* next wavelength
      end do

	return
	end
*================================================
      subroutine getfe2uv( n, x, y )
      real*4 x(n), y(n)
      real*4 xin( 2982 ), yin( 2982 )
      data( xin(i), yin(i), i = 1 , 50 ) /
     & 3.096950 , 0.0000000E+00 , 3.097100 , 5.5837201E-16 ,
     & 3.097250 , 1.9930899E-15 , 3.097400 , 1.0670700E-15 ,
     & 3.097550 , 1.0410000E-15 , 3.097700 , 1.6069400E-16 ,
     & 3.097850 , 2.3654401E-15 , 3.098000 , 2.7727001E-15 ,
     & 3.098150 , 3.7206202E-15 , 3.098300 , 6.0232199E-15 ,
     & 3.098450 , 6.7699900E-15 , 3.098600 , 4.9641399E-15 ,
     & 3.098750 , 4.3099802E-15 , 3.098900 , 0.0000000E+00 ,
     & 3.099050 , 0.0000000E+00 , 3.099200 , 0.0000000E+00 ,
     & 3.099350 , 0.0000000E+00 , 3.099500 , 0.0000000E+00 ,
     & 3.099650 , 0.0000000E+00 , 3.099800 , 0.0000000E+00 ,
     & 3.099950 , 0.0000000E+00 , 3.100100 , 0.0000000E+00 ,
     & 3.100250 , 0.0000000E+00 , 3.100400 , 0.0000000E+00 ,
     & 3.100550 , 0.0000000E+00 , 3.100700 , 0.0000000E+00 ,
     & 3.100850 , 0.0000000E+00 , 3.101000 , 0.0000000E+00 ,
     & 3.101150 , 0.0000000E+00 , 3.101300 , 0.0000000E+00 ,
     & 3.101450 , 0.0000000E+00 , 3.101600 , 0.0000000E+00 ,
     & 3.101750 , 0.0000000E+00 , 3.101900 , 0.0000000E+00 ,
     & 3.102050 , 0.0000000E+00 , 3.102200 , 0.0000000E+00 ,
     & 3.102350 , 0.0000000E+00 , 3.102500 , 0.0000000E+00 ,
     & 3.102650 , 0.0000000E+00 , 3.102800 , 0.0000000E+00 ,
     & 3.102950 , 5.7161103E-16 , 3.103100 , 2.0825000E-15 ,
     & 3.103250 , 3.3631699E-15 , 3.103400 , 2.7946800E-15 ,
     & 3.103550 , 2.2729000E-15 , 3.103700 , 7.8519703E-17 ,
     & 3.103850 , 5.6070198E-18 , 3.104000 , 2.2910901E-15 ,
     & 3.104150 , 2.6224900E-15 , 3.104300 , 2.8209001E-15 /
      data( xin(i), yin(i), i = 51 , 100 ) /
     & 3.104450 , 3.4455200E-15 , 3.104600 , 3.6959499E-15 ,
     & 3.104750 , 4.2049299E-15 , 3.104900 , 4.8281001E-15 ,
     & 3.105050 , 3.6610399E-15 , 3.105200 , 4.6891901E-15 ,
     & 3.105350 , 5.9928000E-15 , 3.105500 , 6.2494298E-15 ,
     & 3.105650 , 3.2764799E-15 , 3.105800 , 6.5499703E-16 ,
     & 3.105950 , 0.0000000E+00 , 3.106100 , 0.0000000E+00 ,
     & 3.106250 , 0.0000000E+00 , 3.106400 , 0.0000000E+00 ,
     & 3.106550 , 0.0000000E+00 , 3.106700 , 0.0000000E+00 ,
     & 3.106850 , 0.0000000E+00 , 3.107000 , 0.0000000E+00 ,
     & 3.107150 , 0.0000000E+00 , 3.107300 , 0.0000000E+00 ,
     & 3.107450 , 0.0000000E+00 , 3.107600 , 0.0000000E+00 ,
     & 3.107750 , 4.1102200E-16 , 3.107900 , 1.1197700E-15 ,
     & 3.108050 , 1.3404900E-15 , 3.108200 , 2.2469999E-15 ,
     & 3.108350 , 3.2338299E-15 , 3.108500 , 2.3942401E-15 ,
     & 3.108650 , 1.8419500E-15 , 3.108800 , 9.9353397E-16 ,
     & 3.108950 , 1.4756300E-15 , 3.109100 , 2.9634401E-15 ,
     & 3.109250 , 3.5485399E-15 , 3.109400 , 4.1255798E-15 ,
     & 3.109550 , 3.7606700E-15 , 3.109700 , 4.4647098E-15 ,
     & 3.109850 , 3.3799700E-15 , 3.110000 , 2.3983600E-15 ,
     & 3.110150 , 1.8593599E-15 , 3.110300 , 1.1776000E-15 ,
     & 3.110450 , 1.7078800E-15 , 3.110600 , 7.5377398E-16 ,
     & 3.110750 , 2.6410900E-15 , 3.110900 , 2.4693700E-15 ,
     & 3.111050 , 1.1395000E-15 , 3.111200 , 1.2821400E-16 ,
     & 3.111350 , 0.0000000E+00 , 3.111500 , 0.0000000E+00 ,
     & 3.111650 , 0.0000000E+00 , 3.111800 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 101 , 150 ) /
     & 3.111950 , 0.0000000E+00 , 3.112100 , 0.0000000E+00 ,
     & 3.112250 , 0.0000000E+00 , 3.112400 , 0.0000000E+00 ,
     & 3.112550 , 0.0000000E+00 , 3.112700 , 0.0000000E+00 ,
     & 3.112850 , 0.0000000E+00 , 3.113000 , 0.0000000E+00 ,
     & 3.113150 , 0.0000000E+00 , 3.113300 , 0.0000000E+00 ,
     & 3.113450 , 0.0000000E+00 , 3.113600 , 0.0000000E+00 ,
     & 3.113750 , 0.0000000E+00 , 3.113900 , 0.0000000E+00 ,
     & 3.114050 , 0.0000000E+00 , 3.114200 , 0.0000000E+00 ,
     & 3.114350 , 0.0000000E+00 , 3.114500 , 0.0000000E+00 ,
     & 3.114650 , 0.0000000E+00 , 3.114800 , 0.0000000E+00 ,
     & 3.114950 , 0.0000000E+00 , 3.115100 , 0.0000000E+00 ,
     & 3.115250 , 0.0000000E+00 , 3.115400 , 0.0000000E+00 ,
     & 3.115550 , 0.0000000E+00 , 3.115700 , 0.0000000E+00 ,
     & 3.115850 , 0.0000000E+00 , 3.116000 , 0.0000000E+00 ,
     & 3.116150 , 0.0000000E+00 , 3.116300 , 0.0000000E+00 ,
     & 3.116450 , 0.0000000E+00 , 3.116600 , 0.0000000E+00 ,
     & 3.116750 , 0.0000000E+00 , 3.116900 , 0.0000000E+00 ,
     & 3.117050 , 0.0000000E+00 , 3.117200 , 0.0000000E+00 ,
     & 3.117350 , 0.0000000E+00 , 3.117500 , 0.0000000E+00 ,
     & 3.117650 , 0.0000000E+00 , 3.117800 , 0.0000000E+00 ,
     & 3.117950 , 0.0000000E+00 , 3.118100 , 0.0000000E+00 ,
     & 3.118250 , 0.0000000E+00 , 3.118400 , 0.0000000E+00 ,
     & 3.118550 , 0.0000000E+00 , 3.118700 , 0.0000000E+00 ,
     & 3.118850 , 0.0000000E+00 , 3.119000 , 0.0000000E+00 ,
     & 3.119150 , 0.0000000E+00 , 3.119300 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 151 , 200 ) /
     & 3.119450 , 0.0000000E+00 , 3.119600 , 0.0000000E+00 ,
     & 3.119750 , 0.0000000E+00 , 3.119900 , 0.0000000E+00 ,
     & 3.120050 , 0.0000000E+00 , 3.120200 , 0.0000000E+00 ,
     & 3.120350 , 0.0000000E+00 , 3.120500 , 0.0000000E+00 ,
     & 3.120650 , 0.0000000E+00 , 3.120800 , 0.0000000E+00 ,
     & 3.120950 , 0.0000000E+00 , 3.121100 , 0.0000000E+00 ,
     & 3.121250 , 0.0000000E+00 , 3.121400 , 0.0000000E+00 ,
     & 3.121550 , 0.0000000E+00 , 3.121700 , 0.0000000E+00 ,
     & 3.121850 , 0.0000000E+00 , 3.122000 , 0.0000000E+00 ,
     & 3.122150 , 0.0000000E+00 , 3.122300 , 0.0000000E+00 ,
     & 3.122450 , 0.0000000E+00 , 3.122600 , 0.0000000E+00 ,
     & 3.122750 , 0.0000000E+00 , 3.122900 , 0.0000000E+00 ,
     & 3.123050 , 0.0000000E+00 , 3.123200 , 0.0000000E+00 ,
     & 3.123350 , 0.0000000E+00 , 3.123500 , 0.0000000E+00 ,
     & 3.123650 , 0.0000000E+00 , 3.123800 , 0.0000000E+00 ,
     & 3.123950 , 0.0000000E+00 , 3.124100 , 0.0000000E+00 ,
     & 3.124250 , 0.0000000E+00 , 3.124400 , 0.0000000E+00 ,
     & 3.124550 , 0.0000000E+00 , 3.124700 , 0.0000000E+00 ,
     & 3.124850 , 0.0000000E+00 , 3.125000 , 0.0000000E+00 ,
     & 3.125150 , 0.0000000E+00 , 3.125300 , 0.0000000E+00 ,
     & 3.125450 , 0.0000000E+00 , 3.125600 , 0.0000000E+00 ,
     & 3.125750 , 0.0000000E+00 , 3.125900 , 0.0000000E+00 ,
     & 3.126050 , 0.0000000E+00 , 3.126200 , 0.0000000E+00 ,
     & 3.126350 , 0.0000000E+00 , 3.126500 , 0.0000000E+00 ,
     & 3.126650 , 0.0000000E+00 , 3.126800 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 201 , 250 ) /
     & 3.126950 , 0.0000000E+00 , 3.127100 , 0.0000000E+00 ,
     & 3.127250 , 0.0000000E+00 , 3.127400 , 0.0000000E+00 ,
     & 3.127550 , 0.0000000E+00 , 3.127700 , 0.0000000E+00 ,
     & 3.127850 , 0.0000000E+00 , 3.128000 , 0.0000000E+00 ,
     & 3.128150 , 0.0000000E+00 , 3.128300 , 0.0000000E+00 ,
     & 3.128450 , 0.0000000E+00 , 3.128600 , 0.0000000E+00 ,
     & 3.128750 , 0.0000000E+00 , 3.128900 , 0.0000000E+00 ,
     & 3.129050 , 0.0000000E+00 , 3.129200 , 0.0000000E+00 ,
     & 3.129350 , 0.0000000E+00 , 3.129500 , 0.0000000E+00 ,
     & 3.129650 , 0.0000000E+00 , 3.129800 , 0.0000000E+00 ,
     & 3.129950 , 0.0000000E+00 , 3.130100 , 0.0000000E+00 ,
     & 3.130250 , 0.0000000E+00 , 3.130400 , 0.0000000E+00 ,
     & 3.130550 , 0.0000000E+00 , 3.130700 , 0.0000000E+00 ,
     & 3.130850 , 0.0000000E+00 , 3.131000 , 0.0000000E+00 ,
     & 3.131150 , 0.0000000E+00 , 3.131300 , 0.0000000E+00 ,
     & 3.131450 , 0.0000000E+00 , 3.131600 , 8.7112601E-16 ,
     & 3.131750 , 1.5256600E-15 , 3.131900 , 2.1471999E-15 ,
     & 3.132050 , 3.1239600E-15 , 3.132200 , 3.1577100E-15 ,
     & 3.132350 , 2.6045001E-15 , 3.132500 , 3.0113999E-15 ,
     & 3.132650 , 3.1183800E-15 , 3.132800 , 3.4509600E-15 ,
     & 3.132950 , 3.9391102E-15 , 3.133100 , 5.1544000E-15 ,
     & 3.133250 , 6.7622401E-15 , 3.133400 , 6.3488999E-15 ,
     & 3.133550 , 4.7310398E-15 , 3.133700 , 4.6780698E-15 ,
     & 3.133850 , 5.2074400E-15 , 3.134000 , 4.9839198E-15 ,
     & 3.134150 , 5.5292100E-15 , 3.134300 , 5.3359599E-15 /
      data( xin(i), yin(i), i = 251 , 300 ) /
     & 3.134450 , 5.7397299E-15 , 3.134600 , 4.8899398E-15 ,
     & 3.134750 , 3.5004200E-15 , 3.134900 , 3.9131999E-15 ,
     & 3.135050 , 4.4173501E-15 , 3.135200 , 4.1888299E-15 ,
     & 3.135350 , 3.1476699E-15 , 3.135500 , 2.4330500E-15 ,
     & 3.135650 , 3.0198400E-15 , 3.135800 , 1.7643100E-15 ,
     & 3.135950 , 1.6538500E-15 , 3.136100 , 1.7818200E-15 ,
     & 3.136250 , 4.5500200E-15 , 3.136400 , 2.1585599E-15 ,
     & 3.136550 , 7.3037698E-16 , 3.136700 , 2.4099301E-15 ,
     & 3.136850 , 2.7986699E-15 , 3.137000 , 1.3537900E-15 ,
     & 3.137150 , 1.3484700E-15 , 3.137300 , 1.4360601E-16 ,
     & 3.137450 , 1.8307400E-15 , 3.137600 , 1.5322500E-15 ,
     & 3.137750 , 6.2314298E-16 , 3.137900 , 4.1006001E-16 ,
     & 3.138050 , 2.3632300E-15 , 3.138200 , 3.0189499E-15 ,
     & 3.138350 , 1.9648001E-15 , 3.138500 , 3.7630500E-16 ,
     & 3.138650 , 5.8729702E-16 , 3.138800 , 1.9563500E-16 ,
     & 3.138950 , 0.0000000E+00 , 3.139100 , 0.0000000E+00 ,
     & 3.139250 , 0.0000000E+00 , 3.139400 , 2.0019101E-15 ,
     & 3.139550 , 3.5555601E-15 , 3.139700 , 1.2699800E-15 ,
     & 3.139850 , 3.1688199E-16 , 3.140000 , 3.9792499E-16 ,
     & 3.140150 , 2.4581301E-16 , 3.140300 , 2.9748000E-15 ,
     & 3.140450 , 2.6983700E-15 , 3.140600 , 9.1535102E-16 ,
     & 3.140750 , 2.4744901E-15 , 3.140900 , 3.3561800E-15 ,
     & 3.141050 , 4.0721702E-15 , 3.141200 , 3.8600299E-15 ,
     & 3.141350 , 1.5026200E-15 , 3.141500 , 9.9697697E-17 ,
     & 3.141650 , 0.0000000E+00 , 3.141800 , 8.3082301E-16 /
      data( xin(i), yin(i), i = 301 , 350 ) /
     & 3.141950 , 1.2741200E-15 , 3.142100 , 6.2526500E-16 ,
     & 3.142250 , 3.6181200E-16 , 3.142400 , 2.9242399E-16 ,
     & 3.142550 , 1.1919200E-15 , 3.142700 , 1.6371300E-15 ,
     & 3.142850 , 1.7213700E-15 , 3.143000 , 1.1536800E-15 ,
     & 3.143150 , 0.0000000E+00 , 3.143300 , 0.0000000E+00 ,
     & 3.143450 , 0.0000000E+00 , 3.143600 , 0.0000000E+00 ,
     & 3.143750 , 0.0000000E+00 , 3.143900 , 0.0000000E+00 ,
     & 3.144050 , 0.0000000E+00 , 3.144200 , 0.0000000E+00 ,
     & 3.144350 , 4.1601899E-16 , 3.144500 , 6.7078900E-16 ,
     & 3.144650 , 2.2354099E-15 , 3.144800 , 2.1625799E-15 ,
     & 3.144950 , 1.2414600E-15 , 3.145100 , 1.3410799E-15 ,
     & 3.145250 , 0.0000000E+00 , 3.145400 , 0.0000000E+00 ,
     & 3.145550 , 0.0000000E+00 , 3.145700 , 0.0000000E+00 ,
     & 3.145850 , 0.0000000E+00 , 3.146000 , 0.0000000E+00 ,
     & 3.146150 , 0.0000000E+00 , 3.146300 , 0.0000000E+00 ,
     & 3.146450 , 0.0000000E+00 , 3.146600 , 0.0000000E+00 ,
     & 3.146750 , 0.0000000E+00 , 3.146900 , 0.0000000E+00 ,
     & 3.147050 , 0.0000000E+00 , 3.147200 , 0.0000000E+00 ,
     & 3.147350 , 0.0000000E+00 , 3.147500 , 0.0000000E+00 ,
     & 3.147650 , 0.0000000E+00 , 3.147800 , 0.0000000E+00 ,
     & 3.147950 , 0.0000000E+00 , 3.148100 , 0.0000000E+00 ,
     & 3.148250 , 0.0000000E+00 , 3.148400 , 0.0000000E+00 ,
     & 3.148550 , 0.0000000E+00 , 3.148700 , 0.0000000E+00 ,
     & 3.148850 , 0.0000000E+00 , 3.149000 , 0.0000000E+00 ,
     & 3.149150 , 0.0000000E+00 , 3.149300 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 351 , 400 ) /
     & 3.149450 , 0.0000000E+00 , 3.149600 , 0.0000000E+00 ,
     & 3.149750 , 0.0000000E+00 , 3.149900 , 0.0000000E+00 ,
     & 3.150050 , 0.0000000E+00 , 3.150200 , 0.0000000E+00 ,
     & 3.150350 , 0.0000000E+00 , 3.150500 , 0.0000000E+00 ,
     & 3.150650 , 0.0000000E+00 , 3.150800 , 0.0000000E+00 ,
     & 3.150950 , 0.0000000E+00 , 3.151100 , 0.0000000E+00 ,
     & 3.151250 , 1.0346800E-15 , 3.151400 , 6.3880498E-16 ,
     & 3.151550 , 1.9599400E-15 , 3.151700 , 1.8670999E-15 ,
     & 3.151850 , 2.2340401E-15 , 3.152000 , 2.6732099E-15 ,
     & 3.152150 , 3.3604899E-15 , 3.152300 , 2.9121101E-15 ,
     & 3.152450 , 5.8119898E-15 , 3.152600 , 4.9284299E-15 ,
     & 3.152750 , 2.2027299E-15 , 3.152900 , 3.0827599E-15 ,
     & 3.153050 , 3.3694799E-15 , 3.153200 , 3.5255900E-15 ,
     & 3.153350 , 4.5934800E-15 , 3.153500 , 4.1328999E-15 ,
     & 3.153650 , 3.9444101E-15 , 3.153800 , 4.6964301E-15 ,
     & 3.153950 , 5.6981401E-15 , 3.154100 , 4.5469800E-15 ,
     & 3.154250 , 3.8793698E-15 , 3.154400 , 3.1349299E-15 ,
     & 3.154550 , 4.1093600E-15 , 3.154700 , 2.6474800E-15 ,
     & 3.154850 , 4.7547602E-15 , 3.155000 , 5.0431198E-15 ,
     & 3.155150 , 4.2555600E-15 , 3.155300 , 5.8269899E-15 ,
     & 3.155450 , 6.7098100E-15 , 3.155600 , 7.6825804E-15 ,
     & 3.155750 , 5.8577902E-15 , 3.155900 , 6.2943501E-15 ,
     & 3.156050 , 6.0360199E-15 , 3.156200 , 4.0971898E-15 ,
     & 3.156350 , 4.7306299E-15 , 3.156500 , 5.5768399E-15 ,
     & 3.156650 , 6.6255798E-15 , 3.156800 , 5.1878299E-15 /
      data( xin(i), yin(i), i = 401 , 450 ) /
     & 3.156950 , 3.2150899E-15 , 3.157100 , 4.2501699E-15 ,
     & 3.157250 , 3.4945500E-15 , 3.157400 , 2.6567900E-15 ,
     & 3.157550 , 4.4750398E-15 , 3.157700 , 5.6607898E-15 ,
     & 3.157850 , 7.4660000E-15 , 3.158000 , 3.9501199E-15 ,
     & 3.158150 , 4.1863701E-15 , 3.158300 , 6.8615200E-15 ,
     & 3.158450 , 5.2348199E-15 , 3.158600 , 5.2522002E-15 ,
     & 3.158750 , 5.0502400E-15 , 3.158900 , 4.7515800E-15 ,
     & 3.159050 , 4.8547100E-15 , 3.159200 , 4.1007601E-15 ,
     & 3.159350 , 4.8929502E-15 , 3.159500 , 6.5007500E-15 ,
     & 3.159650 , 6.0251101E-15 , 3.159800 , 5.6346000E-15 ,
     & 3.159950 , 5.9963199E-15 , 3.160100 , 5.5886899E-15 ,
     & 3.160250 , 5.0595700E-15 , 3.160400 , 5.5838601E-15 ,
     & 3.160550 , 6.2670998E-15 , 3.160700 , 5.3103202E-15 ,
     & 3.160850 , 4.8795899E-15 , 3.161000 , 4.9078000E-15 ,
     & 3.161150 , 5.1541701E-15 , 3.161300 , 5.3817200E-15 ,
     & 3.161450 , 4.8739500E-15 , 3.161600 , 4.9120999E-15 ,
     & 3.161750 , 6.2046701E-15 , 3.161900 , 5.9956499E-15 ,
     & 3.162050 , 5.5202802E-15 , 3.162200 , 7.3147300E-15 ,
     & 3.162350 , 5.8639202E-15 , 3.162500 , 5.1226100E-15 ,
     & 3.162650 , 5.1588698E-15 , 3.162800 , 5.0898502E-15 ,
     & 3.162950 , 3.9336498E-15 , 3.163100 , 3.7845699E-15 ,
     & 3.163250 , 4.2980298E-15 , 3.163400 , 4.1862499E-15 ,
     & 3.163550 , 4.7826398E-15 , 3.163700 , 5.2906199E-15 ,
     & 3.163850 , 4.6966401E-15 , 3.164000 , 3.7082099E-15 ,
     & 3.164150 , 3.1635899E-15 , 3.164300 , 3.7230999E-15 /
      data( xin(i), yin(i), i = 451 , 500 ) /
     & 3.164450 , 5.1659900E-15 , 3.164600 , 4.1874099E-15 ,
     & 3.164750 , 2.8713400E-15 , 3.164900 , 3.3659601E-15 ,
     & 3.165050 , 4.7150699E-15 , 3.165200 , 4.1619599E-15 ,
     & 3.165350 , 3.8968001E-15 , 3.165500 , 3.6661801E-15 ,
     & 3.165650 , 1.9760900E-15 , 3.165800 , 3.1028100E-15 ,
     & 3.165950 , 4.0067102E-15 , 3.166100 , 4.4070701E-15 ,
     & 3.166250 , 4.6256198E-15 , 3.166400 , 3.9290000E-15 ,
     & 3.166550 , 3.1047000E-15 , 3.166700 , 3.3548400E-15 ,
     & 3.166850 , 3.4989500E-15 , 3.167000 , 3.3825200E-15 ,
     & 3.167150 , 4.0695901E-15 , 3.167300 , 3.8718702E-15 ,
     & 3.167450 , 2.4992800E-15 , 3.167600 , 2.5836900E-15 ,
     & 3.167750 , 3.0145299E-15 , 3.167900 , 3.8906400E-15 ,
     & 3.168050 , 5.2142201E-15 , 3.168200 , 5.5064701E-15 ,
     & 3.168350 , 4.3280800E-15 , 3.168500 , 6.5330698E-15 ,
     & 3.168650 , 7.2216496E-15 , 3.168800 , 4.1040301E-15 ,
     & 3.168950 , 2.9191800E-15 , 3.169100 , 4.7034401E-15 ,
     & 3.169250 , 6.1780902E-15 , 3.169400 , 6.0212099E-15 ,
     & 3.169550 , 6.4189300E-15 , 3.169700 , 6.6825301E-15 ,
     & 3.169850 , 7.5003497E-15 , 3.170000 , 6.9057698E-15 ,
     & 3.170150 , 6.8776699E-15 , 3.170300 , 6.9681102E-15 ,
     & 3.170450 , 6.8598598E-15 , 3.170600 , 7.3894799E-15 ,
     & 3.170750 , 6.2452002E-15 , 3.170900 , 6.6872002E-15 ,
     & 3.171050 , 7.7722498E-15 , 3.171200 , 4.9764499E-15 ,
     & 3.171350 , 7.8979402E-15 , 3.171500 , 6.0457002E-15 ,
     & 3.171650 , 5.6725301E-15 , 3.171800 , 6.2247202E-15 /
      data( xin(i), yin(i), i = 501 , 550 ) /
     & 3.171950 , 3.8319699E-15 , 3.172100 , 3.5824200E-15 ,
     & 3.172250 , 2.8893501E-15 , 3.172400 , 2.2605399E-15 ,
     & 3.172550 , 2.2895800E-15 , 3.172700 , 2.1765700E-15 ,
     & 3.172850 , 2.1201499E-15 , 3.173000 , 1.0695200E-15 ,
     & 3.173150 , 2.4510700E-15 , 3.173300 , 3.6502902E-15 ,
     & 3.173450 , 3.5216199E-15 , 3.173600 , 3.7806498E-15 ,
     & 3.173750 , 5.1035099E-15 , 3.173900 , 5.2109200E-15 ,
     & 3.174050 , 6.8598001E-15 , 3.174200 , 7.4457398E-15 ,
     & 3.174350 , 7.2931197E-15 , 3.174500 , 8.4024796E-15 ,
     & 3.174650 , 8.1316103E-15 , 3.174800 , 7.6261697E-15 ,
     & 3.174950 , 6.7490001E-15 , 3.175100 , 5.8412002E-15 ,
     & 3.175250 , 6.2309200E-15 , 3.175400 , 6.4825901E-15 ,
     & 3.175550 , 7.2650897E-15 , 3.175700 , 7.6468601E-15 ,
     & 3.175850 , 8.1967802E-15 , 3.176000 , 7.4711499E-15 ,
     & 3.176150 , 6.7218701E-15 , 3.176300 , 7.4594397E-15 ,
     & 3.176450 , 6.5064802E-15 , 3.176600 , 6.5184699E-15 ,
     & 3.176750 , 6.7851701E-15 , 3.176900 , 6.6023800E-15 ,
     & 3.177050 , 7.0617598E-15 , 3.177200 , 5.3995000E-15 ,
     & 3.177350 , 4.8030499E-15 , 3.177500 , 4.7099898E-15 ,
     & 3.177650 , 4.3675598E-15 , 3.177800 , 3.2733700E-15 ,
     & 3.177950 , 4.6430001E-15 , 3.178100 , 3.9530998E-15 ,
     & 3.178250 , 3.1688199E-15 , 3.178400 , 3.0178501E-15 ,
     & 3.178550 , 4.0362899E-15 , 3.178700 , 4.3912001E-15 ,
     & 3.178850 , 4.4965600E-15 , 3.179000 , 3.3329800E-15 ,
     & 3.179150 , 4.1755899E-15 , 3.179300 , 5.7072601E-15 /
      data( xin(i), yin(i), i = 551 , 600 ) /
     & 3.179450 , 5.5014502E-15 , 3.179600 , 7.8317996E-15 ,
     & 3.179750 , 7.6003097E-15 , 3.179900 , 1.0861400E-14 ,
     & 3.180050 , 8.7120896E-15 , 3.180200 , 1.0753300E-14 ,
     & 3.180350 , 7.8547000E-15 , 3.180500 , 7.6856204E-15 ,
     & 3.180650 , 1.0769700E-14 , 3.180800 , 9.0090399E-15 ,
     & 3.180950 , 9.3180299E-15 , 3.181100 , 9.2798600E-15 ,
     & 3.181250 , 1.1148000E-14 , 3.181400 , 1.3083300E-14 ,
     & 3.181550 , 8.2015100E-15 , 3.181700 , 7.4145503E-15 ,
     & 3.181850 , 8.3089400E-15 , 3.182000 , 6.2070701E-15 ,
     & 3.182150 , 3.0728901E-15 , 3.182300 , 2.3159901E-15 ,
     & 3.182450 , 3.4976800E-15 , 3.182600 , 6.5865001E-16 ,
     & 3.182750 , 0.0000000E+00 , 3.182900 , 1.1925300E-15 ,
     & 3.183050 , 5.5814903E-16 , 3.183200 , 6.4910501E-16 ,
     & 3.183350 , 0.0000000E+00 , 3.183500 , 0.0000000E+00 ,
     & 3.183650 , 0.0000000E+00 , 3.183800 , 0.0000000E+00 ,
     & 3.183950 , 0.0000000E+00 , 3.184100 , 0.0000000E+00 ,
     & 3.184250 , 0.0000000E+00 , 3.184400 , 0.0000000E+00 ,
     & 3.184550 , 0.0000000E+00 , 3.184700 , 0.0000000E+00 ,
     & 3.184850 , 0.0000000E+00 , 3.185000 , 0.0000000E+00 ,
     & 3.185150 , 0.0000000E+00 , 3.185300 , 0.0000000E+00 ,
     & 3.185450 , 0.0000000E+00 , 3.185600 , 0.0000000E+00 ,
     & 3.185750 , 0.0000000E+00 , 3.185900 , 0.0000000E+00 ,
     & 3.186050 , 0.0000000E+00 , 3.186200 , 0.0000000E+00 ,
     & 3.186350 , 0.0000000E+00 , 3.186500 , 0.0000000E+00 ,
     & 3.186650 , 0.0000000E+00 , 3.186800 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 601 , 650 ) /
     & 3.186950 , 0.0000000E+00 , 3.187100 , 0.0000000E+00 ,
     & 3.187250 , 0.0000000E+00 , 3.187400 , 0.0000000E+00 ,
     & 3.187550 , 0.0000000E+00 , 3.187700 , 0.0000000E+00 ,
     & 3.187850 , 0.0000000E+00 , 3.188000 , 0.0000000E+00 ,
     & 3.188150 , 0.0000000E+00 , 3.188300 , 0.0000000E+00 ,
     & 3.188450 , 0.0000000E+00 , 3.188600 , 0.0000000E+00 ,
     & 3.188750 , 0.0000000E+00 , 3.188900 , 0.0000000E+00 ,
     & 3.189050 , 0.0000000E+00 , 3.189200 , 0.0000000E+00 ,
     & 3.189350 , 0.0000000E+00 , 3.189500 , 0.0000000E+00 ,
     & 3.189650 , 0.0000000E+00 , 3.189800 , 0.0000000E+00 ,
     & 3.189950 , 0.0000000E+00 , 3.190100 , 0.0000000E+00 ,
     & 3.190250 , 0.0000000E+00 , 3.190400 , 1.1283800E-16 ,
     & 3.190550 , 1.5252300E-15 , 3.190700 , 2.5015200E-15 ,
     & 3.190850 , 4.1140098E-15 , 3.191000 , 3.3614401E-15 ,
     & 3.191150 , 8.1394599E-16 , 3.191300 , 3.4733999E-17 ,
     & 3.191450 , 0.0000000E+00 , 3.191600 , 0.0000000E+00 ,
     & 3.191750 , 0.0000000E+00 , 3.191900 , 0.0000000E+00 ,
     & 3.192050 , 0.0000000E+00 , 3.192200 , 0.0000000E+00 ,
     & 3.192350 , 0.0000000E+00 , 3.192500 , 0.0000000E+00 ,
     & 3.192650 , 0.0000000E+00 , 3.192800 , 0.0000000E+00 ,
     & 3.192950 , 0.0000000E+00 , 3.193100 , 0.0000000E+00 ,
     & 3.193250 , 0.0000000E+00 , 3.193400 , 0.0000000E+00 ,
     & 3.193550 , 0.0000000E+00 , 3.193700 , 0.0000000E+00 ,
     & 3.193850 , 0.0000000E+00 , 3.194000 , 0.0000000E+00 ,
     & 3.194150 , 0.0000000E+00 , 3.194300 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 651 , 700 ) /
     & 3.194450 , 0.0000000E+00 , 3.194600 , 0.0000000E+00 ,
     & 3.194750 , 0.0000000E+00 , 3.194900 , 0.0000000E+00 ,
     & 3.195050 , 0.0000000E+00 , 3.195200 , 0.0000000E+00 ,
     & 3.195350 , 0.0000000E+00 , 3.195500 , 0.0000000E+00 ,
     & 3.195650 , 0.0000000E+00 , 3.195800 , 0.0000000E+00 ,
     & 3.195950 , 0.0000000E+00 , 3.196100 , 0.0000000E+00 ,
     & 3.196250 , 0.0000000E+00 , 3.196400 , 0.0000000E+00 ,
     & 3.196550 , 0.0000000E+00 , 3.196700 , 0.0000000E+00 ,
     & 3.196850 , 0.0000000E+00 , 3.197000 , 0.0000000E+00 ,
     & 3.197150 , 0.0000000E+00 , 3.197300 , 0.0000000E+00 ,
     & 3.197450 , 0.0000000E+00 , 3.197600 , 0.0000000E+00 ,
     & 3.197750 , 0.0000000E+00 , 3.197900 , 0.0000000E+00 ,
     & 3.198050 , 0.0000000E+00 , 3.198200 , 0.0000000E+00 ,
     & 3.198350 , 0.0000000E+00 , 3.198500 , 0.0000000E+00 ,
     & 3.198650 , 0.0000000E+00 , 3.198800 , 0.0000000E+00 ,
     & 3.198950 , 0.0000000E+00 , 3.199100 , 0.0000000E+00 ,
     & 3.199250 , 0.0000000E+00 , 3.199400 , 0.0000000E+00 ,
     & 3.199550 , 0.0000000E+00 , 3.199700 , 8.1862600E-16 ,
     & 3.199850 , 8.5795200E-16 , 3.200000 , 1.2827400E-15 ,
     & 3.200150 , 2.0752599E-15 , 3.200300 , 1.1319200E-15 ,
     & 3.200450 , 4.7363102E-16 , 3.200600 , 4.6542301E-16 ,
     & 3.200750 , 7.3163498E-16 , 3.200900 , 2.1586201E-16 ,
     & 3.201050 , 1.1619700E-15 , 3.201200 , 6.9793800E-16 ,
     & 3.201350 , 4.1733199E-16 , 3.201500 , 4.6237999E-16 ,
     & 3.201650 , 1.0718800E-15 , 3.201800 , 2.7374100E-15 /
      data( xin(i), yin(i), i = 701 , 750 ) /
     & 3.201950 , 2.9081900E-15 , 3.202100 , 2.5754200E-15 ,
     & 3.202250 , 2.9689000E-15 , 3.202400 , 3.8967001E-15 ,
     & 3.202550 , 3.3921101E-15 , 3.202700 , 2.6973400E-15 ,
     & 3.202850 , 2.8157800E-15 , 3.203000 , 2.8909700E-15 ,
     & 3.203150 , 3.0379000E-15 , 3.203300 , 3.4418801E-15 ,
     & 3.203450 , 4.4800301E-15 , 3.203600 , 4.3467698E-15 ,
     & 3.203750 , 4.1966798E-15 , 3.203900 , 4.6766502E-15 ,
     & 3.204050 , 3.4011700E-15 , 3.204200 , 3.0941999E-15 ,
     & 3.204350 , 3.6115300E-15 , 3.204500 , 2.9643400E-15 ,
     & 3.204650 , 3.3309200E-15 , 3.204800 , 3.3202000E-15 ,
     & 3.204950 , 2.9289000E-15 , 3.205100 , 2.9166500E-15 ,
     & 3.205250 , 3.6498002E-15 , 3.205400 , 3.2357201E-15 ,
     & 3.205550 , 4.0697201E-15 , 3.205700 , 4.7199899E-15 ,
     & 3.205850 , 4.0328801E-15 , 3.206000 , 2.6838701E-15 ,
     & 3.206150 , 2.5729600E-15 , 3.206300 , 4.3224502E-15 ,
     & 3.206450 , 3.7586998E-15 , 3.206600 , 3.3583101E-15 ,
     & 3.206750 , 2.5543600E-15 , 3.206900 , 2.1911999E-15 ,
     & 3.207050 , 2.2743599E-15 , 3.207200 , 2.5085700E-15 ,
     & 3.207350 , 2.7956001E-15 , 3.207500 , 3.7625898E-15 ,
     & 3.207650 , 4.0927599E-15 , 3.207800 , 4.4358298E-15 ,
     & 3.207950 , 3.5210300E-15 , 3.208100 , 2.4414001E-15 ,
     & 3.208250 , 2.6120700E-15 , 3.208400 , 2.7368200E-15 ,
     & 3.208550 , 1.8450000E-15 , 3.208700 , 1.7687600E-15 ,
     & 3.208850 , 1.8231101E-15 , 3.209000 , 2.9136599E-15 ,
     & 3.209150 , 3.6826900E-15 , 3.209300 , 3.3213801E-15 /
      data( xin(i), yin(i), i = 751 , 800 ) /
     & 3.209450 , 3.4119000E-15 , 3.209600 , 4.1442298E-15 ,
     & 3.209750 , 3.0226801E-15 , 3.209900 , 5.0835699E-15 ,
     & 3.210050 , 6.1629601E-15 , 3.210200 , 4.6189799E-15 ,
     & 3.210350 , 4.1317700E-15 , 3.210500 , 3.9114402E-15 ,
     & 3.210650 , 2.6984200E-15 , 3.210800 , 1.2057400E-15 ,
     & 3.210950 , 6.0562300E-17 , 3.211100 , 5.5840700E-16 ,
     & 3.211250 , 1.1152500E-15 , 3.211400 , 0.0000000E+00 ,
     & 3.211550 , 0.0000000E+00 , 3.211700 , 0.0000000E+00 ,
     & 3.211850 , 0.0000000E+00 , 3.212000 , 0.0000000E+00 ,
     & 3.212150 , 0.0000000E+00 , 3.212300 , 0.0000000E+00 ,
     & 3.212450 , 0.0000000E+00 , 3.212600 , 0.0000000E+00 ,
     & 3.212750 , 0.0000000E+00 , 3.212900 , 0.0000000E+00 ,
     & 3.213050 , 0.0000000E+00 , 3.213200 , 0.0000000E+00 ,
     & 3.213350 , 0.0000000E+00 , 3.213500 , 0.0000000E+00 ,
     & 3.213650 , 0.0000000E+00 , 3.213800 , 0.0000000E+00 ,
     & 3.213950 , 0.0000000E+00 , 3.214100 , 0.0000000E+00 ,
     & 3.214250 , 0.0000000E+00 , 3.214400 , 0.0000000E+00 ,
     & 3.214550 , 0.0000000E+00 , 3.214700 , 0.0000000E+00 ,
     & 3.214850 , 0.0000000E+00 , 3.215000 , 0.0000000E+00 ,
     & 3.215150 , 0.0000000E+00 , 3.215300 , 0.0000000E+00 ,
     & 3.215450 , 0.0000000E+00 , 3.215600 , 0.0000000E+00 ,
     & 3.215750 , 0.0000000E+00 , 3.215900 , 0.0000000E+00 ,
     & 3.216050 , 0.0000000E+00 , 3.216200 , 8.9730404E-16 ,
     & 3.216350 , 1.6263900E-15 , 3.216500 , 1.2521700E-15 ,
     & 3.216650 , 8.7222402E-16 , 3.216800 , 1.5555600E-15 /
      data( xin(i), yin(i), i = 801 , 850 ) /
     & 3.216950 , 7.1814201E-16 , 3.217100 , 1.4223700E-15 ,
     & 3.217250 , 1.9346601E-15 , 3.217400 , 1.8441701E-15 ,
     & 3.217550 , 2.1068901E-15 , 3.217700 , 5.7978002E-16 ,
     & 3.217850 , 8.0149103E-18 , 3.218000 , 1.6421400E-15 ,
     & 3.218150 , 2.3710900E-15 , 3.218300 , 1.8942200E-15 ,
     & 3.218450 , 2.4569300E-15 , 3.218600 , 2.4342501E-15 ,
     & 3.218750 , 2.3054001E-15 , 3.218900 , 2.1216299E-15 ,
     & 3.219050 , 2.4869700E-15 , 3.219200 , 3.0438500E-15 ,
     & 3.219350 , 2.9463200E-15 , 3.219500 , 2.3340499E-15 ,
     & 3.219650 , 2.3764200E-15 , 3.219800 , 1.6980400E-15 ,
     & 3.219950 , 1.2707800E-15 , 3.220100 , 1.1720700E-15 ,
     & 3.220250 , 4.0243901E-16 , 3.220400 , 0.0000000E+00 ,
     & 3.220550 , 0.0000000E+00 , 3.220700 , 0.0000000E+00 ,
     & 3.220850 , 0.0000000E+00 , 3.221000 , 0.0000000E+00 ,
     & 3.221150 , 0.0000000E+00 , 3.221300 , 0.0000000E+00 ,
     & 3.221450 , 0.0000000E+00 , 3.221600 , 0.0000000E+00 ,
     & 3.221750 , 0.0000000E+00 , 3.221900 , 0.0000000E+00 ,
     & 3.222050 , 0.0000000E+00 , 3.222200 , 0.0000000E+00 ,
     & 3.222350 , 0.0000000E+00 , 3.222500 , 0.0000000E+00 ,
     & 3.222650 , 0.0000000E+00 , 3.222800 , 0.0000000E+00 ,
     & 3.222950 , 0.0000000E+00 , 3.223100 , 0.0000000E+00 ,
     & 3.223250 , 0.0000000E+00 , 3.223400 , 0.0000000E+00 ,
     & 3.223550 , 0.0000000E+00 , 3.223700 , 0.0000000E+00 ,
     & 3.223850 , 0.0000000E+00 , 3.224000 , 0.0000000E+00 ,
     & 3.224150 , 0.0000000E+00 , 3.224300 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 851 , 900 ) /
     & 3.224450 , 0.0000000E+00 , 3.224600 , 0.0000000E+00 ,
     & 3.224750 , 0.0000000E+00 , 3.224900 , 0.0000000E+00 ,
     & 3.225050 , 0.0000000E+00 , 3.225200 , 0.0000000E+00 ,
     & 3.225350 , 0.0000000E+00 , 3.225500 , 0.0000000E+00 ,
     & 3.225650 , 0.0000000E+00 , 3.225800 , 0.0000000E+00 ,
     & 3.225950 , 0.0000000E+00 , 3.226100 , 0.0000000E+00 ,
     & 3.226250 , 0.0000000E+00 , 3.226400 , 0.0000000E+00 ,
     & 3.226550 , 0.0000000E+00 , 3.226700 , 0.0000000E+00 ,
     & 3.226850 , 0.0000000E+00 , 3.227000 , 0.0000000E+00 ,
     & 3.227150 , 0.0000000E+00 , 3.227300 , 0.0000000E+00 ,
     & 3.227450 , 0.0000000E+00 , 3.227600 , 0.0000000E+00 ,
     & 3.227750 , 0.0000000E+00 , 3.227900 , 0.0000000E+00 ,
     & 3.228050 , 0.0000000E+00 , 3.228200 , 0.0000000E+00 ,
     & 3.228350 , 0.0000000E+00 , 3.228500 , 0.0000000E+00 ,
     & 3.228650 , 0.0000000E+00 , 3.228800 , 0.0000000E+00 ,
     & 3.228950 , 0.0000000E+00 , 3.229100 , 0.0000000E+00 ,
     & 3.229250 , 0.0000000E+00 , 3.229400 , 0.0000000E+00 ,
     & 3.229550 , 0.0000000E+00 , 3.229700 , 0.0000000E+00 ,
     & 3.229850 , 0.0000000E+00 , 3.230000 , 0.0000000E+00 ,
     & 3.230150 , 0.0000000E+00 , 3.230300 , 0.0000000E+00 ,
     & 3.230450 , 0.0000000E+00 , 3.230600 , 1.1997200E-17 ,
     & 3.230750 , 4.7221002E-16 , 3.230900 , 7.2039702E-16 ,
     & 3.231050 , 1.4687200E-15 , 3.231200 , 1.0167500E-15 ,
     & 3.231350 , 1.4756100E-15 , 3.231500 , 1.5737200E-15 ,
     & 3.231650 , 1.6265200E-15 , 3.231800 , 2.3997600E-15 /
      data( xin(i), yin(i), i = 901 , 950 ) /
     & 3.231950 , 3.1125600E-15 , 3.232100 , 3.9863200E-15 ,
     & 3.232250 , 3.6209600E-15 , 3.232400 , 3.8388198E-15 ,
     & 3.232550 , 3.5180800E-15 , 3.232700 , 3.5195900E-15 ,
     & 3.232850 , 3.3201000E-15 , 3.233000 , 3.5361999E-15 ,
     & 3.233150 , 3.7888999E-15 , 3.233300 , 4.1339401E-15 ,
     & 3.233450 , 3.1305099E-15 , 3.233600 , 2.7071601E-15 ,
     & 3.233750 , 2.9659500E-15 , 3.233900 , 3.7601300E-15 ,
     & 3.234050 , 5.1600798E-15 , 3.234200 , 5.2639502E-15 ,
     & 3.234350 , 5.6166399E-15 , 3.234500 , 5.9303102E-15 ,
     & 3.234650 , 6.0477102E-15 , 3.234800 , 5.9109601E-15 ,
     & 3.234950 , 5.6495501E-15 , 3.235100 , 4.8318999E-15 ,
     & 3.235250 , 5.6081001E-15 , 3.235400 , 5.7167998E-15 ,
     & 3.235550 , 5.2971001E-15 , 3.235700 , 5.0662900E-15 ,
     & 3.235850 , 5.4248699E-15 , 3.236000 , 6.1811802E-15 ,
     & 3.236150 , 5.3085401E-15 , 3.236300 , 4.2299102E-15 ,
     & 3.236450 , 3.9549002E-15 , 3.236600 , 3.7312898E-15 ,
     & 3.236750 , 3.6188199E-15 , 3.236900 , 3.5667901E-15 ,
     & 3.237050 , 2.4404000E-15 , 3.237200 , 2.7119299E-15 ,
     & 3.237350 , 3.5102801E-15 , 3.237500 , 3.4349700E-15 ,
     & 3.237650 , 3.3754199E-15 , 3.237800 , 3.3024800E-15 ,
     & 3.237950 , 2.7884200E-15 , 3.238100 , 2.3975100E-15 ,
     & 3.238250 , 2.8618601E-15 , 3.238400 , 2.5002299E-15 ,
     & 3.238550 , 1.7154000E-15 , 3.238700 , 8.9660004E-16 ,
     & 3.238850 , 0.0000000E+00 , 3.239000 , 0.0000000E+00 ,
     & 3.239150 , 0.0000000E+00 , 3.239300 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 951 , 1000 ) /
     & 3.239450 , 0.0000000E+00 , 3.239600 , 0.0000000E+00 ,
     & 3.239750 , 0.0000000E+00 , 3.239900 , 0.0000000E+00 ,
     & 3.240050 , 0.0000000E+00 , 3.240200 , 0.0000000E+00 ,
     & 3.240350 , 0.0000000E+00 , 3.240500 , 0.0000000E+00 ,
     & 3.240650 , 0.0000000E+00 , 3.240800 , 0.0000000E+00 ,
     & 3.240950 , 0.0000000E+00 , 3.241100 , 0.0000000E+00 ,
     & 3.241250 , 0.0000000E+00 , 3.241400 , 0.0000000E+00 ,
     & 3.241550 , 0.0000000E+00 , 3.241700 , 0.0000000E+00 ,
     & 3.241850 , 0.0000000E+00 , 3.242000 , 0.0000000E+00 ,
     & 3.242150 , 0.0000000E+00 , 3.242300 , 0.0000000E+00 ,
     & 3.242450 , 0.0000000E+00 , 3.242600 , 0.0000000E+00 ,
     & 3.242750 , 0.0000000E+00 , 3.242900 , 0.0000000E+00 ,
     & 3.243050 , 0.0000000E+00 , 3.243200 , 0.0000000E+00 ,
     & 3.243350 , 0.0000000E+00 , 3.243500 , 0.0000000E+00 ,
     & 3.243650 , 0.0000000E+00 , 3.243800 , 0.0000000E+00 ,
     & 3.243950 , 0.0000000E+00 , 3.244100 , 0.0000000E+00 ,
     & 3.244250 , 0.0000000E+00 , 3.244400 , 0.0000000E+00 ,
     & 3.244550 , 1.4502201E-16 , 3.244700 , 8.0299099E-16 ,
     & 3.244850 , 2.8793500E-15 , 3.245000 , 4.0201399E-15 ,
     & 3.245150 , 4.6022099E-15 , 3.245300 , 4.5216698E-15 ,
     & 3.245450 , 4.1506800E-15 , 3.245600 , 4.8235799E-15 ,
     & 3.245750 , 2.2062801E-15 , 3.245900 , 1.4488800E-15 ,
     & 3.246050 , 2.2236701E-15 , 3.246200 , 2.5476000E-15 ,
     & 3.246350 , 2.1317200E-15 , 3.246500 , 1.8900700E-15 ,
     & 3.246650 , 1.6322400E-15 , 3.246800 , 1.0501700E-15 /
      data( xin(i), yin(i), i = 1001 , 1050 ) /
     & 3.246950 , 9.3914302E-16 , 3.247100 , 2.4980899E-15 ,
     & 3.247250 , 4.0203500E-15 , 3.247400 , 3.9736501E-15 ,
     & 3.247550 , 3.7340101E-15 , 3.247700 , 3.0370301E-15 ,
     & 3.247850 , 3.0761300E-15 , 3.248000 , 3.6777700E-15 ,
     & 3.248150 , 4.0824798E-15 , 3.248300 , 3.6810201E-15 ,
     & 3.248450 , 3.0948299E-15 , 3.248600 , 3.2342500E-15 ,
     & 3.248750 , 3.6047901E-15 , 3.248900 , 2.7596100E-15 ,
     & 3.249050 , 2.3986400E-15 , 3.249200 , 2.9316600E-15 ,
     & 3.249350 , 1.9798201E-15 , 3.249500 , 1.8307300E-15 ,
     & 3.249650 , 1.1888300E-15 , 3.249800 , 1.0800800E-15 ,
     & 3.249950 , 1.2227000E-15 , 3.250100 , 1.5516900E-15 ,
     & 3.250250 , 1.5901500E-15 , 3.250400 , 9.1367305E-16 ,
     & 3.250550 , 6.0885701E-17 , 3.250700 , -4.2458400E-19 ,
     & 3.250850 , -4.2458400E-19 , 3.251000 , -4.2458400E-19 ,
     & 3.251150 , -4.2458400E-19 , 3.251300 , -4.2458400E-19 ,
     & 3.251450 , -4.2458400E-19 , 3.251600 , -4.2458400E-19 ,
     & 3.251750 , -4.2458400E-19 , 3.251900 , -4.2458400E-19 ,
     & 3.252050 , -4.2458400E-19 , 3.252200 , -4.2458400E-19 ,
     & 3.252350 , -4.2458400E-19 , 3.252500 , -4.2458400E-19 ,
     & 3.252650 , -4.2458400E-19 , 3.252800 , 1.5855200E-15 ,
     & 3.252950 , 1.8653300E-15 , 3.253100 , 1.3838300E-15 ,
     & 3.253250 , 5.5300701E-16 , 3.253400 , 5.3238202E-16 ,
     & 3.253550 , 6.0406901E-16 , 3.253700 , 8.5713898E-17 ,
     & 3.253850 , -3.2159100E-21 , 3.254000 , -2.6669600E-22 ,
     & 3.254150 , -1.4069700E-23 , 3.254300 , -5.1871598E-25 /
      data( xin(i), yin(i), i = 1051 , 1100 ) /
     & 3.254450 , 0.0000000E+00 , 3.254600 , 0.0000000E+00 ,
     & 3.254750 , 0.0000000E+00 , 3.254900 , 0.0000000E+00 ,
     & 3.255050 , 0.0000000E+00 , 3.255200 , 0.0000000E+00 ,
     & 3.255350 , 0.0000000E+00 , 3.255500 , 0.0000000E+00 ,
     & 3.255650 , 0.0000000E+00 , 3.255800 , 0.0000000E+00 ,
     & 3.255950 , 5.1843899E-17 , 3.256100 , 4.7645100E-16 ,
     & 3.256250 , 5.4210098E-16 , 3.256400 , 4.3499700E-18 ,
     & 3.256550 , 0.0000000E+00 , 3.256700 , 1.8358299E-17 ,
     & 3.256850 , 2.4389199E-16 , 3.257000 , 5.5795299E-16 ,
     & 3.257150 , 4.1151600E-16 , 3.257300 , 0.0000000E+00 ,
     & 3.257450 , 0.0000000E+00 , 3.257600 , 2.0286100E-16 ,
     & 3.257750 , 5.3878400E-16 , 3.257900 , 9.7956904E-16 ,
     & 3.258050 , 1.1205900E-15 , 3.258200 , 1.3894700E-15 ,
     & 3.258350 , 1.2287000E-15 , 3.258500 , 1.3798700E-16 ,
     & 3.258650 , 3.5888399E-17 , 3.258800 , 4.3913600E-16 ,
     & 3.258950 , 0.0000000E+00 , 3.259100 , 0.0000000E+00 ,
     & 3.259250 , 8.9060598E-17 , 3.259400 , 7.2857903E-18 ,
     & 3.259550 , 0.0000000E+00 , 3.259700 , 0.0000000E+00 ,
     & 3.259850 , 0.0000000E+00 , 3.260000 , 8.7133400E-16 ,
     & 3.260150 , 2.2308000E-15 , 3.260300 , 1.8826000E-15 ,
     & 3.260450 , 1.6636700E-15 , 3.260600 , 2.6311899E-15 ,
     & 3.260750 , 2.1223300E-15 , 3.260900 , 2.4923400E-15 ,
     & 3.261050 , 2.7677801E-15 , 3.261200 , 2.1074099E-15 ,
     & 3.261350 , 3.1295599E-15 , 3.261500 , 3.1523100E-15 ,
     & 3.261650 , 1.8491900E-15 , 3.261800 , 1.5294400E-15 /
      data( xin(i), yin(i), i = 1101 , 1150 ) /
     & 3.261950 , 1.0278100E-15 , 3.262100 , 1.3645500E-15 ,
     & 3.262250 , 1.1090000E-15 , 3.262400 , 1.4917800E-15 ,
     & 3.262550 , 1.3793700E-15 , 3.262700 , 1.6416500E-15 ,
     & 3.262850 , 1.7166201E-15 , 3.263000 , 1.2932500E-15 ,
     & 3.263150 , 6.6823499E-16 , 3.263300 , 6.8417302E-16 ,
     & 3.263450 , 5.9020599E-16 , 3.263600 , 6.2275900E-16 ,
     & 3.263750 , 3.6453400E-16 , 3.263900 , 5.8028703E-16 ,
     & 3.264050 , 2.2814200E-16 , 3.264200 , 0.0000000E+00 ,
     & 3.264350 , 6.9714898E-16 , 3.264500 , 1.2871300E-15 ,
     & 3.264650 , 1.8336201E-15 , 3.264800 , 1.3358900E-15 ,
     & 3.264950 , 1.1432100E-15 , 3.265100 , 1.5188600E-15 ,
     & 3.265250 , 2.0743900E-15 , 3.265400 , 2.2866601E-15 ,
     & 3.265550 , 1.3498600E-15 , 3.265700 , 5.6439399E-16 ,
     & 3.265850 , 8.8722900E-16 , 3.266000 , 2.5738100E-15 ,
     & 3.266150 , 3.6554499E-15 , 3.266300 , 3.2660801E-15 ,
     & 3.266450 , 3.6412100E-15 , 3.266600 , 4.3120800E-15 ,
     & 3.266750 , 2.7004399E-15 , 3.266900 , 3.0646800E-15 ,
     & 3.267050 , 3.6304700E-15 , 3.267200 , 2.3849000E-15 ,
     & 3.267350 , 1.3817700E-15 , 3.267500 , 1.9254500E-16 ,
     & 3.267650 , 3.5276400E-16 , 3.267800 , 2.0098100E-16 ,
     & 3.267950 , 0.0000000E+00 , 3.268100 , 6.5599901E-16 ,
     & 3.268250 , 7.9692502E-16 , 3.268400 , 2.3060599E-15 ,
     & 3.268550 , 3.0573800E-15 , 3.268700 , 2.8261801E-15 ,
     & 3.268850 , 2.6528600E-15 , 3.269000 , 2.4502399E-15 ,
     & 3.269150 , 5.7609199E-16 , 3.269300 , 1.7484800E-17 /
      data( xin(i), yin(i), i = 1151 , 1200 ) /
     & 3.269450 , 0.0000000E+00 , 3.269600 , 0.0000000E+00 ,
     & 3.269750 , 0.0000000E+00 , 3.269900 , 0.0000000E+00 ,
     & 3.270050 , 0.0000000E+00 , 3.270200 , 0.0000000E+00 ,
     & 3.270350 , 0.0000000E+00 , 3.270500 , 0.0000000E+00 ,
     & 3.270650 , 0.0000000E+00 , 3.270800 , 5.6258700E-18 ,
     & 3.270950 , 3.5639401E-17 , 3.271100 , 9.6266396E-16 ,
     & 3.271250 , 9.8100497E-16 , 3.271400 , 8.4482600E-16 ,
     & 3.271550 , 1.0149400E-15 , 3.271700 , 1.9906001E-15 ,
     & 3.271850 , 1.0445900E-15 , 3.272000 , 1.1581300E-15 ,
     & 3.272150 , 0.0000000E+00 , 3.272300 , 0.0000000E+00 ,
     & 3.272450 , 0.0000000E+00 , 3.272600 , 0.0000000E+00 ,
     & 3.272750 , 0.0000000E+00 , 3.272900 , 0.0000000E+00 ,
     & 3.273050 , 2.8168300E-16 , 3.273200 , 2.8960199E-16 ,
     & 3.273350 , 0.0000000E+00 , 3.273500 , 1.9602899E-16 ,
     & 3.273650 , 1.9649400E-16 , 3.273800 , 0.0000000E+00 ,
     & 3.273950 , 3.1136101E-17 , 3.274100 , 2.6468199E-16 ,
     & 3.274250 , 5.1341701E-17 , 3.274400 , 0.0000000E+00 ,
     & 3.274550 , 1.3278500E-15 , 3.274700 , 3.2656199E-15 ,
     & 3.274850 , 4.2271802E-15 , 3.275000 , 6.0934301E-15 ,
     & 3.275150 , 6.6115500E-15 , 3.275300 , 6.3531101E-15 ,
     & 3.275450 , 6.3181001E-15 , 3.275600 , 5.7605000E-15 ,
     & 3.275750 , 4.0362899E-15 , 3.275900 , 7.9713699E-16 ,
     & 3.276050 , 0.0000000E+00 , 3.276200 , 3.7200302E-18 ,
     & 3.276350 , 8.3466500E-16 , 3.276500 , 4.8769198E-16 ,
     & 3.276650 , 3.9479700E-16 , 3.276800 , 1.0051000E-15 /
      data( xin(i), yin(i), i = 1201 , 1250 ) /
     & 3.276950 , 0.0000000E+00 , 3.277100 , 3.5819001E-16 ,
     & 3.277250 , 1.1891500E-15 , 3.277400 , 0.0000000E+00 ,
     & 3.277550 , 2.9416401E-16 , 3.277700 , 7.0004102E-16 ,
     & 3.277850 , 4.9632901E-17 , 3.278000 , 0.0000000E+00 ,
     & 3.278150 , 8.1326799E-16 , 3.278300 , 2.2483701E-16 ,
     & 3.278450 , 0.0000000E+00 , 3.278600 , 0.0000000E+00 ,
     & 3.278750 , 7.1758498E-16 , 3.278900 , 9.9230799E-16 ,
     & 3.279050 , 2.0862100E-16 , 3.279200 , 8.0601098E-16 ,
     & 3.279350 , 7.8260302E-16 , 3.279500 , 0.0000000E+00 ,
     & 3.279650 , 0.0000000E+00 , 3.279800 , 6.5501100E-16 ,
     & 3.279950 , 1.5081700E-15 , 3.280100 , 0.0000000E+00 ,
     & 3.280250 , 0.0000000E+00 , 3.280400 , 0.0000000E+00 ,
     & 3.280550 , 0.0000000E+00 , 3.280700 , 0.0000000E+00 ,
     & 3.280850 , 0.0000000E+00 , 3.281000 , 0.0000000E+00 ,
     & 3.281150 , 9.7518500E-17 , 3.281300 , 5.1562898E-16 ,
     & 3.281450 , 1.6293400E-16 , 3.281600 , 1.5832700E-16 ,
     & 3.281750 , 1.6142000E-17 , 3.281900 , 2.8818300E-16 ,
     & 3.282050 , 6.2116301E-17 , 3.282200 , 8.2048799E-16 ,
     & 3.282350 , 1.0253500E-15 , 3.282500 , 5.4064399E-17 ,
     & 3.282650 , 0.0000000E+00 , 3.282800 , 0.0000000E+00 ,
     & 3.282950 , 2.9637799E-16 , 3.283100 , 0.0000000E+00 ,
     & 3.283250 , 0.0000000E+00 , 3.283400 , 0.0000000E+00 ,
     & 3.283550 , 2.0646901E-16 , 3.283700 , 2.8832700E-17 ,
     & 3.283850 , 2.7000401E-16 , 3.284000 , 4.0352600E-17 ,
     & 3.284150 , 0.0000000E+00 , 3.284300 , 2.4877101E-16 /
      data( xin(i), yin(i), i = 1251 , 1300 ) /
     & 3.284450 , 8.9655600E-16 , 3.284600 , 2.7601199E-18 ,
     & 3.284750 , 5.9980198E-18 , 3.284900 , 0.0000000E+00 ,
     & 3.285050 , 2.1391499E-15 , 3.285200 , 3.3418601E-15 ,
     & 3.285350 , 2.1245001E-15 , 3.285500 , 1.5545701E-15 ,
     & 3.285650 , 1.3155600E-15 , 3.285800 , 8.3118798E-16 ,
     & 3.285950 , 2.6447701E-16 , 3.286100 , 0.0000000E+00 ,
     & 3.286250 , 6.4265303E-17 , 3.286400 , 9.0756499E-16 ,
     & 3.286550 , 1.7990300E-15 , 3.286700 , 2.4288100E-15 ,
     & 3.286850 , 2.7593301E-15 , 3.287000 , 2.6680600E-15 ,
     & 3.287150 , 1.9281401E-15 , 3.287300 , 2.4548999E-15 ,
     & 3.287450 , 2.4719600E-15 , 3.287600 , 2.7197800E-15 ,
     & 3.287750 , 2.4809800E-15 , 3.287900 , 2.5588399E-15 ,
     & 3.288050 , 1.9775200E-15 , 3.288200 , 1.6048000E-15 ,
     & 3.288350 , 1.6953200E-16 , 3.288500 , 5.9321000E-16 ,
     & 3.288650 , 1.2882999E-15 , 3.288800 , 1.9017700E-15 ,
     & 3.288950 , 2.6319601E-15 , 3.289100 , 3.5536098E-15 ,
     & 3.289250 , 3.6478600E-15 , 3.289400 , 4.1635498E-15 ,
     & 3.289550 , 6.4872500E-15 , 3.289700 , 7.0156800E-15 ,
     & 3.289850 , 6.8142899E-15 , 3.290000 , 6.7552601E-15 ,
     & 3.290150 , 7.9894003E-15 , 3.290300 , 7.8287901E-15 ,
     & 3.290450 , 7.6100599E-15 , 3.290600 , 6.6590300E-15 ,
     & 3.290750 , 7.0051302E-15 , 3.290900 , 6.7335401E-15 ,
     & 3.291050 , 5.7826101E-15 , 3.291200 , 3.9399098E-15 ,
     & 3.291350 , 4.4473499E-15 , 3.291500 , 4.7235800E-15 ,
     & 3.291650 , 4.0200298E-15 , 3.291800 , 4.1489300E-15 /
      data( xin(i), yin(i), i = 1301 , 1350 ) /
     & 3.291950 , 4.3600898E-15 , 3.292100 , 3.1923200E-15 ,
     & 3.292250 , 2.7531601E-15 , 3.292400 , 2.9495100E-15 ,
     & 3.292550 , 2.6475300E-15 , 3.292700 , 2.5236500E-15 ,
     & 3.292850 , 3.6469402E-15 , 3.293000 , 4.0509300E-15 ,
     & 3.293150 , 2.7708400E-15 , 3.293300 , 1.7846000E-15 ,
     & 3.293450 , 1.4302500E-15 , 3.293600 , 1.8344000E-15 ,
     & 3.293750 , 1.3754200E-15 , 3.293900 , 5.4069501E-16 ,
     & 3.294050 , 1.0912500E-16 , 3.294200 , 8.0096902E-16 ,
     & 3.294350 , 1.3898300E-15 , 3.294500 , 1.0631400E-15 ,
     & 3.294650 , 6.8355299E-16 , 3.294800 , 2.3814300E-16 ,
     & 3.294950 , 8.5244798E-16 , 3.295100 , 1.8040201E-15 ,
     & 3.295250 , 1.8783000E-15 , 3.295400 , 1.9046601E-15 ,
     & 3.295550 , 2.2433600E-15 , 3.295700 , 1.7580700E-15 ,
     & 3.295850 , 1.1552700E-15 , 3.296000 , 1.5172700E-15 ,
     & 3.296150 , 1.7273499E-15 , 3.296300 , 1.7609300E-15 ,
     & 3.296450 , 1.9804299E-15 , 3.296600 , 3.2994199E-15 ,
     & 3.296750 , 4.4893602E-15 , 3.296900 , 4.2855200E-15 ,
     & 3.297050 , 4.3654702E-15 , 3.297200 , 4.3217802E-15 ,
     & 3.297350 , 3.8589301E-15 , 3.297500 , 3.2842100E-15 ,
     & 3.297650 , 4.0311501E-15 , 3.297800 , 3.6957801E-15 ,
     & 3.297950 , 2.7371800E-15 , 3.298100 , 2.8829601E-15 ,
     & 3.298250 , 5.0955800E-15 , 3.298400 , 4.8590299E-15 ,
     & 3.298550 , 4.4306502E-15 , 3.298700 , 5.3782700E-15 ,
     & 3.298850 , 5.1745200E-15 , 3.299000 , 5.2375101E-15 ,
     & 3.299150 , 5.0944602E-15 , 3.299300 , 4.2281200E-15 /
      data( xin(i), yin(i), i = 1351 , 1400 ) /
     & 3.299450 , 3.4878699E-15 , 3.299600 , 4.3989102E-15 ,
     & 3.299750 , 4.8031799E-15 , 3.299900 , 3.8326000E-15 ,
     & 3.300050 , 3.2098500E-15 , 3.300200 , 3.0595601E-15 ,
     & 3.300350 , 2.7135600E-15 , 3.300500 , 3.3576600E-15 ,
     & 3.300650 , 3.3152200E-15 , 3.300800 , 3.5835499E-15 ,
     & 3.300950 , 2.9099999E-15 , 3.301100 , 2.8113500E-15 ,
     & 3.301250 , 2.7119200E-15 , 3.301400 , 3.5272201E-15 ,
     & 3.301550 , 2.6565501E-15 , 3.301700 , 2.8514401E-15 ,
     & 3.301850 , 4.0799400E-15 , 3.302000 , 3.9794900E-15 ,
     & 3.302150 , 3.0369299E-15 , 3.302300 , 2.2441501E-15 ,
     & 3.302450 , 2.3500300E-15 , 3.302600 , 2.3438501E-15 ,
     & 3.302750 , 1.8342501E-15 , 3.302900 , 8.9816399E-16 ,
     & 3.303050 , 1.1953700E-16 , 3.303200 , 1.0258500E-15 ,
     & 3.303350 , 1.9966699E-15 , 3.303500 , 1.8103999E-15 ,
     & 3.303650 , 4.5250702E-16 , 3.303800 , 1.2695500E-15 ,
     & 3.303950 , 1.3719700E-15 , 3.304100 , 1.7039500E-15 ,
     & 3.304250 , 1.9045400E-15 , 3.304400 , 1.0175300E-15 ,
     & 3.304550 , 9.3855697E-16 , 3.304700 , 1.1131900E-15 ,
     & 3.304850 , 1.1935300E-15 , 3.305000 , 9.2664600E-16 ,
     & 3.305150 , 1.4041500E-15 , 3.305300 , 1.3877000E-15 ,
     & 3.305450 , 1.9270900E-15 , 3.305600 , 2.6842201E-15 ,
     & 3.305750 , 1.4294900E-15 , 3.305900 , 1.0211800E-15 ,
     & 3.306050 , 1.2016000E-15 , 3.306200 , 1.9439099E-15 ,
     & 3.306350 , 1.4617400E-15 , 3.306500 , 1.2097700E-15 ,
     & 3.306650 , 2.0778701E-15 , 3.306800 , 1.8178000E-15 /
      data( xin(i), yin(i), i = 1401 , 1450 ) /
     & 3.306950 , 1.1949600E-15 , 3.307100 , 1.2645900E-15 ,
     & 3.307250 , 1.6754800E-15 , 3.307400 , 9.9687297E-16 ,
     & 3.307550 , 6.5253798E-16 , 3.307700 , 2.0275200E-16 ,
     & 3.307850 , 9.2122700E-16 , 3.308000 , 1.3368000E-15 ,
     & 3.308150 , 1.3158800E-15 , 3.308300 , 1.9624500E-15 ,
     & 3.308450 , 2.5580700E-15 , 3.308600 , 3.4117699E-15 ,
     & 3.308750 , 3.0588001E-15 , 3.308900 , 2.5796399E-15 ,
     & 3.309050 , 2.5011900E-15 , 3.309200 , 3.0128100E-15 ,
     & 3.309350 , 2.6748900E-15 , 3.309500 , 1.7134200E-15 ,
     & 3.309650 , 1.1263900E-15 , 3.309800 , 1.2593100E-15 ,
     & 3.309950 , 1.1288300E-15 , 3.310100 , 8.3841698E-16 ,
     & 3.310250 , 1.0643500E-15 , 3.310400 , 9.8457500E-16 ,
     & 3.310550 , 1.3534700E-15 , 3.310700 , 1.1802800E-15 ,
     & 3.310850 , 8.1537800E-16 , 3.311000 , 9.8187604E-16 ,
     & 3.311150 , 2.3764100E-16 , 3.311300 , 1.9749300E-16 ,
     & 3.311450 , 8.5195601E-16 , 3.311600 , 1.9637900E-15 ,
     & 3.311750 , 1.9595201E-15 , 3.311900 , 1.6209500E-15 ,
     & 3.312050 , 1.5175000E-15 , 3.312200 , 1.8378400E-15 ,
     & 3.312350 , 1.8968500E-15 , 3.312500 , 3.0220600E-15 ,
     & 3.312650 , 3.7052999E-15 , 3.312800 , 4.2589498E-15 ,
     & 3.312950 , 4.0789901E-15 , 3.313100 , 4.6320899E-15 ,
     & 3.313250 , 5.0795499E-15 , 3.313400 , 4.9519799E-15 ,
     & 3.313550 , 5.3599800E-15 , 3.313700 , 5.5521502E-15 ,
     & 3.313850 , 5.7947798E-15 , 3.314000 , 5.2328099E-15 ,
     & 3.314150 , 5.4423502E-15 , 3.314300 , 5.5333499E-15 /
      data( xin(i), yin(i), i = 1451 , 1500 ) /
     & 3.314450 , 4.4934801E-15 , 3.314600 , 4.1133601E-15 ,
     & 3.314750 , 4.3153601E-15 , 3.314900 , 4.9864300E-15 ,
     & 3.315050 , 5.6211402E-15 , 3.315200 , 6.2273299E-15 ,
     & 3.315350 , 6.1964899E-15 , 3.315500 , 5.5752399E-15 ,
     & 3.315650 , 4.8742299E-15 , 3.315800 , 4.6671100E-15 ,
     & 3.315950 , 3.1709600E-15 , 3.316100 , 1.6987400E-15 ,
     & 3.316250 , 1.4767500E-15 , 3.316400 , 1.3521400E-15 ,
     & 3.316550 , 4.4110601E-16 , 3.316700 , 5.6488701E-16 ,
     & 3.316850 , 1.5399200E-15 , 3.317000 , 2.2754901E-15 ,
     & 3.317150 , 2.6669201E-15 , 3.317300 , 3.4935700E-15 ,
     & 3.317450 , 5.1126900E-15 , 3.317600 , 5.4580499E-15 ,
     & 3.317750 , 5.9658500E-15 , 3.317900 , 5.0611100E-15 ,
     & 3.318050 , 4.2693802E-15 , 3.318200 , 3.3665900E-15 ,
     & 3.318350 , 1.0963400E-15 , 3.318500 , 1.3347700E-15 ,
     & 3.318650 , 1.9250899E-15 , 3.318800 , 1.8582399E-15 ,
     & 3.318950 , 1.4946800E-15 , 3.319100 , 2.2812399E-15 ,
     & 3.319250 , 2.8637699E-15 , 3.319400 , 2.4268800E-15 ,
     & 3.319550 , 2.1213099E-15 , 3.319700 , 2.1987400E-15 ,
     & 3.319850 , 2.6015601E-15 , 3.320000 , 2.3670600E-15 ,
     & 3.320150 , 1.0727800E-15 , 3.320300 , 1.3177500E-15 ,
     & 3.320450 , 1.2381100E-15 , 3.320600 , 1.1107000E-15 ,
     & 3.320750 , 8.6968801E-16 , 3.320900 , 1.3461600E-15 ,
     & 3.321050 , 2.9175499E-15 , 3.321200 , 2.4889000E-15 ,
     & 3.321350 , 1.5590800E-15 , 3.321500 , 1.8337399E-15 ,
     & 3.321650 , 1.7078700E-15 , 3.321800 , 2.8669399E-15 /
      data( xin(i), yin(i), i = 1501 , 1550 ) /
     & 3.321950 , 1.4915000E-15 , 3.322100 , 1.4729900E-15 ,
     & 3.322250 , 1.4578000E-15 , 3.322400 , 1.2927600E-15 ,
     & 3.322550 , 1.2660200E-15 , 3.322700 , 1.4228000E-15 ,
     & 3.322850 , 1.5049200E-15 , 3.323000 , 2.3022701E-15 ,
     & 3.323150 , 2.4155899E-15 , 3.323300 , 3.3062301E-15 ,
     & 3.323450 , 3.5220299E-15 , 3.323600 , 2.3648400E-15 ,
     & 3.323750 , 2.3521099E-15 , 3.323900 , 1.9122701E-15 ,
     & 3.324050 , 2.1010100E-15 , 3.324200 , 2.0623200E-15 ,
     & 3.324350 , 1.3560700E-15 , 3.324500 , 1.4226200E-15 ,
     & 3.324650 , 2.0004301E-15 , 3.324800 , 2.2865100E-15 ,
     & 3.324950 , 2.5545800E-15 , 3.325100 , 2.0838700E-15 ,
     & 3.325250 , 1.5211900E-15 , 3.325400 , 5.1359102E-16 ,
     & 3.325550 , 0.0000000E+00 , 3.325700 , 0.0000000E+00 ,
     & 3.325850 , 0.0000000E+00 , 3.326000 , 0.0000000E+00 ,
     & 3.326150 , 0.0000000E+00 , 3.326300 , 0.0000000E+00 ,
     & 3.326450 , 0.0000000E+00 , 3.326600 , 0.0000000E+00 ,
     & 3.326750 , 0.0000000E+00 , 3.326900 , 0.0000000E+00 ,
     & 3.327050 , 0.0000000E+00 , 3.327200 , 0.0000000E+00 ,
     & 3.327350 , 0.0000000E+00 , 3.327500 , 0.0000000E+00 ,
     & 3.327650 , 0.0000000E+00 , 3.327800 , 0.0000000E+00 ,
     & 3.327950 , 0.0000000E+00 , 3.328100 , 0.0000000E+00 ,
     & 3.328250 , 0.0000000E+00 , 3.328400 , 0.0000000E+00 ,
     & 3.328550 , 0.0000000E+00 , 3.328700 , 0.0000000E+00 ,
     & 3.328850 , 0.0000000E+00 , 3.329000 , 0.0000000E+00 ,
     & 3.329150 , 0.0000000E+00 , 3.329300 , 0.0000000E+00 /
      data( xin(i), yin(i), i = 1551 , 1600 ) /
     & 3.329450 , 0.0000000E+00 , 3.329600 , 0.0000000E+00 ,
     & 3.329750 , 0.0000000E+00 , 3.329900 , 0.0000000E+00 ,
     & 3.330050 , 0.0000000E+00 , 3.330200 , 0.0000000E+00 ,
     & 3.330350 , 0.0000000E+00 , 3.330500 , 0.0000000E+00 ,
     & 3.330650 , 0.0000000E+00 , 3.330800 , 0.0000000E+00 ,
     & 3.330950 , 0.0000000E+00 , 3.331100 , 0.0000000E+00 ,
     & 3.331250 , 0.0000000E+00 , 3.331400 , 0.0000000E+00 ,
     & 3.331550 , 0.0000000E+00 , 3.331700 , 0.0000000E+00 ,
     & 3.331850 , 0.0000000E+00 , 3.332000 , 0.0000000E+00 ,
     & 3.332150 , 0.0000000E+00 , 3.332300 , 0.0000000E+00 ,
     & 3.332450 , 0.0000000E+00 , 3.332600 , 0.0000000E+00 ,
     & 3.332750 , 0.0000000E+00 , 3.332900 , 0.0000000E+00 ,
     & 3.333050 , 0.0000000E+00 , 3.333200 , 0.0000000E+00 ,
     & 3.333350 , 0.0000000E+00 , 3.333500 , 0.0000000E+00 ,
     & 3.333650 , 0.0000000E+00 , 3.333800 , 0.0000000E+00 ,
     & 3.333950 , 0.0000000E+00 , 3.334100 , 0.0000000E+00 ,
     & 3.334250 , 0.0000000E+00 , 3.334400 , 0.0000000E+00 ,
     & 3.334550 , 0.0000000E+00 , 3.334700 , 0.0000000E+00 ,
     & 3.334850 , 0.0000000E+00 , 3.335000 , 0.0000000E+00 ,
     & 3.335150 , 1.0951400E-16 , 3.335300 , 4.5027499E-16 ,
     & 3.335450 , 1.2147600E-15 , 3.335600 , 1.7030100E-15 ,
     & 3.335750 , 1.5001900E-15 , 3.335900 , 2.1635900E-15 ,
     & 3.336050 , 2.2141299E-15 , 3.336200 , 2.6596500E-15 ,
     & 3.336350 , 2.3583301E-15 , 3.336500 , 2.0999601E-15 ,
     & 3.336650 , 2.5849499E-15 , 3.336800 , 3.3493500E-15 /
      data( xin(i), yin(i), i = 1601 , 1650 ) /
     & 3.336950 , 3.1813901E-15 , 3.337100 , 2.5759401E-15 ,
     & 3.337250 , 1.9112699E-15 , 3.337400 , 1.2569400E-15 ,
     & 3.337550 , 9.7101295E-16 , 3.337700 , 7.9543398E-16 ,
     & 3.337850 , 4.1101001E-16 , 3.338000 , 7.8212000E-16 ,
     & 3.338150 , 4.1669601E-16 , 3.338300 , 8.2633999E-16 ,
     & 3.338450 , 2.0982000E-17 , 3.338600 , 0.0000000E+00 ,
     & 3.338750 , 0.0000000E+00 , 3.338900 , 0.0000000E+00 ,
     & 3.339050 , 0.0000000E+00 , 3.339200 , 3.0353701E-16 ,
     & 3.339350 , 9.8125601E-16 , 3.339500 , 1.2561700E-15 ,
     & 3.339650 , 1.5248601E-15 , 3.339800 , 8.2678102E-16 ,
     & 3.339950 , 4.4984602E-16 , 3.340100 , 4.4061000E-16 ,
     & 3.340250 , 2.7601599E-17 , 3.340400 , 0.0000000E+00 ,
     & 3.340550 , 3.5541100E-16 , 3.340700 , 4.6925302E-16 ,
     & 3.340850 , 0.0000000E+00 , 3.341000 , 0.0000000E+00 ,
     & 3.341150 , 0.0000000E+00 , 3.341300 , 0.0000000E+00 ,
     & 3.341450 , 0.0000000E+00 , 3.341600 , 0.0000000E+00 ,
     & 3.341750 , 0.0000000E+00 , 3.341900 , 0.0000000E+00 ,
     & 3.342050 , 0.0000000E+00 , 3.342200 , 0.0000000E+00 ,
     & 3.342350 , 0.0000000E+00 , 3.342500 , 3.9170999E-17 ,
     & 3.342650 , 1.1518299E-16 , 3.342800 , 1.9122100E-16 ,
     & 3.342950 , 2.6728601E-16 , 3.343100 , 3.4337601E-16 ,
     & 3.343250 , 4.1949299E-16 , 3.343400 , 4.9563699E-16 ,
     & 3.343550 , 6.0052900E-16 , 3.343700 , 7.0720300E-16 ,
     & 3.343850 , 8.1391502E-16 , 3.344000 , 9.2066298E-16 ,
     & 3.344150 , 1.0274500E-15 , 3.344300 , 1.1342700E-15 /
      data( xin(i), yin(i), i = 1651 , 1700 ) /
     & 3.344450 , 1.1412499E-15 , 3.344600 , 9.8853795E-16 ,
     & 3.344750 , 8.3577699E-16 , 3.344900 , 6.8296298E-16 ,
     & 3.345050 , 5.3009699E-16 , 3.345200 , 3.7717800E-16 ,
     & 3.345350 , 2.2420599E-16 , 3.345500 , 4.7052003E-16 ,
     & 3.345650 , 7.9198401E-16 , 3.345800 , 1.1135600E-15 ,
     & 3.345950 , 1.4352400E-15 , 3.346100 , 1.7570400E-15 ,
     & 3.346250 , 2.0789500E-15 , 3.346400 , 2.2278800E-15 ,
     & 3.346550 , 1.9977901E-15 , 3.346700 , 1.7676200E-15 ,
     & 3.346850 , 1.5373600E-15 , 3.347000 , 1.3070300E-15 ,
     & 3.347150 , 1.0766200E-15 , 3.347300 , 8.4613102E-16 ,
     & 3.347450 , 7.0163302E-16 , 3.347600 , 5.7861901E-16 ,
     & 3.347750 , 4.5556402E-16 , 3.347900 , 3.3246501E-16 ,
     & 3.348050 , 2.0932400E-16 , 3.348200 , 8.6141100E-17 ,
     & 3.348350 , 0.0000000E+00 , 3.348500 , 0.0000000E+00 ,
     & 3.348650 , 0.0000000E+00 , 3.348800 , 0.0000000E+00 ,
     & 3.348950 , 0.0000000E+00 , 3.349100 , 0.0000000E+00 ,
     & 3.349250 , 0.0000000E+00 , 3.349400 , 0.0000000E+00 ,
     & 3.349550 , 0.0000000E+00 , 3.349700 , 0.0000000E+00 ,
     & 3.349850 , 0.0000000E+00 , 3.350000 , 0.0000000E+00 ,
     & 3.350150 , 0.0000000E+00 , 3.350300 , 4.2900300E-17 ,
     & 3.350450 , 1.6672300E-16 , 3.350600 , 2.9058900E-16 ,
     & 3.350750 , 4.1449801E-16 , 3.350900 , 5.3845000E-16 ,
     & 3.351050 , 6.6244398E-16 , 3.351200 , 7.8648100E-16 ,
     & 3.351350 , 1.0073001E-15 , 3.351500 , 1.2400300E-15 ,
     & 3.351650 , 1.4728401E-15 , 3.351800 , 1.7057300E-15 /
      data( xin(i), yin(i), i = 1701 , 1750 ) /
     & 3.351950 , 1.9387100E-15 , 3.352100 , 2.1717601E-15 ,
     & 3.352250 , 2.2790201E-15 , 3.352400 , 2.2323799E-15 ,
     & 3.352550 , 2.1857200E-15 , 3.352700 , 2.1390500E-15 ,
     & 3.352850 , 2.0923501E-15 , 3.353000 , 2.0456500E-15 ,
     & 3.353150 , 1.9992800E-15 , 3.353300 , 1.9681200E-15 ,
     & 3.353450 , 1.9369501E-15 , 3.353600 , 1.9057699E-15 ,
     & 3.353750 , 1.8745801E-15 , 3.353900 , 1.8433800E-15 ,
     & 3.354050 , 1.8121601E-15 , 3.354200 , 1.8000001E-15 ,
     & 3.354350 , 1.8000001E-15 , 3.354500 , 1.8000001E-15 ,
     & 3.354650 , 1.8000001E-15 , 3.354800 , 1.8000001E-15 ,
     & 3.354950 , 1.8000001E-15 , 3.355100 , 1.8066300E-15 ,
     & 3.355250 , 1.8379300E-15 , 3.355400 , 1.8692399E-15 ,
     & 3.355550 , 1.9005600E-15 , 3.355700 , 1.9319000E-15 ,
     & 3.355850 , 1.9632400E-15 , 3.356000 , 1.9945900E-15 ,
     & 3.356150 , 2.2595900E-15 , 3.356300 , 2.5733401E-15 ,
     & 3.356450 , 2.8872101E-15 , 3.356600 , 3.2011800E-15 ,
     & 3.356750 , 3.5152600E-15 , 3.356900 , 3.8294499E-15 ,
     & 3.357050 , 3.9065600E-15 , 3.357200 , 3.7022002E-15 ,
     & 3.357350 , 3.4977601E-15 , 3.357500 , 3.2932601E-15 ,
     & 3.357650 , 3.0886800E-15 , 3.357800 , 2.8840301E-15 ,
     & 3.357950 , 2.7000001E-15 , 3.358100 , 2.7000001E-15 ,
     & 3.358250 , 2.7000001E-15 , 3.358400 , 2.7000001E-15 ,
     & 3.358550 , 2.7000001E-15 , 3.358700 , 2.7000001E-15 ,
     & 3.358850 , 2.7000001E-15 , 3.359000 , 2.6161701E-15 ,
     & 3.359150 , 2.5056300E-15 , 3.359300 , 2.3950500E-15 /
      data( xin(i), yin(i), i = 1751 , 1800 ) /
     & 3.359450 , 2.2844400E-15 , 3.359600 , 2.1737900E-15 ,
     & 3.359750 , 2.0630999E-15 , 3.359900 , 2.1360900E-15 ,
     & 3.360050 , 2.4525699E-15 , 3.360200 , 2.7691500E-15 ,
     & 3.360350 , 3.0858501E-15 , 3.360500 , 3.4026499E-15 ,
     & 3.360650 , 3.7195699E-15 , 3.360800 , 4.0183002E-15 ,
     & 3.360950 , 4.1768601E-15 , 3.361100 , 4.3354801E-15 ,
     & 3.361250 , 4.4941599E-15 , 3.361400 , 4.6528900E-15 ,
     & 3.361550 , 4.8116799E-15 , 3.361700 , 4.9705202E-15 ,
     & 3.361850 , 4.9482301E-15 , 3.362000 , 4.8846501E-15 ,
     & 3.362150 , 4.8210498E-15 , 3.362300 , 4.7574300E-15 ,
     & 3.362450 , 4.6937801E-15 , 3.362600 , 4.6301099E-15 ,
     & 3.362750 , 4.6083899E-15 , 3.362900 , 4.6243200E-15 ,
     & 3.363050 , 4.6402599E-15 , 3.363200 , 4.6561901E-15 ,
     & 3.363350 , 4.6721401E-15 , 3.363500 , 4.6880902E-15 ,
     & 3.363650 , 4.7242699E-15 , 3.363800 , 4.8200300E-15 ,
     & 3.363950 , 4.9158298E-15 , 3.364100 , 5.0116699E-15 ,
     & 3.364250 , 5.1075299E-15 , 3.364400 , 5.2034301E-15 ,
     & 3.364550 , 5.2993600E-15 , 3.364700 , 5.3794402E-15 ,
     & 3.364850 , 5.4594399E-15 , 3.365000 , 5.5394599E-15 ,
     & 3.365150 , 5.6195198E-15 , 3.365300 , 5.6996000E-15 ,
     & 3.365450 , 5.7797098E-15 , 3.365600 , 5.7162201E-15 ,
     & 3.365750 , 5.6039899E-15 , 3.365900 , 5.4917199E-15 ,
     & 3.366050 , 5.3794101E-15 , 3.366200 , 5.2670601E-15 ,
     & 3.366350 , 5.1546800E-15 , 3.366500 , 5.1082499E-15 ,
     & 3.366650 , 5.1243202E-15 , 3.366800 , 5.1403901E-15 /
      data( xin(i), yin(i), i = 1801 , 1850 ) /
     & 3.366950 , 5.1564600E-15 , 3.367100 , 5.1725498E-15 ,
     & 3.367250 , 5.1886401E-15 , 3.367400 , 5.2189198E-15 ,
     & 3.367550 , 5.2833202E-15 , 3.367700 , 5.3477400E-15 ,
     & 3.367850 , 5.4121801E-15 , 3.368000 , 5.4766402E-15 ,
     & 3.368150 , 5.5411299E-15 , 3.368300 , 5.5873101E-15 ,
     & 3.368450 , 5.4421100E-15 , 3.368600 , 5.2968701E-15 ,
     & 3.368750 , 5.1515701E-15 , 3.368900 , 5.0062201E-15 ,
     & 3.369050 , 4.8608299E-15 , 3.369200 , 4.7153799E-15 ,
     & 3.369350 , 4.6710801E-15 , 3.369500 , 4.6387399E-15 ,
     & 3.369650 , 4.6063901E-15 , 3.369800 , 4.5740198E-15 ,
     & 3.369950 , 4.5416399E-15 , 3.370100 , 4.5092502E-15 ,
     & 3.370250 , 4.5231500E-15 , 3.370400 , 4.5555600E-15 ,
     & 3.370550 , 4.5879798E-15 , 3.370700 , 4.6204101E-15 ,
     & 3.370850 , 4.6528600E-15 , 3.371000 , 4.6853098E-15 ,
     & 3.371150 , 4.6377701E-15 , 3.371300 , 4.5241000E-15 ,
     & 3.371450 , 4.4103799E-15 , 3.371600 , 4.2966301E-15 ,
     & 3.371750 , 4.1828401E-15 , 3.371900 , 4.0690099E-15 ,
     & 3.372050 , 4.0384498E-15 , 3.372200 , 4.1360898E-15 ,
     & 3.372350 , 4.2337599E-15 , 3.372500 , 4.3314601E-15 ,
     & 3.372650 , 4.4292001E-15 , 3.372800 , 4.5269701E-15 ,
     & 3.372950 , 4.5752201E-15 , 3.373100 , 4.4773802E-15 ,
     & 3.373250 , 4.3795102E-15 , 3.373400 , 4.2815999E-15 ,
     & 3.373550 , 4.1836601E-15 , 3.373700 , 4.0856901E-15 ,
     & 3.373850 , 4.0000000E-15 , 3.374000 , 4.0000000E-15 ,
     & 3.374150 , 4.0000000E-15 , 3.374300 , 4.0000000E-15 /
      data( xin(i), yin(i), i = 1851 , 1900 ) /
     & 3.374450 , 4.0000000E-15 , 3.374600 , 4.0000000E-15 ,
     & 3.374750 , 4.0003600E-15 , 3.374900 , 4.0331101E-15 ,
     & 3.375050 , 4.0658700E-15 , 3.375200 , 4.0986400E-15 ,
     & 3.375350 , 4.1314201E-15 , 3.375500 , 4.1642198E-15 ,
     & 3.375650 , 4.1970199E-15 , 3.375800 , 4.2447599E-15 ,
     & 3.375950 , 4.2940001E-15 , 3.376100 , 4.3432601E-15 ,
     & 3.376250 , 4.3925299E-15 , 3.376400 , 4.4418302E-15 ,
     & 3.376550 , 4.4911402E-15 , 3.376700 , 4.5000002E-15 ,
     & 3.376850 , 4.5000002E-15 , 3.377000 , 4.5000002E-15 ,
     & 3.377150 , 4.5000002E-15 , 3.377300 , 4.5000002E-15 ,
     & 3.377450 , 4.5000002E-15 , 3.377600 , 4.4632199E-15 ,
     & 3.377750 , 4.4137701E-15 , 3.377900 , 4.3643102E-15 ,
     & 3.378050 , 4.3148299E-15 , 3.378200 , 4.2653301E-15 ,
     & 3.378350 , 4.2158202E-15 , 3.378500 , 4.2899102E-15 ,
     & 3.378650 , 4.4220401E-15 , 3.378800 , 4.5542200E-15 ,
     & 3.378950 , 4.6864402E-15 , 3.379100 , 4.8187001E-15 ,
     & 3.379250 , 4.9510198E-15 , 3.379400 , 4.9583098E-15 ,
     & 3.379550 , 4.8921099E-15 , 3.379700 , 4.8258902E-15 ,
     & 3.379850 , 4.7596399E-15 , 3.380000 , 4.6933702E-15 ,
     & 3.380150 , 4.6270699E-15 , 3.380300 , 4.6000000E-15 ,
     & 3.380450 , 4.6000000E-15 , 3.380600 , 4.6000000E-15 ,
     & 3.380750 , 4.6000000E-15 , 3.380900 , 4.6000000E-15 ,
     & 3.381050 , 4.6000000E-15 , 3.381200 , 4.4495001E-15 ,
     & 3.381350 , 4.1835902E-15 , 3.381500 , 3.9175901E-15 ,
     & 3.381650 , 3.6515002E-15 , 3.381800 , 3.3853201E-15 /
      data( xin(i), yin(i), i = 1901 , 1950 ) /
     & 3.381950 , 3.1190400E-15 , 3.382100 , 2.9999999E-15 ,
     & 3.382250 , 2.9999999E-15 , 3.382400 , 2.9999999E-15 ,
     & 3.382550 , 2.9999999E-15 , 3.382700 , 2.9999999E-15 ,
     & 3.382850 , 2.9999999E-15 , 3.383000 , 2.9999999E-15 ,
     & 3.383150 , 2.9999999E-15 , 3.383300 , 2.9999999E-15 ,
     & 3.383450 , 2.9999999E-15 , 3.383600 , 2.9999999E-15 ,
     & 3.383750 , 2.9999999E-15 , 3.383900 , 2.9999999E-15 ,
     & 3.384050 , 2.9999999E-15 , 3.384200 , 2.9999999E-15 ,
     & 3.384350 , 2.9999999E-15 , 3.384500 , 2.9999999E-15 ,
     & 3.384650 , 2.9999999E-15 , 3.384800 , 3.0197099E-15 ,
     & 3.384950 , 3.0532300E-15 , 3.385100 , 3.0867600E-15 ,
     & 3.385250 , 3.1202900E-15 , 3.385400 , 3.1538399E-15 ,
     & 3.385550 , 3.1874100E-15 , 3.385700 , 3.2839201E-15 ,
     & 3.385850 , 3.4182599E-15 , 3.386000 , 3.5526400E-15 ,
     & 3.386150 , 3.6870700E-15 , 3.386300 , 3.8215501E-15 ,
     & 3.386450 , 3.9560801E-15 , 3.386600 , 4.0566500E-15 ,
     & 3.386750 , 4.1407900E-15 , 3.386900 , 4.2249601E-15 ,
     & 3.387050 , 4.3091501E-15 , 3.387200 , 4.3933702E-15 ,
     & 3.387350 , 4.4776300E-15 , 3.387500 , 4.5000002E-15 ,
     & 3.387650 , 4.5000002E-15 , 3.387800 , 4.5000002E-15 ,
     & 3.387950 , 4.5000002E-15 , 3.388100 , 4.5000002E-15 ,
     & 3.388250 , 4.5000002E-15 , 3.388400 , 4.4317899E-15 ,
     & 3.388550 , 4.3473102E-15 , 3.388700 , 4.2627899E-15 ,
     & 3.388850 , 4.1782501E-15 , 3.389000 , 4.0936802E-15 ,
     & 3.389150 , 4.0090700E-15 , 3.389300 , 4.0755600E-15 /
      data( xin(i), yin(i), i = 1951 , 2000 ) /
     & 3.389450 , 4.1602201E-15 , 3.389600 , 4.2449099E-15 ,
     & 3.389750 , 4.3296301E-15 , 3.389900 , 4.4143800E-15 ,
     & 3.390050 , 4.4991502E-15 , 3.390200 , 4.7350899E-15 ,
     & 3.390350 , 4.9726302E-15 , 3.390500 , 5.2102602E-15 ,
     & 3.390650 , 5.4479601E-15 , 3.390800 , 5.6857502E-15 ,
     & 3.390950 , 5.8983101E-15 , 3.391100 , 5.8813199E-15 ,
     & 3.391250 , 5.8643098E-15 , 3.391400 , 5.8473098E-15 ,
     & 3.391550 , 5.8302900E-15 , 3.391700 , 5.8132701E-15 ,
     & 3.391850 , 5.8375499E-15 , 3.392000 , 6.0078700E-15 ,
     & 3.392150 , 6.1782401E-15 , 3.392300 , 6.3486801E-15 ,
     & 3.392450 , 6.5191802E-15 , 3.392600 , 6.6897298E-15 ,
     & 3.392750 , 6.7698299E-15 , 3.392900 , 6.6844901E-15 ,
     & 3.393050 , 6.5991299E-15 , 3.393200 , 6.5137300E-15 ,
     & 3.393350 , 6.4283101E-15 , 3.393500 , 6.3428499E-15 ,
     & 3.393650 , 6.3170502E-15 , 3.393800 , 6.3512601E-15 ,
     & 3.393950 , 6.3854701E-15 , 3.394100 , 6.4197000E-15 ,
     & 3.394250 , 6.4539400E-15 , 3.394400 , 6.4882000E-15 ,
     & 3.394550 , 6.5000000E-15 , 3.394700 , 6.5000000E-15 ,
     & 3.394850 , 6.5000000E-15 , 3.395000 , 6.5000000E-15 ,
     & 3.395150 , 6.5000000E-15 , 3.395300 , 6.5000000E-15 ,
     & 3.395450 , 6.5707399E-15 , 3.395600 , 6.6566100E-15 ,
     & 3.395750 , 6.7425000E-15 , 3.395900 , 6.8284298E-15 ,
     & 3.396050 , 6.9143901E-15 , 3.396200 , 6.9999298E-15 ,
     & 3.396350 , 6.9827198E-15 , 3.396500 , 6.9655098E-15 ,
     & 3.396650 , 6.9483002E-15 , 3.396800 , 6.9310800E-15 /
      data( xin(i), yin(i), i = 2001 , 2050 ) /
     & 3.396950 , 6.9138501E-15 , 3.397100 , 6.8966202E-15 ,
     & 3.397250 , 6.8793801E-15 , 3.397400 , 6.8621298E-15 ,
     & 3.397550 , 6.8448800E-15 , 3.397700 , 6.8276200E-15 ,
     & 3.397850 , 6.8103600E-15 , 3.398000 , 6.8483499E-15 ,
     & 3.398150 , 6.9692702E-15 , 3.398300 , 7.0902401E-15 ,
     & 3.398450 , 7.2112497E-15 , 3.398600 , 7.3322899E-15 ,
     & 3.398750 , 7.4533902E-15 , 3.398900 , 7.3935498E-15 ,
     & 3.399050 , 7.2204400E-15 , 3.399200 , 7.0472798E-15 ,
     & 3.399350 , 6.8740501E-15 , 3.399500 , 6.7007599E-15 ,
     & 3.399650 , 6.5274201E-15 , 3.399800 , 6.3540100E-15 ,
     & 3.399950 , 6.1805500E-15 , 3.400100 , 6.0070200E-15 ,
     & 3.400250 , 5.8334401E-15 , 3.400400 , 5.6597899E-15 ,
     & 3.400550 , 5.5139100E-15 , 3.400700 , 5.6876801E-15 ,
     & 3.400850 , 5.8615002E-15 , 3.401000 , 6.0353901E-15 ,
     & 3.401150 , 6.2093300E-15 , 3.401300 , 6.3833398E-15 ,
     & 3.401450 , 6.4425999E-15 , 3.401600 , 6.2684699E-15 ,
     & 3.401750 , 6.0942898E-15 , 3.401900 , 5.9200399E-15 ,
     & 3.402050 , 5.7457400E-15 , 3.402200 , 5.5713698E-15 ,
     & 3.402350 , 5.6030598E-15 , 3.402500 , 5.7775402E-15 ,
     & 3.402650 , 5.9520899E-15 , 3.402800 , 6.1266998E-15 ,
     & 3.402950 , 6.3013602E-15 , 3.403100 , 6.4760899E-15 ,
     & 3.403250 , 6.3943800E-15 , 3.403400 , 6.2719901E-15 ,
     & 3.403550 , 6.1495498E-15 , 3.403700 , 6.0270799E-15 ,
     & 3.403850 , 5.9045502E-15 , 3.404000 , 5.8488798E-15 ,
     & 3.404150 , 6.1816702E-15 , 3.404300 , 6.5145702E-15 /
      data( xin(i), yin(i), i = 2051 , 2100 ) /
     & 3.404450 , 6.8475799E-15 , 3.404600 , 7.1807201E-15 ,
     & 3.404750 , 7.5139598E-15 , 3.404900 , 7.5914498E-15 ,
     & 3.405050 , 7.3457298E-15 , 3.405200 , 7.0999199E-15 ,
     & 3.405350 , 6.8540301E-15 , 3.405500 , 6.6080602E-15 ,
     & 3.405650 , 6.3620001E-15 , 3.405800 , 6.1290101E-15 ,
     & 3.405950 , 5.9003701E-15 , 3.406100 , 5.6716500E-15 ,
     & 3.406250 , 5.4428499E-15 , 3.406400 , 5.2139702E-15 ,
     & 3.406550 , 4.9976901E-15 , 3.406700 , 4.9624598E-15 ,
     & 3.406850 , 4.9272101E-15 , 3.407000 , 4.8919498E-15 ,
     & 3.407150 , 4.8566701E-15 , 3.407300 , 4.8213899E-15 ,
     & 3.407450 , 4.8695399E-15 , 3.407600 , 5.0460899E-15 ,
     & 3.407750 , 5.2226900E-15 , 3.407900 , 5.3993599E-15 ,
     & 3.408050 , 5.5760899E-15 , 3.408200 , 5.7528898E-15 ,
     & 3.408350 , 5.8129699E-15 , 3.408500 , 5.8306699E-15 ,
     & 3.408650 , 5.8483602E-15 , 3.408800 , 5.8660699E-15 ,
     & 3.408950 , 5.8837801E-15 , 3.409100 , 5.8895598E-15 ,
     & 3.409250 , 5.7655000E-15 , 3.409400 , 5.6414101E-15 ,
     & 3.409550 , 5.5172698E-15 , 3.409700 , 5.3930800E-15 ,
     & 3.409850 , 5.2688600E-15 , 3.410000 , 5.1604199E-15 ,
     & 3.410150 , 5.0716301E-15 , 3.410300 , 4.9828001E-15 ,
     & 3.410450 , 4.8939501E-15 , 3.410600 , 4.8050599E-15 ,
     & 3.410750 , 4.7161499E-15 , 3.410900 , 4.7727998E-15 ,
     & 3.411050 , 4.8617798E-15 , 3.411200 , 4.9507898E-15 ,
     & 3.411350 , 5.0398299E-15 , 3.411500 , 5.1289001E-15 ,
     & 3.411650 , 5.2000001E-15 , 3.411800 , 5.2000001E-15 /
      data( xin(i), yin(i), i = 2101 , 2150 ) /
     & 3.411950 , 5.2000001E-15 , 3.412100 , 5.2000001E-15 ,
     & 3.412250 , 5.2000001E-15 , 3.412400 , 5.2000001E-15 ,
     & 3.412550 , 5.1893499E-15 , 3.412700 , 5.1714902E-15 ,
     & 3.412850 , 5.1536199E-15 , 3.413000 , 5.1357399E-15 ,
     & 3.413150 , 5.1178599E-15 , 3.413300 , 5.0997698E-15 ,
     & 3.413450 , 4.9566200E-15 , 3.413600 , 4.8134202E-15 ,
     & 3.413750 , 4.6701699E-15 , 3.413900 , 4.5268600E-15 ,
     & 3.414050 , 4.3835099E-15 , 3.414200 , 4.2775401E-15 ,
     & 3.414350 , 4.2237501E-15 , 3.414500 , 4.1699398E-15 ,
     & 3.414650 , 4.1160999E-15 , 3.414800 , 4.0622502E-15 ,
     & 3.414950 , 4.0083899E-15 , 3.415100 , 4.2274999E-15 ,
     & 3.415250 , 4.4970301E-15 , 3.415400 , 4.7666500E-15 ,
     & 3.415550 , 5.0363601E-15 , 3.415700 , 5.3061701E-15 ,
     & 3.415850 , 5.5608598E-15 , 3.416000 , 5.7768498E-15 ,
     & 3.416150 , 5.9929199E-15 , 3.416300 , 6.2090700E-15 ,
     & 3.416450 , 6.4252798E-15 , 3.416600 , 6.6415798E-15 ,
     & 3.416750 , 6.4762398E-15 , 3.416900 , 6.1696199E-15 ,
     & 3.417050 , 5.8628800E-15 , 3.417200 , 5.5560402E-15 ,
     & 3.417350 , 5.2491000E-15 , 3.417500 , 5.0068198E-15 ,
     & 3.417650 , 5.0429500E-15 , 3.417800 , 5.0791001E-15 ,
     & 3.417950 , 5.1152599E-15 , 3.418100 , 5.1514401E-15 ,
     & 3.418250 , 5.1876198E-15 , 3.418400 , 5.3786698E-15 ,
     & 3.418550 , 5.6502502E-15 , 3.418700 , 5.9219301E-15 ,
     & 3.418850 , 6.1937002E-15 , 3.419000 , 6.4655600E-15 ,
     & 3.419150 , 6.6925001E-15 , 3.419300 , 6.6380901E-15 /
      data( xin(i), yin(i), i = 2151 , 2200 ) /
     & 3.419450 , 6.5836601E-15 , 3.419600 , 6.5292099E-15 ,
     & 3.419750 , 6.4747402E-15 , 3.419900 , 6.4202501E-15 ,
     & 3.420050 , 6.0689199E-15 , 3.420200 , 5.5418600E-15 ,
     & 3.420350 , 5.0146201E-15 , 3.420500 , 4.4871901E-15 ,
     & 3.420650 , 3.9595902E-15 , 3.420800 , 3.4905900E-15 ,
     & 3.420950 , 3.4177699E-15 , 3.421100 , 3.3449200E-15 ,
     & 3.421250 , 3.2720499E-15 , 3.421400 , 3.1991501E-15 ,
     & 3.421550 , 3.1262201E-15 , 3.421700 , 2.9715000E-15 ,
     & 3.421850 , 2.7708199E-15 , 3.422000 , 2.5700699E-15 ,
     & 3.422150 , 2.3692500E-15 , 3.422300 , 2.1683700E-15 ,
     & 3.422450 , 2.0059301E-15 , 3.422600 , 2.0424800E-15 ,
     & 3.422750 , 2.0790400E-15 , 3.422900 , 2.1156101E-15 ,
     & 3.423050 , 2.1522000E-15 , 3.423200 , 2.1888001E-15 ,
     & 3.423350 , 2.1110401E-15 , 3.423500 , 1.9828499E-15 ,
     & 3.423650 , 1.8546100E-15 , 3.423800 , 1.7263300E-15 ,
     & 3.423950 , 1.5980100E-15 , 3.424100 , 1.5216900E-15 ,
     & 3.424250 , 1.6134100E-15 , 3.424400 , 1.7051700E-15 ,
     & 3.424550 , 1.7969499E-15 , 3.424700 , 1.8887700E-15 ,
     & 3.424850 , 1.9806201E-15 , 3.425000 , 2.0725101E-15 ,
     & 3.425150 , 2.1644199E-15 , 3.425300 , 2.2563700E-15 ,
     & 3.425450 , 2.3483400E-15 , 3.425600 , 2.4403500E-15 ,
     & 3.425750 , 2.5000000E-15 , 3.425900 , 2.5000000E-15 ,
     & 3.426050 , 2.5000000E-15 , 3.426200 , 2.5000000E-15 ,
     & 3.426350 , 2.5000000E-15 , 3.426500 , 2.5000000E-15 ,
     & 3.426650 , 2.5000000E-15 , 3.426800 , 2.5000000E-15 /
      data( xin(i), yin(i), i = 2201 , 2250 ) /
     & 3.426950 , 2.5000000E-15 , 3.427100 , 2.5000000E-15 ,
     & 3.427250 , 2.5000000E-15 , 3.427400 , 2.5469499E-15 ,
     & 3.427550 , 2.6393699E-15 , 3.427700 , 2.7318299E-15 ,
     & 3.427850 , 2.8243100E-15 , 3.428000 , 2.9168300E-15 ,
     & 3.428150 , 3.0150100E-15 , 3.428300 , 3.1631501E-15 ,
     & 3.428450 , 3.3113300E-15 , 3.428600 , 3.4595699E-15 ,
     & 3.428750 , 3.6078500E-15 , 3.428900 , 3.7561901E-15 ,
     & 3.429050 , 3.8522902E-15 , 3.429200 , 3.9265102E-15 ,
     & 3.429350 , 4.0007598E-15 , 3.429500 , 4.0750302E-15 ,
     & 3.429650 , 4.1493201E-15 , 3.429800 , 4.1881798E-15 ,
     & 3.429950 , 4.1510002E-15 , 3.430100 , 4.1138201E-15 ,
     & 3.430250 , 4.0766201E-15 , 3.430400 , 4.0394002E-15 ,
     & 3.430550 , 4.0021799E-15 , 3.430700 , 3.8246900E-15 ,
     & 3.430850 , 3.6384300E-15 , 3.431000 , 3.4521101E-15 ,
     & 3.431150 , 3.2657300E-15 , 3.431300 , 3.0792801E-15 ,
     & 3.431450 , 3.1072400E-15 , 3.431600 , 3.2938100E-15 ,
     & 3.431750 , 3.4804601E-15 , 3.431900 , 3.6671699E-15 ,
     & 3.432050 , 3.8539402E-15 , 3.432200 , 4.0815498E-15 ,
     & 3.432350 , 4.4553501E-15 , 3.432500 , 4.8292800E-15 ,
     & 3.432650 , 5.2033399E-15 , 3.432800 , 5.5775298E-15 ,
     & 3.432950 , 5.9518498E-15 , 3.433100 , 5.9836902E-15 ,
     & 3.433250 , 5.9649602E-15 , 3.433400 , 5.9462200E-15 ,
     & 3.433550 , 5.9274798E-15 , 3.433700 , 5.9087299E-15 ,
     & 3.433850 , 5.9100199E-15 , 3.434000 , 5.9287902E-15 ,
     & 3.434150 , 5.9475498E-15 , 3.434300 , 5.9663298E-15 /
      data( xin(i), yin(i), i = 2251 , 2300 ) /
     & 3.434450 , 5.9851098E-15 , 3.434600 , 5.9999998E-15 ,
     & 3.434750 , 5.9999998E-15 , 3.434900 , 5.9999998E-15 ,
     & 3.435050 , 5.9999998E-15 , 3.435200 , 5.9999998E-15 ,
     & 3.435350 , 5.9999998E-15 , 3.435500 , 5.9664899E-15 ,
     & 3.435650 , 5.9288300E-15 , 3.435800 , 5.8911501E-15 ,
     & 3.435950 , 5.8534601E-15 , 3.436100 , 5.8157498E-15 ,
     & 3.436250 , 5.7670501E-15 , 3.436400 , 5.7104501E-15 ,
     & 3.436550 , 5.6538399E-15 , 3.436700 , 5.5972001E-15 ,
     & 3.436850 , 5.5405501E-15 , 3.437000 , 5.5806198E-15 ,
     & 3.437150 , 5.8640900E-15 , 3.437300 , 6.1476499E-15 ,
     & 3.437450 , 6.4313098E-15 , 3.437600 , 6.7150798E-15 ,
     & 3.437750 , 6.9989299E-15 , 3.437900 , 6.9811401E-15 ,
     & 3.438050 , 6.9622000E-15 , 3.438200 , 6.9432599E-15 ,
     & 3.438350 , 6.9243101E-15 , 3.438500 , 6.9053501E-15 ,
     & 3.438650 , 6.8591699E-15 , 3.438800 , 6.8022599E-15 ,
     & 3.438950 , 6.7453299E-15 , 3.439100 , 6.6883801E-15 ,
     & 3.439250 , 6.6314099E-15 , 3.439400 , 6.5829499E-15 ,
     & 3.439550 , 6.5449499E-15 , 3.439700 , 6.5069300E-15 ,
     & 3.439850 , 6.4688999E-15 , 3.440000 , 6.4308499E-15 ,
     & 3.440150 , 6.3315501E-15 , 3.440300 , 5.9698700E-15 ,
     & 3.440450 , 5.6080802E-15 , 3.440600 , 5.2461498E-15 ,
     & 3.440750 , 4.8841101E-15 , 3.440900 , 4.5219299E-15 ,
     & 3.441050 , 4.2312900E-15 , 3.441200 , 3.9451699E-15 ,
     & 3.441350 , 3.6589498E-15 , 3.441500 , 3.3726201E-15 ,
     & 3.441650 , 3.0861999E-15 , 3.441800 , 2.9065201E-15 /
      data( xin(i), yin(i), i = 2301 , 2350 ) /
     & 3.441950 , 2.7727600E-15 , 3.442100 , 2.6389599E-15 ,
     & 3.442250 , 2.5051201E-15 , 3.442400 , 2.3712200E-15 ,
     & 3.442550 , 2.2462399E-15 , 3.442700 , 2.1314000E-15 ,
     & 3.442850 , 2.0165099E-15 , 3.443000 , 1.9015900E-15 ,
     & 3.443150 , 1.7866199E-15 , 3.443300 , 1.6905400E-15 ,
     & 3.443450 , 1.6521900E-15 , 3.443600 , 1.6138300E-15 ,
     & 3.443750 , 1.5754600E-15 , 3.443900 , 1.5370700E-15 ,
     & 3.444050 , 1.5053300E-15 , 3.444200 , 1.6589900E-15 ,
     & 3.444350 , 1.8127001E-15 , 3.444500 , 1.9664600E-15 ,
     & 3.444650 , 2.1202800E-15 , 3.444800 , 2.2741501E-15 ,
     & 3.444950 , 1.9638201E-15 , 3.445100 , 1.5596400E-15 ,
     & 3.445250 , 1.1553100E-15 , 3.445400 , 7.5084500E-16 ,
     & 3.445550 , 3.4623999E-16 , 3.445700 , 2.7385801E-16 ,
     & 3.445850 , 3.8954000E-16 , 3.446000 , 5.0526098E-16 ,
     & 3.446150 , 6.2102200E-16 , 3.446300 , 7.3682300E-16 ,
     & 3.446450 , 7.9122301E-16 , 3.446600 , 7.7190901E-16 ,
     & 3.446750 , 7.5258899E-16 , 3.446900 , 7.3326202E-16 ,
     & 3.447050 , 7.1392802E-16 , 3.447200 , 6.7835200E-16 ,
     & 3.447350 , 6.0096501E-16 , 3.447500 , 5.2355001E-16 ,
     & 3.447650 , 4.4610901E-16 , 3.447800 , 3.6864099E-16 ,
     & 3.447950 , 3.1106700E-16 , 3.448100 , 4.0796900E-16 ,
     & 3.448250 , 5.0490400E-16 , 3.448400 , 6.0187302E-16 ,
     & 3.448550 , 6.9887503E-16 , 3.448700 , 7.9591101E-16 ,
     & 3.448850 , 7.0701999E-16 , 3.449000 , 6.0991698E-16 ,
     & 3.449150 , 5.1278099E-16 , 3.449300 , 4.1561101E-16 /
      data( xin(i), yin(i), i = 2351 , 2400 ) /
     & 3.449450 , 3.1840699E-16 , 3.449600 , 3.0000001E-16 ,
     & 3.449750 , 3.0000001E-16 , 3.449900 , 3.0000001E-16 ,
     & 3.450050 , 3.0000001E-16 , 3.450200 , 3.0000001E-16 ,
     & 3.450350 , 7.3242902E-16 , 3.450500 , 1.3755200E-15 ,
     & 3.450650 , 2.0188399E-15 , 3.450800 , 2.6623800E-15 ,
     & 3.450950 , 3.3061500E-15 , 3.451100 , 3.8228100E-15 ,
     & 3.451250 , 4.2327600E-15 , 3.451400 , 4.6428502E-15 ,
     & 3.451550 , 5.0530898E-15 , 3.451700 , 5.4634599E-15 ,
     & 3.451850 , 5.7414201E-15 , 3.452000 , 5.8391999E-15 ,
     & 3.452150 , 5.9370102E-15 , 3.452300 , 6.0348501E-15 ,
     & 3.452450 , 6.1327299E-15 , 3.452600 , 6.2796702E-15 ,
     & 3.452750 , 6.5343201E-15 , 3.452900 , 6.7890699E-15 ,
     & 3.453050 , 7.0439002E-15 , 3.453200 , 7.2988202E-15 ,
     & 3.453350 , 7.4917201E-15 , 3.453500 , 7.4524703E-15 ,
     & 3.453650 , 7.4132103E-15 , 3.453800 , 7.3739402E-15 ,
     & 3.453950 , 7.3346497E-15 , 3.454100 , 7.2930299E-15 ,
     & 3.454250 , 7.2340603E-15 , 3.454400 , 7.1750704E-15 ,
     & 3.454550 , 7.1160602E-15 , 3.454700 , 7.0570300E-15 ,
     & 3.454850 , 6.9959500E-15 , 3.455000 , 6.8778101E-15 ,
     & 3.455150 , 6.7596198E-15 , 3.455300 , 6.6413998E-15 ,
     & 3.455450 , 6.5231299E-15 , 3.455600 , 6.4048201E-15 ,
     & 3.455750 , 6.2297101E-15 , 3.455900 , 6.0521300E-15 ,
     & 3.456050 , 5.8744801E-15 , 3.456200 , 5.6967701E-15 ,
     & 3.456350 , 5.5189999E-15 , 3.456500 , 5.5529401E-15 ,
     & 3.456650 , 5.6122400E-15 , 3.456800 , 5.6715598E-15 /
      data( xin(i), yin(i), i = 2401 , 2450 ) /
     & 3.456950 , 5.7308898E-15 , 3.457100 , 5.7902499E-15 ,
     & 3.457250 , 5.8661800E-15 , 3.457400 , 5.9453802E-15 ,
     & 3.457550 , 6.0246002E-15 , 3.457700 , 6.1038600E-15 ,
     & 3.457850 , 6.1831402E-15 , 3.458000 , 6.0907200E-15 ,
     & 3.458150 , 5.9518799E-15 , 3.458300 , 5.8129902E-15 ,
     & 3.458450 , 5.6740598E-15 , 3.458600 , 5.5350799E-15 ,
     & 3.458750 , 5.4257500E-15 , 3.458900 , 5.3264100E-15 ,
     & 3.459050 , 5.2270302E-15 , 3.459200 , 5.1276198E-15 ,
     & 3.459350 , 5.0281701E-15 , 3.459500 , 4.9572201E-15 ,
     & 3.459650 , 4.8975102E-15 , 3.459800 , 4.8377800E-15 ,
     & 3.459950 , 4.7780298E-15 , 3.460100 , 4.7182598E-15 ,
     & 3.460250 , 4.6723100E-15 , 3.460400 , 4.6324401E-15 ,
     & 3.460550 , 4.5925500E-15 , 3.460700 , 4.5526500E-15 ,
     & 3.460850 , 4.5127298E-15 , 3.461000 , 4.4456101E-15 ,
     & 3.461150 , 4.3657200E-15 , 3.461300 , 4.2858101E-15 ,
     & 3.461450 , 4.2058701E-15 , 3.461600 , 4.1259000E-15 ,
     & 3.461750 , 3.8971300E-15 , 3.461900 , 3.5970402E-15 ,
     & 3.462050 , 3.2968500E-15 , 3.462200 , 2.9965499E-15 ,
     & 3.462350 , 2.6961499E-15 , 3.462500 , 2.6272499E-15 ,
     & 3.462650 , 2.6673300E-15 , 3.462800 , 2.7074199E-15 ,
     & 3.462950 , 2.7475301E-15 , 3.463100 , 2.7876600E-15 ,
     & 3.463250 , 2.8000000E-15 , 3.463400 , 2.8000000E-15 ,
     & 3.463550 , 2.8000000E-15 , 3.463700 , 2.8000000E-15 ,
     & 3.463850 , 2.8000000E-15 , 3.464000 , 2.8000000E-15 ,
     & 3.464150 , 2.8000000E-15 , 3.464300 , 2.8000000E-15 /
      data( xin(i), yin(i), i = 2451 , 2500 ) /
     & 3.464450 , 2.8000000E-15 , 3.464600 , 2.8000000E-15 ,
     & 3.464750 , 2.8149601E-15 , 3.464900 , 2.8351099E-15 ,
     & 3.465050 , 2.8552600E-15 , 3.465200 , 2.8754200E-15 ,
     & 3.465350 , 2.8955800E-15 , 3.465500 , 3.2308600E-15 ,
     & 3.465650 , 3.6546300E-15 , 3.465800 , 4.0785500E-15 ,
     & 3.465950 , 4.5026099E-15 , 3.466100 , 4.9268201E-15 ,
     & 3.466250 , 5.1672301E-15 , 3.466400 , 5.3693698E-15 ,
     & 3.466550 , 5.5715900E-15 , 3.466700 , 5.7738700E-15 ,
     & 3.466850 , 5.9762299E-15 , 3.467000 , 5.8213500E-15 ,
     & 3.467150 , 5.6188600E-15 , 3.467300 , 5.4162899E-15 ,
     & 3.467450 , 5.2136602E-15 , 3.467600 , 5.0109601E-15 ,
     & 3.467750 , 4.9616399E-15 , 3.467900 , 4.9210700E-15 ,
     & 3.468050 , 4.8804802E-15 , 3.468200 , 4.8398899E-15 ,
     & 3.468350 , 4.8025299E-15 , 3.468500 , 4.9447200E-15 ,
     & 3.468650 , 5.0869500E-15 , 3.468800 , 5.2292401E-15 ,
     & 3.468950 , 5.3715700E-15 , 3.469100 , 5.4900301E-15 ,
     & 3.469250 , 5.3882900E-15 , 3.469400 , 5.2865198E-15 ,
     & 3.469550 , 5.1847098E-15 , 3.469700 , 5.0828698E-15 ,
     & 3.469850 , 4.9695902E-15 , 3.470000 , 4.8065198E-15 ,
     & 3.470150 , 4.6434101E-15 , 3.470300 , 4.4802300E-15 ,
     & 3.470450 , 4.3170000E-15 , 3.470600 , 4.1826398E-15 ,
     & 3.470750 , 4.1213900E-15 , 3.470900 , 4.0601101E-15 ,
     & 3.471050 , 3.9988201E-15 , 3.471200 , 3.9375000E-15 ,
     & 3.471350 , 3.9874101E-15 , 3.471500 , 4.2123901E-15 ,
     & 3.471650 , 4.4374599E-15 , 3.471800 , 4.6626000E-15 /
      data( xin(i), yin(i), i = 2501 , 2550 ) /
     & 3.471950 , 4.8878201E-15 , 3.472100 , 4.9485901E-15 ,
     & 3.472250 , 4.8461402E-15 , 3.472400 , 4.7436598E-15 ,
     & 3.472550 , 4.6411502E-15 , 3.472700 , 4.5385999E-15 ,
     & 3.472850 , 4.3848300E-15 , 3.473000 , 4.2001099E-15 ,
     & 3.473150 , 4.0153300E-15 , 3.473300 , 3.8304901E-15 ,
     & 3.473450 , 3.6455798E-15 , 3.473600 , 3.8168300E-15 ,
     & 3.473750 , 4.1046598E-15 , 3.473900 , 4.3925900E-15 ,
     & 3.474050 , 4.6806202E-15 , 3.474200 , 4.9687499E-15 ,
     & 3.474350 , 4.9999999E-15 , 3.474500 , 4.9999999E-15 ,
     & 3.474650 , 4.9999999E-15 , 3.474800 , 4.9999999E-15 ,
     & 3.474950 , 4.9781998E-15 , 3.475100 , 4.4007402E-15 ,
     & 3.475250 , 3.8230798E-15 , 3.475400 , 3.2452299E-15 ,
     & 3.475550 , 2.6671700E-15 , 3.475700 , 2.1523899E-15 ,
     & 3.475850 , 1.9044801E-15 , 3.476000 , 1.6564900E-15 ,
     & 3.476150 , 1.4084100E-15 , 3.476300 , 1.1602400E-15 ,
     & 3.476450 , 1.2200300E-15 , 3.476600 , 1.8408800E-15 ,
     & 3.476750 , 2.4619400E-15 , 3.476900 , 3.0832101E-15 ,
     & 3.477050 , 3.7047002E-15 , 3.477200 , 3.8694401E-15 ,
     & 3.477350 , 3.6206699E-15 , 3.477500 , 3.3718201E-15 ,
     & 3.477650 , 3.1228800E-15 , 3.477800 , 2.8738500E-15 ,
     & 3.477950 , 2.4202800E-15 , 3.478100 , 1.8803500E-15 ,
     & 3.478250 , 1.3402400E-15 , 3.478400 , 7.9993601E-16 ,
     & 3.478550 , 2.5944900E-16 , 3.478700 , 1.6298300E-16 ,
     & 3.478850 , 1.2137799E-16 , 3.479000 , 7.9758998E-17 ,
     & 3.479150 , 3.8125601E-17 , 3.479300 , 1.4088600E-17 /
      data( xin(i), yin(i), i = 2551 , 2600 ) /
     & 3.479450 , 1.8073701E-16 , 3.479600 , 3.4744399E-16 ,
     & 3.479750 , 5.1420702E-16 , 3.479900 , 6.8102900E-16 ,
     & 3.480050 , 7.5209199E-16 , 3.480200 , 5.8515498E-16 ,
     & 3.480350 , 4.1816100E-16 , 3.480500 , 2.5110901E-16 ,
     & 3.480650 , 8.3998901E-17 , 3.480800 , 1.0396100E-16 ,
     & 3.480950 , 3.1299199E-16 , 3.481100 , 5.2209602E-16 ,
     & 3.481250 , 7.3127202E-16 , 3.481400 , 9.4052103E-16 ,
     & 3.481550 , 1.1198700E-15 , 3.481700 , 1.2873900E-15 ,
     & 3.481850 , 1.4549600E-15 , 3.482000 , 1.6225900E-15 ,
     & 3.482150 , 1.7902799E-15 , 3.482300 , 1.4839499E-15 ,
     & 3.482450 , 1.1483500E-15 , 3.482600 , 8.1262202E-16 ,
     & 3.482750 , 4.7678198E-16 , 3.482900 , 2.2958701E-16 ,
     & 3.483050 , 3.9762299E-16 , 3.483200 , 5.6571599E-16 ,
     & 3.483350 , 7.3386802E-16 , 3.483500 , 9.0207802E-16 ,
     & 3.483650 , 9.8241295E-16 , 3.483800 , 9.4033204E-16 ,
     & 3.483950 , 8.9823598E-16 , 3.484100 , 8.5612500E-16 ,
     & 3.484250 , 8.1399999E-16 , 3.484400 , 7.5778998E-16 ,
     & 3.484550 , 6.9455902E-16 , 3.484700 , 6.3130498E-16 ,
     & 3.484850 , 5.6802998E-16 , 3.485000 , 5.0473301E-16 ,
     & 3.485150 , 5.9764300E-16 , 3.485300 , 7.0321099E-16 ,
     & 3.485450 , 8.0881498E-16 , 3.485600 , 9.1445603E-16 ,
     & 3.485750 , 1.0241600E-15 , 3.485900 , 1.1510200E-15 ,
     & 3.486050 , 1.2779200E-15 , 3.486200 , 1.4048600E-15 ,
     & 3.486350 , 1.5318500E-15 , 3.486500 , 1.5018600E-15 ,
     & 3.486650 , 1.2900700E-15 , 3.486800 , 1.0782000E-15 /
      data( xin(i), yin(i), i = 2601 , 2650 ) /
     & 3.486950 , 8.6626499E-16 , 3.487100 , 6.5425201E-16 ,
     & 3.487250 , 8.6831698E-16 , 3.487400 , 1.2289900E-15 ,
     & 3.487550 , 1.5897800E-15 , 3.487700 , 1.9506999E-15 ,
     & 3.487850 , 2.2917099E-15 , 3.488000 , 2.0367600E-15 ,
     & 3.488150 , 1.7817300E-15 , 3.488300 , 1.5266100E-15 ,
     & 3.488450 , 1.2714100E-15 , 3.488600 , 1.0231000E-15 ,
     & 3.488750 , 7.8900002E-16 , 3.488900 , 5.5481802E-16 ,
     & 3.489050 , 3.2055401E-16 , 3.489200 , 8.6209703E-17 ,
     & 3.489350 , 0.0000000E+00 , 3.489500 , 0.0000000E+00 ,
     & 3.489650 , 0.0000000E+00 , 3.489800 , 0.0000000E+00 ,
     & 3.489950 , 0.0000000E+00 , 3.490100 , 0.0000000E+00 ,
     & 3.490250 , 0.0000000E+00 , 3.490400 , 0.0000000E+00 ,
     & 3.490550 , 1.2596900E-15 , 3.490700 , 1.4610300E-15 ,
     & 3.490850 , 9.5895903E-16 , 3.491000 , 1.8536901E-15 ,
     & 3.491150 , 3.3905000E-16 , 3.491300 , 6.3226499E-16 ,
     & 3.491450 , 1.7137600E-15 , 3.491600 , 2.3133899E-15 ,
     & 3.491750 , 1.5824300E-15 , 3.491900 , 1.7156400E-15 ,
     & 3.492050 , 1.9963300E-15 , 3.492200 , 2.2154799E-15 ,
     & 3.492350 , 2.9901000E-15 , 3.492500 , 3.3845700E-15 ,
     & 3.492650 , 2.8135000E-15 , 3.492800 , 1.7956700E-15 ,
     & 3.492950 , 2.9958600E-15 , 3.493100 , 1.7852200E-15 ,
     & 3.493250 , 1.2235000E-15 , 3.493400 , 3.7980301E-15 ,
     & 3.493550 , 3.6806000E-15 , 3.493700 , 6.4623299E-15 ,
     & 3.493850 , 3.8824801E-15 , 3.494000 , 3.7082501E-15 ,
     & 3.494150 , 1.4134100E-15 , 3.494300 , 3.5437599E-15 /
      data( xin(i), yin(i), i = 2651 , 2700 ) /
     & 3.494450 , 2.2560900E-15 , 3.494600 , 1.7173600E-15 ,
     & 3.494750 , 2.0055701E-15 , 3.494900 , 2.2394700E-15 ,
     & 3.495050 , 2.6242800E-15 , 3.495200 , 1.3234600E-15 ,
     & 3.495350 , 3.4420200E-15 , 3.495500 , 3.5388901E-15 ,
     & 3.495650 , 2.9215600E-15 , 3.495800 , 2.9847700E-15 ,
     & 3.495950 , 2.2538700E-15 , 3.496100 , 4.2891101E-15 ,
     & 3.496250 , 2.2632801E-15 , 3.496400 , 2.7108500E-15 ,
     & 3.496550 , 3.4318300E-15 , 3.496700 , 3.1601601E-15 ,
     & 3.496850 , 1.1497600E-15 , 3.497000 , 8.6636499E-16 ,
     & 3.497150 , 1.1213200E-15 , 3.497300 , 1.7608599E-15 ,
     & 3.497450 , 1.1899100E-15 , 3.497600 , 1.4386100E-15 ,
     & 3.497750 , 1.8243300E-15 , 3.497900 , 1.4807000E-15 ,
     & 3.498050 , 1.5440500E-15 , 3.498200 , 2.0909701E-15 ,
     & 3.498350 , 1.5007900E-15 , 3.498500 , 3.0481201E-15 ,
     & 3.498650 , 2.2034700E-15 , 3.498800 , 2.2031399E-15 ,
     & 3.498950 , 1.6023900E-15 , 3.499100 , 2.9795000E-15 ,
     & 3.499250 , 1.7620600E-15 , 3.499400 , 1.4524600E-15 ,
     & 3.499550 , 2.1866399E-15 , 3.499700 , 3.2510600E-15 ,
     & 3.499850 , 3.4689701E-15 , 3.500000 , 4.8495999E-15 ,
     & 3.500150 , 4.5807601E-15 , 3.500300 , 5.2264499E-15 ,
     & 3.500450 , 3.7933498E-15 , 3.500600 , 3.2077301E-15 ,
     & 3.500750 , 3.9155898E-15 , 3.500900 , 3.5901500E-15 ,
     & 3.501050 , 4.1945199E-15 , 3.501200 , 4.1072399E-15 ,
     & 3.501350 , 2.2652600E-15 , 3.501500 , 8.5696901E-16 ,
     & 3.501650 , 1.6566500E-15 , 3.501800 , 2.8032901E-15 /
      data( xin(i), yin(i), i = 2701 , 2750 ) /
     & 3.501950 , 3.1091401E-15 , 3.502100 , 4.2376999E-15 ,
     & 3.502250 , 5.0307599E-15 , 3.502400 , 5.1639901E-15 ,
     & 3.502550 , 5.8727598E-15 , 3.502700 , 5.7524701E-15 ,
     & 3.502850 , 6.8548898E-15 , 3.503000 , 6.8370301E-15 ,
     & 3.503150 , 5.7570398E-15 , 3.503300 , 5.7774800E-15 ,
     & 3.503450 , 6.9000100E-15 , 3.503600 , 6.2085300E-15 ,
     & 3.503750 , 4.3313398E-15 , 3.503900 , 4.8399001E-15 ,
     & 3.504050 , 6.7551801E-15 , 3.504200 , 7.9570597E-15 ,
     & 3.504350 , 7.4777204E-15 , 3.504500 , 6.8248401E-15 ,
     & 3.504650 , 5.9163701E-15 , 3.504800 , 3.9866000E-15 ,
     & 3.504950 , 3.6609001E-15 , 3.505100 , 1.9236800E-15 ,
     & 3.505250 , 1.5309600E-15 , 3.505400 , 1.4300100E-15 ,
     & 3.505550 , 2.0840001E-15 , 3.505700 , 2.4911000E-15 ,
     & 3.505850 , 2.2480900E-15 , 3.506000 , 1.4911700E-15 ,
     & 3.506150 , 2.8389900E-15 , 3.506300 , 4.2293100E-15 ,
     & 3.506450 , 5.6354902E-15 , 3.506600 , 5.6486099E-15 ,
     & 3.506750 , 5.7770099E-15 , 3.506900 , 5.4923598E-15 ,
     & 3.507050 , 5.1140698E-15 , 3.507200 , 3.3531099E-15 ,
     & 3.507350 , 1.5941400E-15 , 3.507500 , 3.1550400E-15 ,
     & 3.507650 , 2.5555300E-15 , 3.507800 , 2.8524099E-15 ,
     & 3.507950 , 1.8969100E-15 , 3.508100 , 2.4366300E-15 ,
     & 3.508250 , 3.4190800E-15 , 3.508400 , 4.3509198E-15 ,
     & 3.508550 , 4.1994399E-15 , 3.508700 , 5.9817200E-15 ,
     & 3.508850 , 6.8669499E-15 , 3.509000 , 6.1051700E-15 ,
     & 3.509150 , 5.6265099E-15 , 3.509300 , 4.9438200E-15 /
      data( xin(i), yin(i), i = 2751 , 2800 ) /
     & 3.509450 , 4.7222502E-15 , 3.509600 , 5.2234201E-15 ,
     & 3.509750 , 5.9903801E-15 , 3.509900 , 5.6564500E-15 ,
     & 3.510050 , 4.2281602E-15 , 3.510200 , 5.3839400E-15 ,
     & 3.510350 , 3.2751899E-15 , 3.510500 , 5.4364900E-15 ,
     & 3.510650 , 4.2339200E-15 , 3.510800 , 4.5773300E-15 ,
     & 3.510950 , 5.4915598E-15 , 3.511100 , 5.8771102E-15 ,
     & 3.511250 , 5.1493098E-15 , 3.511400 , 5.4581702E-15 ,
     & 3.511550 , 6.2232201E-15 , 3.511700 , 6.9647801E-15 ,
     & 3.511850 , 5.2846898E-15 , 3.512000 , 5.9445501E-15 ,
     & 3.512150 , 5.8085399E-15 , 3.512300 , 6.7803200E-15 ,
     & 3.512450 , 6.3313900E-15 , 3.512600 , 8.7700301E-15 ,
     & 3.512750 , 8.1047001E-15 , 3.512900 , 7.1995302E-15 ,
     & 3.513050 , 7.0215300E-15 , 3.513200 , 5.7482599E-15 ,
     & 3.513350 , 4.8477500E-15 , 3.513500 , 4.6096901E-15 ,
     & 3.513650 , 4.0369700E-15 , 3.513800 , 5.4615401E-15 ,
     & 3.513950 , 5.0876001E-15 , 3.514100 , 4.3147100E-15 ,
     & 3.514250 , 5.0629700E-15 , 3.514400 , 5.2450199E-15 ,
     & 3.514550 , 4.6655401E-15 , 3.514700 , 4.1197798E-15 ,
     & 3.514850 , 5.5726899E-15 , 3.515000 , 5.2610500E-15 ,
     & 3.515150 , 7.4592203E-15 , 3.515300 , 7.1599797E-15 ,
     & 3.515450 , 8.8455600E-15 , 3.515600 , 9.2164596E-15 ,
     & 3.515750 , 6.9682499E-15 , 3.515900 , 7.8272604E-15 ,
     & 3.516050 , 7.8121798E-15 , 3.516200 , 6.5447301E-15 ,
     & 3.516350 , 5.0345102E-15 , 3.516500 , 4.7671700E-15 ,
     & 3.516650 , 5.4007100E-15 , 3.516800 , 5.4090402E-15 /
      data( xin(i), yin(i), i = 2801 , 2850 ) /
     & 3.516950 , 5.4071399E-15 , 3.517100 , 4.0577901E-15 ,
     & 3.517250 , 5.4093900E-15 , 3.517400 , 5.3797599E-15 ,
     & 3.517550 , 4.3381000E-15 , 3.517700 , 4.3124900E-15 ,
     & 3.517850 , 4.9848901E-15 , 3.518000 , 6.4261298E-15 ,
     & 3.518150 , 6.1070601E-15 , 3.518300 , 4.0894302E-15 ,
     & 3.518450 , 3.1189801E-15 , 3.518600 , 4.6621401E-15 ,
     & 3.518750 , 3.6606600E-15 , 3.518900 , 4.6662600E-15 ,
     & 3.519050 , 5.2085801E-15 , 3.519200 , 5.2394400E-15 ,
     & 3.519350 , 3.8246498E-15 , 3.519500 , 4.0697799E-15 ,
     & 3.519650 , 3.5638602E-15 , 3.519800 , 4.5508399E-15 ,
     & 3.519950 , 4.3167302E-15 , 3.520100 , 3.6916101E-15 ,
     & 3.520250 , 4.1916899E-15 , 3.520400 , 3.7453701E-15 ,
     & 3.520550 , 4.0967100E-15 , 3.520700 , 4.0650500E-15 ,
     & 3.520850 , 1.7920200E-15 , 3.521000 , 3.0978400E-15 ,
     & 3.521150 , 3.7084801E-15 , 3.521300 , 3.8113700E-15 ,
     & 3.521450 , 3.5145999E-15 , 3.521600 , 4.3904000E-15 ,
     & 3.521750 , 3.7954301E-15 , 3.521900 , 3.3551100E-15 ,
     & 3.522050 , 3.5780002E-15 , 3.522200 , 3.4199900E-15 ,
     & 3.522350 , 2.8821600E-15 , 3.522500 , 3.2137701E-15 ,
     & 3.522650 , 3.6725799E-15 , 3.522800 , 2.6119800E-15 ,
     & 3.522950 , 3.6332301E-15 , 3.523100 , 4.1682102E-15 ,
     & 3.523250 , 4.5954599E-15 , 3.523400 , 4.8972099E-15 ,
     & 3.523550 , 2.9724701E-15 , 3.523700 , 5.2115299E-15 ,
     & 3.523850 , 3.1620600E-15 , 3.524000 , 2.3759600E-15 ,
     & 3.524150 , 3.6795001E-15 , 3.524300 , 2.4065599E-15 /
      data( xin(i), yin(i), i = 2851 , 2900 ) /
     & 3.524450 , 2.1761100E-15 , 3.524600 , 2.9999900E-15 ,
     & 3.524750 , 2.6004801E-15 , 3.524900 , 3.0949099E-15 ,
     & 3.525050 , 3.6455798E-15 , 3.525200 , 2.9889099E-15 ,
     & 3.525350 , 2.8334601E-15 , 3.525500 , 2.5195800E-15 ,
     & 3.525650 , 1.9915401E-15 , 3.525800 , 2.1528600E-15 ,
     & 3.525950 , 2.3725899E-15 , 3.526100 , 2.4793800E-15 ,
     & 3.526250 , 2.3303700E-15 , 3.526400 , 3.0064399E-15 ,
     & 3.526550 , 2.7174100E-15 , 3.526700 , 2.2448300E-15 ,
     & 3.526850 , 3.1082600E-15 , 3.527000 , 2.4956699E-15 ,
     & 3.527150 , 1.3243100E-15 , 3.527300 , 2.2871601E-15 ,
     & 3.527450 , 3.6250101E-15 , 3.527600 , 1.5988600E-15 ,
     & 3.527750 , 2.3094201E-15 , 3.527900 , 3.4491700E-15 ,
     & 3.528050 , 2.9843800E-15 , 3.528200 , 2.7100201E-15 ,
     & 3.528350 , 2.3067000E-15 , 3.528500 , 2.7123600E-15 ,
     & 3.528650 , 3.5267301E-15 , 3.528800 , 3.4146001E-15 ,
     & 3.528950 , 4.0562502E-15 , 3.529100 , 3.0287101E-15 ,
     & 3.529250 , 2.1281300E-15 , 3.529400 , 2.4567600E-15 ,
     & 3.529550 , 2.1961500E-15 , 3.529700 , 2.5191200E-15 ,
     & 3.529850 , 2.0031400E-15 , 3.530000 , 1.7073500E-15 ,
     & 3.530150 , 2.9884500E-15 , 3.530300 , 3.0206300E-15 ,
     & 3.530450 , 3.1077899E-15 , 3.530600 , 3.4277901E-15 ,
     & 3.530750 , 4.0695698E-15 , 3.530900 , 4.0727301E-15 ,
     & 3.531050 , 3.2151399E-15 , 3.531200 , 3.2098000E-15 ,
     & 3.531350 , 3.8219499E-15 , 3.531500 , 3.2383800E-15 ,
     & 3.531650 , 4.4246901E-15 , 3.531800 , 5.5035801E-15 /
      data( xin(i), yin(i), i = 2901 , 2950 ) /
     & 3.531950 , 4.6378599E-15 , 3.532100 , 3.2500999E-15 ,
     & 3.532250 , 3.5636501E-15 , 3.532400 , 4.7455199E-15 ,
     & 3.532550 , 5.1037301E-15 , 3.532700 , 3.9792702E-15 ,
     & 3.532850 , 4.0923601E-15 , 3.533000 , 3.8280900E-15 ,
     & 3.533150 , 3.3524399E-15 , 3.533300 , 3.5939100E-15 ,
     & 3.533450 , 3.2467099E-15 , 3.533600 , 3.6803399E-15 ,
     & 3.533750 , 2.7656401E-15 , 3.533900 , 2.6515901E-15 ,
     & 3.534050 , 2.1377900E-15 , 3.534200 , 2.8958000E-15 ,
     & 3.534350 , 2.8934099E-15 , 3.534500 , 3.1025301E-15 ,
     & 3.534650 , 2.7645099E-15 , 3.534800 , 2.0350699E-15 ,
     & 3.534950 , 1.3861000E-15 , 3.535100 , 1.2125401E-15 ,
     & 3.535250 , 9.1674196E-16 , 3.535400 , 1.4784100E-15 ,
     & 3.535550 , 2.1561700E-15 , 3.535700 , 2.4423700E-15 ,
     & 3.535850 , 3.0942499E-15 , 3.536000 , 2.6120999E-15 ,
     & 3.536150 , 3.1104299E-15 , 3.536300 , 2.7693001E-15 ,
     & 3.536450 , 3.1359599E-15 , 3.536600 , 4.2016798E-15 ,
     & 3.536750 , 3.9086399E-15 , 3.536900 , 3.7799798E-15 ,
     & 3.537050 , 3.5100800E-15 , 3.537200 , 2.9863301E-15 ,
     & 3.537350 , 1.3935300E-15 , 3.537500 , 1.4328500E-15 ,
     & 3.537650 , 1.6078500E-15 , 3.537800 , 2.9618199E-15 ,
     & 3.537950 , 2.6339099E-15 , 3.538100 , 2.7848800E-15 ,
     & 3.538250 , 3.1215400E-15 , 3.538400 , 3.2909500E-15 ,
     & 3.538550 , 3.6428202E-15 , 3.538700 , 4.0335400E-15 ,
     & 3.538850 , 2.7498499E-15 , 3.539000 , 3.3479200E-15 ,
     & 3.539150 , 2.8367999E-15 , 3.539300 , 3.1073300E-15 /
      data( xin(i), yin(i), i = 2951 , 2982 ) /
     & 3.539450 , 3.3231900E-15 , 3.539600 , 3.2930600E-15 ,
     & 3.539750 , 3.4322899E-15 , 3.539900 , 3.7767399E-15 ,
     & 3.540050 , 4.3387399E-15 , 3.540200 , 4.2714101E-15 ,
     & 3.540350 , 3.2279000E-15 , 3.540500 , 3.3423200E-15 ,
     & 3.540650 , 3.6224601E-15 , 3.540800 , 3.3865000E-15 ,
     & 3.540950 , 3.5967399E-15 , 3.541100 , 3.2675899E-15 ,
     & 3.541250 , 3.4637401E-15 , 3.541400 , 2.7069600E-15 ,
     & 3.541550 , 2.5206301E-15 , 3.541700 , 2.8157800E-15 ,
     & 3.541850 , 2.7642200E-15 , 3.542000 , 2.5498400E-15 ,
     & 3.542150 , 3.5257001E-15 , 3.542300 , 2.6988700E-15 ,
     & 3.542450 , 2.1950700E-15 , 3.542600 , 3.0787699E-15 ,
     & 3.542750 , 3.5505099E-15 , 3.542900 , 3.7524500E-15 ,
     & 3.543050 , 3.5968500E-15 , 3.543200 , 4.0199798E-15 ,
     & 3.543350 , 4.8514998E-15 , 3.543500 , 5.7218401E-15 ,
     & 3.543650 , 4.1252101E-15 , 3.543800 , 3.9963099E-15 ,
     & 3.543950 , 2.9691899E-15 , 3.544100 , 0.0000000E+00 /
      nmax = n
      n = min( nmax,        2982  )
      do i = 1, n
        x(i) = xin(i)
        y(i) = yin(i)
      end do
      return
      end
*=================================================
      subroutine getfe2opt( n, x, y )
      real*4 x(n), y(n)
      real*4 xin( 2001 ), yin( 2001 )
      data( xin(i), yin(i), i = 1 , 50 ) /
     & 3.566514 , 2.6987280E-16 , 3.566668 , 1.9891820E-16 ,
     & 3.566822 , 1.1496700E-16 , 3.566976 , 6.6609083E-17 ,
     & 3.567130 , 7.5408478E-17 , 3.567283 , 1.2998320E-16 ,
     & 3.567437 , 1.6229670E-16 , 3.567591 , 2.0038270E-16 ,
     & 3.567745 , 3.4071781E-16 , 3.567899 , 5.3444491E-16 ,
     & 3.568053 , 6.8886400E-16 , 3.568207 , 8.1099688E-16 ,
     & 3.568361 , 8.9891255E-16 , 3.568515 , 9.0128721E-16 ,
     & 3.568669 , 8.2482343E-16 , 3.568822 , 7.4781251E-16 ,
     & 3.568976 , 7.3683751E-16 , 3.569130 , 8.4311891E-16 ,
     & 3.569284 , 1.0495350E-15 , 3.569438 , 1.3064360E-15 ,
     & 3.569592 , 1.5386479E-15 , 3.569746 , 1.6795770E-15 ,
     & 3.569900 , 1.6845250E-15 , 3.570054 , 1.5888560E-15 ,
     & 3.570208 , 1.5227290E-15 , 3.570361 , 1.5322540E-15 ,
     & 3.570515 , 1.6098839E-15 , 3.570669 , 1.7083560E-15 ,
     & 3.570823 , 1.7749990E-15 , 3.570977 , 1.8801319E-15 ,
     & 3.571131 , 2.0443229E-15 , 3.571285 , 2.1742410E-15 ,
     & 3.571439 , 2.2146790E-15 , 3.571593 , 2.1468249E-15 ,
     & 3.571747 , 2.0353920E-15 , 3.571900 , 1.9817640E-15 ,
     & 3.572054 , 1.9876831E-15 , 3.572208 , 2.0287121E-15 ,
     & 3.572362 , 2.0293910E-15 , 3.572516 , 1.9635009E-15 ,
     & 3.572670 , 1.8897100E-15 , 3.572824 , 1.8622989E-15 ,
     & 3.572978 , 1.9277049E-15 , 3.573132 , 2.0697650E-15 ,
     & 3.573286 , 2.2436531E-15 , 3.573439 , 2.3806500E-15 ,
     & 3.573593 , 2.4268720E-15 , 3.573747 , 2.3718949E-15 ,
     & 3.573901 , 2.2361009E-15 , 3.574055 , 2.0687450E-15 /
      data( xin(i), yin(i), i = 51 , 100 ) /
     & 3.574209 , 1.9279590E-15 , 3.574363 , 1.8700789E-15 ,
     & 3.574517 , 1.8803850E-15 , 3.574671 , 1.9339890E-15 ,
     & 3.574825 , 2.0361219E-15 , 3.574978 , 2.1709641E-15 ,
     & 3.575132 , 2.2987919E-15 , 3.575286 , 2.3911649E-15 ,
     & 3.575440 , 2.4305710E-15 , 3.575594 , 2.4210061E-15 ,
     & 3.575748 , 2.3755039E-15 , 3.575902 , 2.3391480E-15 ,
     & 3.576056 , 2.3106959E-15 , 3.576210 , 2.1949440E-15 ,
     & 3.576364 , 1.9750930E-15 , 3.576517 , 1.7011700E-15 ,
     & 3.576671 , 1.4524950E-15 , 3.576825 , 1.3136190E-15 ,
     & 3.576979 , 1.2547230E-15 , 3.577133 , 1.2574140E-15 ,
     & 3.577287 , 1.3744520E-15 , 3.577441 , 1.5496760E-15 ,
     & 3.577595 , 1.6212480E-15 , 3.577749 , 1.6103380E-15 ,
     & 3.577903 , 1.6140500E-15 , 3.578056 , 1.5747970E-15 ,
     & 3.578210 , 1.4641640E-15 , 3.578364 , 1.3452070E-15 ,
     & 3.578518 , 1.2602890E-15 , 3.578672 , 1.2333740E-15 ,
     & 3.578826 , 1.2069470E-15 , 3.578980 , 1.0898580E-15 ,
     & 3.579134 , 9.5069167E-16 , 3.579288 , 8.5611198E-16 ,
     & 3.579442 , 8.0903770E-16 , 3.579595 , 8.0392199E-16 ,
     & 3.579749 , 8.2226920E-16 , 3.579903 , 8.4335518E-16 ,
     & 3.580057 , 8.4878562E-16 , 3.580211 , 8.3608129E-16 ,
     & 3.580365 , 8.1216452E-16 , 3.580519 , 7.9518569E-16 ,
     & 3.580673 , 8.0851418E-16 , 3.580827 , 8.7145301E-16 ,
     & 3.580981 , 1.0169140E-15 , 3.581134 , 1.2731730E-15 ,
     & 3.581288 , 1.4846680E-15 , 3.581442 , 1.5286610E-15 ,
     & 3.581596 , 1.4269350E-15 , 3.581750 , 1.2515570E-15 /
      data( xin(i), yin(i), i = 101 , 150 ) /
     & 3.581904 , 1.1210070E-15 , 3.582058 , 1.1053920E-15 ,
     & 3.582212 , 1.2346180E-15 , 3.582366 , 1.4278570E-15 ,
     & 3.582520 , 1.5974090E-15 , 3.582673 , 1.6828420E-15 ,
     & 3.582827 , 1.6815550E-15 , 3.582981 , 1.6508470E-15 ,
     & 3.583135 , 1.6187310E-15 , 3.583289 , 1.5995570E-15 ,
     & 3.583443 , 1.5740849E-15 , 3.583597 , 1.5253020E-15 ,
     & 3.583751 , 1.4488670E-15 , 3.583905 , 1.3634670E-15 ,
     & 3.584059 , 1.3035490E-15 , 3.584212 , 1.3312610E-15 ,
     & 3.584366 , 1.4904710E-15 , 3.584520 , 1.7044520E-15 ,
     & 3.584674 , 1.9036371E-15 , 3.584828 , 2.0446079E-15 ,
     & 3.584982 , 2.1318489E-15 , 3.585136 , 2.2046271E-15 ,
     & 3.585290 , 2.2651120E-15 , 3.585443 , 2.3100820E-15 ,
     & 3.585598 , 2.3307431E-15 , 3.585751 , 2.3308310E-15 ,
     & 3.585905 , 2.3234741E-15 , 3.586059 , 2.3777130E-15 ,
     & 3.586213 , 2.5719620E-15 , 3.586367 , 2.7970309E-15 ,
     & 3.586521 , 2.9534131E-15 , 3.586675 , 3.0186719E-15 ,
     & 3.586829 , 2.9374520E-15 , 3.586982 , 2.6376970E-15 ,
     & 3.587137 , 2.2520671E-15 , 3.587290 , 1.9462740E-15 ,
     & 3.587444 , 1.7203580E-15 , 3.587598 , 1.5683320E-15 ,
     & 3.587752 , 1.4810800E-15 , 3.587906 , 1.4433410E-15 ,
     & 3.588060 , 1.4417820E-15 , 3.588214 , 1.4324290E-15 ,
     & 3.588368 , 1.4038970E-15 , 3.588521 , 1.4459090E-15 ,
     & 3.588675 , 1.5620410E-15 , 3.588829 , 1.6744030E-15 ,
     & 3.588983 , 1.7182391E-15 , 3.589137 , 1.6497820E-15 ,
     & 3.589291 , 1.5592190E-15 , 3.589445 , 1.4712380E-15 /
      data( xin(i), yin(i), i = 151 , 200 ) /
     & 3.589599 , 1.2948870E-15 , 3.589753 , 1.0257210E-15 ,
     & 3.589907 , 7.1154002E-16 , 3.590060 , 4.3994860E-16 ,
     & 3.590214 , 2.8550439E-16 , 3.590368 , 2.6794879E-16 ,
     & 3.590522 , 3.7002520E-16 , 3.590676 , 5.4139180E-16 ,
     & 3.590830 , 7.0993479E-16 , 3.590984 , 8.1048702E-16 ,
     & 3.591138 , 8.3210918E-16 , 3.591292 , 7.8550162E-16 ,
     & 3.591446 , 7.0160639E-16 , 3.591599 , 6.1893809E-16 ,
     & 3.591753 , 5.7473991E-16 , 3.591907 , 5.7425710E-16 ,
     & 3.592061 , 6.1643209E-16 , 3.592215 , 7.0482681E-16 ,
     & 3.592369 , 7.9462252E-16 , 3.592523 , 8.1217172E-16 ,
     & 3.592677 , 7.7657849E-16 , 3.592831 , 7.1678310E-16 ,
     & 3.592985 , 6.2815852E-16 , 3.593138 , 5.1435790E-16 ,
     & 3.593292 , 3.8509980E-16 , 3.593446 , 2.8537649E-16 ,
     & 3.593600 , 2.6637709E-16 , 3.593754 , 3.7352549E-16 ,
     & 3.593908 , 5.9518978E-16 , 3.594062 , 8.5267599E-16 ,
     & 3.594216 , 1.0543820E-15 , 3.594370 , 1.1210400E-15 ,
     & 3.594524 , 1.1386630E-15 , 3.594677 , 1.1704610E-15 ,
     & 3.594831 , 1.2063830E-15 , 3.594985 , 1.2461440E-15 ,
     & 3.595139 , 1.2889680E-15 , 3.595293 , 1.2918140E-15 ,
     & 3.595447 , 1.2243430E-15 , 3.595601 , 1.0866740E-15 ,
     & 3.595755 , 9.4458880E-16 , 3.595909 , 9.0787204E-16 ,
     & 3.596063 , 9.2927614E-16 , 3.596216 , 9.4246741E-16 ,
     & 3.596370 , 9.3648354E-16 , 3.596524 , 9.1051013E-16 ,
     & 3.596678 , 8.7952688E-16 , 3.596832 , 8.4731300E-16 ,
     & 3.596986 , 8.2250340E-16 , 3.597140 , 8.4231508E-16 /
      data( xin(i), yin(i), i = 201 , 250 ) /
     & 3.597294 , 9.2616880E-16 , 3.597448 , 1.0750090E-15 ,
     & 3.597602 , 1.2161950E-15 , 3.597755 , 1.2764880E-15 ,
     & 3.597909 , 1.3362760E-15 , 3.598063 , 1.4242360E-15 ,
     & 3.598217 , 1.4951460E-15 , 3.598371 , 1.5071970E-15 ,
     & 3.598525 , 1.4288410E-15 , 3.598679 , 1.3056220E-15 ,
     & 3.598833 , 1.1632890E-15 , 3.598987 , 9.8746773E-16 ,
     & 3.599141 , 8.0580542E-16 , 3.599294 , 6.5906802E-16 ,
     & 3.599448 , 5.5557330E-16 , 3.599602 , 4.9534121E-16 ,
     & 3.599756 , 4.7718972E-16 , 3.599910 , 4.3713480E-16 ,
     & 3.600064 , 2.9831370E-16 , 3.600218 , 1.9434800E-16 ,
     & 3.600372 , 1.9775480E-16 , 3.600526 , 2.6340411E-16 ,
     & 3.600680 , 3.0920861E-16 , 3.600833 , 2.4509589E-16 ,
     & 3.600987 , 1.7758269E-16 , 3.601141 , 1.6813229E-16 ,
     & 3.601295 , 1.7823450E-16 , 3.601449 , 1.8352759E-16 ,
     & 3.601603 , 1.6774400E-16 , 3.601757 , 2.1074360E-16 ,
     & 3.601911 , 3.3791371E-16 , 3.602065 , 4.8091323E-16 ,
     & 3.602219 , 5.6330412E-16 , 3.602372 , 5.2031000E-16 ,
     & 3.602526 , 4.3385499E-16 , 3.602680 , 3.6156250E-16 ,
     & 3.602834 , 2.9177540E-16 , 3.602988 , 2.7942151E-16 ,
     & 3.603142 , 3.8581430E-16 , 3.603296 , 5.1527269E-16 ,
     & 3.603450 , 5.9354399E-16 , 3.603604 , 5.9497002E-16 ,
     & 3.603758 , 5.5927219E-16 , 3.603911 , 5.4942930E-16 ,
     & 3.604065 , 5.3426571E-16 , 3.604219 , 5.1694691E-16 ,
     & 3.604373 , 5.4599251E-16 , 3.604527 , 6.2266668E-16 ,
     & 3.604681 , 7.1970791E-16 , 3.604835 , 7.6024521E-16 /
      data( xin(i), yin(i), i = 251 , 300 ) /
     & 3.604989 , 7.1391928E-16 , 3.605143 , 6.0936148E-16 ,
     & 3.605297 , 5.1164528E-16 , 3.605450 , 4.7799599E-16 ,
     & 3.605604 , 4.8536063E-16 , 3.605758 , 5.0713520E-16 ,
     & 3.605912 , 5.1917582E-16 , 3.606066 , 5.0293688E-16 ,
     & 3.606220 , 4.5473858E-16 , 3.606374 , 3.9727680E-16 ,
     & 3.606528 , 3.6065149E-16 , 3.606682 , 3.7535601E-16 ,
     & 3.606836 , 4.0292521E-16 , 3.606989 , 4.0997549E-16 ,
     & 3.607143 , 4.0383241E-16 , 3.607297 , 4.0953159E-16 ,
     & 3.607451 , 4.5691811E-16 , 3.607605 , 5.7735719E-16 ,
     & 3.607759 , 7.2293812E-16 , 3.607913 , 7.0778512E-16 ,
     & 3.608067 , 6.1547632E-16 , 3.608221 , 6.3491949E-16 ,
     & 3.608375 , 6.6082260E-16 , 3.608528 , 6.6728001E-16 ,
     & 3.608682 , 7.3938321E-16 , 3.608836 , 8.8872994E-16 ,
     & 3.608990 , 1.0888760E-15 , 3.609144 , 1.2739800E-15 ,
     & 3.609298 , 1.3826060E-15 , 3.609452 , 1.3709820E-15 ,
     & 3.609606 , 1.2742041E-15 , 3.609760 , 1.1457060E-15 ,
     & 3.609914 , 1.0186560E-15 , 3.610067 , 9.2136612E-16 ,
     & 3.610221 , 8.7124718E-16 , 3.610375 , 8.3228372E-16 ,
     & 3.610529 , 7.8221132E-16 , 3.610683 , 7.3155028E-16 ,
     & 3.610837 , 7.3285338E-16 , 3.610991 , 8.3724898E-16 ,
     & 3.611145 , 9.7185183E-16 , 3.611299 , 1.0799600E-15 ,
     & 3.611453 , 1.1359790E-15 , 3.611606 , 1.1842670E-15 ,
     & 3.611760 , 1.2718460E-15 , 3.611914 , 1.3765480E-15 ,
     & 3.612068 , 1.4803630E-15 , 3.612222 , 1.5702450E-15 ,
     & 3.612376 , 1.6180910E-15 , 3.612530 , 1.6255200E-15 /
      data( xin(i), yin(i), i = 301 , 350 ) /
     & 3.612684 , 1.6525400E-15 , 3.612838 , 1.6663470E-15 ,
     & 3.612992 , 1.5994270E-15 , 3.613145 , 1.4514500E-15 ,
     & 3.613299 , 1.2536920E-15 , 3.613453 , 1.0681920E-15 ,
     & 3.613607 , 9.3988608E-16 , 3.613761 , 8.9326877E-16 ,
     & 3.613915 , 9.2723818E-16 , 3.614069 , 9.8364380E-16 ,
     & 3.614223 , 9.7608064E-16 , 3.614377 , 9.2167233E-16 ,
     & 3.614531 , 8.6544803E-16 , 3.614684 , 8.7147159E-16 ,
     & 3.614838 , 9.4181011E-16 , 3.614992 , 1.0428530E-15 ,
     & 3.615146 , 1.1242880E-15 , 3.615300 , 1.1629810E-15 ,
     & 3.615454 , 1.1662340E-15 , 3.615608 , 1.1546220E-15 ,
     & 3.615762 , 1.1286310E-15 , 3.615916 , 1.0398830E-15 ,
     & 3.616070 , 8.8517791E-16 , 3.616223 , 6.9529848E-16 ,
     & 3.616377 , 5.5498329E-16 , 3.616531 , 4.9778062E-16 ,
     & 3.616685 , 4.9214149E-16 , 3.616839 , 4.8640920E-16 ,
     & 3.616993 , 4.4903260E-16 , 3.617147 , 4.1738361E-16 ,
     & 3.617301 , 4.0777111E-16 , 3.617455 , 4.1911370E-16 ,
     & 3.617609 , 4.2905869E-16 , 3.617762 , 4.2089761E-16 ,
     & 3.617916 , 3.9190621E-16 , 3.618070 , 3.3953501E-16 ,
     & 3.618224 , 2.7777691E-16 , 3.618378 , 2.6329950E-16 ,
     & 3.618532 , 2.9044691E-16 , 3.618686 , 3.1470929E-16 ,
     & 3.618840 , 3.6280120E-16 , 3.618994 , 4.4966539E-16 ,
     & 3.619148 , 5.7401919E-16 , 3.619301 , 6.7152248E-16 ,
     & 3.619455 , 7.0221138E-16 , 3.619609 , 7.4460612E-16 ,
     & 3.619763 , 8.3452571E-16 , 3.619917 , 9.7430515E-16 ,
     & 3.620071 , 1.1718670E-15 , 3.620225 , 1.4067800E-15 /
      data( xin(i), yin(i), i = 351 , 400 ) /
     & 3.620379 , 1.6427860E-15 , 3.620533 , 1.8192771E-15 ,
     & 3.620687 , 1.9078970E-15 , 3.620840 , 1.9799080E-15 ,
     & 3.620994 , 1.9703299E-15 , 3.621148 , 1.7718350E-15 ,
     & 3.621302 , 1.4713010E-15 , 3.621456 , 1.1623770E-15 ,
     & 3.621610 , 9.1241436E-16 , 3.621764 , 7.5417828E-16 ,
     & 3.621917 , 6.8313980E-16 , 3.622072 , 6.6131372E-16 ,
     & 3.622225 , 6.5943982E-16 , 3.622379 , 6.4401159E-16 ,
     & 3.622533 , 5.5178818E-16 , 3.622687 , 4.2348439E-16 ,
     & 3.622841 , 3.8035821E-16 , 3.622995 , 3.6539860E-16 ,
     & 3.623149 , 3.3683909E-16 , 3.623303 , 3.2279920E-16 ,
     & 3.623456 , 3.3818690E-16 , 3.623610 , 3.8555989E-16 ,
     & 3.623764 , 4.1050149E-16 , 3.623918 , 4.0186139E-16 ,
     & 3.624072 , 3.8170251E-16 , 3.624226 , 3.3302231E-16 ,
     & 3.624380 , 2.7191870E-16 , 3.624534 , 2.4768440E-16 ,
     & 3.624688 , 2.2963611E-16 , 3.624842 , 1.9865640E-16 ,
     & 3.624995 , 1.8798200E-16 , 3.625149 , 2.2234580E-16 ,
     & 3.625303 , 3.1478121E-16 , 3.625457 , 4.1383621E-16 ,
     & 3.625611 , 5.1569568E-16 , 3.625765 , 6.7182381E-16 ,
     & 3.625919 , 8.5840818E-16 , 3.626073 , 1.0639240E-15 ,
     & 3.626227 , 1.2877690E-15 , 3.626381 , 1.5055030E-15 ,
     & 3.626534 , 1.6797340E-15 , 3.626688 , 1.7744031E-15 ,
     & 3.626842 , 1.7465870E-15 , 3.626996 , 1.5832510E-15 ,
     & 3.627150 , 1.4427780E-15 , 3.627304 , 1.4295400E-15 ,
     & 3.627458 , 1.5551930E-15 , 3.627612 , 1.7052540E-15 ,
     & 3.627766 , 1.7736010E-15 , 3.627920 , 1.6945550E-15 /
      data( xin(i), yin(i), i = 401 , 450 ) /
     & 3.628073 , 1.4866800E-15 , 3.628227 , 1.2221600E-15 ,
     & 3.628381 , 1.0165510E-15 , 3.628535 , 9.0362258E-16 ,
     & 3.628689 , 8.7308038E-16 , 3.628843 , 8.9964809E-16 ,
     & 3.628997 , 9.3713745E-16 , 3.629151 , 9.2675886E-16 ,
     & 3.629305 , 8.7754572E-16 , 3.629459 , 8.2581922E-16 ,
     & 3.629612 , 8.2358988E-16 , 3.629766 , 8.3037192E-16 ,
     & 3.629920 , 8.0669888E-16 , 3.630074 , 7.9009952E-16 ,
     & 3.630228 , 8.2687250E-16 , 3.630382 , 9.5308952E-16 ,
     & 3.630536 , 1.1272600E-15 , 3.630690 , 1.2939610E-15 ,
     & 3.630844 , 1.4101130E-15 , 3.630998 , 1.4736640E-15 ,
     & 3.631151 , 1.4965100E-15 , 3.631305 , 1.4730930E-15 ,
     & 3.631459 , 1.4037370E-15 , 3.631613 , 1.3312540E-15 ,
     & 3.631767 , 1.3346010E-15 , 3.631921 , 1.4622670E-15 ,
     & 3.632075 , 1.6741840E-15 , 3.632229 , 1.7988420E-15 ,
     & 3.632383 , 1.8035220E-15 , 3.632537 , 1.7457360E-15 ,
     & 3.632690 , 1.7242670E-15 , 3.632844 , 1.7616250E-15 ,
     & 3.632998 , 1.8284669E-15 , 3.633152 , 1.8754040E-15 ,
     & 3.633306 , 1.8933109E-15 , 3.633460 , 1.9037029E-15 ,
     & 3.633614 , 1.9322549E-15 , 3.633768 , 1.9606809E-15 ,
     & 3.633922 , 1.9449651E-15 , 3.634076 , 1.8353421E-15 ,
     & 3.634229 , 1.6678550E-15 , 3.634383 , 1.5496160E-15 ,
     & 3.634537 , 1.5454530E-15 , 3.634691 , 1.6333950E-15 ,
     & 3.634845 , 1.6459940E-15 , 3.634999 , 1.6179640E-15 ,
     & 3.635153 , 1.6314380E-15 , 3.635307 , 1.7191800E-15 ,
     & 3.635461 , 1.8058480E-15 , 3.635615 , 1.7634930E-15 /
      data( xin(i), yin(i), i = 451 , 500 ) /
     & 3.635768 , 1.6054140E-15 , 3.635922 , 1.4371980E-15 ,
     & 3.636076 , 1.3556880E-15 , 3.636230 , 1.3629930E-15 ,
     & 3.636384 , 1.3834440E-15 , 3.636538 , 1.3161030E-15 ,
     & 3.636692 , 1.3188010E-15 , 3.636846 , 1.3433440E-15 ,
     & 3.637000 , 1.2608990E-15 , 3.637154 , 1.1334180E-15 ,
     & 3.637307 , 1.0523080E-15 , 3.637461 , 1.1914390E-15 ,
     & 3.637615 , 1.0058050E-15 , 3.637769 , 9.6673289E-16 ,
     & 3.637923 , 9.6115116E-16 , 3.638077 , 9.3869144E-16 ,
     & 3.638231 , 8.9403777E-16 , 3.638385 , 8.2134260E-16 ,
     & 3.638539 , 7.7655599E-16 , 3.638693 , 7.7655599E-16 ,
     & 3.638846 , 7.8785229E-16 , 3.639000 , 7.9343403E-16 ,
     & 3.639154 , 8.1576091E-16 , 3.639308 , 8.4366938E-16 ,
     & 3.639462 , 8.7729262E-16 , 3.639616 , 9.0520103E-16 ,
     & 3.639770 , 9.4985491E-16 , 3.639924 , 1.0225500E-15 ,
     & 3.640078 , 1.0505910E-15 , 3.640232 , 1.0617550E-15 ,
     & 3.640385 , 1.1175720E-15 , 3.640539 , 1.1623590E-15 ,
     & 3.640693 , 1.1623590E-15 , 3.640847 , 1.1906680E-15 ,
     & 3.641001 , 1.1728210E-15 , 3.641155 , 1.1689860E-15 ,
     & 3.641309 , 1.2226610E-15 , 3.641463 , 1.3321010E-15 ,
     & 3.641617 , 1.5168200E-15 , 3.641771 , 1.7409940E-15 ,
     & 3.641924 , 1.9003661E-15 , 3.642078 , 1.9001869E-15 ,
     & 3.642232 , 1.7378120E-15 , 3.642386 , 1.5420690E-15 ,
     & 3.642540 , 1.3724830E-15 , 3.642694 , 1.2617250E-15 ,
     & 3.642848 , 1.2269250E-15 , 3.643002 , 1.2530480E-15 ,
     & 3.643156 , 1.2981730E-15 , 3.643310 , 1.3025489E-15 /
      data( xin(i), yin(i), i = 501 , 550 ) /
     & 3.643463 , 1.2589800E-15 , 3.643617 , 1.1921230E-15 ,
     & 3.643771 , 1.1466400E-15 , 3.643925 , 1.1506060E-15 ,
     & 3.644079 , 1.2100330E-15 , 3.644233 , 1.3054050E-15 ,
     & 3.644387 , 1.4592000E-15 , 3.644541 , 1.6830230E-15 ,
     & 3.644695 , 1.9163309E-15 , 3.644849 , 2.1146150E-15 ,
     & 3.645002 , 2.2293501E-15 , 3.645156 , 2.1737779E-15 ,
     & 3.645310 , 1.9414671E-15 , 3.645464 , 1.5997110E-15 ,
     & 3.645618 , 1.2746450E-15 , 3.645772 , 1.0408900E-15 ,
     & 3.645926 , 9.1727824E-16 , 3.646080 , 8.6370541E-16 ,
     & 3.646234 , 8.3730419E-16 , 3.646388 , 8.0643159E-16 ,
     & 3.646541 , 7.7410479E-16 , 3.646695 , 7.4590632E-16 ,
     & 3.646849 , 7.2404959E-16 , 3.647003 , 7.1199858E-16 ,
     & 3.647157 , 7.0771080E-16 , 3.647311 , 7.3257968E-16 ,
     & 3.647465 , 8.9797986E-16 , 3.647619 , 1.1215000E-15 ,
     & 3.647773 , 1.2632000E-15 , 3.647927 , 1.3174740E-15 ,
     & 3.648080 , 1.3312930E-15 , 3.648234 , 1.3659460E-15 ,
     & 3.648388 , 1.4350560E-15 , 3.648542 , 1.4902840E-15 ,
     & 3.648696 , 1.4749410E-15 , 3.648850 , 1.3919550E-15 ,
     & 3.649004 , 1.3153750E-15 , 3.649158 , 1.3078460E-15 ,
     & 3.649312 , 1.3116380E-15 , 3.649466 , 1.3314920E-15 ,
     & 3.649619 , 1.3848660E-15 , 3.649773 , 1.4514990E-15 ,
     & 3.649927 , 1.4846070E-15 , 3.650081 , 1.4695710E-15 ,
     & 3.650235 , 1.4755500E-15 , 3.650389 , 1.5090641E-15 ,
     & 3.650543 , 1.5430350E-15 , 3.650697 , 1.5334560E-15 ,
     & 3.650851 , 1.4616129E-15 , 3.651005 , 1.3396250E-15 /
      data( xin(i), yin(i), i = 551 , 600 ) /
     & 3.651158 , 1.2111400E-15 , 3.651312 , 1.1533390E-15 ,
     & 3.651466 , 1.1991100E-15 , 3.651620 , 1.2957110E-15 ,
     & 3.651774 , 1.4492500E-15 , 3.651928 , 1.6672060E-15 ,
     & 3.652082 , 1.9434430E-15 , 3.652236 , 2.1395040E-15 ,
     & 3.652390 , 2.1634560E-15 , 3.652544 , 2.0390660E-15 ,
     & 3.652697 , 1.8501609E-15 , 3.652851 , 1.6692861E-15 ,
     & 3.653005 , 1.5320970E-15 , 3.653159 , 1.4836140E-15 ,
     & 3.653313 , 1.5311290E-15 , 3.653467 , 1.6476710E-15 ,
     & 3.653621 , 1.7998091E-15 , 3.653775 , 1.9905539E-15 ,
     & 3.653929 , 2.2387970E-15 , 3.654083 , 2.3979111E-15 ,
     & 3.654236 , 2.4623040E-15 , 3.654390 , 2.5261970E-15 ,
     & 3.654544 , 2.6458359E-15 , 3.654698 , 2.7970210E-15 ,
     & 3.654852 , 2.8933621E-15 , 3.655006 , 2.9344061E-15 ,
     & 3.655160 , 2.8921300E-15 , 3.655314 , 2.7458519E-15 ,
     & 3.655468 , 2.5208711E-15 , 3.655622 , 2.2579021E-15 ,
     & 3.655775 , 2.0079181E-15 , 3.655929 , 1.8257950E-15 ,
     & 3.656083 , 1.7068720E-15 , 3.656237 , 1.6385470E-15 ,
     & 3.656391 , 1.6317800E-15 , 3.656545 , 1.6682980E-15 ,
     & 3.656699 , 1.7261330E-15 , 3.656853 , 1.7891989E-15 ,
     & 3.657007 , 1.8872790E-15 , 3.657161 , 2.0075079E-15 ,
     & 3.657314 , 2.0926720E-15 , 3.657468 , 2.1602561E-15 ,
     & 3.657622 , 2.2594430E-15 , 3.657776 , 2.4329759E-15 ,
     & 3.657930 , 2.6032869E-15 , 3.658084 , 2.6722339E-15 ,
     & 3.658238 , 2.5979460E-15 , 3.658392 , 2.5404780E-15 ,
     & 3.658545 , 2.5269041E-15 , 3.658700 , 2.4968729E-15 /
      data( xin(i), yin(i), i = 601 , 650 ) /
     & 3.658853 , 2.3729080E-15 , 3.659007 , 2.1835811E-15 ,
     & 3.659161 , 1.9885449E-15 , 3.659315 , 1.8155851E-15 ,
     & 3.659469 , 1.7203240E-15 , 3.659623 , 1.7176290E-15 ,
     & 3.659777 , 1.7639340E-15 , 3.659931 , 1.8192021E-15 ,
     & 3.660084 , 1.8948161E-15 , 3.660239 , 2.0420270E-15 ,
     & 3.660392 , 2.2010901E-15 , 3.660546 , 2.3513810E-15 ,
     & 3.660700 , 2.5104570E-15 , 3.660854 , 2.7100421E-15 ,
     & 3.661008 , 2.9013081E-15 , 3.661162 , 2.9868969E-15 ,
     & 3.661316 , 2.8704159E-15 , 3.661470 , 2.6153210E-15 ,
     & 3.661623 , 2.3446259E-15 , 3.661777 , 2.1535980E-15 ,
     & 3.661931 , 1.9879620E-15 , 3.662085 , 1.8148471E-15 ,
     & 3.662239 , 1.6797730E-15 , 3.662393 , 1.5611201E-15 ,
     & 3.662547 , 1.4428221E-15 , 3.662701 , 1.3279010E-15 ,
     & 3.662855 , 1.2784760E-15 , 3.663009 , 1.2657350E-15 ,
     & 3.663162 , 1.2182579E-15 , 3.663316 , 1.1178001E-15 ,
     & 3.663470 , 1.0435460E-15 , 3.663624 , 1.0686740E-15 ,
     & 3.663778 , 1.1696740E-15 , 3.663932 , 1.3003070E-15 ,
     & 3.664086 , 1.4550359E-15 , 3.664240 , 1.6823930E-15 ,
     & 3.664394 , 1.8813819E-15 , 3.664548 , 1.9915210E-15 ,
     & 3.664701 , 2.0264370E-15 , 3.664855 , 2.0868289E-15 ,
     & 3.665009 , 2.2047340E-15 , 3.665163 , 2.3621801E-15 ,
     & 3.665317 , 2.5503950E-15 , 3.665471 , 2.6814530E-15 ,
     & 3.665625 , 2.6765900E-15 , 3.665779 , 2.5280200E-15 ,
     & 3.665933 , 2.2958150E-15 , 3.666087 , 2.0289410E-15 ,
     & 3.666240 , 1.7461870E-15 , 3.666394 , 1.5468590E-15 /
      data( xin(i), yin(i), i = 651 , 700 ) /
     & 3.666548 , 1.4069010E-15 , 3.666702 , 1.2495210E-15 ,
     & 3.666856 , 1.1313890E-15 , 3.667010 , 1.0843520E-15 ,
     & 3.667164 , 1.0910380E-15 , 3.667318 , 1.0704430E-15 ,
     & 3.667472 , 1.0979500E-15 , 3.667626 , 1.2321880E-15 ,
     & 3.667779 , 1.4480730E-15 , 3.667933 , 1.5955000E-15 ,
     & 3.668087 , 1.6229110E-15 , 3.668241 , 1.5831740E-15 ,
     & 3.668395 , 1.5589750E-15 , 3.668549 , 1.5869370E-15 ,
     & 3.668703 , 1.6536230E-15 , 3.668857 , 1.7087010E-15 ,
     & 3.669011 , 1.6888911E-15 , 3.669165 , 1.5714260E-15 ,
     & 3.669318 , 1.3925360E-15 , 3.669472 , 1.1806630E-15 ,
     & 3.669626 , 9.9980444E-16 , 3.669780 , 8.9088448E-16 ,
     & 3.669934 , 7.5658841E-16 , 3.670088 , 6.0780818E-16 ,
     & 3.670242 , 4.9407458E-16 , 3.670396 , 4.7096472E-16 ,
     & 3.670550 , 4.7889771E-16 , 3.670704 , 4.5518899E-16 ,
     & 3.670857 , 3.9232009E-16 , 3.671011 , 3.3817261E-16 ,
     & 3.671165 , 2.9551500E-16 , 3.671319 , 2.5677539E-16 ,
     & 3.671473 , 2.7827399E-16 , 3.671627 , 3.8237471E-16 ,
     & 3.671781 , 5.1333061E-16 , 3.671935 , 5.6626741E-16 ,
     & 3.672089 , 5.2949581E-16 , 3.672243 , 4.6260900E-16 ,
     & 3.672396 , 4.4220109E-16 , 3.672550 , 4.2236761E-16 ,
     & 3.672704 , 4.0322990E-16 , 3.672858 , 4.0076940E-16 ,
     & 3.673012 , 4.2272370E-16 , 3.673166 , 3.9787380E-16 ,
     & 3.673320 , 3.2763060E-16 , 3.673474 , 2.9464060E-16 ,
     & 3.673628 , 3.5053651E-16 , 3.673782 , 4.3834540E-16 ,
     & 3.673935 , 4.7360741E-16 , 3.674089 , 4.8120302E-16 /
      data( xin(i), yin(i), i = 701 , 750 ) /
     & 3.674243 , 5.2158298E-16 , 3.674397 , 6.3109879E-16 ,
     & 3.674551 , 8.0320100E-16 , 3.674705 , 9.3338414E-16 ,
     & 3.674859 , 9.6869885E-16 , 3.675013 , 9.4179751E-16 ,
     & 3.675167 , 8.7422191E-16 , 3.675321 , 7.5857258E-16 ,
     & 3.675474 , 6.0632238E-16 , 3.675628 , 4.4112589E-16 ,
     & 3.675782 , 2.8855469E-16 , 3.675936 , 1.8136939E-16 ,
     & 3.676090 , 1.4046960E-16 , 3.676244 , 1.0301650E-16 ,
     & 3.676398 , 7.4307613E-17 , 3.676552 , 7.3408878E-17 ,
     & 3.676706 , 7.2031549E-17 , 3.676860 , 2.1649580E-17 ,
     & 3.677013 , -2.4801650E-18 , 3.677167 , 9.0011333E-17 ,
     & 3.677321 , 2.1837850E-16 , 3.677475 , 2.5997109E-16 ,
     & 3.677629 , 2.3608150E-16 , 3.677783 , 3.2685119E-16 ,
     & 3.677937 , 3.9635771E-16 , 3.678091 , 3.7041669E-16 ,
     & 3.678245 , 2.7072531E-16 , 3.678399 , 1.8938759E-16 ,
     & 3.678552 , 1.5534901E-16 , 3.678706 , 1.7793300E-16 ,
     & 3.678860 , 2.3910959E-16 , 3.679014 , 3.1340849E-16 ,
     & 3.679168 , 3.6136911E-16 , 3.679322 , 3.7750541E-16 ,
     & 3.679476 , 3.7075619E-16 , 3.679630 , 3.2639941E-16 ,
     & 3.679784 , 2.7039910E-16 , 3.679938 , 2.2445359E-16 ,
     & 3.680091 , 2.0387750E-16 , 3.680245 , 2.1064820E-16 ,
     & 3.680399 , 2.4370631E-16 , 3.680553 , 2.7227199E-16 ,
     & 3.680707 , 2.9671101E-16 , 3.680861 , 3.4555249E-16 ,
     & 3.681015 , 4.2472170E-16 , 3.681169 , 4.7286970E-16 ,
     & 3.681323 , 4.6913200E-16 , 3.681477 , 4.4742202E-16 ,
     & 3.681630 , 4.4799149E-16 , 3.681784 , 4.5717910E-16 /
      data( xin(i), yin(i), i = 751 , 800 ) /
     & 3.681938 , 4.9660658E-16 , 3.682092 , 4.1321319E-16 ,
     & 3.682246 , 4.1321319E-16 , 3.682400 , 4.1321319E-16 ,
     & 3.682554 , 3.9646801E-16 , 3.682708 , 3.9646801E-16 ,
     & 3.682862 , 4.1321319E-16 , 3.683016 , 4.1321319E-16 ,
     & 3.683169 , 4.1321319E-16 , 3.683323 , 4.2437650E-16 ,
     & 3.683477 , 4.2437650E-16 , 3.683631 , 4.2437650E-16 ,
     & 3.683785 , 4.1321319E-16 , 3.683939 , 4.1321319E-16 ,
     & 3.684093 , 3.9646801E-16 , 3.684247 , 3.8530449E-16 ,
     & 3.684401 , 3.8530449E-16 , 3.684554 , 3.8530449E-16 ,
     & 3.684708 , 3.6855939E-16 , 3.684862 , 3.6855939E-16 ,
     & 3.685016 , 3.6855939E-16 , 3.685170 , 3.6855939E-16 ,
     & 3.685324 , 3.5739610E-16 , 3.685478 , 3.5739610E-16 ,
     & 3.685632 , 3.6855939E-16 , 3.685786 , 3.5739610E-16 ,
     & 3.685940 , 3.6855939E-16 , 3.686093 , 3.5739610E-16 ,
     & 3.686247 , 3.6855939E-16 , 3.686401 , 3.6855939E-16 ,
     & 3.686555 , 3.6855939E-16 , 3.686709 , 3.8530449E-16 ,
     & 3.686863 , 3.9088620E-16 , 3.687017 , 4.8032650E-16 ,
     & 3.687171 , 4.5799971E-16 , 3.687325 , 4.9707170E-16 ,
     & 3.687479 , 5.2511321E-16 , 3.687632 , 5.6418509E-16 ,
     & 3.687786 , 5.6418509E-16 , 3.687940 , 6.0325708E-16 ,
     & 3.688094 , 5.9209382E-16 , 3.688248 , 6.2571700E-16 ,
     & 3.688402 , 6.8153399E-16 , 3.688556 , 6.4246210E-16 ,
     & 3.688710 , 7.1515722E-16 , 3.688864 , 7.0399381E-16 ,
     & 3.689018 , 8.2692428E-16 , 3.689171 , 8.0459750E-16 ,
     & 3.689325 , 7.9901571E-16 , 3.689479 , 8.3250601E-16 /
      data( xin(i), yin(i), i = 801 , 850 ) /
     & 3.689633 , 8.2692428E-16 , 3.689787 , 8.8287430E-16 ,
     & 3.689941 , 8.5483290E-16 , 3.690095 , 8.7157790E-16 ,
     & 3.690249 , 8.7729262E-16 , 3.690403 , 9.0385171E-16 ,
     & 3.690557 , 8.8287430E-16 , 3.690710 , 1.0414680E-15 ,
     & 3.690864 , 1.0893670E-15 , 3.691018 , 1.1370130E-15 ,
     & 3.691172 , 1.2189190E-15 , 3.691326 , 1.3431830E-15 ,
     & 3.691480 , 1.4745720E-15 , 3.691634 , 1.6361651E-15 ,
     & 3.691788 , 1.8824479E-15 , 3.691941 , 2.2316620E-15 ,
     & 3.692096 , 2.6025460E-15 , 3.692249 , 2.8290900E-15 ,
     & 3.692403 , 2.7847280E-15 , 3.692557 , 2.5485411E-15 ,
     & 3.692711 , 2.2631031E-15 , 3.692865 , 2.0578920E-15 ,
     & 3.693019 , 1.8109230E-15 , 3.693173 , 1.3343920E-15 ,
     & 3.693327 , 1.2262540E-15 , 3.693480 , 1.1342040E-15 ,
     & 3.693635 , 1.0821340E-15 , 3.693788 , 9.9408157E-16 ,
     & 3.693942 , 9.0593392E-16 , 3.694096 , 8.6195529E-16 ,
     & 3.694250 , 8.4596320E-16 , 3.694404 , 8.2587761E-16 ,
     & 3.694558 , 8.1388352E-16 , 3.694712 , 8.0588732E-16 ,
     & 3.694866 , 7.8989512E-16 , 3.695019 , 7.8989512E-16 ,
     & 3.695174 , 7.5381750E-16 , 3.695327 , 7.6581149E-16 ,
     & 3.695481 , 7.3382721E-16 , 3.695635 , 7.0574552E-16 ,
     & 3.695789 , 7.2183301E-16 , 3.695943 , 6.8975328E-16 ,
     & 3.696097 , 6.7775918E-16 , 3.696251 , 6.6176688E-16 ,
     & 3.696405 , 6.8175718E-16 , 3.696558 , 6.9375138E-16 ,
     & 3.696712 , 7.0974362E-16 , 3.696866 , 7.2183301E-16 ,
     & 3.697020 , 7.6581149E-16 , 3.697174 , 8.0588732E-16 /
      data( xin(i), yin(i), i = 851 , 900 ) /
     & 3.697328 , 8.2587761E-16 , 3.697482 , 8.7794748E-16 ,
     & 3.697636 , 9.0593392E-16 , 3.697790 , 9.3401561E-16 ,
     & 3.697944 , 9.9807967E-16 , 3.698097 , 1.0332370E-15 ,
     & 3.698251 , 1.0568730E-15 , 3.698405 , 1.0948030E-15 ,
     & 3.698559 , 1.1610960E-15 , 3.698713 , 1.3077500E-15 ,
     & 3.698867 , 1.3693160E-15 , 3.699021 , 1.3834970E-15 ,
     & 3.699175 , 1.5160830E-15 , 3.699329 , 1.5729210E-15 ,
     & 3.699483 , 1.7718000E-15 , 3.699636 , 1.9516571E-15 ,
     & 3.699790 , 2.0226770E-15 , 3.699944 , 2.0747879E-15 ,
     & 3.700098 , 2.2363451E-15 , 3.700252 , 2.3929221E-15 ,
     & 3.700406 , 2.5206349E-15 , 3.700560 , 2.5182650E-15 ,
     & 3.700714 , 2.3529140E-15 , 3.700868 , 2.0665891E-15 ,
     & 3.701022 , 1.7551720E-15 , 3.701175 , 1.5543180E-15 ,
     & 3.701329 , 1.4617510E-15 , 3.701483 , 1.4157260E-15 ,
     & 3.701637 , 1.3624560E-15 , 3.701791 , 1.2519640E-15 ,
     & 3.701945 , 1.1231910E-15 , 3.702099 , 1.0132320E-15 ,
     & 3.702253 , 9.1750143E-16 , 3.702407 , 8.6599082E-16 ,
     & 3.702561 , 8.4278629E-16 , 3.702714 , 8.0934729E-16 ,
     & 3.702868 , 7.4771892E-16 , 3.703022 , 6.8482180E-16 ,
     & 3.703176 , 6.5392262E-16 , 3.703330 , 6.4979540E-16 ,
     & 3.703484 , 6.3663282E-16 , 3.703638 , 6.1982361E-16 ,
     & 3.703792 , 5.3526638E-16 , 3.703946 , 4.3950740E-16 ,
     & 3.704100 , 4.2618529E-16 , 3.704253 , 4.5494918E-16 ,
     & 3.704407 , 4.3229261E-16 , 3.704561 , 3.8919859E-16 ,
     & 3.704715 , 4.1671681E-16 , 3.704869 , 5.2105788E-16 /
      data( xin(i), yin(i), i = 901 , 950 ) /
     & 3.705023 , 5.7776218E-16 , 3.705177 , 5.3773299E-16 ,
     & 3.705331 , 4.5907042E-16 , 3.705485 , 4.4398889E-16 ,
     & 3.705639 , 4.3635839E-16 , 3.705792 , 4.0567680E-16 ,
     & 3.705946 , 3.7984441E-16 , 3.706100 , 4.0630871E-16 ,
     & 3.706254 , 4.2940179E-16 , 3.706408 , 4.3427731E-16 ,
     & 3.706562 , 3.9624889E-16 , 3.706716 , 3.2069951E-16 ,
     & 3.706870 , 3.3736610E-16 , 3.707024 , 4.0449479E-16 ,
     & 3.707178 , 4.7084957E-16 , 3.707331 , 5.2806120E-16 ,
     & 3.707485 , 5.9752261E-16 , 3.707639 , 6.1991769E-16 ,
     & 3.707793 , 5.9837038E-16 , 3.707947 , 5.8423981E-16 ,
     & 3.708101 , 6.1984950E-16 , 3.708255 , 6.7109669E-16 ,
     & 3.708409 , 6.8983470E-16 , 3.708563 , 6.6583788E-16 ,
     & 3.708717 , 6.2552589E-16 , 3.708870 , 5.6859718E-16 ,
     & 3.709024 , 5.3518602E-16 , 3.709178 , 5.9889899E-16 ,
     & 3.709332 , 7.6530332E-16 , 3.709486 , 8.8231489E-16 ,
     & 3.709640 , 8.9309174E-16 , 3.709794 , 8.9073614E-16 ,
     & 3.709948 , 9.5543718E-16 , 3.710102 , 1.0275710E-15 ,
     & 3.710256 , 1.0544010E-15 , 3.710409 , 1.0274270E-15 ,
     & 3.710563 , 9.8412745E-16 , 3.710717 , 9.6228332E-16 ,
     & 3.710871 , 9.3340077E-16 , 3.711025 , 8.8388867E-16 ,
     & 3.711179 , 8.7339018E-16 , 3.711333 , 8.5483290E-16 ,
     & 3.711487 , 8.3808780E-16 , 3.711641 , 8.4925122E-16 ,
     & 3.711795 , 8.2692428E-16 , 3.711948 , 8.4925122E-16 ,
     & 3.712102 , 9.0520103E-16 , 3.712256 , 9.6673289E-16 ,
     & 3.712410 , 1.0617550E-15 , 3.712564 , 1.1456140E-15 /
      data( xin(i), yin(i), i = 951 , 1000 ) /
     & 3.712718 , 1.4530060E-15 , 3.712872 , 1.5424470E-15 ,
     & 3.713026 , 1.7548180E-15 , 3.713180 , 2.0511801E-15 ,
     & 3.713334 , 2.1824509E-15 , 3.713487 , 2.1785080E-15 ,
     & 3.713641 , 2.0520991E-15 , 3.713795 , 1.7934440E-15 ,
     & 3.713949 , 1.4954110E-15 , 3.714103 , 1.2918070E-15 ,
     & 3.714257 , 1.2442960E-15 , 3.714411 , 1.2829259E-15 ,
     & 3.714565 , 1.3251550E-15 , 3.714719 , 1.3541910E-15 ,
     & 3.714873 , 1.4088320E-15 , 3.715026 , 1.4486870E-15 ,
     & 3.715180 , 1.4339570E-15 , 3.715334 , 1.4524220E-15 ,
     & 3.715488 , 1.6115910E-15 , 3.715642 , 1.8371719E-15 ,
     & 3.715796 , 1.9526119E-15 , 3.715950 , 1.8502791E-15 ,
     & 3.716104 , 1.5631350E-15 , 3.716258 , 1.2362860E-15 ,
     & 3.716412 , 1.0082590E-15 , 3.716565 , 9.2575291E-16 ,
     & 3.716719 , 9.0762471E-16 , 3.716873 , 8.5092220E-16 ,
     & 3.717027 , 7.5700452E-16 , 3.717181 , 7.1445588E-16 ,
     & 3.717335 , 7.5786838E-16 , 3.717489 , 8.6255371E-16 ,
     & 3.717643 , 9.7409858E-16 , 3.717797 , 1.0473790E-15 ,
     & 3.717951 , 1.1068100E-15 , 3.718104 , 1.1916779E-15 ,
     & 3.718258 , 1.3229230E-15 , 3.718412 , 1.4949350E-15 ,
     & 3.718566 , 1.6990940E-15 , 3.718720 , 1.8888809E-15 ,
     & 3.718874 , 1.9756690E-15 , 3.719028 , 1.8975781E-15 ,
     & 3.719182 , 1.6944580E-15 , 3.719336 , 1.5089610E-15 ,
     & 3.719490 , 1.3445590E-15 , 3.719643 , 1.1665250E-15 ,
     & 3.719797 , 1.0034720E-15 , 3.719951 , 9.5461555E-16 ,
     & 3.720105 , 9.3310981E-16 , 3.720259 , 9.2752797E-16 /
      data( xin(i), yin(i), i = 1001 , 1050 ) /
     & 3.720413 , 9.3310981E-16 , 3.720567 , 9.6673289E-16 ,
     & 3.720721 , 1.0225500E-15 , 3.720875 , 1.0840820E-15 ,
     & 3.721029 , 1.1343170E-15 , 3.721182 , 1.2573810E-15 ,
     & 3.721336 , 1.3579840E-15 , 3.721490 , 1.6709590E-15 ,
     & 3.721644 , 1.8722990E-15 , 3.721798 , 2.1217510E-15 ,
     & 3.721952 , 2.3091310E-15 , 3.722106 , 2.4400741E-15 ,
     & 3.722260 , 2.4219120E-15 , 3.722414 , 2.2844599E-15 ,
     & 3.722568 , 2.1154849E-15 , 3.722721 , 1.9752209E-15 ,
     & 3.722875 , 1.8531150E-15 , 3.723029 , 1.7015080E-15 ,
     & 3.723183 , 1.5182550E-15 , 3.723337 , 1.3310559E-15 ,
     & 3.723491 , 1.1692320E-15 , 3.723645 , 1.0515311E-15 ,
     & 3.723799 , 1.0071840E-15 , 3.723953 , 9.9769862E-16 ,
     & 3.724107 , 9.7243882E-16 , 3.724260 , 9.4003388E-16 ,
     & 3.724414 , 9.8307036E-16 , 3.724568 , 1.0654960E-15 ,
     & 3.724722 , 1.1837930E-15 , 3.724876 , 1.3423870E-15 ,
     & 3.725030 , 1.5317230E-15 , 3.725184 , 1.7628460E-15 ,
     & 3.725338 , 2.0588680E-15 , 3.725492 , 2.3480880E-15 ,
     & 3.725646 , 2.4736181E-15 , 3.725799 , 2.3225180E-15 ,
     & 3.725953 , 1.9931820E-15 , 3.726107 , 1.7008770E-15 ,
     & 3.726261 , 1.5327320E-15 , 3.726415 , 1.4557050E-15 ,
     & 3.726569 , 1.4073480E-15 , 3.726723 , 1.3460739E-15 ,
     & 3.726877 , 1.3593420E-15 , 3.727031 , 1.4309330E-15 ,
     & 3.727185 , 1.4345110E-15 , 3.727338 , 1.2799401E-15 ,
     & 3.727492 , 1.0741060E-15 , 3.727646 , 9.3546838E-16 ,
     & 3.727800 , 8.6922828E-16 , 3.727954 , 8.0773109E-16 /
      data( xin(i), yin(i), i = 1051 , 1100 ) /
     & 3.728108 , 7.2114448E-16 , 3.728262 , 6.8266001E-16 ,
     & 3.728416 , 7.0126080E-16 , 3.728570 , 7.4104848E-16 ,
     & 3.728724 , 7.7750102E-16 , 3.728877 , 8.4145698E-16 ,
     & 3.729031 , 1.0012360E-15 , 3.729185 , 1.2312110E-15 ,
     & 3.729339 , 1.4281510E-15 , 3.729493 , 1.4859300E-15 ,
     & 3.729647 , 1.3768350E-15 , 3.729801 , 1.1773150E-15 ,
     & 3.729955 , 1.0084540E-15 , 3.730108 , 8.7594531E-16 ,
     & 3.730263 , 7.9359157E-16 , 3.730416 , 7.8325190E-16 ,
     & 3.730570 , 7.9501210E-16 , 3.730724 , 7.3955352E-16 ,
     & 3.730878 , 6.5555998E-16 , 3.731032 , 5.8351258E-16 ,
     & 3.731186 , 5.0050812E-16 , 3.731340 , 3.7819100E-16 ,
     & 3.731494 , 3.1983681E-16 , 3.731647 , 3.6989691E-16 ,
     & 3.731802 , 4.2130291E-16 , 3.731955 , 4.1609490E-16 ,
     & 3.732109 , 4.2994641E-16 , 3.732263 , 4.7837419E-16 ,
     & 3.732417 , 4.8799320E-16 , 3.732571 , 4.6063859E-16 ,
     & 3.732725 , 4.5615191E-16 , 3.732879 , 5.0748888E-16 ,
     & 3.733033 , 5.7807468E-16 , 3.733186 , 6.8886241E-16 ,
     & 3.733341 , 7.9614919E-16 , 3.733494 , 8.3553368E-16 ,
     & 3.733648 , 8.1486608E-16 , 3.733802 , 8.2474682E-16 ,
     & 3.733956 , 8.8788381E-16 , 3.734110 , 9.8694680E-16 ,
     & 3.734264 , 1.0918880E-15 , 3.734418 , 1.1672110E-15 ,
     & 3.734572 , 1.1807440E-15 , 3.734725 , 1.1253460E-15 ,
     & 3.734879 , 1.0726220E-15 , 3.735033 , 1.0059280E-15 ,
     & 3.735187 , 8.8820140E-16 , 3.735341 , 7.3849208E-16 ,
     & 3.735495 , 6.1748670E-16 , 3.735649 , 5.0888178E-16 /
      data( xin(i), yin(i), i = 1101 , 1150 ) /
     & 3.735803 , 4.1221721E-16 , 3.735957 , 3.6680561E-16 ,
     & 3.736111 , 3.5289050E-16 , 3.736264 , 2.9303370E-16 ,
     & 3.736418 , 2.0682480E-16 , 3.736572 , 1.3992360E-16 ,
     & 3.736726 , 1.4924181E-16 , 3.736880 , 2.1338250E-16 ,
     & 3.737034 , 2.2396149E-16 , 3.737188 , 1.0962400E-16 ,
     & 3.737342 , 3.2471111E-17 , 3.737496 , 6.1281252E-17 ,
     & 3.737650 , 1.1901761E-16 , 3.737803 , 1.5905170E-16 ,
     & 3.737957 , 2.1592450E-16 , 3.738111 , 2.5859551E-16 ,
     & 3.738265 , 2.7018289E-16 , 3.738419 , 3.0870251E-16 ,
     & 3.738573 , 3.8482711E-16 , 3.738727 , 4.3213090E-16 ,
     & 3.738881 , 4.0020920E-16 , 3.739035 , 3.5944791E-16 ,
     & 3.739189 , 3.3455019E-16 , 3.739342 , 3.0556891E-16 ,
     & 3.739496 , 2.7244870E-16 , 3.739650 , 2.6931680E-16 ,
     & 3.739804 , 3.1502479E-16 , 3.739958 , 3.7852939E-16 ,
     & 3.740112 , 4.3081379E-16 , 3.740266 , 4.9561179E-16 ,
     & 3.740420 , 5.5487699E-16 , 3.740574 , 5.6395591E-16 ,
     & 3.740728 , 5.6974962E-16 , 3.740881 , 5.9033681E-16 ,
     & 3.741035 , 5.8433680E-16 , 3.741189 , 5.3855848E-16 ,
     & 3.741343 , 4.6586230E-16 , 3.741497 , 3.9306281E-16 ,
     & 3.741651 , 3.8131870E-16 , 3.741805 , 4.1253350E-16 ,
     & 3.741959 , 4.9031699E-16 , 3.742113 , 6.1611753E-16 ,
     & 3.742267 , 7.7956143E-16 , 3.742420 , 9.5072217E-16 ,
     & 3.742574 , 1.0687100E-15 , 3.742728 , 1.1438750E-15 ,
     & 3.742882 , 1.2091740E-15 , 3.743036 , 1.2588580E-15 ,
     & 3.743190 , 1.2433420E-15 , 3.743344 , 1.1083680E-15 /
      data( xin(i), yin(i), i = 1151 , 1200 ) /
     & 3.743498 , 8.4003233E-16 , 3.743652 , 2.3468281E-16 ,
     & 3.743806 , 2.5834341E-16 , 3.743959 , 4.2552061E-16 ,
     & 3.744113 , 5.0017798E-16 , 3.744267 , 4.3480401E-16 ,
     & 3.744421 , 2.5115250E-16 , 3.744575 , 4.7052680E-17 ,
     & 3.744729 , -9.5608837E-17 , 3.744883 , -1.3222990E-16 ,
     & 3.745037 , -1.0589390E-16 , 3.745191 , -8.7173243E-17 ,
     & 3.745345 , -6.9638814E-18 , 3.745498 , 8.8473862E-17 ,
     & 3.745652 , 9.9252780E-17 , 3.745806 , 4.1910340E-17 ,
     & 3.745960 , 2.4964180E-17 , 3.746114 , 1.0377040E-16 ,
     & 3.746268 , 2.1500240E-16 , 3.746422 , 2.2965771E-16 ,
     & 3.746576 , 1.5142450E-16 , 3.746730 , 1.0106420E-16 ,
     & 3.746883 , 1.1447949E-16 , 3.747037 , 1.2989720E-16 ,
     & 3.747191 , 1.7482000E-16 , 3.747345 , 2.4674919E-16 ,
     & 3.747499 , 1.5719580E-16 , 3.747653 , 4.9225320E-17 ,
     & 3.747807 , 7.3733371E-17 , 3.747961 , 8.7583207E-17 ,
     & 3.748115 , -8.3627139E-17 , 3.748269 , -2.1512010E-16 ,
     & 3.748422 , -2.2523069E-16 , 3.748576 , -1.6533451E-16 ,
     & 3.748730 , -1.2671230E-16 , 3.748884 , -1.3798250E-16 ,
     & 3.749038 , -1.5707930E-16 , 3.749192 , -1.5412700E-16 ,
     & 3.749346 , -1.0673170E-16 , 3.749500 , -3.0517750E-17 ,
     & 3.749654 , -3.3243929E-17 , 3.749808 , -1.1924020E-16 ,
     & 3.749961 , -1.4870810E-16 , 3.750115 , -8.4928182E-17 ,
     & 3.750269 , -5.1824020E-17 , 3.750423 , -7.1260882E-17 ,
     & 3.750577 , -6.9603238E-17 , 3.750731 , -3.6406750E-17 ,
     & 3.750885 , -2.1344810E-17 , 3.751039 , -1.0504060E-17 /
      data( xin(i), yin(i), i = 1201 , 1250 ) /
     & 3.751193 , 5.6506408E-17 , 3.751347 , 1.0714120E-16 ,
     & 3.751500 , 8.2649657E-17 , 3.751654 , 6.5914410E-17 ,
     & 3.751808 , 8.7744573E-17 , 3.751962 , 7.6566273E-17 ,
     & 3.752116 , 6.5081353E-17 , 3.752270 , 1.0991950E-16 ,
     & 3.752424 , 2.1684421E-16 , 3.752578 , 3.4259259E-16 ,
     & 3.752732 , 4.0627851E-16 , 3.752886 , 3.6165469E-16 ,
     & 3.753039 , 2.7148549E-16 , 3.753193 , 2.5714271E-16 ,
     & 3.753347 , 2.2358620E-16 , 3.753501 , 2.2761001E-16 ,
     & 3.753655 , 3.1369021E-16 , 3.753809 , 3.5274690E-16 ,
     & 3.753963 , 2.7442430E-16 , 3.754117 , 2.3266431E-16 ,
     & 3.754271 , 2.2998300E-16 , 3.754425 , 2.0157140E-16 ,
     & 3.754578 , 2.3482080E-16 , 3.754732 , 2.5447371E-16 ,
     & 3.754886 , 1.8607490E-16 , 3.755040 , 1.0532900E-16 ,
     & 3.755194 , 8.3490767E-17 , 3.755348 , 8.3430198E-17 ,
     & 3.755502 , 7.9768898E-17 , 3.755656 , 3.7039480E-17 ,
     & 3.755810 , 6.3942521E-18 , 3.755964 , 1.7700021E-17 ,
     & 3.756117 , 2.3137550E-17 , 3.756271 , 3.2356661E-19 ,
     & 3.756425 , -1.0677700E-17 , 3.756579 , -3.5626209E-17 ,
     & 3.756733 , -2.2715309E-17 , 3.756887 , -1.9862081E-17 ,
     & 3.757041 , -4.9357880E-17 , 3.757195 , -5.3494369E-17 ,
     & 3.757349 , -2.4296720E-17 , 3.757503 , 2.1571390E-17 ,
     & 3.757656 , 4.8204222E-17 , 3.757810 , 8.1145762E-19 ,
     & 3.757964 , -3.8494259E-17 , 3.758118 , -2.6088610E-17 ,
     & 3.758272 , 2.6639189E-19 , 3.758426 , 2.9313689E-17 ,
     & 3.758580 , 1.5779380E-17 , 3.758734 , 4.3279999E-17 /
      data( xin(i), yin(i), i = 1251 , 1300 ) /
     & 3.758888 , 1.6502480E-17 , 3.759042 , 2.0353990E-17 ,
     & 3.759195 , 2.6063310E-17 , 3.759349 , 1.8450920E-17 ,
     & 3.759503 , 2.6063310E-17 , 3.759657 , 2.6063310E-17 ,
     & 3.759811 , 2.6063310E-17 , 3.759965 , 1.6502480E-17 ,
     & 3.760119 , 2.0353990E-17 , 3.760273 , 2.9869561E-17 ,
     & 3.760427 , 2.9869561E-17 , 3.760581 , 6.0744538E-17 ,
     & 3.760734 , 3.5578822E-17 , 3.760888 , 9.6671870E-18 ,
     & 3.761042 , -7.5784878E-17 , 3.761196 , -3.9722881E-17 ,
     & 3.761350 , 2.4266650E-17 , 3.761504 , -2.5286900E-17 ,
     & 3.761658 , -1.3544689E-16 , 3.761812 , -1.6432781E-16 ,
     & 3.761966 , -1.1994030E-16 , 3.762120 , -6.7511067E-17 ,
     & 3.762273 , -3.8745831E-17 , 3.762427 , -5.3131409E-17 ,
     & 3.762581 , -4.3433729E-17 , 3.762735 , 3.5768511E-17 ,
     & 3.762889 , 8.2021158E-17 , 3.763043 , -1.0438410E-17 ,
     & 3.763197 , -9.4727513E-17 , 3.763351 , -7.5468518E-17 ,
     & 3.763505 , -1.5503241E-17 , 3.763659 , 5.1969711E-18 ,
     & 3.763812 , 2.5980620E-17 , 3.763966 , 7.9974733E-17 ,
     & 3.764120 , 1.4207260E-17 , 3.764274 , 1.4207260E-17 ,
     & 3.764428 , 1.9483480E-17 , 3.764582 , 1.9483480E-17 ,
     & 3.764736 , 2.7397889E-17 , 3.764890 , 1.9483480E-17 ,
     & 3.765043 , 2.4759781E-17 , 3.765198 , 1.9483480E-17 ,
     & 3.765351 , 1.4207260E-17 , 3.765505 , 1.9483480E-17 ,
     & 3.765659 , 1.9483480E-17 , 3.765813 , 1.4207260E-17 ,
     & 3.765967 , 1.9483480E-17 , 3.766121 , 1.9483480E-17 ,
     & 3.766275 , 1.9483480E-17 , 3.766429 , 1.4207260E-17 /
      data( xin(i), yin(i), i = 1301 , 1350 ) /
     & 3.766582 , 1.4207260E-17 , 3.766737 , 8.9309574E-18 ,
     & 3.766890 , 1.4207260E-17 , 3.767044 , 8.9309574E-18 ,
     & 3.767198 , 1.1569090E-17 , 3.767352 , 1.1569090E-17 ,
     & 3.767506 , 1.6845369E-17 , 3.767660 , 1.1569090E-17 ,
     & 3.767814 , 1.1569090E-17 , 3.767968 , 1.6845369E-17 ,
     & 3.768121 , 1.6845369E-17 , 3.768275 , 1.1569090E-17 ,
     & 3.768429 , 1.1569090E-17 , 3.768583 , 1.1569090E-17 ,
     & 3.768737 , 1.1569090E-17 , 3.768891 , 1.1569090E-17 ,
     & 3.769045 , 1.1569090E-17 , 3.769199 , 1.1569090E-17 ,
     & 3.769353 , 3.5918701E-18 , 3.769507 , 8.9309574E-18 ,
     & 3.769660 , 8.9309574E-18 , 3.769814 , 1.4207260E-17 ,
     & 3.769968 , 1.4207260E-17 , 3.770122 , 8.9309574E-18 ,
     & 3.770276 , 8.9309574E-18 , 3.770430 , 8.9309574E-18 ,
     & 3.770584 , 8.9309574E-18 , 3.770738 , 8.9309574E-18 ,
     & 3.770892 , 8.9309574E-18 , 3.771046 , 8.9309574E-18 ,
     & 3.771199 , 8.9309574E-18 , 3.771353 , 1.4207260E-17 ,
     & 3.771507 , 8.9309574E-18 , 3.771661 , 8.9309574E-18 ,
     & 3.771815 , 8.9309574E-18 , 3.771969 , 9.5375910E-19 ,
     & 3.772123 , -4.0749911E-17 , 3.772277 , 7.9162012E-17 ,
     & 3.772431 , 1.1426860E-16 , 3.772585 , 1.2094610E-16 ,
     & 3.772738 , 9.2451112E-17 , 3.772892 , 7.6230001E-17 ,
     & 3.773046 , 1.1332329E-16 , 3.773200 , 1.1472380E-16 ,
     & 3.773354 , 7.6801748E-17 , 3.773508 , 1.1739370E-16 ,
     & 3.773662 , 4.8832300E-17 , 3.773816 , 2.4017619E-18 ,
     & 3.773970 , -2.8092691E-17 , 3.774124 , -3.4334901E-17 /
      data( xin(i), yin(i), i = 1351 , 1400 ) /
     & 3.774277 , 5.0161291E-18 , 3.774431 , 4.1769309E-17 ,
     & 3.774585 , 2.3892680E-17 , 3.774739 , -2.1376570E-17 ,
     & 3.774893 , -3.2932641E-17 , 3.775047 , 3.3114330E-17 ,
     & 3.775201 , 2.3806280E-17 , 3.775355 , -2.3467470E-17 ,
     & 3.775509 , -3.6690499E-17 , 3.775663 , -1.7670379E-17 ,
     & 3.775816 , -1.4410570E-17 , 3.775970 , 1.9529620E-17 ,
     & 3.776124 , 7.7443382E-17 , 3.776278 , 6.9255108E-17 ,
     & 3.776432 , 1.0735630E-16 , 3.776586 , 1.0629590E-16 ,
     & 3.776740 , 1.0120260E-16 , 3.776894 , 1.3382019E-16 ,
     & 3.777048 , 1.9216171E-16 , 3.777202 , 2.9278369E-16 ,
     & 3.777355 , 3.8388211E-16 , 3.777509 , 4.5272090E-16 ,
     & 3.777663 , 5.0567020E-16 , 3.777817 , 4.7286382E-16 ,
     & 3.777971 , 3.8467829E-16 , 3.778125 , 1.7099820E-16 ,
     & 3.778279 , 4.9944030E-17 , 3.778433 , 9.0085342E-17 ,
     & 3.778587 , 8.3943930E-17 , 3.778741 , -2.3455189E-17 ,
     & 3.778894 , -7.7047387E-17 , 3.779048 , -4.9187200E-17 ,
     & 3.779202 , -1.4961990E-17 , 3.779356 , 2.4890060E-17 ,
     & 3.779510 , 2.7509939E-17 , 3.779664 , 2.3672030E-17 ,
     & 3.779818 , 3.1498191E-17 , 3.779972 , 5.5957961E-17 ,
     & 3.780126 , 2.3481260E-17 , 3.780280 , 2.9752161E-17 ,
     & 3.780433 , 3.4455351E-17 , 3.780587 , 2.9752161E-17 ,
     & 3.780741 , 3.4455351E-17 , 3.780895 , 2.9752161E-17 ,
     & 3.781049 , 2.8184449E-17 , 3.781203 , 2.9752161E-17 ,
     & 3.781357 , 3.4455351E-17 , 3.781511 , 3.4455351E-17 ,
     & 3.781665 , 3.4455351E-17 , 3.781819 , 3.4455351E-17 /
      data( xin(i), yin(i), i = 1401 , 1450 ) /
     & 3.781972 , 3.4455351E-17 , 3.782126 , 3.4455351E-17 ,
     & 3.782280 , 3.7628152E-17 , 3.782434 , 3.7628152E-17 ,
     & 3.782588 , 3.7628152E-17 , 3.782742 , 4.2331348E-17 ,
     & 3.782896 , 3.7628152E-17 , 3.783050 , 4.2331348E-17 ,
     & 3.783204 , 4.2331348E-17 , 3.783358 , 4.5466780E-17 ,
     & 3.783511 , 6.9380469E-18 , 3.783665 , 1.9170050E-17 ,
     & 3.783819 , 6.1663582E-17 , 3.783973 , 6.9050973E-17 ,
     & 3.784127 , 8.9168852E-17 , 3.784281 , 1.4833031E-16 ,
     & 3.784435 , 2.1180910E-16 , 3.784589 , 2.2290011E-16 ,
     & 3.784743 , 1.0527690E-16 , 3.784897 , 3.7125881E-17 ,
     & 3.785050 , 5.0917271E-17 , 3.785204 , -3.7434621E-18 ,
     & 3.785358 , -8.4203122E-17 , 3.785512 , -6.0632743E-17 ,
     & 3.785666 , 3.4605529E-18 , 3.785820 , 3.6495262E-17 ,
     & 3.785974 , 4.0160800E-17 , 3.786128 , 3.5756229E-17 ,
     & 3.786282 , 7.4620638E-17 , 3.786436 , 1.3158229E-16 ,
     & 3.786589 , 1.3697620E-16 , 3.786743 , 1.3191231E-16 ,
     & 3.786897 , 1.0896060E-16 , 3.787051 , 1.0596640E-16 ,
     & 3.787205 , 1.6710439E-16 , 3.787359 , 2.4445159E-16 ,
     & 3.787513 , 2.3626970E-16 , 3.787667 , 1.8491030E-16 ,
     & 3.787821 , 1.6967850E-16 , 3.787975 , 2.0509761E-16 ,
     & 3.788128 , 2.9617060E-16 , 3.788282 , 4.0206661E-16 ,
     & 3.788436 , 4.9899129E-16 , 3.788590 , 6.7690717E-16 ,
     & 3.788744 , 8.0715929E-16 , 3.788898 , 8.1525741E-16 ,
     & 3.789052 , 7.4988081E-16 , 3.789206 , 6.9747742E-16 ,
     & 3.789360 , 5.5592382E-16 , 3.789514 , 3.8248151E-16 /
      data( xin(i), yin(i), i = 1451 , 1500 ) /
     & 3.789667 , 2.7940401E-16 , 3.789821 , 2.4207400E-16 ,
     & 3.789975 , 2.2811190E-16 , 3.790129 , 1.9081619E-16 ,
     & 3.790283 , 1.2180591E-16 , 3.790437 , 1.0525820E-16 ,
     & 3.790591 , 1.8529991E-16 , 3.790745 , 2.2580371E-16 ,
     & 3.790899 , 1.9834120E-16 , 3.791053 , 1.9098479E-16 ,
     & 3.791206 , 2.0917820E-16 , 3.791360 , 1.3422680E-16 ,
     & 3.791514 , 7.4703217E-17 , 3.791668 , 1.1171979E-16 ,
     & 3.791822 , 1.8141750E-16 , 3.791976 , 1.6065550E-16 ,
     & 3.792130 , 7.8022752E-17 , 3.792284 , 1.0306700E-17 ,
     & 3.792438 , -4.7800190E-17 , 3.792592 , 1.6169860E-18 ,
     & 3.792745 , 9.0046802E-17 , 3.792899 , 6.8245440E-18 ,
     & 3.793053 , -2.2360399E-17 , 3.793207 , 1.0732330E-16 ,
     & 3.793361 , 2.0280640E-16 , 3.793515 , 2.1971151E-16 ,
     & 3.793669 , 2.7535861E-16 , 3.793823 , 3.4440270E-16 ,
     & 3.793977 , 3.1581920E-16 , 3.794131 , 2.6100349E-16 ,
     & 3.794284 , 3.2144350E-16 , 3.794438 , 4.2075679E-16 ,
     & 3.794592 , 5.2693448E-16 , 3.794746 , 7.0693672E-16 ,
     & 3.794900 , 8.3153441E-16 , 3.795054 , 9.2352976E-16 ,
     & 3.795208 , 1.0270760E-15 , 3.795362 , 1.1082260E-15 ,
     & 3.795516 , 1.0973910E-15 , 3.795670 , 1.0912530E-15 ,
     & 3.795823 , 1.1010890E-15 , 3.795977 , 1.0219320E-15 ,
     & 3.796131 , 9.9193826E-16 , 3.796285 , 8.1177822E-16 ,
     & 3.796439 , 5.8091261E-16 , 3.796593 , 4.7445412E-16 ,
     & 3.796747 , 4.6636528E-16 , 3.796901 , 4.4586459E-16 ,
     & 3.797055 , 3.6106770E-16 , 3.797209 , 2.8395760E-16 /
      data( xin(i), yin(i), i = 1501 , 1550 ) /
     & 3.797362 , 2.7191539E-16 , 3.797516 , 3.5259740E-16 ,
     & 3.797670 , 4.6613240E-16 , 3.797824 , 4.3121690E-16 ,
     & 3.797978 , 4.3112241E-16 , 3.798132 , 4.0458661E-16 ,
     & 3.798286 , 2.8615190E-16 , 3.798440 , 2.4859739E-16 ,
     & 3.798594 , 2.0900190E-16 , 3.798748 , 2.0566241E-16 ,
     & 3.798901 , 2.0399260E-16 , 3.799055 , 1.9226450E-16 ,
     & 3.799209 , 2.1401120E-16 , 3.799363 , 2.1735071E-16 ,
     & 3.799517 , 2.4076710E-16 , 3.799671 , 2.6919279E-16 ,
     & 3.799825 , 3.1769530E-16 , 3.799979 , 3.4612101E-16 ,
     & 3.800133 , 4.9997750E-16 , 3.800287 , 5.5181962E-16 ,
     & 3.800440 , 6.3165989E-16 , 3.800594 , 6.9727472E-16 ,
     & 3.800748 , 7.4052131E-16 , 3.800902 , 7.3036152E-16 ,
     & 3.801056 , 4.9601651E-16 , 3.801210 , 4.1156111E-16 ,
     & 3.801364 , 3.5537850E-16 , 3.801518 , 3.0420280E-16 ,
     & 3.801672 , 3.8562819E-16 , 3.801826 , 4.0771319E-16 ,
     & 3.801979 , 3.8803270E-16 , 3.802133 , 3.0225079E-16 ,
     & 3.802287 , 2.3782459E-16 , 3.802441 , 2.2698540E-16 ,
     & 3.802595 , 2.0186581E-16 , 3.802749 , 1.9676399E-16 ,
     & 3.802903 , 2.0478450E-16 , 3.803057 , 2.3142740E-16 ,
     & 3.803210 , 1.9207530E-16 , 3.803365 , 1.2607440E-16 ,
     & 3.803518 , 4.9148091E-17 , 3.803672 , 3.4480961E-17 ,
     & 3.803826 , 7.2246332E-17 , 3.803980 , 7.4341660E-17 ,
     & 3.804134 , 1.1210699E-16 , 3.804288 , 1.4149120E-16 ,
     & 3.804442 , 2.7268349E-16 , 3.804596 , 2.4267110E-16 ,
     & 3.804749 , 1.6427061E-16 , 3.804904 , 1.4696769E-16 /
      data( xin(i), yin(i), i = 1551 , 1600 ) /
     & 3.805057 , 1.2326241E-16 , 3.805211 , 1.1491660E-16 ,
     & 3.805365 , 9.9385612E-17 , 3.805519 , 2.8491389E-17 ,
     & 3.805673 , -1.0106040E-16 , 3.805827 , -7.1271728E-17 ,
     & 3.805981 , -3.6666369E-18 , 3.806135 , 1.8102431E-17 ,
     & 3.806288 , 3.3705800E-17 , 3.806442 , -3.6019481E-18 ,
     & 3.806596 , -2.6624901E-17 , 3.806750 , 2.1788240E-17 ,
     & 3.806904 , 8.7584193E-17 , 3.807058 , 1.4097840E-16 ,
     & 3.807212 , 1.9925829E-16 , 3.807366 , 2.0604300E-16 ,
     & 3.807520 , 1.6740550E-16 , 3.807674 , 2.0254161E-16 ,
     & 3.807827 , 1.9592701E-16 , 3.807981 , 5.0917159E-17 ,
     & 3.808135 , 1.4248030E-16 , 3.808289 , 2.1382980E-16 ,
     & 3.808443 , 3.6599110E-16 , 3.808597 , 4.5611718E-16 ,
     & 3.808751 , 3.7649040E-16 , 3.808905 , 2.0007299E-16 ,
     & 3.809059 , 1.2063599E-16 , 3.809212 , 1.9151730E-16 ,
     & 3.809366 , 1.6616000E-16 , 3.809520 , 9.1116631E-17 ,
     & 3.809674 , 7.3825962E-17 , 3.809828 , 4.2950640E-16 ,
     & 3.809982 , 7.1733420E-16 , 3.810136 , 5.5726838E-16 ,
     & 3.810290 , 2.8403889E-16 , 3.810444 , 1.2712980E-16 ,
     & 3.810598 , 1.4514870E-16 , 3.810751 , 9.9014419E-17 ,
     & 3.810905 , 2.5891870E-17 , 3.811059 , -1.0405710E-16 ,
     & 3.811213 , -1.4568420E-16 , 3.811367 , -1.5034601E-16 ,
     & 3.811521 , -8.9037192E-17 , 3.811675 , 7.6036063E-17 ,
     & 3.811829 , 7.3963499E-17 , 3.811983 , 1.6183610E-17 ,
     & 3.812137 , 1.1843190E-17 , 3.812290 , 4.8408069E-18 ,
     & 3.812444 , -6.0448639E-18 , 3.812598 , -9.5059067E-18 /
      data( xin(i), yin(i), i = 1601 , 1650 ) /
     & 3.812752 , -9.9244344E-18 , 3.812906 , -4.3094650E-18 ,
     & 3.813060 , 1.0257610E-17 , 3.813214 , 9.7370797E-18 ,
     & 3.813368 , 3.9342170E-18 , 3.813522 , 3.6683409E-18 ,
     & 3.813676 , 1.8302000E-18 , 3.813829 , -4.1057280E-19 ,
     & 3.813983 , -1.4765900E-18 , 3.814137 , -1.4038120E-18 ,
     & 3.814291 , -5.2715890E-19 , 3.814445 , 8.7894227E-19 ,
     & 3.814599 , 9.5039744E-19 , 3.814753 , 3.3116341E-19 ,
     & 3.814907 , 5.8233520E-22 , 3.815061 , 5.5451541E-19 ,
     & 3.815215 , 8.7990841E-19 , 3.815368 , -8.6357661E-19 ,
     & 3.815522 , -3.2780969E-18 , 3.815676 , -4.4953362E-18 ,
     & 3.815830 , -4.8872209E-18 , 3.815984 , -4.9400281E-18 ,
     & 3.816138 , -6.1510999E-18 , 3.816292 , -6.0083749E-18 ,
     & 3.816446 , -6.6559320E-18 , 3.816600 , -8.8808758E-18 ,
     & 3.816754 , -8.5879082E-18 , 3.816907 , -8.8263480E-18 ,
     & 3.817061 , -7.4661719E-18 , 3.817215 , -4.5259088E-18 ,
     & 3.817369 , -6.9940569E-18 , 3.817523 , -1.5896160E-17 ,
     & 3.817677 , -3.1209141E-17 , 3.817831 , -4.5781711E-17 ,
     & 3.817985 , -5.5793418E-17 , 3.818139 , -7.1517533E-17 ,
     & 3.818293 , -8.7216018E-17 , 3.818446 , -9.7503021E-17 ,
     & 3.818600 , -9.0751110E-17 , 3.818754 , -5.7767647E-17 ,
     & 3.818908 , -5.2427100E-18 , 3.819062 , 5.1592039E-17 ,
     & 3.819216 , 9.6456942E-17 , 3.819370 , 1.3535870E-16 ,
     & 3.819524 , 1.7941530E-16 , 3.819678 , 2.1921350E-16 ,
     & 3.819832 , 2.4163211E-16 , 3.819985 , 2.3181539E-16 ,
     & 3.820139 , 1.9977561E-16 , 3.820293 , 8.1517339E-17 /
      data( xin(i), yin(i), i = 1651 , 1700 ) /
     & 3.820447 , -3.5069811E-19 , 3.820601 , -1.3577300E-17 ,
     & 3.820755 , 1.2399159E-16 , 3.820909 , 9.9950152E-17 ,
     & 3.821063 , 3.6061551E-17 , 3.821217 , 7.4129147E-17 ,
     & 3.821371 , -2.0168520E-18 , 3.821524 , -1.9062480E-17 ,
     & 3.821678 , 3.4342200E-17 , 3.821832 , -3.5747279E-17 ,
     & 3.821986 , -4.5122461E-17 , 3.822140 , 6.2582500E-17 ,
     & 3.822294 , 3.3311149E-17 , 3.822448 , -1.7920090E-17 ,
     & 3.822602 , -3.1513619E-17 , 3.822756 , -2.2012409E-17 ,
     & 3.822910 , 4.0314411E-17 , 3.823063 , 1.0504530E-16 ,
     & 3.823217 , 6.3184489E-17 , 3.823371 , -7.6927347E-17 ,
     & 3.823525 , -6.6077629E-17 , 3.823679 , -2.2615780E-18 ,
     & 3.823833 , -7.1749324E-18 , 3.823987 , 5.8817571E-17 ,
     & 3.824141 , 1.2159420E-16 , 3.824295 , 2.6008279E-18 ,
     & 3.824449 , -7.0463572E-17 , 3.824602 , -8.6034058E-19 ,
     & 3.824756 , 1.1147520E-17 , 3.824910 , 8.3941230E-18 ,
     & 3.825064 , -1.0636950E-18 , 3.825218 , 3.5779969E-17 ,
     & 3.825372 , 4.2454390E-17 , 3.825526 , 4.1079281E-17 ,
     & 3.825680 , 6.1057887E-17 , 3.825834 , 3.2736910E-17 ,
     & 3.825988 , -8.3942408E-17 , 3.826141 , -1.2285910E-16 ,
     & 3.826295 , -1.4442130E-17 , 3.826449 , -3.2134451E-17 ,
     & 3.826603 , -1.0816580E-16 , 3.826757 , -4.5088901E-17 ,
     & 3.826911 , 1.3153690E-16 , 3.827065 , 6.4509533E-17 ,
     & 3.827219 , -7.9272722E-17 , 3.827373 , -4.0244808E-17 ,
     & 3.827527 , 7.1244947E-17 , 3.827680 , 1.5767831E-16 ,
     & 3.827834 , 1.2460940E-16 , 3.827988 , 6.0217359E-18 /
      data( xin(i), yin(i), i = 1701 , 1750 ) /
     & 3.828142 , -1.9183620E-17 , 3.828296 , -6.4261021E-17 ,
     & 3.828450 , -1.1699350E-16 , 3.828604 , -6.2413358E-17 ,
     & 3.828758 , 2.5555169E-17 , 3.828912 , 1.7320691E-17 ,
     & 3.829066 , -5.9099878E-17 , 3.829219 , -3.5188760E-17 ,
     & 3.829373 , 2.6438659E-17 , 3.829527 , 2.5925010E-17 ,
     & 3.829681 , 3.3214700E-17 , 3.829835 , 7.9912609E-17 ,
     & 3.829989 , 3.3006171E-17 , 3.830143 , -8.8025980E-17 ,
     & 3.830297 , -6.8979478E-17 , 3.830451 , -5.3176239E-17 ,
     & 3.830605 , -1.9312441E-17 , 3.830758 , 1.1250620E-16 ,
     & 3.830912 , -3.4192950E-17 , 3.831066 , -2.1487011E-17 ,
     & 3.831220 , 8.4233893E-17 , 3.831374 , 9.3897579E-17 ,
     & 3.831528 , 5.7930913E-17 , 3.831682 , 6.4390472E-17 ,
     & 3.831836 , 1.6757650E-17 , 3.831990 , -1.2115270E-16 ,
     & 3.832144 , -1.5376779E-16 , 3.832297 , -6.8053122E-17 ,
     & 3.832451 , 4.5284611E-18 , 3.832605 , -1.2310910E-17 ,
     & 3.832759 , 7.7343981E-17 , 3.832913 , 3.7459890E-17 ,
     & 3.833067 , -1.5712010E-17 , 3.833221 , 1.5428340E-17 ,
     & 3.833375 , 5.4060531E-17 , 3.833529 , -3.3527341E-17 ,
     & 3.833683 , -2.5031600E-17 , 3.833836 , 4.5428620E-17 ,
     & 3.833990 , -1.3156230E-17 , 3.834144 , 7.8377911E-18 ,
     & 3.834298 , -4.4303622E-17 , 3.834452 , -3.3918759E-17 ,
     & 3.834606 , 9.1037533E-17 , 3.834760 , 8.2199373E-17 ,
     & 3.834914 , -7.1743512E-17 , 3.835068 , -5.3317170E-17 ,
     & 3.835222 , 7.4995321E-18 , 3.835375 , 1.3663290E-18 ,
     & 3.835529 , 2.9707480E-17 , 3.835683 , 4.6338400E-17 /
      data( xin(i), yin(i), i = 1751 , 1800 ) /
     & 3.835837 , 4.2075700E-17 , 3.835991 , 6.1972358E-17 ,
     & 3.836145 , 9.7493327E-17 , 3.836299 , 3.0900589E-17 ,
     & 3.836453 , -1.9604949E-16 , 3.836607 , -1.8104920E-16 ,
     & 3.836761 , 8.3810297E-17 , 3.836914 , 1.1858930E-16 ,
     & 3.837068 , 6.4042039E-18 , 3.837222 , -3.6728199E-17 ,
     & 3.837376 , -9.7959149E-17 , 3.837530 , -6.8436662E-17 ,
     & 3.837684 , 6.6032571E-18 , 3.837838 , 6.5785032E-17 ,
     & 3.837992 , 3.8042371E-17 , 3.838145 , -8.5151799E-17 ,
     & 3.838300 , -1.2190670E-16 , 3.838453 , -1.9064811E-17 ,
     & 3.838607 , 1.5472010E-16 , 3.838761 , 8.0839342E-17 ,
     & 3.838915 , -1.5724699E-16 , 3.839069 , -1.4372669E-16 ,
     & 3.839223 , 2.6895840E-17 , 3.839377 , 8.8610658E-17 ,
     & 3.839531 , 4.7205361E-17 , 3.839684 , -9.1335993E-17 ,
     & 3.839839 , -1.1205060E-16 , 3.839992 , 6.8469908E-17 ,
     & 3.840146 , -2.7768490E-17 , 3.840300 , -2.5728581E-16 ,
     & 3.840454 , -2.3436549E-16 , 3.840608 , -2.4903089E-16 ,
     & 3.840762 , -1.6576840E-16 , 3.840916 , -4.9768691E-17 ,
     & 3.841070 , -1.8238310E-17 , 3.841223 , -7.1245000E-17 ,
     & 3.841377 , 6.7339119E-20 , 3.841531 , -4.4917949E-17 ,
     & 3.841685 , -2.4480950E-17 , 3.841839 , -1.5302290E-17 ,
     & 3.841993 , -8.6375338E-17 , 3.842147 , -1.7056770E-16 ,
     & 3.842301 , -6.6413517E-17 , 3.842455 , 1.5935229E-17 ,
     & 3.842609 , -6.7685562E-17 , 3.842762 , -2.0543680E-16 ,
     & 3.842916 , -1.5412079E-16 , 3.843070 , -1.0955100E-17 ,
     & 3.843224 , 3.5751778E-17 , 3.843378 , -1.6085999E-17 /
      data( xin(i), yin(i), i = 1801 , 1850 ) /
     & 3.843532 , -3.7715201E-17 , 3.843686 , 1.0078590E-16 ,
     & 3.843840 , 1.8260250E-16 , 3.843994 , -2.8319279E-17 ,
     & 3.844148 , -9.2456823E-17 , 3.844301 , -9.6029402E-17 ,
     & 3.844455 , 2.6062140E-17 , 3.844609 , 8.6098358E-17 ,
     & 3.844763 , 1.1412820E-16 , 3.844917 , 6.9749140E-17 ,
     & 3.845071 , 1.4789111E-16 , 3.845225 , 2.6612589E-16 ,
     & 3.845379 , 2.4091041E-16 , 3.845533 , 1.5534969E-16 ,
     & 3.845687 , 1.1933400E-16 , 3.845840 , -4.9541690E-17 ,
     & 3.845994 , -6.6864781E-18 , 3.846148 , 2.1367760E-16 ,
     & 3.846302 , 3.8601621E-17 , 3.846456 , -1.0802250E-16 ,
     & 3.846610 , -1.4022420E-17 , 3.846764 , -4.0725340E-18 ,
     & 3.846918 , -8.1571602E-17 , 3.847072 , -9.9286449E-17 ,
     & 3.847226 , -3.2301601E-17 , 3.847379 , 7.3455538E-17 ,
     & 3.847533 , 4.1161139E-17 , 3.847687 , 8.1645082E-17 ,
     & 3.847841 , 1.4202670E-16 , 3.847995 , 9.3581259E-17 ,
     & 3.848149 , 1.8266330E-16 , 3.848303 , 2.7129409E-16 ,
     & 3.848457 , 2.2934690E-16 , 3.848611 , 3.3051840E-16 ,
     & 3.848765 , 4.1507881E-16 , 3.848918 , 3.7832639E-16 ,
     & 3.849072 , 2.5943769E-16 , 3.849226 , 2.8969199E-16 ,
     & 3.849380 , 1.7976110E-16 , 3.849534 , 7.7146907E-17 ,
     & 3.849688 , 1.0222950E-16 , 3.849842 , -2.3331949E-17 ,
     & 3.849996 , 1.1794930E-19 , 3.850150 , 7.6731232E-17 ,
     & 3.850304 , 8.6886727E-17 , 3.850457 , 1.2073310E-16 ,
     & 3.850611 , 1.5683920E-16 , 3.850765 , 6.3146313E-17 ,
     & 3.850919 , -1.0161280E-16 , 3.851073 , -5.7128141E-18 /
      data( xin(i), yin(i), i = 1851 , 1900 ) /
     & 3.851227 , 2.6880591E-18 , 3.851381 , -8.0441018E-17 ,
     & 3.851535 , -2.3212541E-16 , 3.851689 , -2.7054441E-17 ,
     & 3.851843 , -3.1719902E-17 , 3.851996 , -1.0206660E-16 ,
     & 3.852150 , -3.6260210E-17 , 3.852304 , 8.9158483E-17 ,
     & 3.852458 , 1.0648140E-16 , 3.852612 , 9.1334080E-17 ,
     & 3.852766 , -5.0028519E-17 , 3.852920 , -9.8220253E-17 ,
     & 3.853074 , -2.4991709E-18 , 3.853228 , 4.7114510E-17 ,
     & 3.853382 , 9.9569987E-17 , 3.853535 , 1.3387140E-16 ,
     & 3.853689 , -8.4904473E-18 , 3.853843 , -1.5279840E-16 ,
     & 3.853997 , -8.9232380E-17 , 3.854151 , 6.5321057E-17 ,
     & 3.854305 , 1.7021060E-16 , 3.854459 , 2.6932890E-16 ,
     & 3.854613 , 4.8258008E-16 , 3.854767 , 7.5549452E-16 ,
     & 3.854921 , 8.3325087E-16 , 3.855074 , 5.7683388E-16 ,
     & 3.855228 , 2.5788360E-16 , 3.855382 , 1.1185490E-17 ,
     & 3.855536 , -1.8471760E-16 , 3.855690 , -3.0963970E-16 ,
     & 3.855844 , -2.6080250E-16 , 3.855998 , -1.9402200E-16 ,
     & 3.856152 , -1.1255631E-16 , 3.856306 , 1.8853531E-16 ,
     & 3.856460 , 2.9693780E-16 , 3.856613 , 1.9604541E-16 ,
     & 3.856767 , 1.6486330E-16 , 3.856921 , 1.9008460E-16 ,
     & 3.857075 , 7.8803710E-17 , 3.857229 , -9.0104400E-17 ,
     & 3.857383 , 7.6060812E-17 , 3.857537 , 6.6198378E-17 ,
     & 3.857691 , -2.7912589E-16 , 3.857845 , -1.4100260E-16 ,
     & 3.857999 , 7.9904430E-17 , 3.858152 , 2.6052981E-16 ,
     & 3.858306 , -2.0737061E-17 , 3.858460 , -2.0737061E-17 ,
     & 3.858614 , -3.2650791E-17 , 3.858768 , -3.2650791E-17 /
      data( xin(i), yin(i), i = 1901 , 1950 ) /
     & 3.858922 , -5.0662520E-17 , 3.859076 , -6.2575830E-17 ,
     & 3.859230 , -7.4489143E-17 , 3.859384 , -2.0874700E-17 ,
     & 3.859538 , 4.1440448E-17 , 3.859691 , -1.2785391E-16 ,
     & 3.859845 , -1.2802970E-16 , 3.859999 , -4.1530240E-17 ,
     & 3.860153 , 1.5147070E-18 , 3.860307 , 4.7798920E-17 ,
     & 3.860461 , 2.2440020E-18 , 3.860615 , -8.5971508E-17 ,
     & 3.860769 , -5.4469509E-17 , 3.860923 , 3.2844970E-17 ,
     & 3.861077 , 2.4208410E-17 , 3.861230 , -9.4520407E-18 ,
     & 3.861384 , 6.6466682E-17 , 3.861538 , -5.6715209E-18 ,
     & 3.861692 , 3.9669091E-17 , 3.861846 , 4.3129009E-17 ,
     & 3.862000 , 1.8174569E-17 , 3.862154 , 1.4147139E-17 ,
     & 3.862308 , 1.4648800E-17 , 3.862462 , -6.4629249E-17 ,
     & 3.862616 , 2.2020679E-16 , 3.862769 , 8.4647200E-16 ,
     & 3.862923 , 1.0771060E-15 , 3.863077 , 1.0043750E-15 ,
     & 3.863231 , 7.4105372E-16 , 3.863385 , 5.3770790E-16 ,
     & 3.863539 , 4.9580232E-16 , 3.863693 , 4.1975671E-16 ,
     & 3.863847 , 5.5251451E-16 , 3.864001 , 7.6946718E-16 ,
     & 3.864155 , 8.2439372E-16 , 3.864308 , 6.5359730E-16 ,
     & 3.864462 , 4.9865301E-16 , 3.864616 , 6.7308520E-16 ,
     & 3.864770 , 1.0165540E-15 , 3.864924 , 1.1144280E-15 ,
     & 3.865078 , 6.7980620E-16 , 3.865232 , 3.7119379E-16 ,
     & 3.865386 , 2.6626311E-16 , 3.865540 , 2.3641579E-16 ,
     & 3.865694 , 1.1018630E-16 , 3.865847 , 6.7275797E-17 ,
     & 3.866001 , 1.0672700E-16 , 3.866155 , 1.6736860E-16 ,
     & 3.866309 , 1.0416680E-16 , 3.866463 , -6.2167348E-17 /
      data( xin(i), yin(i), i = 1951 , 2000 ) /
     & 3.866617 , 2.9128189E-17 , 3.866771 , 2.6835740E-16 ,
     & 3.866925 , 4.1153199E-16 , 3.867079 , 1.7419340E-16 ,
     & 3.867233 , 4.6768289E-17 , 3.867386 , 2.5677931E-16 ,
     & 3.867540 , 2.9470010E-16 , 3.867694 , 1.1507260E-16 ,
     & 3.867848 , 2.3066931E-16 , 3.868002 , 3.0207249E-16 ,
     & 3.868156 , 2.7187391E-16 , 3.868310 , 2.1821089E-16 ,
     & 3.868464 , 2.4950650E-16 , 3.868618 , 3.9326191E-16 ,
     & 3.868772 , 2.9663311E-16 , 3.868925 , 1.0165030E-16 ,
     & 3.869079 , 7.1951432E-17 , 3.869233 , 2.0605940E-16 ,
     & 3.869387 , 2.7179850E-16 , 3.869541 , 2.8341000E-16 ,
     & 3.869695 , 2.3314259E-16 , 3.869849 , 2.4688070E-16 ,
     & 3.870003 , 3.1609999E-16 , 3.870157 , 3.8303910E-16 ,
     & 3.870311 , 3.7941721E-16 , 3.870464 , 2.8489569E-16 ,
     & 3.870618 , 2.0234981E-16 , 3.870772 , 1.3245920E-16 ,
     & 3.870926 , 1.8621980E-16 , 3.871080 , 2.4373119E-16 ,
     & 3.871234 , 3.8312891E-16 , 3.871388 , 4.0217511E-16 ,
     & 3.871542 , 2.5444261E-16 , 3.871696 , 2.8610989E-16 ,
     & 3.871849 , 3.6792549E-16 , 3.872003 , 3.4926390E-16 ,
     & 3.872157 , 3.5781721E-16 , 3.872311 , 5.1607558E-16 ,
     & 3.872465 , 6.2839511E-16 , 3.872619 , 6.9637728E-16 ,
     & 3.872773 , 5.7853409E-16 , 3.872927 , 4.9353349E-16 ,
     & 3.873080 , 3.7032410E-16 , 3.873235 , 2.8852359E-16 ,
     & 3.873388 , 3.5730200E-16 , 3.873542 , 5.0264841E-16 ,
     & 3.873696 , 3.8021930E-16 , 3.873850 , 1.8319011E-16 ,
     & 3.874004 , 1.2813981E-16 , 3.874158 , -1.2383540E-16 /
      data( xin(i), yin(i), i = 2001 , 2001 ) /
     & 3.874312 , 0.0000000E+00 /
      nmax = n
      n = min( nmax,        2001  )
      do i = 1, n
        x(i) = xin(i)
        y(i) = yin(i)
      end do
      return
      end

C* PGSTART ... open a plot
C+
      SUBROUTINE PGSTART( NX, NY, NEW )
*
* PGSTART opens and PGSTOP closes a plot.
* Like PGBEGIN and PGEND, but keeping track of previous plot device
* and local plot queues so plots can be spooled at run time.
*
* Input:
*	NX,NY	I4 number of plots per page in X and Y direction
*		selected interactively if input values are 0
* Output:
*	NEW	I4 1 if opening a new plot, otherwise
*	NX,NY	I4 if changed by interaction
*
C--
* 1980 KDH at CIT - Original version
* 1985 Nov KDH @ STScI - added QMS devices
* 1986 Apr KDH @ STScI - added laser printer
* 1987 Jul KDH @ STScI - added Steve Baron's DeAnza driver
* 1987 Nov AWC @ STScI - option not to plot named Q,Z,P,V files.
* 1987 Dec KDH @ STScI - add retrographics option
* 1987 Dec KDH @ STScI - add metafile options
* 1988 Feb KDH @ STScI - call PGIDEN in PGSTOP
* 1988 Nov KDH @ STSCI - PRINT/NOFLAG
* 1989 Apr KDH @ STSCI - CHANGE QUEUE NAMES
* 1989 Jun KDH @ STSCI - put flag page back in
* 1989 Oct KDH @ STSCI - change queue 3C_T800 to 3C_T2400
* 1989 Nov KDH @ STSCI - add VAX WS option, also ?
* 1989 Dec KDH @ STSCI - update STScI printer queues
* 1990 Jan KDH @ STScI - interactive setting of NX, NY if 0 on input
* 1990 Feb KDH @ STScI - pgbegin option, add 3CLPS_POST queue
* 1991 Apr KDH @ STScI - Ant queue
* 1992 Mar Carole Hawell @ STScI - LP5 queue added
* 1992 Mar KDH @ STScI - distinguish VT125 and VT340 drivers
* 1992 Jul KDH @ Amsterdam - add amsterdam postscript queues
* 1992 Jul KDH @ cavad - add cavad canon queues
* 1992 Jul KDH @ cavad - add pericom_mg
* 1992 Oct KDH @ STScI - update STScI postscript queues
* 1993 Feb CAH @ STScI - update P&A postscript queues
* 1993 Apr KDH @ STScI - change SOL331 and ANT423S to 331PS1 and S423PS
* 1994 Jan KDH @ Utrecht - write(*,'(A)') '$...' -> write(*,'(A,$)') ' ...'
* 1994 Jan KDH @ Utrecht - add lpr for use on unix versions
* 1994 Jan KDH @ Utrecht - add XW devicetype
* 1994 Mar KDH @ Utrecht - eliminate de-anzas
* 1994 Mar KDH @ Utrecht - change LIB$SPAWN to SPAWN
* 1994 Mar KDH @ Utrecht - don't upcase filenames
* 1994 May KDH @ STScI - import Utrecht version, set OPSYS->VMS, SITE->STSCI
* 1995 Jan KDH @ St.Andrews - implement St-Andrews queues
* 1999 Sep KDH @ St.And - remove PGIDEN from PGSTOP
* 2000 Nov KDH @ Austin - implement Austin queues
* 2001 Jul KDH @ St.And - new St-Andrews queues
* 2001 Jul KDH @ StA - linux port: must use g77 -fno-automatic
* 2001 Jul KDH @ StA - simplify, strip vms & multi-sites
* 2001 Aug KDH @ StA - FULLPATH plot files, ASPECT
* 2004 Jan KDH @ StA - add err= to read (linux)
* 2005 Feb KDH @ StA - strip @ from plotfile
* 2006 May KDH @ StA - add farside printer
* 2010 Jun KDH @ StA - update StA printers
* 2014 Mar KDH @ StA - kdh -> kdh1
* 2014 Sep KDH @ StA - kdh1 -> kdh

        character*20 site
	character*1 aspect, queue, mode, oldmode
	character*256 reply
	character*64 terminal, devtype
	character*128 prtcom, plotdir, plotfile 
	character*128 psfile, cpsfile, giffile, pltfile, jfile
	character*256 task, path
	logical soft, spool, auto
	integer pgbegin
	common /pgstartmode/ mode
	data icall/0/
	icall = icall + 1

* first call initializations
      if( icall .eq. 1 ) then
	aspect = 'L'
	mode = 'H'
	queue = '?'
	iopen = 0
* page format
	nx0 = 1
	ny0 = 1

* site
	site = 'STANDREWS'
	write(*,*) 'PGSTART at ', SITE( :LEN1(SITE) )

* default directory
	plotdir='$SCR/'
* if system doesn't translate the environment variable $SCR
* correctly try the current directory as the default
c	plotdir = './'
	l1 = len1( plotdir )
        write(*,*) 'Default plot dir: ', plotdir(:l1)
	call fullpath( plotdir, path )
      if( plotdir(:l1) .ne. path(:len1(path)) ) then
	write(*,*) 'Default path: ', path(:len1(path))
      end if

* default plot files
	psfile = plotdir(:l1) // 'pgplot.ps'
	cpsfile = plotdir(:l1) // 'pgplot.cps'
	giffile = plotdir(:l1) // 'pgplot.gif'
	pltfile = plotdir(:l1) // 'pgplot.plt'

* end of first call initializations
      end if

* every call initializations
	oldmode = mode
	new = 0
	goto 1

* menu of device types
   10	write(*,*) 'PGSTART device types:'
	write(*,*) ' X=Xserve W=xWin T=Tektronix G=Gif H=Help'
	write(*,*) ' P=PostScript C=ColourPS N=null B=pgBegin'

* select device type
    1	write(*,'(A,$)')
     &	' PGSTART device type (H=help) [' // mode // '] '
	read(*,'(A)', err=1 ) reply
	call upcase( reply, reply )
	if( reply .eq. 'H' ) goto 10
	if( reply .eq. ' ' ) reply = mode

* soft devices (terminals) 
      if(    reply .eq. 'T'
     &	.or. reply .eq. 'X'
     &	.or. reply .eq. 'W'
     &	.or. reply .eq. 'B'
     &	.or. reply .eq. 'N'
     &	) then
	mode = reply
	soft = .true.
	spool = .false.
	auto = .false.

* hardcopy devices require a disk file
      else if( reply .eq. 'P'
     &	.or.   reply .eq. 'C'
     &	.or.   reply .eq. 'G' ) then
	mode = reply
	soft = .false.
	spool = mode .eq. 'P' .or. mode .eq. 'C'
	auto = .false.

* trap invalid replies
      else if( reply .ne. ' ' ) then
	goto 10
      else if( mode .eq. ' ' .or. mode .eq. 'H' ) then
	goto 10
      end if

* close previous plot if one was open
      if( mode .ne. oldmode .and. iopen .ne. 0 ) then
	call pgend
	iopen = 0
      end if

* terminals
      if( soft ) then
	if( mode .eq. 'N' ) terminal = '/NU'
	if( mode .eq. 'T' ) terminal = '/TE'
	if( mode .eq. 'W' ) terminal = '/XW'
	if( mode .eq. 'X' ) terminal = '/XSERV'
	if( mode .eq. 'B' ) terminal = '?'

* plot file 
      else

	jfile = pltfile
	if( mode .eq. 'P' ) jfile = psfile
	if( mode .eq. 'C' ) jfile = cpsfile
	if( mode .eq. 'G' ) jfile = giffile
      if( mode .ne. oldmode ) then
	plotfile = pltfile
	if( mode .eq. 'P' ) plotfile = psfile
	if( mode .eq. 'C' ) plotfile = cpsfile
	if( mode .eq. 'G' ) plotfile = giffile
      end if

	if( plotfile .ne. ' ' )
     &	write(*,*) '<CR> uses plotfile ', plotfile( :len1(plotfile) )
	write(*,*) 'JUNK autoprints ', jfile( :len1(jfile) )
	if( mode .eq. 'P' ) write(*,'(A,$)') ' PostScript file : '
	if( mode .eq. 'C' ) write(*,'(A,$)') ' ColourPostScript file : '
	if( mode .eq. 'G' ) write(*,'(A,$)') ' GIF file : '
 	read(*,'(A)') reply
      if( reply .eq. ' ' ) then
	reply = plotfile
      else
	if( reply(1:1) .eq. '@' ) reply = reply(2:)
	plotfile = reply
	call upcase( reply, reply )
	auto = .false.
      if( reply .eq. 'JUNK') then
	plotfile = jfile
	auto = .true.
      end if
	if( plotfile .eq. ' ' ) goto 10
      end if

      if( spool ) then

* print queues at each site
      if( site .eq. 'STANDREWS' ) then
   16	write(*,'(A,$)')
     &	' Which Queue (?,U,K,D,T,C) ? [' // queue // '] '
	read(*,'(A)') reply
	if( reply .eq. ' ' ) reply = queue
	call upcase( reply, reply )
	prtcom = ' '
      if( reply .eq. 'K') then
	prtcom = 'lpr -Pkdh1'
c	prtcom = 'lpr -Pkdh'
      else if( reply .eq. 'D') then
	prtcom = 'lpr -Pduplex'
      else if( reply .eq. 'T') then
	prtcom = 'lpr -PT644N'
      else if( reply .eq. 'C') then
	prtcom = 'lpr -PHPCP2025'
      else if( reply .eq. 'U') then
	prtcom = 'lpr -PUniPrint_Ricoh'
      else
        write(*,*) 'St.Andrews Printer queues :'
        write(*,*) ' K  kdh1    (Keith Horne''s office)'
        write(*,*) ' D  duplex  double-sided (Starlink room)'
        write(*,*) ' T  T644N   double-sided (south corridor)'
        write(*,*) ' C HPCP2025 colour (Starlink room)'
        write(*,*) ' U UniPrint_Ricoh'
	goto 16
      end if
	queue = reply

* last site
      else
	write(*,*) '** PGSTART: no queues at ', site( :len1(site) )
	spool = .false.
	auto = .false.
      end if

      end if

* portrait vs landscape
	write(*,'(A,$)')
     &	' P(ortrait) or L(andscape) ? [' // aspect // '] '
	read(*,'(A)') reply
	call upcase( reply, reply )
	if( reply .eq. ' ' ) reply = aspect
	if( reply .eq. 'P' .or. reply .eq. 'L' ) aspect = reply

* device type
      if( aspect .eq. 'L' ) then
	if( mode .eq. 'P' ) devtype  =  'PS'
	if( mode .eq. 'C' ) devtype  =  'CPS'
	if( mode .eq. 'G' ) devtype  =  'GIF'
      else if( aspect .eq. 'P' ) then
	if( mode .eq. 'P' ) devtype  =  'VPS'
	if( mode .eq. 'C' ) devtype  =  'VCPS'
	if( mode .eq. 'G' ) devtype  =  'VGIF'
      end if

* end of hard devices
      end if

* need to open a new plot ?
      if( iopen .le. 0 ) then

* page format
      if( nx .le. 0 .or. ny .le. 0 ) then
   40	write(*,'(A,I3,A,I3,A,$)')
     #	' Plot page format (NX,NY) [', nx0, ' ,', ny0, ' ] '
	read(*,'(A)') reply
      if( reply .eq. ' ' ) then
	nx = nx0
	ny = ny0
      else
	read( reply,*,err=40, end=40 ) nx, ny
	IF( nx .le. 0 .or. ny .le. 0 ) goto 40
      end if
      end if
	nx0 = nx
	ny0 = ny

* open the plot

* terminals
      if( soft ) then
	write(*,*) 'PGBEGIN( 0, ',
     &	'''', terminal( :len1( terminal ) ), ''',',
     &	nx, ',', ny, ' )'
	ierr = pgbegin( 0, terminal, nx, ny )

* hardcopy devices
      else
* get full path
	call fullpath( plotfile, path )
* call pgbegin
	task = '"' // path( :len1( path ) ) // '"'
     &		// '/' // devtype( :len1( devtype ) )
	write(*,*) 'PGBEGIN( 0, ', task( :len1(task) ),
     &	', ', nx, ', ', ny, ' )'
	ierr = pgbegin( 0, task( :len1(task) ), nx, ny )
      end if
* failure
      if( ierr .ne. 1 ) then
	write(*,*) '** FAILED TO OPEN PLOT.'
	goto 1
      end if
* success
	iopen = 1
	new = 1
      end if

c	write(*,*) 'PGSTART spool', spool, ' auto', auto
	return

C* PGSTOP ... close plot, send output to printer queue
C+
	entry pgstop
C--
* write time and username at bottom of plot
c	call pgiden

* close the plot
	call pgend
	iopen = 0

* how to print the plot file
	write(*,*) 'PGSTOP spool', spool, ' auto', auto
      if( spool ) then
	call word1( prtcom, l1, l2 )
	l2 = len1( prtcom )
	write(*,*) 'COMMAND: ', prtcom( l1:l2 )
	call word1( plotfile, l3, l4 )
	write(*,*) 'PLOTFILE: ', plotfile( l3:l4 )
	call fullpath( plotfile, path )
	call word1( path, l5, l6 )
      if( plotfile( l3:l4 ) .ne. path( l5:l6 ) ) then
	write(*,*) 'PATH: ', path( l5:l6 )
      end if
	task = prtcom( l1:l2 ) // ' ' // path( l5:l6 )
	write(*,*) 'TASK: ', task( :len1( task ) )

* decide to spool, or not to spool
      if( .not. auto ) then
	write(*,'(A,$)') ' Queue file for plotting? [Y] '
	read(*,'(A)') reply
	call upcase( reply, reply )
	if( reply .eq. ' ' ) reply = 'Y'
      else
	reply = 'Y'
      end if

* print the plot file
      if( reply .eq. 'Y' ) then
	call spawn( task( : len1( task ) ) )
      end if
      end if

	return
	end
*=====================================
	logical function pgagain()
* plot again ?
* 1997 Aug Keith Horne @ St.Andrews
* 1999 Oct KDH @ St.And - make logical
	character*10 reply
	write(*,'(A,$)') ' Plot again ? [N] '
	read(*,'(A)') reply
	call upcase( reply, reply )
	pgagain = .false.
	if( reply.eq.'Y') pgagain = .true.
	return
	end
      SUBROUTINE PGLIMIT( NPLOT, XPLOT, XSMALL, XLARGE, SIZE )
*
*  DETERMINES REASONABLE PLOT LIMITS
*
*  Input:
*	NPLOT	= NUMBER OF VALUES TO BE PLOTTED
*	XPLOT	= ARRAY OF VALUES TO BE PLOTTED
*	SIZE	= DESIRED UNITS BETWEEN PLOT LIMITS
*  Output:
*	XSMALL	= LOWER PLOT LIMIT
*	XLARGE	= UPPER PLOT LIMIT
*
*  ADAPTED FROM 'PLOTLIM' AUG 1984 BY KEITH HORNE AT IOA
* Feb 1994 KDH @ STScI - avoid float overflow in calc of rms of data.
* 2019 Nov KDH @ StA - xplot(1) -> xplot(nplot)
*
	REAL*4 XPLOT( NPLOT )
	REAL*8 CALC1, CALC2
	PARAMETER ( THRESH=10. )	! SIGMA LIMIT FOR REJECT
	PARAMETER ( MAXTEST = 10000 )	! MAX NUMBER OF DATA POINTS TO CHECK
*
*  TEST INPUTS
*
      IF(NPLOT.LE.0) THEN
	WRITE(*,*) '** NULL ARRAY IN ''PGLIMIT''.', NPLOT
	RETURN
      END IF
	UNIT = ABS( SIZE )
*
*  COMPUTE MEAN AND SIGMA OF PLOT DATA (USE ONLY MAXTEST POINTS)
*
	CALC1=0.D0
	NTEST = MAX(NPLOT,MAXTEST)
	SCALE = FLOAT(NPLOT-1)/(NTEST-1)
      DO ITEST=0,NTEST-1
	I = NINT( ITEST*SCALE ) + 1
	CALC1 = CALC1 + XPLOT(I)
      END DO
	XMU = CALC1/NTEST
	CALC2=0.D0
      DO ITEST=0,NTEST-1
	I = NINT( ITEST*SCALE ) + 1
	CALC2 = CALC2 + ( XPLOT(I) - XMU )**2
      END DO
	XSG = CALC2
	IF(NTEST.GT.1) XSG = XSG / (NTEST-1)
	XSG = SQRT( MAX( XSG,UNIT/2. ) )
*
*  FIND EXTREMA, BUT REJECT THRESH*SIGMA DEVIANTS
*
	XLARGE=XMU
	XSMALL=XMU
	NTEST = MAX(NPLOT,MAXTEST)
	SCALE = FLOAT(NPLOT-1)/(NTEST-1)
      DO ITEST=0, NTEST-1
	I = NINT( ITEST*SCALE ) + 1 
	TEST = 0.
	IF( XSG.GT.0. ) TEST = (XPLOT(I) - XMU) / XSG
      IF(ABS(TEST).LT.THRESH) THEN
	XLARGE = MAX(XLARGE, XPLOT(I))
	XSMALL = MIN(XSMALL, XPLOT(I))
      END IF
      END DO
*
*  ROUND RANGE TO NEAREST INTEGER AND MID TO NEAREST HALF-INTEGER
*  MULTIPLE OF UNIT
*
      IF( UNIT.GT.0. ) THEN
	ISIZE = 1.1*(XLARGE-XSMALL)/UNIT + 2.
	I2MID = (XLARGE+XSMALL)/UNIT + 0.5
	XLARGE = 0.5*UNIT*(I2MID+ISIZE)
	XSMALL = 0.5*UNIT*(I2MID-ISIZE)
      END IF
*
	RETURN
	END
C*PGEWIN ... edit plot window
C+
	INTEGER FUNCTION PGEWIN( XLFT, XRGT, YBOT, YTOP )
*
* Edit the window
*
* Input:
*	XLFT	R4 left edge of the default window
*	XRGT	R4 right edge
*	YBOT	R4 bottom edge
*	YTOP	R4 top edge
* Output:
*	XLFT	R4 left edge of the final window
*	XRGT	R4 right edge
*	YBOT	R4 bottom edge
*	YTOP	R4 top edge
*	PGEWIN	I4 0 if successful
*		   1 if aborted
C--
* Aug 1984 Keith Horne @ IOA - original version
* Mar 1988 Keith Horne @ STScI - eliminate case sensitivity
* Jul 1988 KDH @ STScI - change name from PGSETLIMS to PGSWIN
* Jan 1990 KDH @ STScI - eliminate type
* Jan 1992 KDH @ STScI - change PGSWIN to PGEWIN, conflict with TJP
* Jan 2004 KDH @ STScI - add end= to read statements (linux)

	CHARACTER*75 REPLY

   10	WRITE(*,*) 'Plot window (left, right, bottom, top) :'
	WRITE(*,*)  XLFT, XRGT, YBOT, YTOP
	WRITE(*,'(A,$)')
     #	' A(bort), C(hange window) or Q(uit) ? [Q] '
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )

	IF( REPLY.EQ.' ') GOTO 1000
	IF( REPLY.EQ.'Q') GOTO 1000
	IF( REPLY.EQ.'A') GOTO 999

* change window

      IF( REPLY.EQ.'C') THEN
	WRITE(*,*) 'Enter 4 new window limits (0,0 keeps old pair) :'
	READ(*,*,ERR= 10) XLFT1, XRGT1, YBOT1, YTOP1
      ELSE
	READ(REPLY,*,ERR=18,end=18) XLFT1, XRGT1, YBOT1, YTOP1
      END IF

   15 IF(XLFT1.NE.XRGT1) THEN
	XLFT = XLFT1
	XRGT = XRGT1
      END IF
      IF(YBOT1.NE.YTOP1) THEN
	YBOT = YBOT1
	YTOP = YTOP1
      END IF
	GOTO 10

* trap invalid reply

   18	WRITE(*,*) '** Invalid reply.'
	GOTO  10

* normal return

 1000	PGEWIN = 0
	RETURN

* error return

  999	WRITE(*,*) '** PGEWIN aborted.'
	PGEWIN = 1
	RETURN
	END
C*PGELAB ... edit title and axis labels
C+
	SUBROUTINE PGELAB( XLABEL, YLABEL, TITLE )
*
* Edit the title and axis labels.
*
* Input:
*	XLABEL	C* default label for x-axis
*	YLABEL	C* default label for y-axis
*	TITLE	C* default plot title
* Output:
*	XLABEL	C* final label for x-axis
*	YLABEL	C* final label for y-axis
*	TITLE	C* final plot title
C--
* Aug 1984 by Keith Horne @ IOA.
* Feb 1988 KDH @ STScI - eliminate PARSE
* Mar 1988 KDH @ STScI - remove case sensitivity
* Jul 1988 KDH @ STScI - change PGSETLABS to PGSLAB
* Jan 1992 KDH @ STScI - change PGSLAB to PGELAB
* Mar 1995 KDH @ St.Andrews - eliminate type
* 2006 May KDH @ St.A - use len1(title) etc

	CHARACTER*(*) XLABEL
	CHARACTER*(*) YLABEL
	CHARACTER*(*) TITLE
	CHARACTER*128 STRING
	CHARACTER*1 REPLY

   10	WRITE(*,*)  ' Title=|', TITLE(:len1(title)) , '|'
	WRITE(*,*)  'Xlabel=|', XLABEL(:len1(xlabel)), '|'
	WRITE(*,*)  'Ylabel=|', YLABEL(:len1(ylabel)), '|'
	WRITE(*,'(A,$)')
     #	' Edit T(itle), X(label), Y(label) or Q(uit) ? [Q] '
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )

* normal return

      IF( REPLY.EQ. ' ' .OR. REPLY.EQ.'Q' ) THEN
	RETURN

* change plot title

      ELSE IF( REPLY.EQ.'T') THEN
	WRITE(*,*) 'Enter a new TITLE or ''OLD'' to keep old title.'
	WRITE(*,'(A,$)') '  Title=|'
	READ(*,'(A)') STRING
	IF( STRING(1:3).NE.'OLD' .AND. STRING(1:3).NE.'old') TITLE = STRING

* change x-axis label

      ELSE IF( REPLY.EQ.'X') THEN
	WRITE(*,*) 'Enter a new X LABEL or ''OLD'' to keep old label.'
	WRITE(*,'(A,$)') ' Xlabel=|'
	READ(*,'(A)') STRING
	IF( STRING(1:3).NE.'OLD' .AND. STRING(1:3).NE.'old') XLABEL = STRING

* change x-axis label

      ELSE IF( REPLY.EQ.'Y') THEN
	WRITE(*,*) 'Enter a new Y LABEL or ''OLD'' to keep old label.'
	WRITE(*,'(A,$)') ' Ylabel=|'
	READ(*,'(A)') STRING
	IF( STRING(1:3).NE.'OLD' .AND. STRING(1:3).NE.'old') YLABEL = STRING

* trap bad reply

      ELSE
	WRITE(*,*) '** bad reply.'
      END IF

	GOTO  10
	END
C* PGELUT ... edit the look-up table for false-color on displayed image
C+
	SUBROUTINE PGELUT
* Interactive manipulation of look-up-tables for false-color on image displays.
* The color look-up table is a spiral in color space.
* The user controls the intensity, hue and saturation
* at the beginning and end of the spiral, and the number of times
* the spiral is repeated.  The look-up table can be inverted.
* Look-up tables can also be saved in and recalled from disk files.
C--
* Oct 1986 KDH @ STScI - adapted from palset
* Feb 1987 KDH @ STScI - implement IMGUNW
* Feb 1988 Keith Horne @ STScI - adapted from IMCOLOR for pgplot
* Apr 1988 KDH @ STScI - make wedge optional, default scale on first call only
* Nov 1988 KDH @ STScI - eliminate TYPE *, use PGQIMG.
* May 1990 KDH @ STScI - PGUPDT after each change
* May 1991 KDH @ STScI - fix backwards color spiral
* Jan 1992 KDH @ STScI - PGSLUT -> PGELUT
* Jun 1995 KDH @ St.And - PGWEDGE -> PGWEDG
* 2001 Jul KDH @ St.And - eliminate TYPE, readonly not supported
* 2010 Jun KDH @ StA - alter open statement
	PARAMETER ( MAXLEVELS=256 )
	REAL*4 GUN(MAXLEVELS,3)
	LOGICAL COLOR
	DATA DROUNDS /1./		! NUMBER OF ROUNDS
	DATA DHUE1,DHUE2/1.,6./		! HUE LIMITS
	DATA DSAT1,DSAT2/1.,.6/		! SATURATION LIMITS
	DATA DBRT1,DBRT2/.6,1.1/	! LUMINOSITY LIMITS
	DATA COLOR/.TRUE./		! COLORS ON
	LOGICAL INVERT/.FALSE./
	LOGICAL FIRSTCALL/.TRUE./
	CHARACTER*1 REPLY
	CHARACTER*70 FILE
	TWOPI = ATAN2(1.,1.)*8.

* ABORT IF device is not an image display

	CALL PGQIMG( MINCI, MAXCI )
	NCI = MAXCI - MINCI + 1
      IF( NCI.LE.1 ) THEN
	WRITE(*,*) '** NOT AN IMAGE DISPLAY DEVICE.'
	GOTO 999
      ELSE IF( NCI.GT.MAXLEVELS ) THEN
	WRITE(*,*) '** WARNING: NCI=', NCI, ' max=', MAXLEVELS
	MAXCI = MINCI + MAXLEVELS - 1
	NCI = MAXCI - MINCI + 1
      END IF

* preliminaries

      IF( FIRSTCALL ) THEN
	FIRSTCALL = .FALSE.
	GOTO 60
      END IF

* command list

   10	WRITE(*,*) 'PGELUT command menu:'
	WRITE(*,*) '  W ... show WEDGE for calibration'
	WRITE(*,*) '  B ... BACK to default color scale'
	WRITE(*,*) '  G ... GREYSCALE (colors off)'
	WRITE(*,*) '  C ... COLORS on'
	WRITE(*,*) '  V ... INVERT color scale'
	WRITE(*,*) '  R ... set number of ROUNDS'
	WRITE(*,*) '  I ... set INTENSITY limits'
	WRITE(*,*) '  S ... set SATURATION limits'
        WRITE(*,*) '  H ... set HUES limits'
	WRITE(*,*) '  D ... DUMP color table to disk file.'
	WRITE(*,*) '  L ... LOAD color table from disk file.'
	WRITE(*,*) '  Q ... QUIT'

* command node

   20	write(*,'(A,$)') ' PGELUT > '
	READ(*,'(A)') REPLY
	CALL UPCASE( REPLY, REPLY )

	IF(REPLY.EQ.'Q') RETURN
	IF(REPLY.EQ.'W') GOTO 50
	IF(REPLY.EQ.'B') GOTO 60
	IF(REPLY.EQ.'G') GOTO 1000
	IF(REPLY.EQ.'C') GOTO 2000
	IF(REPLY.EQ.'R') GOTO 3000
	IF(REPLY.EQ.'I') GOTO 4000
	IF(REPLY.EQ.'S') GOTO 5000
	IF(REPLY.EQ.'H') GOTO 6000
	IF(REPLY.EQ.'V') GOTO 7000
	IF(REPLY.EQ.'D') GOTO 8000
	IF(REPLY.EQ.'L') GOTO 8100
	GOTO 10


* Paint plain calibration wedge

C   50	CALL PGWEDGE(0.,0.,0)
   50	CALL PGWEDG('RI', 0.5, 3., 0.,1., ' ')
	GOTO 20

* Set default color scale parameters

   60	ROUNDS = DROUNDS
	HUE1 = DHUE1
	HUE2 = DHUE2
	SAT1 = DSAT1
	SAT2 = DSAT2
	BRT1 = DBRT1
	BRT2 = DBRT2
	INVERT = .FALSE.
	COLOR = .TRUE.
	IF(COLOR) GOTO 2000
	GOTO 1000

* Set palette to a simple greyscale

 1000	WRITE(*,*) 'Greyscale parameters:'
	WRITE(*,*) '    ROUNDS =',ROUNDS
	WRITE(*,*) ' INTENSITY =',BRT1,' TO',BRT2
      DO I=1,NCI
	PART = ROUNDS*(I-1.)/FLOAT(NCI)
	IPART= PART
	PART = PART-IPART
	VALUE = BRT1*(1.-PART) + BRT2*PART
      DO IGUN=1,3
	GUN(I,IGUN) = MAX(0., MIN(1., VALUE ) )
      END DO
      END DO

* set extreme values to white and black 

      IF(INVERT) THEN
      DO IGUN=1,3
	GUN(NCI,IGUN) = 0.
	GUN(1,IGUN) = 1.
      END DO
      ELSE	
      DO IGUN=1,3
	GUN(NCI,IGUN) = 1.
	GUN(1,IGUN) = 0.
      END DO
      END IF
	COLOR=.FALSE.
	GOTO 1500

* Construct a color spiral palette

 2000	WRITE(*,*) 'Color Spiral parameters:'
	WRITE(*,*) ' ROUNDS=',ROUNDS
	WRITE(*,*) '   INT =',BRT1,' TO', BRT2
	WRITE(*,*) '   SAT =',SAT1,' TO', SAT2
	WRITE(*,*) '   HUE =',HUE1,' TO', HUE2
      DO I=1,NCI
	PART = ROUNDS*(I-1.)/(NCI-1.)
	IPART = PART
	PART = PART-IPART
	BRT = BRT1*(1.-PART) + BRT2*PART
	SAT = SAT1*(1.-PART) + SAT2*PART
	PHASE = ( HUE1*(1.-PART) + HUE2*PART ) / 6.
      DO IGUN=1,3
	RADIAN = TWOPI*( PHASE - (IGUN-1.)/3. )
	VALUE = BRT + SAT*( 0.5*(1.+COS(RADIAN)) -1.)
	GUN(I,IGUN) = MAX(0., MIN(1., VALUE ) )
      END DO
      END DO

* set extreme values to white and black 

      IF(INVERT) THEN
      DO IGUN=1,3
	GUN(NCI,IGUN) = 0.
	GUN(1,IGUN) = 1.
      END DO
      ELSE	
      DO IGUN=1,3
	GUN(NCI,IGUN) = 1.
	GUN(1,IGUN) = 0.
      END DO
      END IF

	COLOR=.TRUE.

	GOTO 1500

* set number of rounds

3000	WRITE(*,*) 'Current number of rounds is', ROUNDS
	WRITE(*,*) 'How many rounds do you want ?'
	READ(*,*,ERR=10) ROUNDS
	IF(COLOR) GOTO 2000
	GOTO 1000

* Set brilliance limits

4000	WRITE(*,*) 'Enter (1) Intensity (0-1) at bottom of scale'
	WRITE(*,*) '      (2) Intensity at top of scale'
	READ(*,*,ERR=10) VAL1,VAL2
	BRT1=VAL1
	BRT2=VAL2
	IF(COLOR) GOTO 2000
	GOTO 1000

* Set saturation limits

5000	WRITE(*,*) 'Saturation (0-1) measures the intensity of the colors.'
	WRITE(*,*) 'Enter (1) Saturation at bottom of scale'
	WRITE(*,*) '      (2) Saturation at top of scale'
	READ(*,*,ERR=10) VAL1,VAL2
	SAT1=VAL1
	SAT2=VAL2
	IF(COLOR) GOTO 2000
	GOTO 1000

* Set hue limits

6000	WRITE(*,*) 'COLOR: RED pur BLU aqu GRN yel'
	WRITE(*,*) 'INDEX:  0   1   2   3   4   5'
	WRITE(*,*) '        6   7   8   9  10  11'
	WRITE(*,*) '       12  13  14  15  16  17 ...'
	WRITE(*,*) 'Enter (1) INDEX at bottom of color scale'
	WRITE(*,*) '      (2) INDEX at  top   of color scale'
	READ(*,*,ERR=10) VAL1,VAL2
	HUE1 = VAL1
	HUE2 = VAL2
	IF(COLOR) GOTO 2000
	GOTO 1000

* Invert color scale

7000	HOLD = BRT1
	BRT1 = BRT2
	BRT2 = HOLD
	HOLD = SAT2
	SAT2 = SAT1
	SAT1 = HOLD
	HOLD = HUE1
	HUE1 = HUE2
	HUE2 = HOLD
	INVERT = .NOT. INVERT
	IF(COLOR) GOTO 2000
	GOTO 1000

* DUMP look-up table

 8000	WRITE(*,*) 'Name of look-up table save file ? '
	READ(*,'(A)') FILE
c	OPEN( UNIT=48, NAME=FILE, TYPE='NEW', FORM='FORMATTED',
	OPEN( UNIT=48, FILE=FILE, STATUS='NEW', FORM='FORMATTED',
     $	ERR=8030 )
	WRITE(*,*) 'LUT save file opened.'
      DO I=1,MAXLEVELS
	WRITE( 48, *, ERR=8020 ) (GUN(I,J), J=1,3)
      END DO
	WRITE(*,*) 'Values dumped=', MAXLEVELS
 8010	CLOSE( UNIT=48 )
	WRITE(*,*) 'LUT save file closed.'
	GOTO 20

 8020	WRITE(*,*) '** Read error.'
	GOTO 8010
 8025	WRITE(*,*) '** Premature end of file.'
	GOTO 8010
 8030	WRITE(*,*) '** Open error.'
	GOTO 20

* LOAD look-up table

 8100	WRITE(*,*) 'Name of look-up table input file ? '
	READ(*,'(A)') FILE
C	OPEN( UNIT=48, NAME=FILE, TYPE='OLD', FORM='FORMATTED',
	OPEN( UNIT=48, FILE=FILE, STATUS='OLD', FORM='FORMATTED',
c    &	readonly,
     &	ERR=8030 )
	WRITE(*,*) 'LUT input file opened.'
      DO I=1,MAXLEVELS
	READ( 48, *, ERR=8020, END=8025 ) (GUN(I,J), J=1,3)
      END DO
	CLOSE( UNIT=48 )
	WRITE(*,*) 'LUT save file closed.'
	GOTO 1500

* Load the guns

 1500	J = 0
	CALL PGBBUF
      DO I=MINCI, MAXCI
	J = J + 1
	CALL PGSCR( I, GUN(J,1), GUN(J,2), GUN(J,3) )
      END DO
	CALL PGEBUF
	CALL PGUPDT
	GOTO 20

* error return

  999	WRITE(*,*) '** PGELUT aborted.'
	RETURN
	
	END
C* PGQIMG ... inquire image display color index range
C+
	SUBROUTINE PGQIMG( MINCI, MAXCI )
* Returns the minimum and maximum color indices available for image display.
C--
* Nov 1988 Keith Horne @ STScI
* 2010 Jun KDH @ St.Andrews - comment out D line 
*
	CHARACTER*2 DEVTYPE
	CALL PGQINF( 'TYPE', DEVTYPE, LENGTH )
c	WRITE(*,*) 'PGQIMG LEN=', LENGTH, ' DEVTYPE=', DEVTYPE
	CALL UPCASE( DEVTYPE, DEVTYPE )
      IF( DEVTYPE.EQ.'D1' .OR. DEVTYPE.EQ.'DE'
     #	.OR. DEVTYPE.EQ.'GR'
     #	.OR. DEVTYPE.EQ.'IK'
     #	.OR. DEVTYPE.EQ.'LI'
     #	.OR. DEVTYPE.EQ.'AR'
     #	.OR. DEVTYPE.EQ.'WS'
     #	.OR. DEVTYPE.EQ.'IV'
     #	.OR. DEVTYPE.EQ.'XD'
     #	.OR. DEVTYPE.EQ.'XW'
     #	.OR. DEVTYPE.EQ.'XS'
     #			) THEN
	MINCI = 16
	MAXCI = 255
      ELSE IF( DEVTYPE.EQ.'X1' ) THEN
	MINCI = 16
	MAXCI = 143
      ELSE
	MINCI = 0
	MAXCI = 0
      END IF
	CALL PGQCOL( K1, K2 )
	WRITE(*,*) DEVTYPE, ' Colors:', K1, K2
	MINCI = 16+K1
	MAXCI = 16+K2
	RETURN
	END
	SUBROUTINE PGPIC( MODE, D, NX,NY, IX1,IX2, IY1,IY2, FG,BG, X,Y )
*
* PGGRAY/PGIMAG image display but account for non-linear pixel scales
*
* Jun 1995 KDH @ St-Andrews
* Aug 1997 KDH @ StA - median dx,dy
* Jun 2013 KDH @ StA - gabby
	CHARACTER*(*) MODE
	REAL*4 D(*)
	REAL*4 X(*)
	REAL*4 Y(*)
	REAL*4 TR(6)
	REAL*8 SUM, SUMW
	logical gabby/.false./
c	logical gabby/.true./
	LOGICAL GRAY
	GRAY = INDEX( MODE, 'G' ) .GT. 0 .OR. INDEX( MODE, 'g' ) .GT. 0

* trap invalid 
      IF( FG.EQ.BG ) THEN
	WRITE(*,*) '** PGPIC FG = BG = ', FG
	RETURN
      END IF


* mean stepsize
	DX = ( X(IX2) - X(IX1) ) / MAX(1, IX2-IX1 )
	DY = ( Y(IY2) - Y(IY1) ) / MAX(1, IY2-IY1 )
	if( gabby ) WRITE(*,*) 'mean dx,dy:', dx, dy
* max,min stepsizes
	DXMN = MAX( X(IX1), X(IX2) ) - MIN( X(IX1), X(IX2) )
	DXMX = -DXMN
      DO I=IX1+1,IX2
	IM = MAX( I-1, IX1 )
	TEST = ( X(I) - X(IM) ) / MAX(1,I-IM)
	DXMN = MIN( DXMN, TEST )
	DXMX = MAX( DXMX, TEST )
      END DO
	if( gabby ) WRITE(*,*) 'min/max dx:', dxmn, dxmx
	DYMN = MAX( Y(IY1), Y(IY2) ) - MIN( Y(IY1), Y(IY2) )
	DYMX = -DYMN
      DO I=IY1+1,IY2
	IM = MAX( I-1, IY1 )
	TEST = ( Y(I) - Y(IM) ) / MAX(1,I-IM)
	DYMN = MIN( DYMN, TEST )
	DYMX = MAX( DYMX, TEST )
      END DO
	if( gabby ) WRITE(*,*) 'min/max dy:', dymn, dymx
* median stepsizes
	DXMED = 0.5 * ( ABS( DXMN ) + ABS( DXMX ) )
	DYMED = 0.5 * ( ABS( DYMN ) + ABS( DYMX ) )
	NLOOP = 5
      DO LOOP=1,NLOOP
	SUM = 0.D0
	SUMW = 0.D0
      DO I=2,NX
	IM = MAX( I-1, 1 )
	TEST = ABS( X(I) - X(IM) ) / MAX( 1, I-IM )
      IF( TEST.NE. DXMED ) THEN
	WGT = 1. / ABS( TEST - DXMED )
	SUM = SUM + WGT * TEST
	SUMW = SUMW + WGT
      END IF
      END DO
      IF( SUMW.GT.0.D0 ) THEN
	DXMED = SUM / SUMW
      END IF

	SUM = 0.D0
	SUMW = 0.D0
      DO I=2,NY
	IM = MAX( I-1, 1 )
	TEST = ABS( Y(I) - Y(IM) ) / MAX( 1, I-IM )
      IF( TEST.NE. DYMED ) THEN
	WGT = 1. / ABS( TEST - DYMED )
	SUM = SUM + WGT * TEST
	SUMW = SUMW + WGT
      END IF
      END DO
      IF( SUMW.GT.0.D0 ) THEN
	DYMED = SUM / SUMW
      END IF
	if( gabby ) WRITE(*,*) 'median dx,dy:', LOOP, DXMED, DYMED
      END DO

* limit range of step sizes

	dxhi = abs( dxmed * 1.2 )
	dxlo = - dxhi
	dyhi = abs( dymed * 1.2 )
	dylo = - dyhi

* construct best linear transformation matrix
	IF( DX.EQ.0. ) DX = 1.
	IF( DY.EQ.0. ) DY = 1.
        TR(6) = DY
        TR(5) = 0.
        TR(4) = Y(IY1) - IY1 * TR(6)
        TR(3) = 0.
        TR(2) = DX
        TR(1) = X(1) - IX1 * TR(2)
	TR(2) = MAX( DXLO, MIN( DXHI, TR(2) ) )
	TR(6) = MAX( DYLO, MIN( DYHI, TR(6) ) )
* maximum pixel error of transformation
	XTEST = 0.
      DO I=IX1,IX2
        XERR = ABS( ( TR(1) + I * TR(2) - X(I) ) / TR(2) )
	XTEST = MAX( XTEST, XERR )
      END DO
	YTEST = 0.
      DO I=IY1,IY2
        YERR = ABS( ( TR(4) + I * TR(6) - Y(I) ) / TR(6) )
	YTEST = MAX( YTEST, YERR )
      END DO
* max allowed pixel error
        BAD = 0.1

* display entire map

      IF( XTEST.LT.BAD .AND. YTEST.LT.BAD ) THEN

      IF( GRAY ) THEN
        if( gabby ) write(*,*) 'PGGRAY entire map. dx,dy:', TR(2), TR(6)
        CALL PGGRAY( D, NX, NY, IX1,IX2, IY1,IY2, FG,BG, TR )
      ELSE
        if( gabby ) write(*,*) 'PGIMAG entire map. dx,dy:', TR(2), TR(6)
        CALL PGIMAG( D, NX, NY, IX1,IX2, IY1,IY2, FG,BG, TR )
      END IF

* column blocks

      ELSE IF( XTEST.GE.BAD .AND. YTEST.LT.BAD ) THEN
        JX1 = IX1
      DO JX2=MIN(IX2,3),IX2
        TR(2) = ( X(JX2) - X(JX1) ) / MAX(1,JX2-JX1)
        TR(1) = X(JX1) - JX1 * TR(2)
	XTEST = 0.
      DO I=JX1,JX2
        XERR = ABS( ( TR(1) + I * TR(2) - X(I) ) / TR(2) )
	XTEST = MAX( XTEST, XERR )
      END DO
      IF( XTEST.GT.BAD .OR. JX2.GE.IX2 ) THEN
        JX2M = JX2 - 1
        IF( JX2.GE.IX2 ) JX2M = IX2

      IF( JX2M - JX1 .GT.1 ) THEN
        TR(2) = ( X(JX2M) - X(JX1) ) / MAX(1,JX2M-JX1)
        TR(1) = X(JX1) - JX1 * TR(2)
      IF( GRAY ) THEN
        if( gabby ) write(*,*) 'PGGRAY col:', JX1, JX2M
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGGRAY( D, NX,NY, JX1,JX2M, IY1,IY2, FG,BG, TR )
      ELSE
        if( gabby ) write(*,*) 'PGIMAG col:', JX1, JX2M
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGIMAG( D, NX,NY, JX1,JX2M, IY1,IY2, FG,BG, TR )
      END IF

      ELSE

        TR(2) = DXMED
      DO J=JX1,JX2M
        TR(1) = X(J) - J * TR(2)
      IF( GRAY ) THEN
        if( gabby ) write(*,*) 'PGGRAY col:', J, J
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGGRAY( D, NX,NY, J,J, IY1,IY2, FG,BG, TR )
      ELSE
        if( gabby ) write(*,*) 'PGIMAG col:', J, J
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGIMAG( D, NX,NY, J,J, IY1,IY2, FG,BG, TR )
      END IF
      END DO

      END IF

        JX1 = JX2
      END IF
      END DO

* row blocks

      ELSE IF( XTEST.LT.BAD .AND. YTEST.GE.BAD ) THEN
        JY1 = IY1
      DO JY2=MIN(IY2,3),IY2
        TR(6) = ( Y(JY2) - Y(JY1) ) / MAX(1,JY2-JY1)
        TR(4) = Y(JY1) - JY1 * TR(6)
	YTEST = 0.
      DO I=JY1,JY2
        YERR = ABS( ( TR(4) + I * TR(6) - Y(I) ) / TR(6) )
	YTEST = MAX( YTEST, YERR )
      END DO
      IF( YTEST.GT.BAD .OR. JY2.GE.IY2 ) THEN
        JY2M = JY2 - 1
        IF( JY2.GE.IY2 ) JY2M = IY2

      IF( JY2M - JY1 .GT. 1 ) THEN

        TR(6) = ( Y(JY2M) - Y(JY1) ) / MAX(1,JY2M-JY1)
        TR(4) = Y(JY1) - JY1 * TR(6)
      IF( GRAY ) THEN
        if( gabby ) write(*,*) 'PGGRAY row:', JY1, JY2M
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGGRAY( D, NX,NY, IX1,IX2, JY1,JY2M, FG,BG, TR )
      ELSE
        if( gabby ) write(*,*) 'PGIMAG row:', JY1, JY2M
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGIMAG( D, NX,NY, IX1,IX2, JY1,JY2M, FG,BG, TR )
      END IF

      ELSE

      DO J=JY1,JY2M
        TR(6) = DYMED
        TR(4) = Y(J) - J * TR(6)
      IF( GRAY ) THEN
        if( gabby ) write(*,*) 'PGGRAY row:', J, J
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGGRAY( D, NX,NY, IX1,IX2, J,J, FG,BG, TR )
      ELSE
        if( gabby ) write(*,*) 'PGIMAG row:', J, J
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
c        CALL PGIMAG( D, NX,NY, IX1,IX2, J,JM, FG,BG, TR )
        CALL PGIMAG( D, NX,NY, IX1,IX2, J,J, FG,BG, TR )
      END IF
      END DO

      END IF
        JY1 = JY2
      END IF
      END DO

* patch blocks

      ELSE
        JY1 = IY1
      DO JY2=MIN(IY2,3),IY2
        TR(6) = ( Y(JY2) - Y(JY1) ) / MAX(1,JY2-JY1)
        TR(4) = Y(JY1) - JY1 * TR(6)
	YTEST = 0.
      DO I=JY1,JY2
        YERR = ABS( ( TR(4) + I * TR(6) - Y(I) ) / TR(6) )
	YTEST = MAX( YTEST, YERR )
      END DO
      IF( YTEST.GT.BAD .OR. JY2.GE.IY2 ) THEN
        JY2M = JY2 - 1
        IF( JY2.GE.IY2 ) JY2M = IY2
        TR(6) = ( Y(JY2M) - Y(JY1) ) / MAX(1,JY2M-JY1)
        TR(4) = Y(JY1) - JY1 * TR(6)

        JX1 = IX1
      DO JX2=MIN(IX2,3),IX2
        TR(2) = ( X(JX2) - X(JX1) ) / MAX(1,JX2-JX1)
        TR(1) = X(JX1) - JX1 * TR(2)
	XTEST = 0.
      DO I=JX1,JX2
        XERR = ABS( ( TR(1) + I * TR(2) - X(I) ) / TR(2) )
	XTEST = MAX( XTEST, XERR )
      END DO
      IF( XTEST.GT.BAD .OR. JX2.GE.IX2 ) THEN
        JX2M = JX2 - 1
        IF( JX2.GE.IX2 ) JX2M = IX2
        TR(2) = ( X(JX2M) - X(JX1) ) / MAX(1,JX2M-JX1)
        TR(1) = X(JX1) - JX1 * TR(2)


      IF( GRAY ) THEN
        if( gabby ) write(*,*) 'PGGRAY col:', JX1, JX2M, ' row:', JY1, JY2M
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGGRAY( D, NX,NY, JX1,JX2M, JY1,JY2M, FG,BG, TR )
      ELSE
        if( gabby ) write(*,*) 'PGIMAG col:', JX1, JX2M, ' row:', JY1, JY2M
        if( gabby ) write(*,*) 'dx,dy:', TR(2), TR(6)
        CALL PGIMAG( D, NX,NY, JX1,JX2M, JY1,JY2M, FG,BG, TR )
      END IF

        JX1 = JX2
      END IF
      END DO
        JY1 = JY2
      END IF
      END DO

      END IF

	RETURN
	END
*----------------------------------------
	subroutine pgbgw
* set background/foreground colours to white/black
* 2010 Oct Keith Horne @ St-And
	call pgscr( 0, 1., 1., 1. )
	call pgscr( 1, 0., 0., 0. )
	return
	end
